// Type definitions for Microsoft HTML Object Library - MSHTML 4.0
// Project: https://msdn.microsoft.com/en-us/library/aa741317(v=vs.85).aspx
// Definitions by: Zev Spitz <https://github.com/zspitz>
// Definitions: https://github.com/DefinitelyTyped/DefinitelyTyped
// TypeScript Version: 2.3

declare namespace MSHTML {
    const enum _BEHAVIOR_EVENT {
        BEHAVIOR_EVENT_Max = 2147483647,
        BEHAVIOREVENT_APPLYSTYLE = 2,
        BEHAVIOREVENT_CONTENTREADY = 0,
        BEHAVIOREVENT_CONTENTSAVE = 4,
        BEHAVIOREVENT_DOCUMENTCONTEXTCHANGE = 3,
        BEHAVIOREVENT_DOCUMENTREADY = 1,
        BEHAVIOREVENT_FIRST = 0,
        BEHAVIOREVENT_LAST = 4,
    }

    const enum _BEHAVIOR_EVENT_FLAGS {
        BEHAVIOR_EVENT_FLAGS_Max = 2147483647,
        BEHAVIOREVENTFLAGS_BUBBLE = 1,
        BEHAVIOREVENTFLAGS_STANDARDADDITIVE = 2,
    }

    const enum _BEHAVIOR_LAYOUT_INFO {
        BEHAVIOR_LAYOUT_INFO_Max = 2147483647,
        BEHAVIORLAYOUTINFO_FULLDELEGATION = 1,
        BEHAVIORLAYOUTINFO_MAPSIZE = 4,
        BEHAVIORLAYOUTINFO_MODIFYNATURAL = 2,
    }

    const enum _BEHAVIOR_LAYOUT_MODE {
        BEHAVIOR_LAYOUT_MODE_Max = 2147483647,
        BEHAVIORLAYOUTMODE_FINAL_PERCENT = 32768,
        BEHAVIORLAYOUTMODE_MAXWIDTH = 4,
        BEHAVIORLAYOUTMODE_MEDIA_RESOLUTION = 16384,
        BEHAVIORLAYOUTMODE_MINWIDTH = 2,
        BEHAVIORLAYOUTMODE_NATURAL = 1,
    }

    const enum _BEHAVIOR_RELATION {
        BEHAVIOR_CHILD = 2,
        BEHAVIOR_FIRSTRELATION = 0,
        BEHAVIOR_LASTRELATION = 3,
        BEHAVIOR_PARENT = 1,
        BEHAVIOR_RELATION_Max = 2147483647,
        BEHAVIOR_SAMEELEMENT = 0,
        BEHAVIOR_SIBLING = 3,
    }

    const enum _BEHAVIOR_RENDER_INFO {
        BEHAVIOR_RENDER_INFO_Max = 2147483647,
        BEHAVIORRENDERINFO_3DSURFACE = 2097152,
        BEHAVIORRENDERINFO_ABOVECONTENT = 40,
        BEHAVIORRENDERINFO_AFTERBACKGROUND = 2,
        BEHAVIORRENDERINFO_AFTERCONTENT = 8,
        BEHAVIORRENDERINFO_AFTERFOREGROUND = 32,
        BEHAVIORRENDERINFO_ALLLAYERS = 255,
        BEHAVIORRENDERINFO_BEFOREBACKGROUND = 1,
        BEHAVIORRENDERINFO_BEFORECONTENT = 4,
        BEHAVIORRENDERINFO_DISABLEALLLAYERS = 3840,
        BEHAVIORRENDERINFO_DISABLEBACKGROUND = 256,
        BEHAVIORRENDERINFO_DISABLECONTENT = 1024,
        BEHAVIORRENDERINFO_DISABLENEGATIVEZ = 512,
        BEHAVIORRENDERINFO_DISABLEPOSITIVEZ = 2048,
        BEHAVIORRENDERINFO_HITTESTING = 4096,
        BEHAVIORRENDERINFO_SURFACE = 1048576,
    }

    const enum _bodyScroll {
        bodyScroll_Max = 2147483647,
        bodyScrollauto = 4,
        bodyScrolldefault = 3,
        bodyScrollno = 2,
        bodyScrollyes = 1,
    }

    const enum _BoolValue {
        BoolValue_Max = 2147483647,
        False = 0,
        True = 1,
    }

    const enum _CARET_DIRECTION {
        CARET_DIRECTION_BACKWARD = 2,
        CARET_DIRECTION_FORWARD = 3,
        CARET_DIRECTION_INDETERMINATE = 0,
        CARET_DIRECTION_Max = 2147483647,
        CARET_DIRECTION_SAME = 1,
    }

    const enum _COORD_SYSTEM {
        COORD_SYSTEM_CLIENT = 5,
        COORD_SYSTEM_CONTAINER = 2,
        COORD_SYSTEM_CONTENT = 3,
        COORD_SYSTEM_FRAME = 4,
        COORD_SYSTEM_GLOBAL = 0,
        COORD_SYSTEM_Max = 2147483647,
        COORD_SYSTEM_PARENT = 1,
    }

    const enum _DEV_CONSOLE_MESSAGE_LEVEL {
        DCML_ERROR = 2,
        DCML_INFORMATIONAL = 0,
        DCML_WARNING = 1,
        DEV_CONSOLE_MESSAGE_LEVEL_Max = 2147483647,
    }

    const enum _DISPLAY_BREAK {
        DISPLAY_BREAK_Block = 1,
        DISPLAY_BREAK_Break = 2,
        DISPLAY_BREAK_Max = 2147483647,
        DISPLAY_BREAK_None = 0,
    }

    const enum _DISPLAY_GRAVITY {
        DISPLAY_GRAVITY_Max = 2147483647,
        DISPLAY_GRAVITY_NextLine = 2,
        DISPLAY_GRAVITY_PreviousLine = 1,
    }

    const enum _DISPLAY_MOVEUNIT {
        DISPLAY_MOVEUNIT_BottomOfWindow = 6,
        DISPLAY_MOVEUNIT_CurrentLineEnd = 4,
        DISPLAY_MOVEUNIT_CurrentLineStart = 3,
        DISPLAY_MOVEUNIT_Max = 2147483647,
        DISPLAY_MOVEUNIT_NextLine = 2,
        DISPLAY_MOVEUNIT_PreviousLine = 1,
        DISPLAY_MOVEUNIT_TopOfWindow = 5,
    }

    const enum _DOM_EVENT_PHASE {
        DEP_AT_TARGET = 2,
        DEP_BUBBLING_PHASE = 3,
        DEP_CAPTURING_PHASE = 1,
        DOM_EVENT_PHASE_Max = 2147483647,
    }

    const enum _DomConstructor {
        DomConstructor_Max = 2147483647,
        DomConstructorAttr = 1,
        DomConstructorBehaviorUrnsCollection = 2,
        DomConstructorBookmarkCollection = 3,
        DomConstructorCompatibleInfo = 4,
        DomConstructorCompatibleInfoCollection = 5,
        DomConstructorControlRangeCollection = 6,
        DomConstructorCSSCurrentStyleDeclaration = 7,
        DomConstructorCSSRuleList = 8,
        DomConstructorCSSRuleStyleDeclaration = 9,
        DomConstructorCSSStyleDeclaration = 10,
        DomConstructorCSSStyleRule = 11,
        DomConstructorCSSStyleSheet = 12,
        DomConstructorDataTransfer = 13,
        DomConstructorDOMImplementation = 14,
        DomConstructorElement = 15,
        DomConstructorEvent = 16,
        DomConstructorHistory = 17,
        DomConstructorHTCElementBehaviorDefaults = 18,
        DomConstructorHTMLAnchorElement = 19,
        DomConstructorHTMLAreaElement = 20,
        DomConstructorHTMLAreasCollection = 21,
        DomConstructorHTMLBaseElement = 22,
        DomConstructorHTMLBaseFontElement = 23,
        DomConstructorHTMLBGSoundElement = 24,
        DomConstructorHTMLBlockElement = 25,
        DomConstructorHTMLBodyElement = 26,
        DomConstructorHTMLBRElement = 27,
        DomConstructorHTMLButtonElement = 28,
        DomConstructorHTMLCollection = 29,
        DomConstructorHTMLCommentElement = 30,
        DomConstructorHTMLDDElement = 31,
        DomConstructorHTMLDivElement = 32,
        DomConstructorHTMLDListElement = 34,
        DomConstructorHTMLDocument = 33,
        DomConstructorHTMLDTElement = 35,
        DomConstructorHTMLEmbedElement = 36,
        DomConstructorHTMLFieldSetElement = 37,
        DomConstructorHTMLFontElement = 38,
        DomConstructorHTMLFormElement = 39,
        DomConstructorHTMLFrameElement = 40,
        DomConstructorHTMLFrameSetElement = 41,
        DomConstructorHTMLGenericElement = 42,
        DomConstructorHTMLHeadElement = 43,
        DomConstructorHTMLHeadingElement = 44,
        DomConstructorHTMLHRElement = 45,
        DomConstructorHTMLHtmlElement = 46,
        DomConstructorHTMLIFrameElement = 47,
        DomConstructorHTMLImageElement = 48,
        DomConstructorHTMLInputElement = 49,
        DomConstructorHTMLIsIndexElement = 50,
        DomConstructorHTMLLabelElement = 51,
        DomConstructorHTMLLegendElement = 52,
        DomConstructorHTMLLIElement = 53,
        DomConstructorHTMLLinkElement = 54,
        DomConstructorHTMLMapElement = 55,
        DomConstructorHTMLMarqueeElement = 56,
        DomConstructorHTMLMetaElement = 57,
        DomConstructorHTMLModelessDialog = 58,
        DomConstructorHTMLNamespaceInfo = 59,
        DomConstructorHTMLNamespaceInfoCollection = 60,
        DomConstructorHTMLNextIdElement = 61,
        DomConstructorHTMLNoShowElement = 62,
        DomConstructorHTMLObjectElement = 63,
        DomConstructorHTMLOListElement = 64,
        DomConstructorHTMLOptionElement = 65,
        DomConstructorHTMLParagraphElement = 66,
        DomConstructorHTMLParamElement = 67,
        DomConstructorHTMLPhraseElement = 68,
        DomConstructorHTMLPluginsCollection = 69,
        DomConstructorHTMLPopup = 70,
        DomConstructorHTMLScriptElement = 71,
        DomConstructorHTMLSelectElement = 72,
        DomConstructorHTMLSpanElement = 73,
        DomConstructorHTMLStyleElement = 74,
        DomConstructorHTMLTableCaptionElement = 75,
        DomConstructorHTMLTableCellElement = 76,
        DomConstructorHTMLTableColElement = 77,
        DomConstructorHTMLTableElement = 78,
        DomConstructorHTMLTableRowElement = 79,
        DomConstructorHTMLTableSectionElement = 80,
        DomConstructorHTMLTextAreaElement = 81,
        DomConstructorHTMLTextElement = 82,
        DomConstructorHTMLTitleElement = 83,
        DomConstructorHTMLUListElement = 84,
        DomConstructorHTMLUnknownElement = 85,
        DomConstructorImage = 86,
        DomConstructorLocation = 87,
        DomConstructorMax = 107,
        DomConstructorNamedNodeMap = 88,
        DomConstructorNavigator = 89,
        DomConstructorNodeList = 90,
        DomConstructorObject = 0,
        DomConstructorOption = 91,
        DomConstructorScreen = 92,
        DomConstructorSelection = 93,
        DomConstructorStaticNodeList = 94,
        DomConstructorStorage = 95,
        DomConstructorStyleSheetList = 96,
        DomConstructorStyleSheetPage = 97,
        DomConstructorStyleSheetPageList = 98,
        DomConstructorText = 99,
        DomConstructorTextRange = 100,
        DomConstructorTextRangeCollection = 101,
        DomConstructorTextRectangle = 102,
        DomConstructorTextRectangleList = 103,
        DomConstructorWindow = 104,
        DomConstructorXDomainRequest = 105,
        DomConstructorXMLHttpRequest = 106,
    }

    const enum _ELEMENT_ADJACENCY {
        ELEM_ADJ_AfterBegin = 1,
        ELEM_ADJ_AfterEnd = 3,
        ELEM_ADJ_BeforeBegin = 0,
        ELEM_ADJ_BeforeEnd = 2,
        ELEMENT_ADJACENCY_Max = 2147483647,
    }

    const enum _ELEMENT_CORNER {
        ELEMENT_CORNER_BOTTOM = 3,
        ELEMENT_CORNER_BOTTOMLEFT = 7,
        ELEMENT_CORNER_BOTTOMRIGHT = 8,
        ELEMENT_CORNER_LEFT = 2,
        ELEMENT_CORNER_Max = 2147483647,
        ELEMENT_CORNER_NONE = 0,
        ELEMENT_CORNER_RIGHT = 4,
        ELEMENT_CORNER_TOP = 1,
        ELEMENT_CORNER_TOPLEFT = 5,
        ELEMENT_CORNER_TOPRIGHT = 6,
    }

    const enum _ELEMENT_TAG_ID {
        ELEMENT_TAG_ID_Max = 2147483647,
        TAGID_A = 2,
        TAGID_ABBR = 110,
        TAGID_ACRONYM = 3,
        TAGID_ADDRESS = 4,
        TAGID_APPLET = 5,
        TAGID_AREA = 6,
        TAGID_ARTICLE = 199,
        TAGID_ASIDE = 200,
        TAGID_AUDIO = 192,
        TAGID_B = 7,
        TAGID_BASE = 8,
        TAGID_BASEFONT = 9,
        TAGID_BDO = 10,
        TAGID_BGSOUND = 11,
        TAGID_BIG = 12,
        TAGID_BLINK = 13,
        TAGID_BLOCKQUOTE = 14,
        TAGID_BODY = 15,
        TAGID_BR = 16,
        TAGID_BUTTON = 17,
        TAGID_CANVAS = 195,
        TAGID_CAPTION = 18,
        TAGID_CENTER = 19,
        TAGID_CITE = 20,
        TAGID_CODE = 21,
        TAGID_COL = 22,
        TAGID_COLGROUP = 23,
        TAGID_COMMAND = 220,
        TAGID_COMMENT = 24,
        TAGID_COMMENT_RAW = 25,
        TAGID_COUNT = 224,
        TAGID_DATALIST = 217,
        TAGID_DD = 26,
        TAGID_DEL = 27,
        TAGID_DETAILS = 221,
        TAGID_DFN = 28,
        TAGID_DIR = 29,
        TAGID_DIV = 30,
        TAGID_DL = 31,
        TAGID_DOCTYPE = 196,
        TAGID_DT = 32,
        TAGID_EM = 33,
        TAGID_EMBED = 34,
        TAGID_FIELDSET = 35,
        TAGID_FIGCAPTION = 201,
        TAGID_FIGURE = 202,
        TAGID_FONT = 36,
        TAGID_FOOTER = 203,
        TAGID_FORM = 37,
        TAGID_FRAME = 38,
        TAGID_FRAMESET = 39,
        TAGID_GENERIC = 40,
        TAGID_H1 = 41,
        TAGID_H2 = 42,
        TAGID_H3 = 43,
        TAGID_H4 = 44,
        TAGID_H5 = 45,
        TAGID_H6 = 46,
        TAGID_HEAD = 47,
        TAGID_HEADER = 204,
        TAGID_HGROUP = 205,
        TAGID_HR = 48,
        TAGID_HTML = 49,
        TAGID_I = 50,
        TAGID_IFRAME = 51,
        TAGID_IMG = 52,
        TAGID_INPUT = 53,
        TAGID_INS = 54,
        TAGID_ISINDEX = 219,
        TAGID_KBD = 55,
        TAGID_KEYGEN = 197,
        TAGID_LABEL = 56,
        TAGID_LAST_PREDEFINED = 10000,
        TAGID_LEGEND = 57,
        TAGID_LI = 58,
        TAGID_LINK = 59,
        TAGID_LISTING = 60,
        TAGID_MAP = 61,
        TAGID_MARK = 206,
        TAGID_MARQUEE = 62,
        TAGID_MATHML_ANNOTATION_XML = 210,
        TAGID_MATHML_MATH = 211,
        TAGID_MATHML_MI = 212,
        TAGID_MATHML_MN = 213,
        TAGID_MATHML_MO = 214,
        TAGID_MATHML_MS = 215,
        TAGID_MATHML_MTEXT = 216,
        TAGID_MENU = 63,
        TAGID_META = 64,
        TAGID_NAV = 207,
        TAGID_NEXTID = 65,
        TAGID_NOBR = 66,
        TAGID_NOEMBED = 67,
        TAGID_NOFRAMES = 68,
        TAGID_NOSCRIPT = 69,
        TAGID_NULL = 0,
        TAGID_OBJECT = 70,
        TAGID_OL = 71,
        TAGID_OPTGROUP = 109,
        TAGID_OPTION = 72,
        TAGID_P = 73,
        TAGID_PARAM = 74,
        TAGID_PLAINTEXT = 75,
        TAGID_PRE = 76,
        TAGID_PROCESSINGINSTRUCTION = 198,
        TAGID_PROGRESS = 209,
        TAGID_Q = 77,
        TAGID_ROOT = 108,
        TAGID_RP = 78,
        TAGID_RT = 79,
        TAGID_RUBY = 80,
        TAGID_S = 81,
        TAGID_SAMP = 82,
        TAGID_SCRIPT = 83,
        TAGID_SECTION = 208,
        TAGID_SELECT = 84,
        TAGID_SMALL = 85,
        TAGID_SOURCE = 193,
        TAGID_SPAN = 86,
        TAGID_STRIKE = 87,
        TAGID_STRONG = 88,
        TAGID_STYLE = 89,
        TAGID_SUB = 90,
        TAGID_SUMMARY = 222,
        TAGID_SUP = 91,
        TAGID_SVG_A = 111,
        TAGID_SVG_ALTGLYPH = 112,
        TAGID_SVG_ALTGLYPHDEF = 113,
        TAGID_SVG_ALTGLYPHITEM = 114,
        TAGID_SVG_ANIMATE = 115,
        TAGID_SVG_ANIMATECOLOR = 116,
        TAGID_SVG_ANIMATEMOTION = 117,
        TAGID_SVG_ANIMATETRANSFORM = 118,
        TAGID_SVG_CIRCLE = 119,
        TAGID_SVG_CLIPPATH = 120,
        TAGID_SVG_COLOR_PROFILE = 121,
        TAGID_SVG_CURSOR = 122,
        TAGID_SVG_DEFINITION_SRC = 123,
        TAGID_SVG_DEFS = 124,
        TAGID_SVG_DESC = 125,
        TAGID_SVG_ELLIPSE = 126,
        TAGID_SVG_FEBLEND = 127,
        TAGID_SVG_FECOLORMATRIX = 128,
        TAGID_SVG_FECOMPONENTTRANSFER = 129,
        TAGID_SVG_FECOMPOSITE = 130,
        TAGID_SVG_FECONVOLVEMATRIX = 131,
        TAGID_SVG_FEDIFFUSELIGHTING = 132,
        TAGID_SVG_FEDISPLACEMENTMAP = 133,
        TAGID_SVG_FEDISTANTLIGHT = 134,
        TAGID_SVG_FEFLOOD = 135,
        TAGID_SVG_FEFUNCA = 136,
        TAGID_SVG_FEFUNCB = 137,
        TAGID_SVG_FEFUNCG = 138,
        TAGID_SVG_FEFUNCR = 139,
        TAGID_SVG_FEGAUSSIANBLUR = 140,
        TAGID_SVG_FEIMAGE = 141,
        TAGID_SVG_FEMERGE = 142,
        TAGID_SVG_FEMERGENODE = 143,
        TAGID_SVG_FEMORPHOLOGY = 144,
        TAGID_SVG_FEOFFSET = 145,
        TAGID_SVG_FEPOINTLIGHT = 146,
        TAGID_SVG_FESPECULARLIGHTING = 147,
        TAGID_SVG_FESPOTLIGHT = 148,
        TAGID_SVG_FETILE = 149,
        TAGID_SVG_FETURBULENCE = 150,
        TAGID_SVG_FILTER = 151,
        TAGID_SVG_FONT = 152,
        TAGID_SVG_FONT_FACE = 153,
        TAGID_SVG_FONT_FACE_FORMAT = 154,
        TAGID_SVG_FONT_FACE_NAME = 155,
        TAGID_SVG_FONT_FACE_SRC = 156,
        TAGID_SVG_FONT_FACE_URI = 157,
        TAGID_SVG_FOREIGNOBJECT = 158,
        TAGID_SVG_G = 159,
        TAGID_SVG_GLYPH = 160,
        TAGID_SVG_GLYPHREF = 161,
        TAGID_SVG_HKERN = 162,
        TAGID_SVG_IMAGE = 163,
        TAGID_SVG_LINE = 164,
        TAGID_SVG_LINEARGRADIENT = 165,
        TAGID_SVG_MARKER = 166,
        TAGID_SVG_MASK = 167,
        TAGID_SVG_METADATA = 168,
        TAGID_SVG_MISSING_GLYPH = 169,
        TAGID_SVG_MPATH = 170,
        TAGID_SVG_PATH = 171,
        TAGID_SVG_PATTERN = 172,
        TAGID_SVG_POLYGON = 173,
        TAGID_SVG_POLYLINE = 174,
        TAGID_SVG_RADIALGRADIENT = 175,
        TAGID_SVG_RECT = 176,
        TAGID_SVG_SCRIPT = 177,
        TAGID_SVG_SET = 178,
        TAGID_SVG_STOP = 179,
        TAGID_SVG_STYLE = 180,
        TAGID_SVG_SVG = 181,
        TAGID_SVG_SWITCH = 182,
        TAGID_SVG_SYMBOL = 183,
        TAGID_SVG_TEXT = 184,
        TAGID_SVG_TEXTPATH = 185,
        TAGID_SVG_TITLE = 186,
        TAGID_SVG_TREF = 187,
        TAGID_SVG_TSPAN = 188,
        TAGID_SVG_USE = 189,
        TAGID_SVG_VIEW = 190,
        TAGID_SVG_VKERN = 191,
        TAGID_TABLE = 92,
        TAGID_TBODY = 93,
        TAGID_TC = 94,
        TAGID_TD = 95,
        TAGID_TEXTAREA = 96,
        TAGID_TFOOT = 97,
        TAGID_TH = 98,
        TAGID_THEAD = 99,
        TAGID_TITLE = 100,
        TAGID_TR = 101,
        TAGID_TRACK = 218,
        TAGID_TT = 102,
        TAGID_U = 103,
        TAGID_UL = 104,
        TAGID_UNKNOWN = 1,
        TAGID_VAR = 105,
        TAGID_VIDEO = 194,
        TAGID_WBR = 106,
        TAGID_X_MS_WEBVIEW = 223,
        TAGID_XMP = 107,
    }

    const enum _ELEMENTDESCRIPTOR_FLAGS {
        ELEMENTDESCRIPTOR_FLAGS_Max = 2147483647,
        ELEMENTDESCRIPTORFLAGS_LITERAL = 1,
        ELEMENTDESCRIPTORFLAGS_NESTED_LITERAL = 2,
    }

    const enum _ELEMENTNAMESPACE_FLAGS {
        ELEMENTNAMESPACE_FLAGS_Max = 2147483647,
        ELEMENTNAMESPACEFLAGS_ALLOWANYTAG = 1,
        ELEMENTNAMESPACEFLAGS_QUERYFORUNKNOWNTAGS = 2,
    }

    const enum _FINDTEXT_FLAGS {
        FINDTEXT_BACKWARDS = 1,
        FINDTEXT_FLAGS_Max = 2147483647,
        FINDTEXT_MATCHALEFHAMZA = -2147483648,
        FINDTEXT_MATCHCASE = 4,
        FINDTEXT_MATCHDIAC = 536870912,
        FINDTEXT_MATCHKASHIDA = 1073741824,
        FINDTEXT_MATCHREPEATEDWHITESPACE = 262144,
        FINDTEXT_RAW = 131072,
        FINDTEXT_WHOLEWORD = 2,
    }

    const enum _frameScrolling {
        frameScrolling_Max = 2147483647,
        frameScrollingauto = 4,
        frameScrollingno = 2,
        frameScrollingyes = 1,
    }

    const enum _HT_OPTIONS {
        HT_OPT_AllowAfterEOL = 1,
        HT_OPTIONS_Max = 2147483647,
    }

    const enum _HT_RESULTS {
        HT_RESULTS_Glyph = 1,
        HT_RESULTS_Max = 2147483647,
    }

    const enum _HTML_PAINT_DRAW_FLAGS {
        HTML_PAINT_DRAW_FLAGS_Max = 2147483647,
        HTMLPAINT_DRAW_UPDATEREGION = 1,
        HTMLPAINT_DRAW_USE_XFORM = 2,
    }

    const enum _HTML_PAINT_DRAW_INFO_FLAGS {
        HTML_PAINT_DRAW_INFO_FLAGS_Max = 2147483647,
        HTMLPAINT_DRAWINFO_UPDATEREGION = 2,
        HTMLPAINT_DRAWINFO_VIEWPORT = 1,
        HTMLPAINT_DRAWINFO_XFORM = 4,
    }

    const enum _HTML_PAINT_EVENT_FLAGS {
        HTML_PAINT_EVENT_FLAGS_Max = 2147483647,
        HTMLPAINT_EVENT_SETCURSOR = 2,
        HTMLPAINT_EVENT_TARGET = 1,
    }

    const enum _HTML_PAINT_ZORDER {
        HTML_PAINT_ZORDER_Max = 2147483647,
        HTMLPAINT_ZORDER_ABOVE_CONTENT = 7,
        HTMLPAINT_ZORDER_ABOVE_FLOW = 6,
        HTMLPAINT_ZORDER_BELOW_CONTENT = 4,
        HTMLPAINT_ZORDER_BELOW_FLOW = 5,
        HTMLPAINT_ZORDER_NONE = 0,
        HTMLPAINT_ZORDER_REPLACE_ALL = 1,
        HTMLPAINT_ZORDER_REPLACE_BACKGROUND = 3,
        HTMLPAINT_ZORDER_REPLACE_CONTENT = 2,
        HTMLPAINT_ZORDER_WINDOW_TOP = 8,
    }

    const enum _HTML_PAINTER {
        HTML_PAINTER_Max = 2147483647,
        HTMLPAINTER_3DSURFACE = 512,
        HTMLPAINTER_ALPHA = 4,
        HTMLPAINTER_COMPLEX = 8,
        HTMLPAINTER_EXPAND = 65536,
        HTMLPAINTER_HITTEST = 32,
        HTMLPAINTER_NOBAND = 1024,
        HTMLPAINTER_NODC = 4096,
        HTMLPAINTER_NOPHYSICALCLIP = 8192,
        HTMLPAINTER_NOSAVEDC = 16384,
        HTMLPAINTER_NOSCROLLBITS = 131072,
        HTMLPAINTER_OPAQUE = 1,
        HTMLPAINTER_OVERLAY = 16,
        HTMLPAINTER_SUPPORTS_XFORM = 32768,
        HTMLPAINTER_SURFACE = 256,
        HTMLPAINTER_TRANSPARENT = 2,
    }

    const enum _htmlAdjacency {
        htmlAdjacency_Max = 2147483647,
        htmlAdjacencyAfterBegin = 2,
        htmlAdjacencyAfterEnd = 4,
        htmlAdjacencyBeforeBegin = 1,
        htmlAdjacencyBeforeEnd = 3,
    }

    const enum _HTMLAppFlag {
        HTMLAppFlag_Max = 2147483647,
        HTMLAppFlag0 = 0,
        HTMLAppFlag1 = 1,
        HTMLAppFlagNo = 0,
        HTMLAppFlagOff = 0,
        HTMLAppFlagOn = 1,
        HTMLAppFlagYes = 1,
    }

    const enum _htmlApplyLocation {
        htmlApplyLocation_Max = 2147483647,
        htmlApplyLocationInside = 0,
        htmlApplyLocationOutside = 1,
    }

    const enum _htmlBlockAlign {
        htmlBlockAlign_Max = 2147483647,
        htmlBlockAlignCenter = 2,
        htmlBlockAlignJustify = 4,
        htmlBlockAlignLeft = 1,
        htmlBlockAlignNotSet = 0,
        htmlBlockAlignRight = 3,
    }

    const enum _HTMLBorder {
        HTMLBorder_Max = 2147483647,
        HTMLBorderDialog = 4194304,
        HTMLBorderNone = 0,
        HTMLBorderThick = 262144,
        HTMLBorderThin = 8388608,
    }

    const enum _HTMLBorderStyle {
        HTMLBorderStyle_Max = 2147483647,
        HTMLBorderStylecombined = 768,
        HTMLBorderStyleNormal = 0,
        HTMLBorderStyleRaised = 256,
        HTMLBorderStyleStatic = 131072,
        HTMLBorderStyleSunken = 512,
    }

    const enum _htmlCaptionAlign {
        htmlCaptionAlign_Max = 2147483647,
        htmlCaptionAlignBottom = 6,
        htmlCaptionAlignCenter = 2,
        htmlCaptionAlignJustify = 4,
        htmlCaptionAlignLeft = 1,
        htmlCaptionAlignNotSet = 0,
        htmlCaptionAlignRight = 3,
        htmlCaptionAlignTop = 5,
    }

    const enum _HTMLCaptionFlag {
        HTMLCaptionFlag_Max = 2147483647,
        HTMLCaptionFlagNo = 0,
        HTMLCaptionFlagYes = 12582912,
    }

    const enum _htmlCaptionVAlign {
        htmlCaptionVAlign_Max = 2147483647,
        htmlCaptionVAlignBottom = 2,
        htmlCaptionVAlignNotSet = 0,
        htmlCaptionVAlignTop = 1,
    }

    const enum _htmlCellAlign {
        htmlCellAlign_Max = 2147483647,
        htmlCellAlignCenter = 2,
        htmlCellAlignLeft = 1,
        htmlCellAlignMiddle = 2,
        htmlCellAlignNotSet = 0,
        htmlCellAlignRight = 3,
    }

    const enum _htmlCellVAlign {
        htmlCellVAlign_Max = 2147483647,
        htmlCellVAlignBaseline = 4,
        htmlCellVAlignBottom = 3,
        htmlCellVAlignCenter = 2,
        htmlCellVAlignMiddle = 2,
        htmlCellVAlignNotSet = 0,
        htmlCellVAlignTop = 1,
    }

    const enum _htmlClear {
        htmlClear_Max = 2147483647,
        htmlClearAll = 1,
        htmlClearBoth = 4,
        htmlClearLeft = 2,
        htmlClearNone = 5,
        htmlClearNotSet = 0,
        htmlClearRight = 3,
    }

    const enum _htmlCompatMode {
        htmlCompatMode_Max = 2147483647,
        htmlCompatModeBackCompat = 0,
        htmlCompatModeCSS1Compat = 1,
    }

    const enum _htmlComponent {
        htmlComponent_Max = 2147483647,
        htmlComponentClient = 0,
        htmlComponentGHBottom = 27,
        htmlComponentGHBottomLeft = 25,
        htmlComponentGHBottomRight = 29,
        htmlComponentGHLeft = 23,
        htmlComponentGHRight = 28,
        htmlComponentGHTop = 24,
        htmlComponentGHTopLeft = 22,
        htmlComponentGHTopRight = 26,
        htmlComponentOutside = 21,
        htmlComponentSbBottom = 20,
        htmlComponentSbDown = 10,
        htmlComponentSbDown2 = 17,
        htmlComponentSbHThumb = 3,
        htmlComponentSbLeft = 1,
        htmlComponentSbLeft2 = 11,
        htmlComponentSbPageDown = 9,
        htmlComponentSbPageDown2 = 18,
        htmlComponentSbPageLeft = 2,
        htmlComponentSbPageLeft2 = 12,
        htmlComponentSbPageRight = 4,
        htmlComponentSbPageRight2 = 14,
        htmlComponentSbPageUp = 7,
        htmlComponentSbPageUp2 = 16,
        htmlComponentSbRight = 5,
        htmlComponentSbRight2 = 13,
        htmlComponentSbTop = 19,
        htmlComponentSbUp = 6,
        htmlComponentSbUp2 = 15,
        htmlComponentSbVThumb = 8,
    }

    const enum _htmlControlAlign {
        htmlControlAlign_Max = 2147483647,
        htmlControlAlignAbsBottom = 7,
        htmlControlAlignAbsMiddle = 5,
        htmlControlAlignBaseline = 6,
        htmlControlAlignBottom = 8,
        htmlControlAlignCenter = 2,
        htmlControlAlignLeft = 1,
        htmlControlAlignMiddle = 9,
        htmlControlAlignNotSet = 0,
        htmlControlAlignRight = 3,
        htmlControlAlignTextTop = 4,
        htmlControlAlignTop = 10,
    }

    const enum _htmlDesignMode {
        htmlDesignMode_Max = 2147483647,
        htmlDesignModeInherit = -2,
        htmlDesignModeOff = 0,
        htmlDesignModeOn = -1,
    }

    const enum _htmlDir {
        htmlDir_Max = 2147483647,
        htmlDirLeftToRight = 1,
        htmlDirNotSet = 0,
        htmlDirRightToLeft = 2,
    }

    const enum _htmlDirection {
        htmlDirection_Max = 2147483647,
        htmlDirectionBackward = -99999,
        htmlDirectionForward = 99999,
    }

    const enum _HTMLDlgBorder {
        HTMLDlgBorder_Max = 2147483647,
        HTMLDlgBorderThick = 262144,
        HTMLDlgBorderThin = 0,
    }

    const enum _HTMLDlgCenter {
        HTMLDlgCenter_Max = 2147483647,
        HTMLDlgCenter0 = 0,
        HTMLDlgCenter1 = 1,
        HTMLDlgCenterDesktop = 2,
        HTMLDlgCenterNo = 0,
        HTMLDlgCenterOff = 0,
        HTMLDlgCenterOn = 1,
        HTMLDlgCenterParent = 1,
        HTMLDlgCenterYes = 1,
    }

    const enum _HTMLDlgEdge {
        HTMLDlgEdge_Max = 2147483647,
        HTMLDlgEdgeRaised = 16,
        HTMLDlgEdgeSunken = 0,
    }

    const enum _HTMLDlgFlag {
        HTMLDlgFlag_Max = 2147483647,
        HTMLDlgFlag0 = 0,
        HTMLDlgFlag1 = 1,
        HTMLDlgFlagNo = 0,
        HTMLDlgFlagNotSet = -1,
        HTMLDlgFlagOff = 0,
        HTMLDlgFlagOn = 1,
        HTMLDlgFlagYes = 1,
    }

    const enum _htmlDraggable {
        htmlDraggable_Max = 2147483647,
        htmlDraggableAuto = 0,
        htmlDraggableFalse = 2,
        htmlDraggableTrue = 1,
    }

    const enum _htmlDropEffect {
        htmlDropEffect_Max = 2147483647,
        htmlDropEffectCopy = 0,
        htmlDropEffectLink = 1,
        htmlDropEffectMove = 2,
        htmlDropEffectNone = 3,
    }

    const enum _htmlEditable {
        htmlEditable_Max = 2147483647,
        htmlEditableFalse = 2,
        htmlEditableInherit = 0,
        htmlEditableTrue = 1,
    }

    const enum _htmlEffectAllowed {
        htmlEffectAllowed_Max = 2147483647,
        htmlEffectAllowedAll = 6,
        htmlEffectAllowedCopy = 0,
        htmlEffectAllowedCopyLink = 3,
        htmlEffectAllowedCopyMove = 4,
        htmlEffectAllowedLink = 1,
        htmlEffectAllowedLinkMove = 5,
        htmlEffectAllowedMove = 2,
        htmlEffectAllowedNone = 7,
        htmlEffectAllowedUninitialized = 8,
    }

    const enum _htmlEncoding {
        htmlEncoding_Max = 2147483647,
        htmlEncodingMultipart = 1,
        htmlEncodingText = 2,
        htmlEncodingURL = 0,
    }

    const enum _htmlEndPoints {
        htmlEndPoints_Max = 2147483647,
        htmlEndPointsEndToEnd = 4,
        htmlEndPointsEndToStart = 3,
        htmlEndPointsStartToEnd = 2,
        htmlEndPointsStartToStart = 1,
    }

    const enum _htmlFrame {
        htmlFrame_Max = 2147483647,
        htmlFrameabove = 2,
        htmlFramebelow = 3,
        htmlFrameborder = 9,
        htmlFramebox = 8,
        htmlFramehsides = 4,
        htmlFramelhs = 5,
        htmlFrameNotSet = 0,
        htmlFramerhs = 6,
        htmlFramevoid = 1,
        htmlFramevsides = 7,
    }

    const enum _htmlGlyphMode {
        htmlGlyphMode_Max = 2147483647,
        htmlGlyphModeBegin = 1,
        htmlGlyphModeBoth = 3,
        htmlGlyphModeEnd = 2,
        htmlGlyphModeNone = 0,
    }

    const enum _htmlInput {
        htmlInput_Max = 2147483647,
        htmlInputButton = 1,
        htmlInputCheckbox = 2,
        htmlInputEmail = 17,
        htmlInputFile = 3,
        htmlInputHidden = 4,
        htmlInputImage = 5,
        htmlInputNotSet = 0,
        htmlInputNumber = 18,
        htmlInputPassword = 6,
        htmlInputRadio = 7,
        htmlInputRange = 15,
        htmlInputReset = 8,
        htmlInputRichtext = 14,
        htmlInputSearch = 20,
        htmlInputSelectMultiple = 10,
        htmlInputSelectOne = 9,
        htmlInputSubmit = 11,
        htmlInputTel = 19,
        htmlInputText = 12,
        htmlInputTextarea = 13,
        htmlInputUrl = 16,
    }

    const enum _htmlListType {
        htmlListType_Max = 2147483647,
        htmlListTypeCircle = 7,
        htmlListTypeDisc = 6,
        htmlListTypeLargeAlpha = 1,
        htmlListTypeLargeRoman = 3,
        htmlListTypeNotSet = 0,
        htmlListTypeNumbers = 5,
        htmlListTypeSmallAlpha = 2,
        htmlListTypeSmallRoman = 4,
        htmlListTypeSquare = 8,
    }

    const enum _htmlLoop {
        htmlLoop_Max = 2147483647,
        htmlLoopLoopInfinite = -1,
    }

    const enum _htmlMarqueeBehavior {
        htmlMarqueeBehavior_Max = 2147483647,
        htmlMarqueeBehavioralternate = 3,
        htmlMarqueeBehaviorscroll = 1,
        htmlMarqueeBehaviorslide = 2,
    }

    const enum _htmlMarqueeDirection {
        htmlMarqueeDirection_Max = 2147483647,
        htmlMarqueeDirectiondown = 7,
        htmlMarqueeDirectionleft = 1,
        htmlMarqueeDirectionright = 3,
        htmlMarqueeDirectionup = 5,
    }

    const enum _HTMLMaximizeFlag {
        HTMLMaximizeFlag_Max = 2147483647,
        HTMLMaximizeFlagNo = 0,
        HTMLMaximizeFlagYes = 65536,
    }

    const enum _htmlMediaErr {
        htmlMediaErr_Max = 2147483647,
        htmlMediaErrAborted = 0,
        htmlMediaErrDecode = 2,
        htmlMediaErrNetwork = 1,
        htmlMediaErrSrcNotSupported = 3,
    }

    const enum _htmlMediaNetworkState {
        htmlMediaNetworkState_Max = 2147483647,
        htmlMediaNetworkStateEmpty = 0,
        htmlMediaNetworkStateIdle = 1,
        htmlMediaNetworkStateLoading = 2,
        htmlMediaNetworkStateNoSource = 3,
    }

    const enum _htmlMediaReadyState {
        htmlMediaReadyState_Max = 2147483647,
        htmlMediaReadyStateHaveCurrentData = 2,
        htmlMediaReadyStateHaveEnoughData = 4,
        htmlMediaReadyStateHaveFutureData = 3,
        htmlMediaReadyStateHaveMetadata = 1,
        htmlMediaReadyStateHaveNothing = 0,
    }

    const enum _htmlMethod {
        htmlMethod_Max = 2147483647,
        htmlMethodGet = 1,
        htmlMethodNotSet = 0,
        htmlMethodPost = 2,
    }

    const enum _HTMLMinimizeFlag {
        HTMLMinimizeFlag_Max = 2147483647,
        HTMLMinimizeFlagNo = 0,
        HTMLMinimizeFlagYes = 131072,
    }

    const enum _htmlPersistState {
        htmlPersistState_Max = 2147483647,
        htmlPersistStateFavorite = 1,
        htmlPersistStateHistory = 2,
        htmlPersistStateNormal = 0,
        htmlPersistStateSnapshot = 3,
        htmlPersistStateUserData = 4,
    }

    const enum _htmlReadyState {
        htmlReadyState_Max = 2147483647,
        htmlReadyStatecomplete = 4,
        htmlReadyStateinteractive = 3,
        htmlReadyStateloaded = 2,
        htmlReadyStateloading = 1,
        htmlReadyStateuninitialized = 0,
    }

    const enum _htmlRules {
        htmlRules_Max = 2147483647,
        htmlRulesall = 5,
        htmlRulescols = 4,
        htmlRulesgroups = 2,
        htmlRulesnone = 1,
        htmlRulesNotSet = 0,
        htmlRulesrows = 3,
    }

    const enum _htmlSelectExFlag {
        htmlSelectExFlag_Max = 2147483647,
        htmlSelectExFlagHideSelectionInDesign = 1,
        htmlSelectExFlagNone = 0,
    }

    const enum _htmlSelection {
        htmlSelection_Max = 2147483647,
        htmlSelectionControl = 2,
        htmlSelectionNone = 0,
        htmlSelectionTable = 3,
        htmlSelectionText = 1,
    }

    const enum _htmlSelectType {
        htmlSelectType_Max = 2147483647,
        htmlSelectTypeSelectMultiple = 2,
        htmlSelectTypeSelectOne = 1,
    }

    const enum _htmlSpellCheck {
        htmlSpellCheck_Max = 2147483647,
        htmlSpellCheckDefault = 3,
        htmlSpellCheckFalse = 2,
        htmlSpellCheckNotSet = 0,
        htmlSpellCheckTrue = 1,
    }

    const enum _htmlStart {
        htmlStart_Max = 2147483647,
        htmlStartfileopen = 0,
        htmlStartmouseover = 1,
    }

    const enum _HTMLSysMenuFlag {
        HTMLSysMenuFlag_Max = 2147483647,
        HTMLSysMenuFlagNo = 0,
        HTMLSysMenuFlagYes = 524288,
    }

    const enum _htmlTabIndex {
        htmlTabIndex_Max = 2147483647,
        htmlTabIndexNotSet = -32768,
    }

    const enum _htmlUnit {
        htmlUnit_Max = 2147483647,
        htmlUnitCharacter = 1,
        htmlUnitSentence = 3,
        htmlUnitTextEdit = 6,
        htmlUnitWord = 2,
    }

    const enum _HTMLWindowState {
        HTMLWindowState_Max = 2147483647,
        HTMLWindowStateMaximize = 3,
        HTMLWindowStateMinimize = 6,
        HTMLWindowStateNormal = 1,
    }

    const enum _htmlWrap {
        htmlWrap_Max = 2147483647,
        htmlWrapHard = 3,
        htmlWrapOff = 1,
        htmlWrapSoft = 2,
    }

    const enum _htmlZOrder {
        htmlZOrder_Max = 2147483647,
        htmlZOrderBack = 1,
        htmlZOrderFront = 0,
    }

    const enum _lengthAdjust {
        lengthAdjust_Max = 2147483647,
        LENGTHADJUST_SPACING = 1,
        LENGTHADJUST_SPACINGANDGLYPHS = 2,
        LENGTHADJUST_UNKNOWN = 0,
    }

    const enum _LINE_DIRECTION {
        LINE_DIRECTION_LeftToRight = 2,
        LINE_DIRECTION_Max = 2147483647,
        LINE_DIRECTION_RightToLeft = 1,
    }

    const enum _MARKUP_CONTEXT_TYPE {
        CONTEXT_TYPE_EnterScope = 2,
        CONTEXT_TYPE_ExitScope = 3,
        CONTEXT_TYPE_None = 0,
        CONTEXT_TYPE_NoScope = 4,
        CONTEXT_TYPE_Text = 1,
        MARKUP_CONTEXT_TYPE_Max = 2147483647,
    }

    const enum _mediaType {
        mediaType_Max = 2147483647,
        mediaTypeAll = 511,
        mediaTypeAural = 1,
        mediaTypeBraille = 2,
        mediaTypeEmbossed = 4,
        mediaTypeHandheld = 8,
        mediaTypeNotSet = 0,
        mediaTypePrint = 16,
        mediaTypeProjection = 32,
        mediaTypeScreen = 64,
        mediaTypeTty = 128,
        mediaTypeTv = 256,
    }

    const enum _MOVEUNIT_ACTION {
        MOVEUNIT_ACTION_Max = 2147483647,
        MOVEUNIT_NEXTBLOCK = 19,
        MOVEUNIT_NEXTCHAR = 1,
        MOVEUNIT_NEXTCLUSTERBEGIN = 3,
        MOVEUNIT_NEXTCLUSTEREND = 5,
        MOVEUNIT_NEXTPROOFWORD = 11,
        MOVEUNIT_NEXTSENTENCE = 17,
        MOVEUNIT_NEXTURLBEGIN = 12,
        MOVEUNIT_NEXTURLEND = 14,
        MOVEUNIT_NEXTWORDBEGIN = 7,
        MOVEUNIT_NEXTWORDEND = 9,
        MOVEUNIT_PREVBLOCK = 18,
        MOVEUNIT_PREVCHAR = 0,
        MOVEUNIT_PREVCLUSTERBEGIN = 2,
        MOVEUNIT_PREVCLUSTEREND = 4,
        MOVEUNIT_PREVPROOFWORD = 10,
        MOVEUNIT_PREVSENTENCE = 16,
        MOVEUNIT_PREVURLBEGIN = 13,
        MOVEUNIT_PREVURLEND = 15,
        MOVEUNIT_PREVWORDBEGIN = 6,
        MOVEUNIT_PREVWORDEND = 8,
    }

    const enum _PARSE_FLAGS {
        PARSE_ABSOLUTIFYIE40URLS = 1,
        PARSE_DISABLEVML = 2,
        PARSE_FLAGS_Max = 2147483647,
    }

    const enum _POINTER_GRAVITY {
        POINTER_GRAVITY_Left = 0,
        POINTER_GRAVITY_Max = 2147483647,
        POINTER_GRAVITY_Right = 1,
    }

    const enum _sandboxAllow {
        sandboxAllow_Max = 2147483647,
        sandboxAllowForms = 3,
        sandboxAllowPopups = 4,
        sandboxAllowSameOrigin = 1,
        sandboxAllowScripts = 0,
        sandboxAllowTopNavigation = 2,
    }

    const enum _SAVE_SEGMENTS_FLAGS {
        SAVE_SEGMENTS_FLAGS_Max = 2147483647,
        SAVE_SEGMENTS_NoIE4SelectionCompat = 1,
    }

    const enum _SCRIPT_TIMER_TYPE {
        SCRIPT_TIMER_TYPE_Max = 2147483647,
        STT_ANIMATION_FRAME = 3,
        STT_IMMEDIATE = 2,
        STT_INTERVAL = 1,
        STT_TIMEOUT = 0,
    }

    const enum _SECUREURLHOSTVALIDATE_FLAGS {
        SECUREURLHOSTVALIDATE_FLAGS_Max = 2147483647,
        SUHV_PROMPTBEFORENO = 1,
        SUHV_SILENTYES = 2,
        SUHV_UNSECURESOURCE = 4,
    }

    const enum _SELECTION_TYPE {
        SELECTION_TYPE_Caret = 1,
        SELECTION_TYPE_Control = 3,
        SELECTION_TYPE_Max = 2147483647,
        SELECTION_TYPE_None = 0,
        SELECTION_TYPE_Text = 2,
    }

    const enum _styleAccelerator {
        styleAccelerator_Max = 2147483647,
        styleAcceleratorFalse = 0,
        styleAcceleratorTrue = 1,
    }

    const enum _styleAlignContent {
        styleAlignContent_Max = 2147483647,
        styleAlignContentCenter = 2,
        styleAlignContentFlexEnd = 1,
        styleAlignContentFlexStart = 0,
        styleAlignContentNotSet = 6,
        styleAlignContentSpaceAround = 4,
        styleAlignContentSpaceBetween = 3,
        styleAlignContentStretch = 5,
    }

    const enum _styleAlignItems {
        styleAlignItems_Max = 2147483647,
        styleAlignItemsBaseline = 3,
        styleAlignItemsCenter = 2,
        styleAlignItemsFlexEnd = 1,
        styleAlignItemsFlexStart = 0,
        styleAlignItemsNotSet = 5,
        styleAlignItemsStretch = 4,
    }

    const enum _styleAlignmentBaseline {
        styleAlignmentBaseline_Max = 2147483647,
        styleAlignmentBaselineAfterEdge = 1,
        styleAlignmentBaselineAlphabetic = 2,
        styleAlignmentBaselineAuto = 3,
        styleAlignmentBaselineBaseline = 4,
        styleAlignmentBaselineBeforeEdge = 5,
        styleAlignmentBaselineCentral = 6,
        styleAlignmentBaselineHanging = 7,
        styleAlignmentBaselineIdeographic = 12,
        styleAlignmentBaselineMathematical = 8,
        styleAlignmentBaselineMiddle = 9,
        styleAlignmentBaselineNotSet = 0,
        styleAlignmentBaselineTextAfterEdge = 10,
        styleAlignmentBaselineTextBeforeEdge = 11,
    }

    const enum _styleAlignSelf {
        styleAlignSelf_Max = 2147483647,
        styleAlignSelfAuto = 5,
        styleAlignSelfBaseline = 3,
        styleAlignSelfCenter = 2,
        styleAlignSelfFlexEnd = 1,
        styleAlignSelfFlexStart = 0,
        styleAlignSelfNotSet = 6,
        styleAlignSelfStretch = 4,
    }

    const enum _styleAttrType {
        styleAttrType_Max = 2147483647,
        styleAttrTypeAngle = 20,
        styleAttrTypeCh = 15,
        styleAttrTypeCm = 10,
        styleAttrTypeColor = 1,
        styleAttrTypeDeg = 21,
        styleAttrTypeEm = 7,
        styleAttrTypeEx = 8,
        styleAttrTypeGrad = 23,
        styleAttrTypeIn = 9,
        styleAttrTypeInteger = 3,
        styleAttrTypeLength = 5,
        styleAttrTypeMm = 11,
        styleAttrTypeMs = 26,
        styleAttrTypeNumber = 4,
        styleAttrTypePc = 13,
        styleAttrTypePercentage = 19,
        styleAttrTypePt = 12,
        styleAttrTypePx = 6,
        styleAttrTypeRad = 22,
        styleAttrTypeRem = 14,
        styleAttrTypeS = 25,
        styleAttrTypeString = 0,
        styleAttrTypeTime = 24,
        styleAttrTypeUrl = 2,
        styleAttrTypeVh = 16,
        styleAttrTypeVmin = 18,
        styleAttrTypeVw = 17,
    }

    const enum _styleAuto {
        styleAuto_Max = 2147483647,
        styleAutoAuto = 0,
    }

    const enum _styleBackfaceVisibility {
        styleBackfaceVisibility_Max = 2147483647,
        styleBackfaceVisibilityHidden = 1,
        styleBackfaceVisibilityNotSet = 2,
        styleBackfaceVisibilityVisible = 0,
    }

    const enum _styleBackgroundAttachment {
        styleBackgroundAttachment_Max = 2147483647,
        styleBackgroundAttachmentFixed = 0,
        styleBackgroundAttachmentNotSet = 2,
        styleBackgroundAttachmentScroll = 1,
    }

    const enum _styleBackgroundAttachment3 {
        styleBackgroundAttachment3_Max = 2147483647,
        styleBackgroundAttachment3Fixed = 0,
        styleBackgroundAttachment3Local = 2,
        styleBackgroundAttachment3NotSet = 3,
        styleBackgroundAttachment3Scroll = 1,
    }

    const enum _styleBackgroundClip {
        styleBackgroundClip_Max = 2147483647,
        styleBackgroundClipBorderBox = 0,
        styleBackgroundClipContentBox = 2,
        styleBackgroundClipNotSet = 3,
        styleBackgroundClipPaddingBox = 1,
    }

    const enum _styleBackgroundOrigin {
        styleBackgroundOrigin_Max = 2147483647,
        styleBackgroundOriginBorderBox = 0,
        styleBackgroundOriginContentBox = 2,
        styleBackgroundOriginNotSet = 3,
        styleBackgroundOriginPaddingBox = 1,
    }

    const enum _styleBackgroundRepeat {
        styleBackgroundRepeat_Max = 2147483647,
        styleBackgroundRepeatNoRepeat = 3,
        styleBackgroundRepeatNotSet = 4,
        styleBackgroundRepeatRepeat = 0,
        styleBackgroundRepeatRepeatX = 1,
        styleBackgroundRepeatRepeatY = 2,
    }

    const enum _styleBaselineShift {
        styleBaselineShift_Max = 2147483647,
        styleBaselineShiftBaseline = 0,
        styleBaselineShiftSub = 1,
        styleBaselineShiftSuper = 2,
    }

    const enum _styleBidi {
        styleBidi_Max = 2147483647,
        styleBidiEmbed = 2,
        styleBidiInherit = 4,
        styleBidiNormal = 1,
        styleBidiNotSet = 0,
        styleBidiOverride = 3,
    }

    const enum _styleBlockProgression {
        styleBlockProgression_Max = 2147483647,
        styleBlockProgressionBt = 2,
        styleBlockProgressionLr = 3,
        styleBlockProgressionNotSet = 4,
        styleBlockProgressionRl = 1,
        styleBlockProgressionTb = 0,
    }

    const enum _styleBool {
        styleBool_Max = 2147483647,
        styleBoolFalse = 0,
        styleBoolTrue = 1,
    }

    const enum _styleBorderCollapse {
        styleBorderCollapse_Max = 2147483647,
        styleBorderCollapseCollapse = 2,
        styleBorderCollapseNotSet = 0,
        styleBorderCollapseSeparate = 1,
    }

    const enum _styleBorderImageRepeat {
        styleBorderImageRepeat_Max = 2147483647,
        styleBorderImageRepeatNotSet = 4,
        styleBorderImageRepeatRepeat = 1,
        styleBorderImageRepeatRound = 2,
        styleBorderImageRepeatSpace = 3,
        styleBorderImageRepeatStretch = 0,
    }

    const enum _styleBorderImageSliceFill {
        styleBorderImageSliceFill_Max = 2147483647,
        styleBorderImageSliceFillFill = 1,
        styleBorderImageSliceFillNotSet = 0,
    }

    const enum _styleBorderStyle {
        styleBorderStyle_Max = 2147483647,
        styleBorderStyleDashed = 2,
        styleBorderStyleDotted = 1,
        styleBorderStyleDouble = 4,
        styleBorderStyleGroove = 5,
        styleBorderStyleHidden = 11,
        styleBorderStyleInset = 7,
        styleBorderStyleNone = 10,
        styleBorderStyleNotSet = 0,
        styleBorderStyleOutset = 8,
        styleBorderStyleRidge = 6,
        styleBorderStyleSolid = 3,
        styleBorderStyleWindowInset = 9,
    }

    const enum _styleBorderWidth {
        styleBorderWidth_Max = 2147483647,
        styleBorderWidthMedium = 1,
        styleBorderWidthThick = 2,
        styleBorderWidthThin = 0,
    }

    const enum _styleBoxSizing {
        styleBoxSizing_Max = 2147483647,
        styleBoxSizingBorderBox = 2,
        styleBoxSizingContentBox = 1,
        styleBoxSizingNotSet = 0,
    }

    const enum _styleBreak {
        styleBreak_Max = 2147483647,
        styleBreakAlways = 2,
        styleBreakAuto = 1,
        styleBreakAvoid = 3,
        styleBreakAvoidColumn = 9,
        styleBreakAvoidPage = 8,
        styleBreakColumn = 7,
        styleBreakLeft = 4,
        styleBreakNotSet = 0,
        styleBreakPage = 6,
        styleBreakRight = 5,
    }

    const enum _styleBreakInside {
        styleBreakInside_Max = 2147483647,
        styleBreakInsideAuto = 1,
        styleBreakInsideAvoid = 2,
        styleBreakInsideAvoidColumn = 4,
        styleBreakInsideAvoidPage = 3,
        styleBreakInsideNotSet = 0,
    }

    const enum _styleCaptionSide {
        styleCaptionSide_Max = 2147483647,
        styleCaptionSideBottom = 2,
        styleCaptionSideLeft = 3,
        styleCaptionSideNotSet = 0,
        styleCaptionSideRight = 4,
        styleCaptionSideTop = 1,
    }

    const enum _styleClipRule {
        styleClipRule_Max = 2147483647,
        styleClipRuleEvenOdd = 2,
        styleClipRuleNonZero = 1,
        styleClipRuleNotSet = 0,
    }

    const enum _styleColorInterpolationFilters {
        styleColorInterpolationFilters_Max = 2147483647,
        styleColorInterpolationFiltersAuto = 0,
        styleColorInterpolationFiltersLinearRgb = 2,
        styleColorInterpolationFiltersNotSet = 3,
        styleColorInterpolationFiltersSRgb = 1,
    }

    const enum _styleColumnFill {
        styleColumnFill_Max = 2147483647,
        styleColumnFillAuto = 0,
        styleColumnFillBalance = 1,
        styleColumnFillNotSet = 2,
    }

    const enum _styleColumnSpan {
        styleColumnSpan_Max = 2147483647,
        styleColumnSpanAll = 1,
        styleColumnSpanNone = 0,
        styleColumnSpanNotSet = 3,
        styleColumnSpanOne = 2,
    }

    const enum _styleCursor {
        styleCursor_Max = 2147483647,
        styleCursorAlias = 32,
        styleCursorall_scroll = 21,
        styleCursorAuto = 0,
        styleCursorCell = 30,
        styleCursorcol_resize = 22,
        styleCursorContext_menu = 25,
        styleCursorCopy = 31,
        styleCursorCrosshair = 1,
        styleCursorcustom = 33,
        styleCursorDefault = 2,
        styleCursorE_resize = 5,
        styleCursorEw_resize = 26,
        styleCursorHand = 3,
        styleCursorHelp = 15,
        styleCursorMove = 4,
        styleCursorN_resize = 8,
        styleCursorNe_resize = 6,
        styleCursorNesw_resize = 28,
        styleCursorNo_drop = 19,
        styleCursorNone = 24,
        styleCursorNot_allowed = 18,
        styleCursorNotSet = 34,
        styleCursorNs_resize = 27,
        styleCursorNw_resize = 7,
        styleCursorNwse_resize = 29,
        styleCursorPointer = 16,
        styleCursorProgress = 17,
        styleCursorrow_resize = 23,
        styleCursorS_resize = 11,
        styleCursorSe_resize = 9,
        styleCursorSw_resize = 10,
        styleCursorText = 13,
        styleCursorVertical_text = 20,
        styleCursorW_resize = 12,
        styleCursorWait = 14,
    }

    const enum _styleDataRepeat {
        styleDataRepeat_Max = 2147483647,
        styleDataRepeatInner = 1,
        styleDataRepeatNone = 0,
    }

    const enum _styleDefaultTextSelection {
        styleDefaultTextSelection_Max = 2147483647,
        styleDefaultTextSelectionFalse = 0,
        styleDefaultTextSelectionTrue = 1,
    }

    const enum _styleDir {
        styleDir_Max = 2147483647,
        styleDirInherit = 3,
        styleDirLeftToRight = 1,
        styleDirNotSet = 0,
        styleDirRightToLeft = 2,
    }

    const enum _styleDisplay {
        styleDisplay_Max = 2147483647,
        styleDisplayBlock = 1,
        styleDisplayFlex = 26,
        styleDisplayInline = 2,
        styleDisplayInlineBlock = 7,
        styleDisplayInlineFlex = 27,
        styleDisplayInlineTable = 9,
        styleDisplayListItem = 3,
        styleDisplayMsFlexbox = 22,
        styleDisplayMsGrid = 24,
        styleDisplayMsInlineFlexbox = 23,
        styleDisplayMsInlineGrid = 25,
        styleDisplayNone = 4,
        styleDisplayNotSet = 0,
        styleDisplayRuby = 17,
        styleDisplayRubyBase = 18,
        styleDisplayRubyBaseContainer = 20,
        styleDisplayRubyText = 19,
        styleDisplayRubyTextContainer = 21,
        styleDisplayRunIn = 16,
        styleDisplayTable = 8,
        styleDisplayTableCaption = 15,
        styleDisplayTableCell = 14,
        styleDisplayTableColumn = 12,
        styleDisplayTableColumnGroup = 13,
        styleDisplayTableFooterGroup = 6,
        styleDisplayTableHeaderGroup = 5,
        styleDisplayTableRow = 10,
        styleDisplayTableRowGroup = 11,
        styleDisplayWebkitBox = 28,
        styleDisplayWebkitInlineBox = 29,
    }

    const enum _styleDominantBaseline {
        styleDominantBaseline_Max = 2147483647,
        styleDominantBaselineAlphabetic = 1,
        styleDominantBaselineAuto = 2,
        styleDominantBaselineCentral = 3,
        styleDominantBaselineHanging = 4,
        styleDominantBaselineIdeographic = 5,
        styleDominantBaselineMathematical = 6,
        styleDominantBaselineMiddle = 7,
        styleDominantBaselineNoChange = 8,
        styleDominantBaselineNotSet = 0,
        styleDominantBaselineResetSize = 9,
        styleDominantBaselineTextAfterEdge = 10,
        styleDominantBaselineTextBeforeEdge = 11,
        styleDominantBaselineUseScript = 12,
    }

    const enum _styleEmptyCells {
        styleEmptyCells_Max = 2147483647,
        styleEmptyCellsHide = 2,
        styleEmptyCellsNotSet = 0,
        styleEmptyCellsShow = 1,
    }

    const enum _styleEnableBackground {
        styleEnableBackground_Max = 2147483647,
        styleEnableBackgroundAccumulate = 1,
        styleEnableBackgroundInherit = 3,
        styleEnableBackgroundNew = 2,
        styleEnableBackgroundNotSet = 0,
    }

    const enum _styleFillRule {
        styleFillRule_Max = 2147483647,
        styleFillRuleEvenOdd = 2,
        styleFillRuleNonZero = 1,
        styleFillRuleNotSet = 0,
    }

    const enum _styleFlex {
        styleFlex_Max = 2147483647,
        styleFlexNone = 0,
        styleFlexNotSet = 1,
    }

    const enum _styleFlexBasis {
        styleFlexBasis_Max = 2147483647,
        styleFlexBasisAuto = 0,
        styleFlexBasisNotSet = 1,
    }

    const enum _styleFlexDirection {
        styleFlexDirection_Max = 2147483647,
        styleFlexDirectionColumn = 2,
        styleFlexDirectionColumnReverse = 3,
        styleFlexDirectionNotSet = 4,
        styleFlexDirectionRow = 0,
        styleFlexDirectionRowReverse = 1,
    }

    const enum _styleFlexWrap {
        styleFlexWrap_Max = 2147483647,
        styleFlexWrapNotSet = 3,
        styleFlexWrapNowrap = 0,
        styleFlexWrapWrap = 1,
        styleFlexWrapWrapReverse = 2,
    }

    const enum _styleFontSize {
        styleFontSize_Max = 2147483647,
        styleFontSizeLarge = 4,
        styleFontSizeLarger = 8,
        styleFontSizeMedium = 3,
        styleFontSizeSmall = 2,
        styleFontSizeSmaller = 7,
        styleFontSizeXLarge = 5,
        styleFontSizeXSmall = 1,
        styleFontSizeXXLarge = 6,
        styleFontSizeXXSmall = 0,
    }

    const enum _styleFontStretch {
        styleFontStretch_Max = 2147483647,
        styleFontStretchCondensed = 5,
        styleFontStretchExpanded = 9,
        styleFontStretchExtraCondensed = 4,
        styleFontStretchExtraExpanded = 10,
        styleFontStretchNarrower = 2,
        styleFontStretchNormal = 7,
        styleFontStretchNotSet = 0,
        styleFontStretchSemiCondensed = 6,
        styleFontStretchSemiExpanded = 8,
        styleFontStretchUltraCondensed = 3,
        styleFontStretchUltraExpanded = 11,
        styleFontStretchWider = 1,
    }

    const enum _styleFontStyle {
        styleFontStyle_Max = 2147483647,
        styleFontStyleItalic = 1,
        styleFontStyleNormal = 3,
        styleFontStyleNotSet = 0,
        styleFontStyleOblique = 2,
    }

    const enum _styleFontVariant {
        styleFontVariant_Max = 2147483647,
        styleFontVariantNormal = 2,
        styleFontVariantNotSet = 0,
        styleFontVariantSmallCaps = 1,
    }

    const enum _styleFontWeight {
        styleFontWeight_Max = 2147483647,
        styleFontWeight100 = 1,
        styleFontWeight200 = 2,
        styleFontWeight300 = 3,
        styleFontWeight400 = 4,
        styleFontWeight500 = 5,
        styleFontWeight600 = 6,
        styleFontWeight700 = 7,
        styleFontWeight800 = 8,
        styleFontWeight900 = 9,
        styleFontWeightBold = 11,
        styleFontWeightBolder = 12,
        styleFontWeightLighter = 13,
        styleFontWeightNormal = 10,
        styleFontWeightNotSet = 0,
    }

    const enum _styleGridColumn {
        styleGridColumn_Max = 2147483647,
        styleGridColumnNotSet = 0,
    }

    const enum _styleGridColumnAlign {
        styleGridColumnAlign_Max = 2147483647,
        styleGridColumnAlignCenter = 0,
        styleGridColumnAlignEnd = 1,
        styleGridColumnAlignNotSet = 4,
        styleGridColumnAlignStart = 2,
        styleGridColumnAlignStretch = 3,
    }

    const enum _styleGridColumnSpan {
        styleGridColumnSpan_Max = 2147483647,
        styleGridColumnSpanNotSet = 0,
    }

    const enum _styleGridRow {
        styleGridRow_Max = 2147483647,
        styleGridRowNotSet = 0,
    }

    const enum _styleGridRowAlign {
        styleGridRowAlign_Max = 2147483647,
        styleGridRowAlignCenter = 0,
        styleGridRowAlignEnd = 1,
        styleGridRowAlignNotSet = 4,
        styleGridRowAlignStart = 2,
        styleGridRowAlignStretch = 3,
    }

    const enum _styleGridRowSpan {
        styleGridRowSpan_Max = 2147483647,
        styleGridRowSpanNotSet = 0,
    }

    const enum _styleHyphenateLimitLines {
        styleHyphenateLimitLines_Max = 2147483647,
        styleHyphenateLimitLinesNoLimit = 0,
    }

    const enum _styleHyphens {
        styleHyphens_Max = 2147483647,
        styleHyphensAuto = 2,
        styleHyphensManual = 1,
        styleHyphensNone = 0,
        styleHyphensNotSet = 3,
    }

    const enum _styleImeMode {
        styleImeMode_Max = 2147483647,
        styleImeModeActive = 1,
        styleImeModeAuto = 0,
        styleImeModeDisabled = 3,
        styleImeModeInactive = 2,
        styleImeModeNotSet = 4,
    }

    const enum _styleInitialColor {
        styleInitialColor_Max = 2147483647,
        styleInitialColorColorProperty = 1,
        styleInitialColorInvert = 3,
        styleInitialColorNoInitial = 0,
        styleInitialColorTransparent = 2,
    }

    const enum _styleInitialString {
        styleInitialString_Max = 2147483647,
        styleInitialStringAuto = 2,
        styleInitialStringNoInitial = 0,
        styleInitialStringNone = 1,
        styleInitialStringNormal = 3,
    }

    const enum _styleInterpolation {
        styleInterpolation_Max = 2147483647,
        styleInterpolationBCH = 2,
        styleInterpolationNN = 1,
        styleInterpolationNotSet = 0,
    }

    const enum _styleJustifyContent {
        styleJustifyContent_Max = 2147483647,
        styleJustifyContentCenter = 2,
        styleJustifyContentFlexEnd = 1,
        styleJustifyContentFlexStart = 0,
        styleJustifyContentNotSet = 5,
        styleJustifyContentSpaceAround = 4,
        styleJustifyContentSpaceBetween = 3,
    }

    const enum _styleLayoutFlow {
        styleLayoutFlow_Max = 2147483647,
        styleLayoutFlowHorizontal = 0,
        styleLayoutFlowNotSet = 2,
        styleLayoutFlowVerticalIdeographic = 1,
    }

    const enum _styleLayoutGridChar {
        styleLayoutGridChar_Max = 2147483647,
        styleLayoutGridCharAuto = 1,
        styleLayoutGridCharNone = 2,
        styleLayoutGridCharNotSet = 0,
    }

    const enum _styleLayoutGridLine {
        styleLayoutGridLine_Max = 2147483647,
        styleLayoutGridLineAuto = 1,
        styleLayoutGridLineNone = 2,
        styleLayoutGridLineNotSet = 0,
    }

    const enum _styleLayoutGridMode {
        styleLayoutGridMode_Max = 2147483647,
        styleLayoutGridModeBoth = 3,
        styleLayoutGridModeChar = 1,
        styleLayoutGridModeLine = 2,
        styleLayoutGridModeNone = 4,
        styleLayoutGridModeNotSet = 0,
    }

    const enum _styleLayoutGridType {
        styleLayoutGridType_Max = 2147483647,
        styleLayoutGridTypeFixed = 3,
        styleLayoutGridTypeLoose = 1,
        styleLayoutGridTypeNotSet = 0,
        styleLayoutGridTypeStrict = 2,
    }

    const enum _styleLineBreak {
        styleLineBreak_Max = 2147483647,
        styleLineBreakNormal = 1,
        styleLineBreakNotSet = 0,
        styleLineBreakStrict = 2,
    }

    const enum _styleListStylePosition {
        styleListStylePosition_Max = 2147483647,
        styleListStylePositionInside = 1,
        styleListStylePositionNotSet = 0,
        styleListStylePositionOutSide = 2,
    }

    const enum _styleListStyleType {
        styleListStyleType_Max = 2147483647,
        styleListStyleTypeArmenian = 12,
        styleListStyleTypeCircle = 2,
        styleListStyleTypeDecimal = 4,
        styleListStyleTypeDecimalLeadingZero = 10,
        styleListStyleTypeDisc = 1,
        styleListStyleTypeGeorgian = 11,
        styleListStyleTypeLowerAlpha = 7,
        styleListStyleTypeLowerGreek = 16,
        styleListStyleTypeLowerLatin = 14,
        styleListStyleTypeLowerRoman = 5,
        styleListStyleTypeNone = 9,
        styleListStyleTypeNotSet = 0,
        styleListStyleTypeSquare = 3,
        styleListStyleTypeUpperAlpha = 8,
        styleListStyleTypeUpperGreek = 15,
        styleListStyleTypeUpperLatin = 13,
        styleListStyleTypeUpperRoman = 6,
    }

    const enum _styleMsAnimationDirection {
        styleMsAnimationDirection_Max = 2147483647,
        styleMsAnimationDirectionAlternate = 1,
        styleMsAnimationDirectionAlternateReverse = 3,
        styleMsAnimationDirectionNormal = 0,
        styleMsAnimationDirectionNotSet = 4,
        styleMsAnimationDirectionReverse = 2,
    }

    const enum _styleMsAnimationFillMode {
        styleMsAnimationFillMode_Max = 2147483647,
        styleMsAnimationFillModeBackwards = 2,
        styleMsAnimationFillModeBoth = 3,
        styleMsAnimationFillModeForwards = 1,
        styleMsAnimationFillModeNone = 0,
        styleMsAnimationFillModeNotSet = 4,
    }

    const enum _styleMsAnimationPlayState {
        styleMsAnimationPlayState_Max = 2147483647,
        styleMsAnimationPlayStateNotSet = 2,
        styleMsAnimationPlayStatePaused = 1,
        styleMsAnimationPlayStateRunning = 0,
    }

    const enum _styleMsContentZoomChaining {
        styleMsContentZoomChaining_Max = 2147483647,
        styleMsContentZoomChainingChained = 2,
        styleMsContentZoomChainingNone = 1,
        styleMsContentZoomChainingNotSet = 0,
    }

    const enum _styleMsContentZooming {
        styleMsContentZooming_Max = 2147483647,
        styleMsContentZoomingNone = 1,
        styleMsContentZoomingNotSet = 0,
        styleMsContentZoomingZoom = 2,
    }

    const enum _styleMsContentZoomSnapType {
        styleMsContentZoomSnapType_Max = 2147483647,
        styleMsContentZoomSnapTypeMandatory = 2,
        styleMsContentZoomSnapTypeNone = 1,
        styleMsContentZoomSnapTypeNotSet = 0,
        styleMsContentZoomSnapTypeProximity = 3,
    }

    const enum _styleMsFlexAlign {
        styleMsFlexAlign_Max = 2147483647,
        styleMsFlexAlignBaseline = 3,
        styleMsFlexAlignCenter = 2,
        styleMsFlexAlignEnd = 1,
        styleMsFlexAlignNotSet = 5,
        styleMsFlexAlignStart = 0,
        styleMsFlexAlignStretch = 4,
    }

    const enum _styleMsFlexItemAlign {
        styleMsFlexItemAlign_Max = 2147483647,
        styleMsFlexItemAlignAuto = 5,
        styleMsFlexItemAlignBaseline = 3,
        styleMsFlexItemAlignCenter = 2,
        styleMsFlexItemAlignEnd = 1,
        styleMsFlexItemAlignNotSet = 6,
        styleMsFlexItemAlignStart = 0,
        styleMsFlexItemAlignStretch = 4,
    }

    const enum _styleMsFlexLinePack {
        styleMsFlexLinePack_Max = 2147483647,
        styleMsFlexLinePackCenter = 2,
        styleMsFlexLinePackDistribute = 4,
        styleMsFlexLinePackEnd = 1,
        styleMsFlexLinePackJustify = 3,
        styleMsFlexLinePackNotSet = 6,
        styleMsFlexLinePackStart = 0,
        styleMsFlexLinePackStretch = 5,
    }

    const enum _styleMsFlexPack {
        styleMsFlexPack_Max = 2147483647,
        styleMsFlexPackCenter = 2,
        styleMsFlexPackDistribute = 4,
        styleMsFlexPackEnd = 1,
        styleMsFlexPackJustify = 3,
        styleMsFlexPackNotSet = 5,
        styleMsFlexPackStart = 0,
    }

    const enum _styleMsHighContrastAdjust {
        styleMsHighContrastAdjust_Max = 2147483647,
        styleMsHighContrastAdjustAuto = 1,
        styleMsHighContrastAdjustNone = 2,
        styleMsHighContrastAdjustNotSet = 0,
    }

    const enum _styleMsImeAlign {
        styleMsImeAlign_Max = 2147483647,
        styleMsImeAlignAfter = 1,
        styleMsImeAlignAuto = 0,
        styleMsImeAlignNotSet = 2,
    }

    const enum _styleMsOverflowStyle {
        styleMsOverflowStyle_Max = 2147483647,
        styleMsOverflowStyleAuto = 1,
        styleMsOverflowStyleMsAutoHidingScrollbar = 4,
        styleMsOverflowStyleNone = 2,
        styleMsOverflowStyleNotSet = 0,
        styleMsOverflowStyleScrollbar = 3,
    }

    const enum _styleMsScrollChaining {
        styleMsScrollChaining_Max = 2147483647,
        styleMsScrollChainingChained = 2,
        styleMsScrollChainingNone = 1,
        styleMsScrollChainingNotSet = 0,
    }

    const enum _styleMsScrollRails {
        styleMsScrollRails_Max = 2147483647,
        styleMsScrollRailsNone = 1,
        styleMsScrollRailsNotSet = 0,
        styleMsScrollRailsRailed = 2,
    }

    const enum _styleMsScrollSnapType {
        styleMsScrollSnapType_Max = 2147483647,
        styleMsScrollSnapTypeMandatory = 2,
        styleMsScrollSnapTypeNone = 1,
        styleMsScrollSnapTypeNotSet = 0,
        styleMsScrollSnapTypeProximity = 3,
    }

    const enum _styleMsScrollTranslation {
        styleMsScrollTranslation_Max = 2147483647,
        styleMsScrollTranslationNone = 1,
        styleMsScrollTranslationNotSet = 0,
        styleMsScrollTranslationVtoH = 2,
    }

    const enum _styleMsTextCombineHorizontal {
        styleMsTextCombineHorizontal_Max = 2147483647,
        styleMsTextCombineHorizontalAll = 1,
        styleMsTextCombineHorizontalDigits = 2,
        styleMsTextCombineHorizontalNone = 0,
        styleMsTextCombineHorizontalNotSet = 3,
    }

    const enum _styleMsTouchAction {
        styleMsTouchAction_Max = 2147483647,
        styleMsTouchActionAuto = 1,
        styleMsTouchActionCrossSlideX = 64,
        styleMsTouchActionCrossSlideY = 128,
        styleMsTouchActionDoubleTapZoom = 4,
        styleMsTouchActionManipulation = 2,
        styleMsTouchActionNone = 0,
        styleMsTouchActionNotSet = -1,
        styleMsTouchActionPanX = 8,
        styleMsTouchActionPanY = 16,
        styleMsTouchActionPinchZoom = 32,
    }

    const enum _styleMsTouchSelect {
        styleMsTouchSelect_Max = 2147483647,
        styleMsTouchSelectGrippers = 0,
        styleMsTouchSelectNone = 1,
        styleMsTouchSelectNotSet = 2,
    }

    const enum _styleMsUserSelect {
        styleMsUserSelect_Max = 2147483647,
        styleMsUserSelectAuto = 0,
        styleMsUserSelectElement = 2,
        styleMsUserSelectNone = 3,
        styleMsUserSelectNotSet = 4,
        styleMsUserSelectText = 1,
    }

    const enum _styleNone {
        styleNone_Max = 2147483647,
        styleNoneNone = 0,
    }

    const enum _styleNormal {
        styleNormal_Max = 2147483647,
        styleNormalNormal = 0,
    }

    const enum _styleOutlineStyle {
        styleOutlineStyle_Max = 2147483647,
        styleOutlineStyleDashed = 2,
        styleOutlineStyleDotted = 1,
        styleOutlineStyleDouble = 4,
        styleOutlineStyleGroove = 5,
        styleOutlineStyleInset = 7,
        styleOutlineStyleNone = 10,
        styleOutlineStyleNotSet = 0,
        styleOutlineStyleOutset = 8,
        styleOutlineStyleRidge = 6,
        styleOutlineStyleSolid = 3,
        styleOutlineStyleWindowInset = 9,
    }

    const enum _styleOverflow {
        styleOverflow_Max = 2147483647,
        styleOverflowAuto = 1,
        styleOverflowHidden = 2,
        styleOverflowNotSet = 0,
        styleOverflowScroll = 4,
        styleOverflowVisible = 3,
    }

    const enum _stylePageBreak {
        stylePageBreak_Max = 2147483647,
        stylePageBreakAlways = 2,
        stylePageBreakAuto = 1,
        stylePageBreakAvoid = 5,
        stylePageBreakLeft = 3,
        stylePageBreakNotSet = 0,
        stylePageBreakRight = 4,
    }

    const enum _stylePageBreakInside {
        stylePageBreakInside_Max = 2147483647,
        stylePageBreakInsideAuto = 1,
        stylePageBreakInsideAvoid = 2,
        stylePageBreakInsideNotSet = 0,
    }

    const enum _stylePerspectiveOriginX {
        stylePerspectiveOriginX_Max = 2147483647,
        stylePerspectiveOriginXCenter = 2,
        stylePerspectiveOriginXLeft = 1,
        stylePerspectiveOriginXNotSet = 0,
        stylePerspectiveOriginXRight = 3,
    }

    const enum _stylePerspectiveOriginY {
        stylePerspectiveOriginY_Max = 2147483647,
        stylePerspectiveOriginYBottom = 3,
        stylePerspectiveOriginYCenter = 2,
        stylePerspectiveOriginYNotSet = 0,
        stylePerspectiveOriginYTop = 1,
    }

    const enum _stylePointerEvents {
        stylePointerEvents_Max = 2147483647,
        stylePointerEventsAll = 8,
        stylePointerEventsAuto = 11,
        stylePointerEventsFill = 6,
        stylePointerEventsInitial = 10,
        stylePointerEventsNone = 9,
        stylePointerEventsNotSet = 0,
        stylePointerEventsPainted = 5,
        stylePointerEventsStroke = 7,
        stylePointerEventsVisible = 4,
        stylePointerEventsVisibleFill = 2,
        stylePointerEventsVisiblePainted = 1,
        stylePointerEventsVisibleStroke = 3,
    }

    const enum _stylePosition {
        stylePosition_Max = 2147483647,
        stylePositionabsolute = 3,
        stylePositionfixed = 4,
        stylePositionMsDeviceFixed = 6,
        stylePositionMsPage = 5,
        stylePositionNotSet = 0,
        stylePositionrelative = 2,
        stylePositionstatic = 1,
    }

    const enum _styleRubyAlign {
        styleRubyAlign_Max = 2147483647,
        styleRubyAlignAuto = 1,
        styleRubyAlignCenter = 3,
        styleRubyAlignDistributeLetter = 5,
        styleRubyAlignDistributeSpace = 6,
        styleRubyAlignLeft = 2,
        styleRubyAlignLineEdge = 7,
        styleRubyAlignNotSet = 0,
        styleRubyAlignRight = 4,
    }

    const enum _styleRubyOverhang {
        styleRubyOverhang_Max = 2147483647,
        styleRubyOverhangAuto = 1,
        styleRubyOverhangNone = 3,
        styleRubyOverhangNotSet = 0,
        styleRubyOverhangWhitespace = 2,
    }

    const enum _styleRubyPosition {
        styleRubyPosition_Max = 2147483647,
        styleRubyPositionAbove = 1,
        styleRubyPositionInline = 2,
        styleRubyPositionNotSet = 0,
    }

    const enum _styleStrokeLinecap {
        styleStrokeLinecap_Max = 2147483647,
        styleStrokeLinecapButt = 1,
        styleStrokeLinecapNotSet = 0,
        styleStrokeLinecapRound = 2,
        styleStrokeLinecapSquare = 3,
    }

    const enum _styleStrokeLinejoin {
        styleStrokeLinejoin_Max = 2147483647,
        styleStrokeLinejoinBevel = 3,
        styleStrokeLinejoinMiter = 1,
        styleStrokeLinejoinNotSet = 0,
        styleStrokeLinejoinRound = 2,
    }

    const enum _styleStyleFloat {
        styleStyleFloat_Max = 2147483647,
        styleStyleFloatLeft = 1,
        styleStyleFloatNone = 3,
        styleStyleFloatNotSet = 0,
        styleStyleFloatRight = 2,
    }

    const enum _styleTableLayout {
        styleTableLayout_Max = 2147483647,
        styleTableLayoutAuto = 1,
        styleTableLayoutFixed = 2,
        styleTableLayoutNotSet = 0,
    }

    const enum _styleTextAlignLast {
        styleTextAlignLast_Max = 2147483647,
        styleTextAlignLastAuto = 5,
        styleTextAlignLastCenter = 2,
        styleTextAlignLastJustify = 4,
        styleTextAlignLastLeft = 1,
        styleTextAlignLastNotSet = 0,
        styleTextAlignLastRight = 3,
    }

    const enum _styleTextAnchor {
        styleTextAnchor_Max = 2147483647,
        styleTextAnchorEnd = 3,
        styleTextAnchorMiddle = 2,
        styleTextAnchorNotSet = 0,
        styleTextAnchorStart = 1,
    }

    const enum _styleTextDecoration {
        styleTextDecoration_Max = 2147483647,
        styleTextDecorationBlink = 4,
        styleTextDecorationLineThrough = 3,
        styleTextDecorationNone = 0,
        styleTextDecorationOverline = 2,
        styleTextDecorationUnderline = 1,
    }

    const enum _styleTextEffect {
        styleTextEffect_Max = 2147483647,
        styleTextEffectEmboss = 1,
        styleTextEffectEngrave = 2,
        styleTextEffectNone = 0,
        styleTextEffectOutline = 3,
    }

    const enum _styleTextJustify {
        styleTextJustify_Max = 2147483647,
        styleTextJustifyAuto = 8,
        styleTextJustifyDistribute = 3,
        styleTextJustifyDistributeAllLines = 4,
        styleTextJustifyInterCluster = 6,
        styleTextJustifyInterIdeograph = 5,
        styleTextJustifyInterWord = 1,
        styleTextJustifyKashida = 7,
        styleTextJustifyNewspaper = 2,
        styleTextJustifyNotSet = 0,
    }

    const enum _styleTextJustifyTrim {
        styleTextJustifyTrim_Max = 2147483647,
        styleTextJustifyTrimNone = 1,
        styleTextJustifyTrimNotSet = 0,
        styleTextJustifyTrimPunctAndKana = 3,
        styleTextJustifyTrimPunctuation = 2,
    }

    const enum _styleTextLineThroughStyle {
        styleTextLineThroughStyle_Max = 2147483647,
        styleTextLineThroughStyleDouble = 2,
        styleTextLineThroughStyleSingle = 1,
        styleTextLineThroughStyleUndefined = 0,
    }

    const enum _styleTextOverflow {
        styleTextOverflow_Max = 2147483647,
        styleTextOverflowClip = 0,
        styleTextOverflowEllipsis = 1,
        styleTextOverflowNotSet = 2,
    }

    const enum _styleTextSizeAdjust {
        styleTextSizeAdjust_Max = 2147483647,
        styleTextSizeAdjustAuto = 1,
        styleTextSizeAdjustNone = 0,
    }

    const enum _styleTextTransform {
        styleTextTransform_Max = 2147483647,
        styleTextTransformCapitalize = 1,
        styleTextTransformLowercase = 2,
        styleTextTransformNone = 4,
        styleTextTransformNotSet = 0,
        styleTextTransformUppercase = 3,
    }

    const enum _styleTextUnderlinePosition {
        styleTextUnderlinePosition_Max = 2147483647,
        styleTextUnderlinePositionAbove = 1,
        styleTextUnderlinePositionAuto = 2,
        styleTextUnderlinePositionBelow = 0,
        styleTextUnderlinePositionNotSet = 3,
    }

    const enum _styleTextUnderlineStyle {
        styleTextUnderlineStyle_Max = 2147483647,
        styleTextUnderlineStyleDash = 6,
        styleTextUnderlineStyleDotDash = 7,
        styleTextUnderlineStyleDotDotDash = 8,
        styleTextUnderlineStyleDotted = 4,
        styleTextUnderlineStyleDouble = 2,
        styleTextUnderlineStyleDoubleAccounting = 11,
        styleTextUnderlineStyleSingle = 1,
        styleTextUnderlineStyleSingleAccounting = 10,
        styleTextUnderlineStyleThick = 5,
        styleTextUnderlineStyleThickDash = 12,
        styleTextUnderlineStyleUndefined = 0,
        styleTextUnderlineStyleWave = 9,
        styleTextUnderlineStyleWords = 3,
    }

    const enum _styleTransformOriginX {
        styleTransformOriginX_Max = 2147483647,
        styleTransformOriginXCenter = 2,
        styleTransformOriginXLeft = 1,
        styleTransformOriginXNotSet = 0,
        styleTransformOriginXRight = 3,
    }

    const enum _styleTransformOriginY {
        styleTransformOriginY_Max = 2147483647,
        styleTransformOriginYBottom = 3,
        styleTransformOriginYCenter = 2,
        styleTransformOriginYNotSet = 0,
        styleTransformOriginYTop = 1,
    }

    const enum _styleTransformStyle {
        styleTransformStyle_Max = 2147483647,
        styleTransformStyleFlat = 0,
        styleTransformStyleNotSet = 2,
        styleTransformStylePreserve3D = 1,
    }

    const enum _styleUserZoom {
        styleUserZoom_Max = 2147483647,
        styleUserZoomFixed = 2,
        styleUserZoomNotSet = 0,
        styleUserZoomZoom = 1,
    }

    const enum _styleVerticalAlign {
        styleVerticalAlign_Max = 2147483647,
        styleVerticalAlignAuto = 0,
        styleVerticalAlignBaseline = 1,
        styleVerticalAlignBottom = 7,
        styleVerticalAlignInherit = 9,
        styleVerticalAlignMiddle = 6,
        styleVerticalAlignNotSet = 10,
        styleVerticalAlignSub = 2,
        styleVerticalAlignSuper = 3,
        styleVerticalAlignTextBottom = 8,
        styleVerticalAlignTextTop = 5,
        styleVerticalAlignTop = 4,
    }

    const enum _styleViewportSize {
        styleViewportSize_Max = 2147483647,
        styleViewportSizeAuto = 0,
        styleViewportSizeDeviceHeight = 2,
        styleViewportSizeDeviceWidth = 1,
    }

    const enum _styleVisibility {
        styleVisibility_Max = 2147483647,
        styleVisibilityCollapse = 4,
        styleVisibilityHidden = 3,
        styleVisibilityInherit = 1,
        styleVisibilityNotSet = 0,
        styleVisibilityVisible = 2,
    }

    const enum _styleWebkitAppearance {
        styleWebkitAppearance_Max = 2147483647,
        styleWebkitAppearanceButton = 2,
        styleWebkitAppearanceButtonBevel = 3,
        styleWebkitAppearanceCapsLockIndicator = 1,
        styleWebkitAppearanceCaret = 4,
        styleWebkitAppearanceCheckbox = 5,
        styleWebkitAppearanceDefaultButton = 6,
        styleWebkitAppearanceListbox = 7,
        styleWebkitAppearanceListitem = 8,
        styleWebkitAppearanceMediaFullscreenButton = 9,
        styleWebkitAppearanceMediaMuteButton = 10,
        styleWebkitAppearanceMediaPlayButton = 11,
        styleWebkitAppearanceMediaSeekBackButton = 12,
        styleWebkitAppearanceMediaSeekForwardButton = 13,
        styleWebkitAppearanceMediaSlider = 14,
        styleWebkitAppearanceMediaSliderthumb = 15,
        styleWebkitAppearanceMenulist = 16,
        styleWebkitAppearanceMenulistButton = 17,
        styleWebkitAppearanceMenulistText = 18,
        styleWebkitAppearanceMenulistTextfield = 19,
        styleWebkitAppearanceNone = 0,
        styleWebkitAppearanceNotSet = 34,
        styleWebkitAppearancePushButton = 20,
        styleWebkitAppearanceRadio = 21,
        styleWebkitAppearanceSearchfield = 22,
        styleWebkitAppearanceSearchfieldCancelButton = 23,
        styleWebkitAppearanceSearchfieldDecoration = 24,
        styleWebkitAppearanceSearchfieldResultsButton = 25,
        styleWebkitAppearanceSearchfieldResultsDecoration = 26,
        styleWebkitAppearanceSliderHorizontal = 27,
        styleWebkitAppearanceSliderthumbHorizontal = 29,
        styleWebkitAppearanceSliderthumbVertical = 30,
        styleWebkitAppearanceSliderVertical = 28,
        styleWebkitAppearanceSquareButton = 31,
        styleWebkitAppearanceTextarea = 32,
        styleWebkitAppearanceTextfield = 33,
    }

    const enum _styleWebkitBoxDirection {
        styleWebkitBoxDirection_Max = 2147483647,
        styleWebkitBoxDirectionNormal = 0,
        styleWebkitBoxDirectionNotSet = 2,
        styleWebkitBoxDirectionReverse = 1,
    }

    const enum _styleWebkitBoxOrient {
        styleWebkitBoxOrient_Max = 2147483647,
        styleWebkitBoxOrientBlockAxis = 3,
        styleWebkitBoxOrientHorizontal = 0,
        styleWebkitBoxOrientInlineAxis = 1,
        styleWebkitBoxOrientNotSet = 4,
        styleWebkitBoxOrientVertical = 2,
    }

    const enum _styleWebkitBoxPack {
        styleWebkitBoxPack_Max = 2147483647,
        styleWebkitBoxPackCenter = 2,
        styleWebkitBoxPackEnd = 1,
        styleWebkitBoxPackJustify = 3,
        styleWebkitBoxPackNotSet = 5,
        styleWebkitBoxPackStart = 0,
    }

    const enum _styleWhiteSpace {
        styleWhiteSpace_Max = 2147483647,
        styleWhiteSpaceNormal = 1,
        styleWhiteSpaceNotSet = 0,
        styleWhiteSpaceNowrap = 3,
        styleWhiteSpacePre = 2,
        styleWhiteSpacePreline = 4,
        styleWhiteSpacePrewrap = 5,
    }

    const enum _styleWidowsOrphans {
        styleWidowsOrphans_Max = 2147483647,
        styleWidowsOrphansNotSet = -2147483647,
    }

    const enum _styleWordBreak {
        styleWordBreak_Max = 2147483647,
        styleWordBreakBreakAll = 2,
        styleWordBreakKeepAll = 3,
        styleWordBreakNormal = 1,
        styleWordBreakNotSet = 0,
    }

    const enum _styleWordWrap {
        styleWordWrap_Max = 2147483647,
        styleWordWrapNotSet = 0,
        styleWordWrapOff = 1,
        styleWordWrapOn = 2,
    }

    const enum _styleWrapFlow {
        styleWrapFlow_Max = 2147483647,
        styleWrapFlowAuto = 1,
        styleWrapFlowBoth = 2,
        styleWrapFlowClear = 5,
        styleWrapFlowEnd = 4,
        styleWrapFlowMaximum = 7,
        styleWrapFlowMinimum = 6,
        styleWrapFlowNotSet = 0,
        styleWrapFlowStart = 3,
    }

    const enum _styleWrapThrough {
        styleWrapThrough_Max = 2147483647,
        styleWrapThroughNone = 2,
        styleWrapThroughNotSet = 0,
        styleWrapThroughWrap = 1,
    }

    const enum _styleWritingMode {
        styleWritingMode_Max = 2147483647,
        styleWritingModeBtlr = 6,
        styleWritingModeBtrl = 3,
        styleWritingModeLr = 9,
        styleWritingModeLrbt = 7,
        styleWritingModeLrtb = 0,
        styleWritingModeNotSet = 4,
        styleWritingModeRl = 10,
        styleWritingModeRlbt = 8,
        styleWritingModeRltb = 2,
        styleWritingModeTb = 11,
        styleWritingModeTblr = 5,
        styleWritingModeTbrl = 1,
    }

    const enum _styleZIndex {
        styleZIndex_Max = 2147483647,
        styleZIndexAuto = -2147483647,
    }

    const enum _svgAngleType {
        SVG_ANGLETYPE_DEG = 2,
        SVG_ANGLETYPE_GRAD = 4,
        SVG_ANGLETYPE_RAD = 3,
        SVG_ANGLETYPE_UNKNOWN = 0,
        SVG_ANGLETYPE_UNSPECIFIED = 1,
        svgAngleType_Max = 2147483647,
    }

    const enum _svgChannel {
        SVG_CHANNEL_A = 4,
        SVG_CHANNEL_B = 3,
        SVG_CHANNEL_G = 2,
        SVG_CHANNEL_R = 1,
        SVG_CHANNEL_UNKNOWN = 0,
        svgChannel_Max = 2147483647,
    }

    const enum _svgEdgemode {
        SVG_EDGEMODE_DUPLICATE = 1,
        SVG_EDGEMODE_NONE = 3,
        SVG_EDGEMODE_UNKNOWN = 0,
        SVG_EDGEMODE_WRAP = 2,
        svgEdgemode_Max = 2147483647,
    }

    const enum _svgExternalResourcesRequired {
        svgExternalResourcesRequired_Max = 2147483647,
        svgExternalResourcesRequiredFalse = 0,
        svgExternalResourcesRequiredTrue = 1,
    }

    const enum _svgFeblendMode {
        SVG_FEBLEND_MODE_DARKEN = 4,
        SVG_FEBLEND_MODE_LIGHTEN = 5,
        SVG_FEBLEND_MODE_MULTIPLY = 2,
        SVG_FEBLEND_MODE_NORMAL = 1,
        SVG_FEBLEND_MODE_SCREEN = 3,
        SVG_FEBLEND_MODE_UNKNOWN = 0,
        svgFeblendMode_Max = 2147483647,
    }

    const enum _svgFecolormatrixType {
        SVG_FECOLORMATRIX_TYPE_HUEROTATE = 3,
        SVG_FECOLORMATRIX_TYPE_LUMINANCETOALPHA = 4,
        SVG_FECOLORMATRIX_TYPE_MATRIX = 1,
        SVG_FECOLORMATRIX_TYPE_SATURATE = 2,
        SVG_FECOLORMATRIX_TYPE_UNKNOWN = 0,
        svgFecolormatrixType_Max = 2147483647,
    }

    const enum _svgFecomponenttransferType {
        SVG_FECOMPONENTTRANSFER_TYPE_DISCRETE = 3,
        SVG_FECOMPONENTTRANSFER_TYPE_GAMMA = 5,
        SVG_FECOMPONENTTRANSFER_TYPE_IDENTITY = 1,
        SVG_FECOMPONENTTRANSFER_TYPE_LINEAR = 4,
        SVG_FECOMPONENTTRANSFER_TYPE_TABLE = 2,
        SVG_FECOMPONENTTRANSFER_TYPE_UNKNOWN = 0,
        svgFecomponenttransferType_Max = 2147483647,
    }

    const enum _svgFecompositeOperator {
        SVG_FECOMPOSITE_OPERATOR_ARITHMETIC = 6,
        SVG_FECOMPOSITE_OPERATOR_ATOP = 4,
        SVG_FECOMPOSITE_OPERATOR_IN = 2,
        SVG_FECOMPOSITE_OPERATOR_OUT = 3,
        SVG_FECOMPOSITE_OPERATOR_OVER = 1,
        SVG_FECOMPOSITE_OPERATOR_UNKNOWN = 0,
        SVG_FECOMPOSITE_OPERATOR_XOR = 5,
        svgFecompositeOperator_Max = 2147483647,
    }

    const enum _svgFocusable {
        svgFocusable_Max = 2147483647,
        svgFocusableAuto = 1,
        svgFocusableFalse = 3,
        svgFocusableNotSet = 0,
        svgFocusableTrue = 2,
    }

    const enum _svgLengthType {
        SVG_LENGTHTYPE_CM = 6,
        SVG_LENGTHTYPE_EMS = 3,
        SVG_LENGTHTYPE_EXS = 4,
        SVG_LENGTHTYPE_IN = 8,
        SVG_LENGTHTYPE_MM = 7,
        SVG_LENGTHTYPE_NUMBER = 1,
        SVG_LENGTHTYPE_PC = 10,
        SVG_LENGTHTYPE_PERCENTAGE = 2,
        SVG_LENGTHTYPE_PT = 9,
        SVG_LENGTHTYPE_PX = 5,
        SVG_LENGTHTYPE_UNKNOWN = 0,
        svgLengthType_Max = 2147483647,
    }

    const enum _svgMarkerOrient {
        SVG_MARKER_ORIENT_ANGLE = 2,
        SVG_MARKER_ORIENT_AUTO = 1,
        SVG_MARKER_ORIENT_UNKNOWN = 0,
        svgMarkerOrient_Max = 2147483647,
    }

    const enum _svgMarkerOrientAttribute {
        svgMarkerOrientAttribute_Max = 2147483647,
        svgMarkerOrientAttributeAuto = 0,
    }

    const enum _svgMarkerUnits {
        SVG_MARKERUNITS_STROKEWIDTH = 2,
        SVG_MARKERUNITS_UNKNOWN = 0,
        SVG_MARKERUNITS_USERSPACEONUSE = 1,
        svgMarkerUnits_Max = 2147483647,
    }

    const enum _svgMorphologyOperator {
        SVG_MORPHOLOGY_OPERATOR_DILATE = 2,
        SVG_MORPHOLOGY_OPERATOR_ERODE = 1,
        SVG_MORPHOLOGY_OPERATOR_UNKNOWN = 0,
        svgMorphologyOperator_Max = 2147483647,
    }

    const enum _svgPathSegType {
        PATHSEG_ARC_ABS = 10,
        PATHSEG_ARC_REL = 11,
        PATHSEG_CLOSEPATH = 1,
        PATHSEG_CURVETO_CUBIC_ABS = 6,
        PATHSEG_CURVETO_CUBIC_REL = 7,
        PATHSEG_CURVETO_CUBIC_SMOOTH_ABS = 16,
        PATHSEG_CURVETO_CUBIC_SMOOTH_REL = 17,
        PATHSEG_CURVETO_QUADRATIC_ABS = 8,
        PATHSEG_CURVETO_QUADRATIC_REL = 9,
        PATHSEG_CURVETO_QUADRATIC_SMOOTH_ABS = 18,
        PATHSEG_CURVETO_QUADRATIC_SMOOTH_REL = 19,
        PATHSEG_LINETO_ABS = 4,
        PATHSEG_LINETO_HORIZONTAL_ABS = 12,
        PATHSEG_LINETO_HORIZONTAL_REL = 13,
        PATHSEG_LINETO_REL = 5,
        PATHSEG_LINETO_VERTICAL_ABS = 14,
        PATHSEG_LINETO_VERTICAL_REL = 15,
        PATHSEG_MOVETO_ABS = 2,
        PATHSEG_MOVETO_REL = 3,
        PATHSEG_UNKNOWN = 0,
        svgPathSegType_Max = 2147483647,
    }

    const enum _svgPreserveAlpha {
        SVG_PRESERVEALPHA_FALSE = 0,
        SVG_PRESERVEALPHA_TRUE = 1,
        svgPreserveAlpha_Max = 2147483647,
    }

    const enum _svgPreserveAspectMeetOrSliceType {
        SVG_MEETORSLICE_MEET = 1,
        SVG_MEETORSLICE_SLICE = 2,
        SVG_MEETORSLICE_UNKNOWN = 0,
        svgPreserveAspectMeetOrSliceType_Max = 2147483647,
    }

    const enum _svgPreserveAspectRatioAlignType {
        SVG_PRESERVEASPECTRATIO_NONE = 1,
        SVG_PRESERVEASPECTRATIO_UNKNOWN = 0,
        SVG_PRESERVEASPECTRATIO_XMAXYMAX = 10,
        SVG_PRESERVEASPECTRATIO_XMAXYMID = 7,
        SVG_PRESERVEASPECTRATIO_XMAXYMIN = 4,
        SVG_PRESERVEASPECTRATIO_XMIDYMAX = 9,
        SVG_PRESERVEASPECTRATIO_XMIDYMID = 6,
        SVG_PRESERVEASPECTRATIO_XMIDYMIN = 3,
        SVG_PRESERVEASPECTRATIO_XMINYMAX = 8,
        SVG_PRESERVEASPECTRATIO_XMINYMID = 5,
        SVG_PRESERVEASPECTRATIO_XMINYMIN = 2,
        svgPreserveAspectRatioAlignType_Max = 2147483647,
    }

    const enum _svgSpreadMethod {
        SVG_SPREADMETHOD_PAD = 1,
        SVG_SPREADMETHOD_REFLECT = 2,
        SVG_SPREADMETHOD_REPEAT = 3,
        SVG_SPREADMETHOD_UNKNOWN = 0,
        svgSpreadMethod_Max = 2147483647,
    }

    const enum _svgStitchtype {
        SVG_STITCHTYPE_NOSTITCH = 2,
        SVG_STITCHTYPE_STITCH = 1,
        SVG_STITCHTYPE_UNKNOWN = 0,
        svgStitchtype_Max = 2147483647,
    }

    const enum _svgTransformType {
        SVG_TRANSFORM_MATRIX = 1,
        SVG_TRANSFORM_ROTATE = 4,
        SVG_TRANSFORM_SCALE = 3,
        SVG_TRANSFORM_SKEWX = 5,
        SVG_TRANSFORM_SKEWY = 6,
        SVG_TRANSFORM_TRANSLATE = 2,
        SVG_TRANSFORM_UNKNOWN = 0,
        svgTransformType_Max = 2147483647,
    }

    const enum _svgTurbulenceType {
        SVG_TURBULENCE_TYPE_FACTALNOISE = 1,
        SVG_TURBULENCE_TYPE_TURBULENCE = 2,
        SVG_TURBULENCE_TYPE_UNKNOWN = 0,
        svgTurbulenceType_Max = 2147483647,
    }

    const enum _svgUnitTypes {
        SVG_UNITTYPE_OBJECTBOUNDINGBOX = 2,
        SVG_UNITTYPE_UNKNOWN = 0,
        SVG_UNITTYPE_USERSPACEONUSE = 1,
        svgUnitTypes_Max = 2147483647,
    }

    const enum _textDecoration {
        textDecoration_Max = 2147483647,
        textDecorationBlink = 4,
        textDecorationLineThrough = 3,
        textDecorationNone = 0,
        textDecorationOverline = 2,
        textDecorationUnderline = 1,
    }

    const enum _textpathMethodtype {
        TEXTPATH_METHODTYPE_ALIGN = 1,
        TEXTPATH_METHODTYPE_STRETCH = 2,
        TEXTPATH_METHODTYPE_UNKNOWN = 0,
        textpathMethodtype_Max = 2147483647,
    }

    const enum _textpathSpacingtype {
        TEXTPATH_SPACINGTYPE_AUTO = 1,
        TEXTPATH_SPACINGTYPE_EXACT = 2,
        TEXTPATH_SPACINGTYPE_UNKNOWN = 0,
        textpathSpacingtype_Max = 2147483647,
    }

    const enum _VIEW_OBJECT_ALPHA_MODE {
        VIEW_OBJECT_ALPHA_MODE_IGNORE = 0,
        VIEW_OBJECT_ALPHA_MODE_Max = 2147483647,
        VIEW_OBJECT_ALPHA_MODE_PREMULTIPLIED = 1,
    }

    const enum _VIEW_OBJECT_COMPOSITION_MODE {
        VIEW_OBJECT_COMPOSITION_MODE_LEGACY = 0,
        VIEW_OBJECT_COMPOSITION_MODE_Max = 2147483647,
        VIEW_OBJECT_COMPOSITION_MODE_SURFACEPRESENTER = 1,
    }

    const enum DXGI_FORMAT {
        DXGI_FORMAT_420_OPAQUE = 106,
        DXGI_FORMAT_A8_UNORM = 65,
        DXGI_FORMAT_A8P8 = 114,
        DXGI_FORMAT_AI44 = 111,
        DXGI_FORMAT_AYUV = 100,
        DXGI_FORMAT_B4G4R4A4_UNORM = 115,
        DXGI_FORMAT_B5G5R5A1_UNORM = 86,
        DXGI_FORMAT_B5G6R5_UNORM = 85,
        DXGI_FORMAT_B8G8R8A8_TYPELESS = 90,
        DXGI_FORMAT_B8G8R8A8_UNORM = 87,
        DXGI_FORMAT_B8G8R8A8_UNORM_SRGB = 91,
        DXGI_FORMAT_B8G8R8X8_TYPELESS = 92,
        DXGI_FORMAT_B8G8R8X8_UNORM = 88,
        DXGI_FORMAT_B8G8R8X8_UNORM_SRGB = 93,
        DXGI_FORMAT_BC1_TYPELESS = 70,
        DXGI_FORMAT_BC1_UNORM = 71,
        DXGI_FORMAT_BC1_UNORM_SRGB = 72,
        DXGI_FORMAT_BC2_TYPELESS = 73,
        DXGI_FORMAT_BC2_UNORM = 74,
        DXGI_FORMAT_BC2_UNORM_SRGB = 75,
        DXGI_FORMAT_BC3_TYPELESS = 76,
        DXGI_FORMAT_BC3_UNORM = 77,
        DXGI_FORMAT_BC3_UNORM_SRGB = 78,
        DXGI_FORMAT_BC4_SNORM = 81,
        DXGI_FORMAT_BC4_TYPELESS = 79,
        DXGI_FORMAT_BC4_UNORM = 80,
        DXGI_FORMAT_BC5_SNORM = 84,
        DXGI_FORMAT_BC5_TYPELESS = 82,
        DXGI_FORMAT_BC5_UNORM = 83,
        DXGI_FORMAT_BC6H_SF16 = 96,
        DXGI_FORMAT_BC6H_TYPELESS = 94,
        DXGI_FORMAT_BC6H_UF16 = 95,
        DXGI_FORMAT_BC7_TYPELESS = 97,
        DXGI_FORMAT_BC7_UNORM = 98,
        DXGI_FORMAT_BC7_UNORM_SRGB = 99,
        DXGI_FORMAT_D16_UNORM = 55,
        DXGI_FORMAT_D24_UNORM_S8_UINT = 45,
        DXGI_FORMAT_D32_FLOAT = 40,
        DXGI_FORMAT_D32_FLOAT_S8X24_UINT = 20,
        DXGI_FORMAT_FORCE_UINT = -1,
        DXGI_FORMAT_G8R8_G8B8_UNORM = 69,
        DXGI_FORMAT_IA44 = 112,
        DXGI_FORMAT_NV11 = 110,
        DXGI_FORMAT_NV12 = 103,
        DXGI_FORMAT_P010 = 104,
        DXGI_FORMAT_P016 = 105,
        DXGI_FORMAT_P208 = 130,
        DXGI_FORMAT_P8 = 113,
        DXGI_FORMAT_R1_UNORM = 66,
        DXGI_FORMAT_R10G10B10_XR_BIAS_A2_UNORM = 89,
        DXGI_FORMAT_R10G10B10A2_TYPELESS = 23,
        DXGI_FORMAT_R10G10B10A2_UINT = 25,
        DXGI_FORMAT_R10G10B10A2_UNORM = 24,
        DXGI_FORMAT_R11G11B10_FLOAT = 26,
        DXGI_FORMAT_R16_FLOAT = 54,
        DXGI_FORMAT_R16_SINT = 59,
        DXGI_FORMAT_R16_SNORM = 58,
        DXGI_FORMAT_R16_TYPELESS = 53,
        DXGI_FORMAT_R16_UINT = 57,
        DXGI_FORMAT_R16_UNORM = 56,
        DXGI_FORMAT_R16G16_FLOAT = 34,
        DXGI_FORMAT_R16G16_SINT = 38,
        DXGI_FORMAT_R16G16_SNORM = 37,
        DXGI_FORMAT_R16G16_TYPELESS = 33,
        DXGI_FORMAT_R16G16_UINT = 36,
        DXGI_FORMAT_R16G16_UNORM = 35,
        DXGI_FORMAT_R16G16B16A16_FLOAT = 10,
        DXGI_FORMAT_R16G16B16A16_SINT = 14,
        DXGI_FORMAT_R16G16B16A16_SNORM = 13,
        DXGI_FORMAT_R16G16B16A16_TYPELESS = 9,
        DXGI_FORMAT_R16G16B16A16_UINT = 12,
        DXGI_FORMAT_R16G16B16A16_UNORM = 11,
        DXGI_FORMAT_R24_UNORM_X8_TYPELESS = 46,
        DXGI_FORMAT_R24G8_TYPELESS = 44,
        DXGI_FORMAT_R32_FLOAT = 41,
        DXGI_FORMAT_R32_FLOAT_X8X24_TYPELESS = 21,
        DXGI_FORMAT_R32_SINT = 43,
        DXGI_FORMAT_R32_TYPELESS = 39,
        DXGI_FORMAT_R32_UINT = 42,
        DXGI_FORMAT_R32G32_FLOAT = 16,
        DXGI_FORMAT_R32G32_SINT = 18,
        DXGI_FORMAT_R32G32_TYPELESS = 15,
        DXGI_FORMAT_R32G32_UINT = 17,
        DXGI_FORMAT_R32G32B32_FLOAT = 6,
        DXGI_FORMAT_R32G32B32_SINT = 8,
        DXGI_FORMAT_R32G32B32_TYPELESS = 5,
        DXGI_FORMAT_R32G32B32_UINT = 7,
        DXGI_FORMAT_R32G32B32A32_FLOAT = 2,
        DXGI_FORMAT_R32G32B32A32_SINT = 4,
        DXGI_FORMAT_R32G32B32A32_TYPELESS = 1,
        DXGI_FORMAT_R32G32B32A32_UINT = 3,
        DXGI_FORMAT_R32G8X24_TYPELESS = 19,
        DXGI_FORMAT_R8_SINT = 64,
        DXGI_FORMAT_R8_SNORM = 63,
        DXGI_FORMAT_R8_TYPELESS = 60,
        DXGI_FORMAT_R8_UINT = 62,
        DXGI_FORMAT_R8_UNORM = 61,
        DXGI_FORMAT_R8G8_B8G8_UNORM = 68,
        DXGI_FORMAT_R8G8_SINT = 52,
        DXGI_FORMAT_R8G8_SNORM = 51,
        DXGI_FORMAT_R8G8_TYPELESS = 48,
        DXGI_FORMAT_R8G8_UINT = 50,
        DXGI_FORMAT_R8G8_UNORM = 49,
        DXGI_FORMAT_R8G8B8A8_SINT = 32,
        DXGI_FORMAT_R8G8B8A8_SNORM = 31,
        DXGI_FORMAT_R8G8B8A8_TYPELESS = 27,
        DXGI_FORMAT_R8G8B8A8_UINT = 30,
        DXGI_FORMAT_R8G8B8A8_UNORM = 28,
        DXGI_FORMAT_R8G8B8A8_UNORM_SRGB = 29,
        DXGI_FORMAT_R9G9B9E5_SHAREDEXP = 67,
        DXGI_FORMAT_UNKNOWN = 0,
        DXGI_FORMAT_V208 = 131,
        DXGI_FORMAT_V408 = 132,
        DXGI_FORMAT_X24_TYPELESS_G8_UINT = 47,
        DXGI_FORMAT_X32_TYPELESS_G8X24_UINT = 22,
        DXGI_FORMAT_Y210 = 108,
        DXGI_FORMAT_Y216 = 109,
        DXGI_FORMAT_Y410 = 101,
        DXGI_FORMAT_Y416 = 102,
        DXGI_FORMAT_YUY2 = 107,
    }

    class applicationCache {
        private 'MSHTML.applicationCache_typekey': applicationCache;
        private constructor();
        abort(): void;
        oncached: any;
        onchecking: any;
        ondownloading: any;
        onerror: any;
        onnoupdate: any;
        onobsolete: any;
        onprogress: any;
        onupdateready: any;
        readonly status: number;
        swapCache(): void;
        update(): void;
    }

    class BlockFormats {
        private 'MSHTML.BlockFormats_typekey': BlockFormats;
        private constructor();
        readonly Count: number;
        item(pvarIndex: any): string;
    }

    class CanvasGradient {
        private 'MSHTML.CanvasGradient_typekey': CanvasGradient;
        private constructor();
        addColorStop(offset: number, color: string): void;
    }

    class CanvasImageData {
        private 'MSHTML.CanvasImageData_typekey': CanvasImageData;
        private constructor();
        readonly data: any;
        readonly height: number;
        readonly width: number;
    }

    class CanvasPattern {
        private 'MSHTML.CanvasPattern_typekey': CanvasPattern;
        private constructor();
    }

    class CanvasRenderingContext2D {
        private 'MSHTML.CanvasRenderingContext2D_typekey': CanvasRenderingContext2D;
        private constructor();
        arc(x: number, y: number, radius: number, startAngle: number, endAngle: number, anticlockwise: number): void;
        arcTo(x1: number, y1: number, x2: number, y2: number, radius: number): void;
        beginPath(): void;
        bezierCurveTo(cp1x: number, cp1y: number, cp2x: number, cp2y: number, x: number, y: number): void;
        readonly canvas: IHTMLCanvasElement;
        clearRect(x: number, y: number, w: number, h: number): void;
        clip(): void;
        closePath(): void;
        createImageData(a1: any, a2: any): ICanvasImageData;
        createLinearGradient(x0: number, y0: number, x1: number, y1: number): ICanvasGradient;
        createPattern(Image: any, repetition: any): ICanvasPattern;
        createRadialGradient(x0: number, y0: number, r0: number, x1: number, y1: number, r1: number): ICanvasGradient;
        drawImage(pSrc: any, a1: any, a2: any, a3: any, a4: any, a5: any, a6: any, a7: any, a8: any): void;
        fill(): void;
        fillRect(x: number, y: number, w: number, h: number): void;
        fillStyle: any;
        fillText(text: string, x: number, y: number, maxWidth: any): void;
        font: string;
        getImageData(sx: number, sy: number, sw: number, sh: number): ICanvasImageData;
        globalAlpha: number;
        globalCompositeOperation: string;
        isPointInPath(x: number, y: number): boolean;
        lineCap: string;
        lineJoin: string;
        lineTo(x: number, y: number): void;
        lineWidth: number;
        measureText(text: string): ICanvasTextMetrics;
        miterLimit: number;
        moveTo(x: number, y: number): void;
        putImageData(imagedata: ICanvasImageData, dx: number, dy: number, dirtyX: any, dirtyY: any, dirtyWidth: any, dirtyHeight: any): void;
        quadraticCurveTo(cpx: number, cpy: number, x: number, y: number): void;
        rect(x: number, y: number, w: number, h: number): void;
        restore(): void;
        rotate(angle: number): void;
        save(): void;
        scale(x: number, y: number): void;
        setTransform(m11: number, m12: number, m21: number, m22: number, dx: number, dy: number): void;
        shadowBlur: number;
        shadowColor: string;
        shadowOffsetX: number;
        shadowOffsetY: number;
        stroke(): void;
        strokeRect(x: number, y: number, w: number, h: number): void;
        strokeStyle: any;
        strokeText(text: string, x: number, y: number, maxWidth: any): void;
        textAlign: string;
        textBaseline: string;
        transform(m11: number, m12: number, m21: number, m22: number, dx: number, dy: number): void;
        translate(x: number, y: number): void;
    }

    class CanvasTextMetrics {
        private 'MSHTML.CanvasTextMetrics_typekey': CanvasTextMetrics;
        private constructor();
        readonly width: number;
    }

    class CClientCaps {
        private 'MSHTML.CClientCaps_typekey': CClientCaps;
        private constructor();

        /** @param string [bStrVer=''] */
        addComponentRequest(bstrName: string, bstrURL: string, bStrVer?: string): void;
        readonly availHeight: number;
        readonly availWidth: number;
        readonly bufferDepth: number;
        clearComponentRequest(): void;
        readonly colorDepth: number;
        compareVersions(bstrVer1: string, bstrVer2: string): number;
        readonly connectionSpeed: number;
        readonly connectionType: string;
        readonly cookieEnabled: boolean;
        readonly cpuClass: string;
        doComponentRequest(): boolean;
        getComponentVersion(bstrName: string, bstrURL: string): string;
        readonly height: number;

        /** @param string [bStrVer=''] */
        isComponentInstalled(bstrName: string, bstrURL: string, bStrVer?: string): boolean;
        readonly javaEnabled: boolean;
        readonly onLine: boolean;
        readonly platform: string;
        readonly systemLanguage: string;
        readonly userLanguage: string;
        readonly width: number;
    }

    class CEventObj {
        private 'MSHTML.CEventObj_typekey': CEventObj;
        private constructor();
        readonly actionURL: string;
        altKey: boolean;
        altLeft: boolean;
        readonly behaviorCookie: number;
        readonly behaviorPart: number;
        bookmarks: IHTMLBookmarkCollection;
        boundElements: IHTMLElementCollection;
        button: number;
        readonly buttonID: number;
        cancelBubble: boolean;
        clientX: number;
        clientY: number;
        readonly 'constructor': any;
        readonly contentOverflow: boolean;
        ctrlKey: boolean;
        ctrlLeft: boolean;
        data: string;
        dataFld: string;
        readonly dataTransfer: IHTMLDataTransfer;
        fromElement: IHTMLElement;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        keyCode: number;
        readonly nextPage: string;
        offsetX: number;
        offsetY: number;
        origin: string;
        propertyName: string;
        qualifier: string;
        reason: number;
        recordset: any;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        repeat: boolean;
        returnValue: any;
        screenX: number;
        screenY: number;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        shiftKey: boolean;
        shiftLeft: boolean;
        readonly source: any;
        srcElement: IHTMLElement;
        srcFilter: any;
        srcUrn: string;
        toElement: IHTMLElement;
        type: string;
        url: string;
        readonly wheelDelta: number;
        x: number;
        y: number;
    }

    class CMimeTypes {
        private 'MSHTML.CMimeTypes_typekey': CMimeTypes;
        private constructor();
        readonly length: number;
    }

    class COpsProfile {
        private 'MSHTML.COpsProfile_typekey': COpsProfile;
        private constructor();
        addReadRequest(name: string, reserved?: any): boolean;
        addRequest(name: string, reserved?: any): boolean;
        clearRequest(): void;
        commitChanges(): boolean;
        doReadRequest(usage: any, fname?: any, domain?: any, path?: any, expire?: any, reserved?: any): void;
        doRequest(usage: any, fname?: any, domain?: any, path?: any, expire?: any, reserved?: any): void;
        doWriteRequest(): boolean;
        getAttribute(name: string): string;
        setAttribute(name: string, value: string, prefs?: any): boolean;
    }

    class CPlugins {
        private 'MSHTML.CPlugins_typekey': CPlugins;
        private constructor();
        readonly 'constructor': any;
        readonly length: number;

        /** @param boolean [reload=false] */
        refresh(reload?: boolean): void;
    }

    class CPrintManagerTemplatePrinter {
        private 'MSHTML.CPrintManagerTemplatePrinter_typekey': CPrintManagerTemplatePrinter;
        private constructor();
        allLinkedDocuments: boolean;
        collate: boolean;
        copies: number;
        currentPage: boolean;
        currentPageAvail: boolean;
        deviceSupports(bstrProperty: string): any;
        drawPreviewPage(pElemDisp: any, nPage: number): void;
        readonly duplex: boolean;
        endPrint(): void;
        ensurePrintDialogDefaults(): boolean;
        footer: string;
        frameActive: boolean;
        frameActiveEnabled: boolean;
        frameAsShown: boolean;
        framesetDocument: boolean;
        getPageMarginBottom(pageRule: any, pageWidth: number, pageHeight: number): any;
        getPageMarginBottomImportant(pageRule: any): boolean;
        getPageMarginLeft(pageRule: any, pageWidth: number, pageHeight: number): any;
        getPageMarginLeftImportant(pageRule: any): boolean;
        getPageMarginRight(pageRule: any, pageWidth: number, pageHeight: number): any;
        getPageMarginRightImportant(pageRule: any): boolean;
        getPageMarginTop(pageRule: any, pageWidth: number, pageHeight: number): any;
        getPageMarginTopImportant(pageRule: any): boolean;
        getPrintTaskOptionValue(bstrKey: string): any;
        header: string;
        headerFooterFont: string;
        invalidatePreview(): void;
        marginBottom: number;
        marginLeft: number;
        marginRight: number;
        marginTop: number;
        orientation: string;
        pageFrom: number;
        readonly pageHeight: number;
        pageTo: number;
        readonly pageWidth: number;
        readonly percentScale: number;
        printBlankPage(): void;
        printNonNative(pMarkup: any): boolean;
        printNonNativeFrames(pMarkup: any, fActiveFrame: boolean): void;
        printPage(pElemDisp: any): void;
        selectedPages: boolean;
        selection: boolean;
        selectionEnabled: boolean;
        setPageCount(nPage: number): void;
        readonly showHeaderFooter: boolean;
        showPageSetupDialog(): boolean;
        showPrintDialog(): boolean;
        readonly shrinkToFit: boolean;
        startDoc(bstrTitle: string): boolean;
        startPrint(): void;
        stopDoc(): void;
        tableOfLinks: boolean;
        readonly unprintableBottom: number;
        readonly unprintableLeft: number;
        readonly unprintableRight: number;
        readonly unprintableTop: number;
        updatePageStatus(p: number): void;
        usePrinterCopyCollate: boolean;
    }

    class CTemplatePrinter {
        private 'MSHTML.CTemplatePrinter_typekey': CTemplatePrinter;
        private constructor();
        allLinkedDocuments: boolean;
        collate: boolean;
        copies: number;
        currentPage: boolean;
        currentPageAvail: boolean;
        deviceSupports(bstrProperty: string): any;
        readonly duplex: boolean;
        ensurePrintDialogDefaults(): boolean;
        footer: string;
        frameActive: boolean;
        frameActiveEnabled: boolean;
        frameAsShown: boolean;
        framesetDocument: boolean;
        getPageMarginBottom(pageRule: any, pageWidth: number, pageHeight: number): any;
        getPageMarginBottomImportant(pageRule: any): boolean;
        getPageMarginLeft(pageRule: any, pageWidth: number, pageHeight: number): any;
        getPageMarginLeftImportant(pageRule: any): boolean;
        getPageMarginRight(pageRule: any, pageWidth: number, pageHeight: number): any;
        getPageMarginRightImportant(pageRule: any): boolean;
        getPageMarginTop(pageRule: any, pageWidth: number, pageHeight: number): any;
        getPageMarginTopImportant(pageRule: any): boolean;
        header: string;
        headerFooterFont: string;
        marginBottom: number;
        marginLeft: number;
        marginRight: number;
        marginTop: number;
        orientation: string;
        pageFrom: number;
        readonly pageHeight: number;
        pageTo: number;
        readonly pageWidth: number;
        printBlankPage(): void;
        printNonNative(pMarkup: any): boolean;
        printNonNativeFrames(pMarkup: any, fActiveFrame: boolean): void;
        printPage(pElemDisp: any): void;
        selectedPages: boolean;
        selection: boolean;
        selectionEnabled: boolean;
        showPageSetupDialog(): boolean;
        showPrintDialog(): boolean;
        startDoc(bstrTitle: string): boolean;
        stopDoc(): void;
        tableOfLinks: boolean;
        readonly unprintableBottom: number;
        readonly unprintableLeft: number;
        readonly unprintableRight: number;
        readonly unprintableTop: number;
        updatePageStatus(p: number): void;
        usePrinterCopyCollate: boolean;
    }

    class DOMBeforeUnloadEvent {
        private 'MSHTML.DOMBeforeUnloadEvent_typekey': DOMBeforeUnloadEvent;
        private constructor();
        readonly bubbles: boolean;
        readonly cancelable: boolean;
        cancelBubble: boolean;
        readonly currentTarget: IEventTarget;
        readonly defaultPrevented: boolean;
        readonly eventPhase: number;
        initEvent(eventType: string, canBubble: boolean, cancelable: boolean): void;
        readonly isTrusted: boolean;
        preventDefault(): void;
        returnValue: any;
        readonly srcElement: IHTMLElement;
        stopImmediatePropagation(): void;
        stopPropagation(): void;
        readonly target: IEventTarget;
        readonly timeStamp: number;
        readonly type: string;
    }

    class DOMChildrenCollection {
        private 'MSHTML.DOMChildrenCollection_typekey': DOMChildrenCollection;
        private constructor();
        readonly 'constructor': any;
        ie9_item(index: number): any;
        item(index: number): any;
        readonly length: number;
    }

    class DOMCloseEvent {
        private 'MSHTML.DOMCloseEvent_typekey': DOMCloseEvent;
        private constructor();
        readonly bubbles: boolean;
        readonly cancelable: boolean;
        cancelBubble: boolean;
        readonly currentTarget: IEventTarget;
        readonly defaultPrevented: boolean;
        readonly eventPhase: number;
        initCloseEvent(eventType: string, canBubble: boolean, cancelable: boolean, wasClean: boolean, code: number, reason: string): void;
        initEvent(eventType: string, canBubble: boolean, cancelable: boolean): void;
        readonly isTrusted: boolean;
        preventDefault(): void;
        readonly srcElement: IHTMLElement;
        stopImmediatePropagation(): void;
        stopPropagation(): void;
        readonly target: IEventTarget;
        readonly timeStamp: number;
        readonly type: string;
        readonly wasClean: boolean;
    }

    class DOMCompositionEvent {
        private 'MSHTML.DOMCompositionEvent_typekey': DOMCompositionEvent;
        private constructor();
        readonly bubbles: boolean;
        readonly cancelable: boolean;
        cancelBubble: boolean;
        readonly currentTarget: IEventTarget;
        readonly data: string;
        readonly defaultPrevented: boolean;
        readonly detail: number;
        readonly eventPhase: number;
        initCompositionEvent(eventType: string, canBubble: boolean, cancelable: boolean, viewArg: IHTMLWindow2, data: string, locale: string): void;
        initEvent(eventType: string, canBubble: boolean, cancelable: boolean): void;
        initUIEvent(eventType: string, canBubble: boolean, cancelable: boolean, view: IHTMLWindow2, detail: number): void;
        readonly isTrusted: boolean;
        readonly locale: string;
        preventDefault(): void;
        readonly srcElement: IHTMLElement;
        stopImmediatePropagation(): void;
        stopPropagation(): void;
        readonly target: IEventTarget;
        readonly timeStamp: number;
        readonly type: string;
        readonly view: IHTMLWindow2;
    }

    class DOMCustomEvent {
        private 'MSHTML.DOMCustomEvent_typekey': DOMCustomEvent;
        private constructor();
        readonly bubbles: boolean;
        readonly cancelable: boolean;
        cancelBubble: boolean;
        readonly currentTarget: IEventTarget;
        readonly defaultPrevented: boolean;
        readonly detail: any;
        readonly eventPhase: number;
        initCustomEvent(eventType: string, canBubble: boolean, cancelable: boolean, detail: any): void;
        initEvent(eventType: string, canBubble: boolean, cancelable: boolean): void;
        readonly isTrusted: boolean;
        preventDefault(): void;
        readonly srcElement: IHTMLElement;
        stopImmediatePropagation(): void;
        stopPropagation(): void;
        readonly target: IEventTarget;
        readonly timeStamp: number;
        readonly type: string;
    }

    class DOMDocumentType {
        private 'MSHTML.DOMDocumentType_typekey': DOMDocumentType;
        private constructor();
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        readonly attributes: any;
        readonly childNodes: any;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        readonly entities: any;
        readonly firstChild: IHTMLDOMNode;
        hasChildNodes(): boolean;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly internalSubset: any;
        isDefaultNamespace(pvarNamespace: any): boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly lastChild: IHTMLDOMNode;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        readonly name: string;
        readonly namespaceURI: any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        readonly notations: any;
        readonly ownerDocument: any;
        readonly parentNode: IHTMLDOMNode;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        readonly publicId: any;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        readonly systemId: any;
        textContent: any;
    }

    class DOMDragEvent {
        private 'MSHTML.DOMDragEvent_typekey': DOMDragEvent;
        private constructor();
        readonly altKey: boolean;
        readonly bubbles: boolean;
        readonly button: number;
        readonly buttons: number;
        readonly cancelable: boolean;
        cancelBubble: boolean;
        readonly clientX: number;
        readonly clientY: number;
        readonly ctrlKey: boolean;
        readonly currentTarget: IEventTarget;
        readonly dataTransfer: IHTMLDataTransfer;
        readonly defaultPrevented: boolean;
        readonly detail: number;
        readonly eventPhase: number;
        readonly fromElement: IHTMLElement;
        getModifierState(keyArg: string): boolean;
        initDragEvent(
            eventType: string, canBubble: boolean, cancelable: boolean, viewArg: IHTMLWindow2, detailArg: number, screenXArg: number, screenYArg: number,
            clientXArg: number, clientYArg: number, ctrlKeyArg: boolean, altKeyArg: boolean, shiftKeyArg: boolean, metaKeyArg: boolean, buttonArg: number,
            relatedTargetArg: IEventTarget, dataTransferArg: IHTMLDataTransfer): void;
        initEvent(eventType: string, canBubble: boolean, cancelable: boolean): void;
        initMouseEvent(
            eventType: string, canBubble: boolean, cancelable: boolean, viewArg: IHTMLWindow2, detailArg: number, screenXArg: number, screenYArg: number,
            clientXArg: number, clientYArg: number, ctrlKeyArg: boolean, altKeyArg: boolean, shiftKeyArg: boolean, metaKeyArg: boolean, buttonArg: number, relatedTargetArg: IEventTarget): void;
        initUIEvent(eventType: string, canBubble: boolean, cancelable: boolean, view: IHTMLWindow2, detail: number): void;
        readonly isTrusted: boolean;
        readonly layerX: number;
        readonly layerY: number;
        readonly metaKey: boolean;
        readonly offsetX: number;
        readonly offsetY: number;
        readonly pageX: number;
        readonly pageY: number;
        preventDefault(): void;
        readonly relatedTarget: IEventTarget;
        readonly screenX: number;
        readonly screenY: number;
        readonly shiftKey: boolean;
        readonly srcElement: IHTMLElement;
        stopImmediatePropagation(): void;
        stopPropagation(): void;
        readonly target: IEventTarget;
        readonly timeStamp: number;
        readonly toElement: IHTMLElement;
        readonly type: string;
        readonly view: IHTMLWindow2;
        readonly which: number;
        readonly x: number;
        readonly y: number;
    }

    class DOMEvent {
        private 'MSHTML.DOMEvent_typekey': DOMEvent;
        private constructor();
        readonly bubbles: boolean;
        readonly cancelable: boolean;
        cancelBubble: boolean;
        readonly currentTarget: IEventTarget;
        readonly defaultPrevented: boolean;
        readonly eventPhase: number;
        initEvent(eventType: string, canBubble: boolean, cancelable: boolean): void;
        readonly isTrusted: boolean;
        preventDefault(): void;
        readonly srcElement: IHTMLElement;
        stopImmediatePropagation(): void;
        stopPropagation(): void;
        readonly target: IEventTarget;
        readonly timeStamp: number;
        readonly type: string;
    }

    class DOMException {
        private 'MSHTML.DOMException_typekey': DOMException;
        private constructor();
        code: number;
        readonly message: string;
    }

    class DOMFocusEvent {
        private 'MSHTML.DOMFocusEvent_typekey': DOMFocusEvent;
        private constructor();
        readonly bubbles: boolean;
        readonly cancelable: boolean;
        cancelBubble: boolean;
        readonly currentTarget: IEventTarget;
        readonly defaultPrevented: boolean;
        readonly detail: number;
        readonly eventPhase: number;
        initEvent(eventType: string, canBubble: boolean, cancelable: boolean): void;
        initFocusEvent(eventType: string, canBubble: boolean, cancelable: boolean, view: IHTMLWindow2, detail: number, relatedTargetArg: IEventTarget): void;
        initUIEvent(eventType: string, canBubble: boolean, cancelable: boolean, view: IHTMLWindow2, detail: number): void;
        readonly isTrusted: boolean;
        preventDefault(): void;
        readonly relatedTarget: IEventTarget;
        readonly srcElement: IHTMLElement;
        stopImmediatePropagation(): void;
        stopPropagation(): void;
        readonly target: IEventTarget;
        readonly timeStamp: number;
        readonly type: string;
        readonly view: IHTMLWindow2;
    }

    class DOMKeyboardEvent {
        private 'MSHTML.DOMKeyboardEvent_typekey': DOMKeyboardEvent;
        private constructor();
        readonly altKey: boolean;
        readonly bubbles: boolean;
        readonly cancelable: boolean;
        cancelBubble: boolean;
        readonly charCode: number;
        readonly ctrlKey: boolean;
        readonly currentTarget: IEventTarget;
        readonly defaultPrevented: boolean;
        readonly detail: number;
        readonly eventPhase: number;
        getModifierState(keyArg: string): boolean;
        readonly ie9_char: any;
        initEvent(eventType: string, canBubble: boolean, cancelable: boolean): void;
        initKeyboardEvent(
            eventType: string, canBubble: boolean, cancelable: boolean, viewArg: IHTMLWindow2, keyArg: string, locationArg: number, modifiersListArg: string, repeat: boolean, locale: string): void;
        initUIEvent(eventType: string, canBubble: boolean, cancelable: boolean, view: IHTMLWindow2, detail: number): void;
        readonly isTrusted: boolean;
        readonly key: string;
        readonly keyCode: number;
        readonly locale: string;
        readonly location: number;
        readonly metaKey: boolean;
        preventDefault(): void;
        readonly repeat: boolean;
        readonly shiftKey: boolean;
        readonly srcElement: IHTMLElement;
        stopImmediatePropagation(): void;
        stopPropagation(): void;
        readonly target: IEventTarget;
        readonly timeStamp: number;
        readonly type: string;
        readonly view: IHTMLWindow2;
        readonly which: number;
    }

    class DOMMessageEvent {
        private 'MSHTML.DOMMessageEvent_typekey': DOMMessageEvent;
        private constructor();
        readonly bubbles: boolean;
        readonly cancelable: boolean;
        cancelBubble: boolean;
        readonly currentTarget: IEventTarget;
        readonly data: string;
        readonly defaultPrevented: boolean;
        readonly eventPhase: number;
        initEvent(eventType: string, canBubble: boolean, cancelable: boolean): void;
        initMessageEvent(eventType: string, canBubble: boolean, cancelable: boolean, data: string, origin: string, lastEventId: string, source: IHTMLWindow2): void;
        readonly isTrusted: boolean;
        readonly origin: string;
        preventDefault(): void;
        readonly source: IHTMLWindow2;
        readonly srcElement: IHTMLElement;
        stopImmediatePropagation(): void;
        stopPropagation(): void;
        readonly target: IEventTarget;
        readonly timeStamp: number;
        readonly type: string;
    }

    class DOMMouseEvent {
        private 'MSHTML.DOMMouseEvent_typekey': DOMMouseEvent;
        private constructor();
        readonly altKey: boolean;
        readonly bubbles: boolean;
        readonly button: number;
        readonly buttons: number;
        readonly cancelable: boolean;
        cancelBubble: boolean;
        readonly clientX: number;
        readonly clientY: number;
        readonly ctrlKey: boolean;
        readonly currentTarget: IEventTarget;
        readonly defaultPrevented: boolean;
        readonly detail: number;
        readonly eventPhase: number;
        readonly fromElement: IHTMLElement;
        getModifierState(keyArg: string): boolean;
        initEvent(eventType: string, canBubble: boolean, cancelable: boolean): void;
        initMouseEvent(
            eventType: string, canBubble: boolean, cancelable: boolean, viewArg: IHTMLWindow2, detailArg: number, screenXArg: number, screenYArg: number,
            clientXArg: number, clientYArg: number, ctrlKeyArg: boolean, altKeyArg: boolean, shiftKeyArg: boolean, metaKeyArg: boolean, buttonArg: number, relatedTargetArg: IEventTarget): void;
        initUIEvent(eventType: string, canBubble: boolean, cancelable: boolean, view: IHTMLWindow2, detail: number): void;
        readonly isTrusted: boolean;
        readonly layerX: number;
        readonly layerY: number;
        readonly metaKey: boolean;
        readonly offsetX: number;
        readonly offsetY: number;
        readonly pageX: number;
        readonly pageY: number;
        preventDefault(): void;
        readonly relatedTarget: IEventTarget;
        readonly screenX: number;
        readonly screenY: number;
        readonly shiftKey: boolean;
        readonly srcElement: IHTMLElement;
        stopImmediatePropagation(): void;
        stopPropagation(): void;
        readonly target: IEventTarget;
        readonly timeStamp: number;
        readonly toElement: IHTMLElement;
        readonly type: string;
        readonly view: IHTMLWindow2;
        readonly which: number;
        readonly x: number;
        readonly y: number;
    }

    class DOMMouseWheelEvent {
        private 'MSHTML.DOMMouseWheelEvent_typekey': DOMMouseWheelEvent;
        private constructor();
        readonly altKey: boolean;
        readonly bubbles: boolean;
        readonly button: number;
        readonly buttons: number;
        readonly cancelable: boolean;
        cancelBubble: boolean;
        readonly clientX: number;
        readonly clientY: number;
        readonly ctrlKey: boolean;
        readonly currentTarget: IEventTarget;
        readonly defaultPrevented: boolean;
        readonly detail: number;
        readonly eventPhase: number;
        readonly fromElement: IHTMLElement;
        getModifierState(keyArg: string): boolean;
        initEvent(eventType: string, canBubble: boolean, cancelable: boolean): void;
        initMouseEvent(
            eventType: string, canBubble: boolean, cancelable: boolean, viewArg: IHTMLWindow2, detailArg: number, screenXArg: number, screenYArg: number,
            clientXArg: number, clientYArg: number, ctrlKeyArg: boolean, altKeyArg: boolean, shiftKeyArg: boolean, metaKeyArg: boolean, buttonArg: number, relatedTargetArg: IEventTarget): void;
        initMouseWheelEvent(
            eventType: string, canBubble: boolean, cancelable: boolean, viewArg: IHTMLWindow2, detailArg: number, screenXArg: number, screenYArg: number,
            clientXArg: number, clientYArg: number, buttonArg: number, relatedTargetArg: IEventTarget, modifiersListArg: string, wheelDeltaArg: number): void;
        initUIEvent(eventType: string, canBubble: boolean, cancelable: boolean, view: IHTMLWindow2, detail: number): void;
        readonly isTrusted: boolean;
        readonly layerX: number;
        readonly layerY: number;
        readonly metaKey: boolean;
        readonly offsetX: number;
        readonly offsetY: number;
        readonly pageX: number;
        readonly pageY: number;
        preventDefault(): void;
        readonly relatedTarget: IEventTarget;
        readonly screenX: number;
        readonly screenY: number;
        readonly shiftKey: boolean;
        readonly srcElement: IHTMLElement;
        stopImmediatePropagation(): void;
        stopPropagation(): void;
        readonly target: IEventTarget;
        readonly timeStamp: number;
        readonly toElement: IHTMLElement;
        readonly type: string;
        readonly view: IHTMLWindow2;
        readonly wheelDelta: number;
        readonly which: number;
        readonly x: number;
        readonly y: number;
    }

    class DOMMSAnimationEvent {
        private 'MSHTML.DOMMSAnimationEvent_typekey': DOMMSAnimationEvent;
        private constructor();
        readonly animationName: string;
        readonly bubbles: boolean;
        readonly cancelable: boolean;
        cancelBubble: boolean;
        readonly currentTarget: IEventTarget;
        readonly defaultPrevented: boolean;
        readonly elapsedTime: number;
        readonly eventPhase: number;
        initEvent(eventType: string, canBubble: boolean, cancelable: boolean): void;
        initMSAnimationEvent(eventType: string, canBubble: boolean, cancelable: boolean, animationName: string, elapsedTime: number): void;
        readonly isTrusted: boolean;
        preventDefault(): void;
        readonly srcElement: IHTMLElement;
        stopImmediatePropagation(): void;
        stopPropagation(): void;
        readonly target: IEventTarget;
        readonly timeStamp: number;
        readonly type: string;
    }

    class DOMMSManipulationEvent {
        private 'MSHTML.DOMMSManipulationEvent_typekey': DOMMSManipulationEvent;
        private constructor();
        readonly bubbles: boolean;
        readonly cancelable: boolean;
        cancelBubble: boolean;
        readonly currentState: number;
        readonly currentTarget: IEventTarget;
        readonly defaultPrevented: boolean;
        readonly detail: number;
        readonly eventPhase: number;
        initEvent(eventType: string, canBubble: boolean, cancelable: boolean): void;
        initMSManipulationEvent(eventType: string, canBubble: boolean, cancelable: boolean, viewArg: IHTMLWindow2, detailArg: number, lastState: number, currentState: number): void;
        initUIEvent(eventType: string, canBubble: boolean, cancelable: boolean, view: IHTMLWindow2, detail: number): void;
        readonly isTrusted: boolean;
        readonly lastState: number;
        preventDefault(): void;
        readonly srcElement: IHTMLElement;
        stopImmediatePropagation(): void;
        stopPropagation(): void;
        readonly target: IEventTarget;
        readonly timeStamp: number;
        readonly type: string;
        readonly view: IHTMLWindow2;
    }

    class DOMMSTransitionEvent {
        private 'MSHTML.DOMMSTransitionEvent_typekey': DOMMSTransitionEvent;
        private constructor();
        readonly bubbles: boolean;
        readonly cancelable: boolean;
        cancelBubble: boolean;
        readonly currentTarget: IEventTarget;
        readonly defaultPrevented: boolean;
        readonly elapsedTime: number;
        readonly eventPhase: number;
        initEvent(eventType: string, canBubble: boolean, cancelable: boolean): void;
        initMSTransitionEvent(eventType: string, canBubble: boolean, cancelable: boolean, propertyName: string, elapsedTime: number): void;
        readonly isTrusted: boolean;
        preventDefault(): void;
        readonly propertyName: string;
        readonly srcElement: IHTMLElement;
        stopImmediatePropagation(): void;
        stopPropagation(): void;
        readonly target: IEventTarget;
        readonly timeStamp: number;
        readonly type: string;
    }

    class DOMMutationEvent {
        private 'MSHTML.DOMMutationEvent_typekey': DOMMutationEvent;
        private constructor();
        readonly attrChange: number;
        readonly attrName: string;
        readonly bubbles: boolean;
        readonly cancelable: boolean;
        cancelBubble: boolean;
        readonly currentTarget: IEventTarget;
        readonly defaultPrevented: boolean;
        readonly eventPhase: number;
        initEvent(eventType: string, canBubble: boolean, cancelable: boolean): void;
        initMutationEvent(
            eventType: string, canBubble: boolean, cancelable: boolean, relatedNodeArg: any, prevValueArg: string, newValueArg: string, attrNameArg: string, attrChangeArg: number): void;
        readonly isTrusted: boolean;
        readonly newValue: string;
        preventDefault(): void;
        readonly prevValue: string;
        readonly relatedNode: any;
        readonly srcElement: IHTMLElement;
        stopImmediatePropagation(): void;
        stopPropagation(): void;
        readonly target: IEventTarget;
        readonly timeStamp: number;
        readonly type: string;
    }

    class DOMParser {
        private 'MSHTML.DOMParser_typekey': DOMParser;
        private constructor();
        parseFromString(xmlSource: string, mimeType: string): IHTMLDocument2;
    }

    class DOMParserFactory {
        private 'MSHTML.DOMParserFactory_typekey': DOMParserFactory;
        private constructor();
        create(): IDOMParser;
    }

    class DOMProcessingInstruction {
        private 'MSHTML.DOMProcessingInstruction_typekey': DOMProcessingInstruction;
        private constructor();
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        readonly attributes: any;
        readonly childNodes: any;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        data: string;
        readonly firstChild: IHTMLDOMNode;
        hasChildNodes(): boolean;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        isDefaultNamespace(pvarNamespace: any): boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly lastChild: IHTMLDOMNode;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        readonly namespaceURI: any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        readonly ownerDocument: any;
        readonly parentNode: IHTMLDOMNode;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        readonly target: string;
        textContent: any;
    }

    class DOMProgressEvent {
        private 'MSHTML.DOMProgressEvent_typekey': DOMProgressEvent;
        private constructor();
        readonly bubbles: boolean;
        readonly cancelable: boolean;
        cancelBubble: boolean;
        readonly currentTarget: IEventTarget;
        readonly defaultPrevented: boolean;
        readonly eventPhase: number;
        initEvent(eventType: string, canBubble: boolean, cancelable: boolean): void;
        initProgressEvent(eventType: string, canBubble: boolean, cancelable: boolean, lengthComputableArg: boolean, loadedArg: number, totalArg: number): void;
        readonly isTrusted: boolean;
        readonly lengthComputable: boolean;
        readonly loaded: number;
        preventDefault(): void;
        readonly srcElement: IHTMLElement;
        stopImmediatePropagation(): void;
        stopPropagation(): void;
        readonly target: IEventTarget;
        readonly timeStamp: number;
        readonly total: number;
        readonly type: string;
    }

    class DOMSiteModeEvent {
        private 'MSHTML.DOMSiteModeEvent_typekey': DOMSiteModeEvent;
        private constructor();
        readonly actionURL: string;
        readonly bubbles: boolean;
        readonly buttonID: number;
        readonly cancelable: boolean;
        cancelBubble: boolean;
        readonly currentTarget: IEventTarget;
        readonly defaultPrevented: boolean;
        readonly eventPhase: number;
        initEvent(eventType: string, canBubble: boolean, cancelable: boolean): void;
        readonly isTrusted: boolean;
        preventDefault(): void;
        readonly srcElement: IHTMLElement;
        stopImmediatePropagation(): void;
        stopPropagation(): void;
        readonly target: IEventTarget;
        readonly timeStamp: number;
        readonly type: string;
    }

    class DOMStorageEvent {
        private 'MSHTML.DOMStorageEvent_typekey': DOMStorageEvent;
        private constructor();
        readonly bubbles: boolean;
        readonly cancelable: boolean;
        cancelBubble: boolean;
        readonly currentTarget: IEventTarget;
        readonly defaultPrevented: boolean;
        readonly eventPhase: number;
        initEvent(eventType: string, canBubble: boolean, cancelable: boolean): void;
        initStorageEvent(
            eventType: string, canBubble: boolean, cancelable: boolean, keyArg: string, oldValueArg: string, newValueArg: string, urlArg: string, storageAreaArg: IHTMLStorage): void;
        readonly isTrusted: boolean;
        readonly key: string;
        readonly newValue: string;
        readonly oldValue: string;
        preventDefault(): void;
        readonly srcElement: IHTMLElement;
        stopImmediatePropagation(): void;
        stopPropagation(): void;
        readonly storageArea: IHTMLStorage;
        readonly target: IEventTarget;
        readonly timeStamp: number;
        readonly type: string;
        readonly url: string;
    }

    class DOMTextEvent {
        private 'MSHTML.DOMTextEvent_typekey': DOMTextEvent;
        private constructor();
        readonly bubbles: boolean;
        readonly cancelable: boolean;
        cancelBubble: boolean;
        readonly currentTarget: IEventTarget;
        readonly data: string;
        readonly defaultPrevented: boolean;
        readonly detail: number;
        readonly eventPhase: number;
        initEvent(eventType: string, canBubble: boolean, cancelable: boolean): void;
        initTextEvent(eventType: string, canBubble: boolean, cancelable: boolean, viewArg: IHTMLWindow2, dataArg: string, inputMethod: number, locale: string): void;
        initUIEvent(eventType: string, canBubble: boolean, cancelable: boolean, view: IHTMLWindow2, detail: number): void;
        readonly inputMethod: number;
        readonly isTrusted: boolean;
        readonly locale: string;
        preventDefault(): void;
        readonly srcElement: IHTMLElement;
        stopImmediatePropagation(): void;
        stopPropagation(): void;
        readonly target: IEventTarget;
        readonly timeStamp: number;
        readonly type: string;
        readonly view: IHTMLWindow2;
    }

    class DOMUIEvent {
        private 'MSHTML.DOMUIEvent_typekey': DOMUIEvent;
        private constructor();
        readonly bubbles: boolean;
        readonly cancelable: boolean;
        cancelBubble: boolean;
        readonly currentTarget: IEventTarget;
        readonly defaultPrevented: boolean;
        readonly detail: number;
        readonly eventPhase: number;
        initEvent(eventType: string, canBubble: boolean, cancelable: boolean): void;
        initUIEvent(eventType: string, canBubble: boolean, cancelable: boolean, view: IHTMLWindow2, detail: number): void;
        readonly isTrusted: boolean;
        preventDefault(): void;
        readonly srcElement: IHTMLElement;
        stopImmediatePropagation(): void;
        stopPropagation(): void;
        readonly target: IEventTarget;
        readonly timeStamp: number;
        readonly type: string;
        readonly view: IHTMLWindow2;
    }

    class DOMWheelEvent {
        private 'MSHTML.DOMWheelEvent_typekey': DOMWheelEvent;
        private constructor();
        readonly altKey: boolean;
        readonly bubbles: boolean;
        readonly button: number;
        readonly buttons: number;
        readonly cancelable: boolean;
        cancelBubble: boolean;
        readonly clientX: number;
        readonly clientY: number;
        readonly ctrlKey: boolean;
        readonly currentTarget: IEventTarget;
        readonly defaultPrevented: boolean;
        readonly deltaMode: number;
        readonly deltaX: number;
        readonly deltaY: number;
        readonly deltaZ: number;
        readonly detail: number;
        readonly eventPhase: number;
        readonly fromElement: IHTMLElement;
        getModifierState(keyArg: string): boolean;
        initEvent(eventType: string, canBubble: boolean, cancelable: boolean): void;
        initMouseEvent(
            eventType: string, canBubble: boolean, cancelable: boolean, viewArg: IHTMLWindow2, detailArg: number, screenXArg: number, screenYArg: number,
            clientXArg: number, clientYArg: number, ctrlKeyArg: boolean, altKeyArg: boolean, shiftKeyArg: boolean, metaKeyArg: boolean, buttonArg: number, relatedTargetArg: IEventTarget): void;
        initUIEvent(eventType: string, canBubble: boolean, cancelable: boolean, view: IHTMLWindow2, detail: number): void;
        initWheelEvent(
            eventType: string, canBubble: boolean, cancelable: boolean, viewArg: IHTMLWindow2, detailArg: number, screenXArg: number, screenYArg: number,
            clientXArg: number, clientYArg: number, buttonArg: number, relatedTargetArg: IEventTarget, modifiersListArg: string, deltaX: number, deltaY: number,
            deltaZ: number, deltaMode: number): void;
        readonly isTrusted: boolean;
        readonly layerX: number;
        readonly layerY: number;
        readonly metaKey: boolean;
        readonly offsetX: number;
        readonly offsetY: number;
        readonly pageX: number;
        readonly pageY: number;
        preventDefault(): void;
        readonly relatedTarget: IEventTarget;
        readonly screenX: number;
        readonly screenY: number;
        readonly shiftKey: boolean;
        readonly srcElement: IHTMLElement;
        stopImmediatePropagation(): void;
        stopPropagation(): void;
        readonly target: IEventTarget;
        readonly timeStamp: number;
        readonly toElement: IHTMLElement;
        readonly type: string;
        readonly view: IHTMLWindow2;
        readonly which: number;
        readonly x: number;
        readonly y: number;
    }

    class EventException {
        private 'MSHTML.EventException_typekey': EventException;
        private constructor();
    }

    class FontNames {
        private 'MSHTML.FontNames_typekey': FontNames;
        private constructor();
        readonly Count: number;
        item(pvarIndex: any): string;
    }

    class FramesCollection {
        private 'MSHTML.FramesCollection_typekey': FramesCollection;
        private constructor();
        item(pvarIndex: any): any;
        readonly length: number;
    }

    class HTCAttachBehavior {
        private 'MSHTML.HTCAttachBehavior_typekey': HTCAttachBehavior;
        private constructor();
        detachEvent(): void;
        FireEvent(evt: any): void;
    }

    class HTCDefaultDispatch {
        private 'MSHTML.HTCDefaultDispatch_typekey': HTCDefaultDispatch;
        private constructor();
        CreateEventObject(): IHTMLEventObj;
        readonly defaults: any;
        readonly document: any;
        readonly element: IHTMLElement;
    }

    class HTCDescBehavior {
        private 'MSHTML.HTCDescBehavior_typekey': HTCDescBehavior;
        private constructor();
        readonly name: string;
        readonly urn: string;
    }

    class HTCEventBehavior {
        private 'MSHTML.HTCEventBehavior_typekey': HTCEventBehavior;
        private constructor();
        fire(pVar: IHTMLEventObj): void;
    }

    class HTCMethodBehavior {
        private 'MSHTML.HTCMethodBehavior_typekey': HTCMethodBehavior;
        private constructor();
    }

    class HTCPropertyBehavior {
        private 'MSHTML.HTCPropertyBehavior_typekey': HTCPropertyBehavior;
        private constructor();
        fireChange(): void;
        value: any;
    }

    class HTMLAnchorElement {
        private 'MSHTML.HTMLAnchorElement_typekey': HTMLAnchorElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        charset: string;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        coords: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        dataFld: string;
        dataFormatAs: string;
        dataSrc: string;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hash: string;
        hideFocus: boolean;
        host: string;
        hostname: string;
        href: string;
        hreflang: string;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_coords: string;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_href: string;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_shape: string;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        isDefaultNamespace(pvarNamespace: any): boolean;
        readonly isDisabled: boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        readonly isMultiLine: boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        Methods: string;
        readonly mimeType: string;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        name: string;
        readonly nameProp: string;
        readonly namespaceURI: any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        pathname: string;
        port: string;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        protocol: string;
        readonly protocolLong: string;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readonly readyState: any;
        readonly recordNumber: any;
        rel: string;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        rev: string;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        search: string;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        shape: string;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        target: string;
        textContent: any;
        title: string;
        toString(): string;
        type: string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        urn: string;
        xmsAcceleratorKey: string;
    }

    class HTMLAppBehavior {
        private 'MSHTML.HTMLAppBehavior_typekey': HTMLAppBehavior;
        private constructor();
        applicationName: string;
        border: string;
        borderStyle: string;
        caption: string;
        readonly commandLine: string;
        contextMenu: string;
        icon: string;
        innerBorder: string;
        maximizeButton: string;
        minimizeButton: string;
        scroll: string;
        scrollFlat: string;
        selection: string;
        showInTaskBar: string;
        singleInstance: string;
        sysMenu: string;
        version: string;
        windowState: string;
    }

    class HTMLAreaElement {
        private 'MSHTML.HTMLAreaElement_typekey': HTMLAreaElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        alt: string;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        coords: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hash: string;
        hideFocus: boolean;
        host: string;
        hostname: string;
        href: string;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_coords: string;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_href: string;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_shape: string;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        noHref: boolean;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        pathname: string;
        port: string;
        readonly previousSibling: IHTMLDOMNode;
        protocol: string;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        search: string;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        shape: string;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        target: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLAreasCollection {
        private 'MSHTML.HTMLAreasCollection_typekey': HTMLAreasCollection;
        private constructor();
        add(element: IHTMLElement, before?: any): void;
        readonly 'constructor': any;
        ie8_item(index: number): IHTMLElement2;
        readonly ie8_length: number;
        ie8_namedItem(name: string): IHTMLElement2;
        item(name?: any, index?: any): any;
        length: number;
        namedItem(name: string): any;

        /** @param number [index=-1] */
        remove(index?: number): void;
        tags(tagName: any): any;
        urns(urn: any): any;
    }

    class HTMLAttributeCollection {
        private 'MSHTML.HTMLAttributeCollection_typekey': HTMLAttributeCollection;
        private constructor();
        readonly 'constructor': any;
        getNamedItem(bstrName: string): IHTMLDOMAttribute;
        getNamedItemNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        ie8_getNamedItem(bstrName: string): IHTMLDOMAttribute;
        ie8_item(index: number): IHTMLDOMAttribute;
        readonly ie8_length: number;
        ie8_removeNamedItem(bstrName: string): IHTMLDOMAttribute;
        ie8_setNamedItem(pNodeIn: IHTMLDOMAttribute): IHTMLDOMAttribute;
        ie9_getNamedItem(bstrName: string): IHTMLDOMAttribute2;
        ie9_item(index: number): IHTMLDOMAttribute2;
        readonly ie9_length: number;
        ie9_removeNamedItem(bstrName: string): IHTMLDOMAttribute2;
        ie9_setNamedItem(pNodeIn: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        item(name?: any): any;
        readonly length: number;
        removeNamedItem(bstrName: string): IHTMLDOMAttribute;
        removeNamedItemNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        setNamedItem(ppNode: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setNamedItemNS(pNodeIn: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
    }

    class HTMLAudioElement {
        private 'MSHTML.HTMLAudioElement_typekey': HTMLAudioElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        autobuffer: boolean;
        autoplay: boolean;
        readonly behaviorUrns: any;
        blur(): void;
        readonly buffered: IHTMLTimeRanges;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        canPlayType(type: string): string;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        controls: boolean;
        createControlRange(): any;
        readonly currentSrc: string;
        readonly currentStyle: IHTMLCurrentStyle;
        currentTime: number;
        currentTimeDouble: number;
        dataFld: string;
        dataFormatAs: string;
        dataSrc: string;
        defaultPlaybackRate: number;
        defaultPlaybackRateDouble: number;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly duration: number;
        readonly durationDouble: number;
        readonly ended: boolean;
        readonly error: IHTMLMediaError;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        readonly initialTime: number;
        readonly initialTimeDouble: number;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        isDefaultNamespace(pvarNamespace: any): boolean;
        readonly isDisabled: boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        readonly isMultiLine: boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        load(): void;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        loop: boolean;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msPlayToDisabled: boolean;
        msPlayToPrimary: boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        muted: boolean;
        readonly namespaceURI: any;
        readonly networkState: number;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        pause(): void;
        readonly paused: boolean;
        play(): void;
        playbackRate: number;
        playbackRateDouble: number;
        readonly played: IHTMLTimeRanges;
        prefix: any;
        preload: string;
        readonly previousSibling: IHTMLDOMNode;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        readonly seekable: IHTMLTimeRanges;
        readonly seeking: boolean;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        src: string;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        textContent: any;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        volume: number;
        volumeDouble: number;
        xmsAcceleratorKey: string;
    }

    class HTMLAudioElementFactory {
        private 'MSHTML.HTMLAudioElementFactory_typekey': HTMLAudioElementFactory;
        private constructor();
        create(src?: any): IHTMLAudioElement;
    }

    class HTMLBaseElement {
        private 'MSHTML.HTMLBaseElement_typekey': HTMLBaseElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        href: string;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_href: string;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        target: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLBaseFontElement {
        private 'MSHTML.HTMLBaseFontElement_typekey': HTMLBaseFontElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        color: any;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        face: string;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        size: number;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLBGsound {
        private 'MSHTML.HTMLBGsound_typekey': HTMLBGsound;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        balance: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        loop: any;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        src: string;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        volume: any;
        xmsAcceleratorKey: string;
    }

    class HTMLBlockElement {
        private 'MSHTML.HTMLBlockElement_typekey': HTMLBlockElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        cite: string;
        className: string;
        clear: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_cite: string;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        width: string;
        xmsAcceleratorKey: string;
    }

    class HTMLBody {
        private 'MSHTML.HTMLBody_typekey': HTMLBody;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        aLink: any;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        background: string;
        readonly behaviorUrns: any;
        bgColor: any;
        bgProperties: string;
        blur(): void;
        bottomMargin: any;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        createTextRange(): IHTMLTxtRange;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_background: string;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        leftMargin: any;
        link: any;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        noWrap: boolean;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterprint: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeprint: any;
        onbeforeunload: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhashchange: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmessage: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onoffline: any;
        ononline: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onpopstate: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onstorage: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onunload: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        rightMargin: any;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        scroll: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        text: any;
        title: string;
        topMargin: any;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        vLink: any;
        xmsAcceleratorKey: string;
    }

    class HTMLBRElement {
        private 'MSHTML.HTMLBRElement_typekey': HTMLBRElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clear: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLButtonElement {
        private 'MSHTML.HTMLButtonElement_typekey': HTMLButtonElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        createTextRange(): IHTMLTxtRange;
        readonly currentStyle: IHTMLCurrentStyle;
        dataFld: string;
        dataFormatAs: string;
        dataSrc: string;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        readonly form: IHTMLFormElement;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        ie9_type: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        isDefaultNamespace(pvarNamespace: any): boolean;
        readonly isDisabled: boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        readonly isMultiLine: boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        name: string;
        readonly namespaceURI: any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        status: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        textContent: any;
        title: string;
        toString(): string;
        readonly type: string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        value: string;
        xmsAcceleratorKey: string;
    }

    class HTMLCanvasElement {
        private 'MSHTML.HTMLCanvasElement_typekey': HTMLCanvasElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getContext(contextId: string): ICanvasRenderingContext2D;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        height: number;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toDataURL(type: string, jpegquality: any): string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        width: number;
        xmsAcceleratorKey: string;
    }

    class HTMLCommentElement {
        private 'MSHTML.HTMLCommentElement_typekey': HTMLCommentElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        appendData(bstrstring: string): void;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        atomic: number;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        data: string;
        deleteData(offset: number, Count: number): void;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_deleteData(offset: number, Count: number): void;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        ie9_insertData(offset: number, bstrstring: string): void;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_replaceData(offset: number, Count: number, bstrstring: string): void;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_substringData(offset: number, Count: number): string;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        insertData(offset: number, bstrstring: string): void;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        readonly length: number;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceData(offset: number, Count: number, bstrstring: string): void;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        substringData(offset: number, Count: number): string;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        text: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLCSSImportRule {
        private 'MSHTML.HTMLCSSImportRule_typekey': HTMLCSSImportRule;
        private constructor();
        cssText: string;
        readonly href: string;
        media: any;
        readonly parentRule: IHTMLCSSRule;
        readonly parentStyleSheet: IHTMLStyleSheet;
        readonly styleSheet: IHTMLStyleSheet;
        readonly type: number;
    }

    class HTMLCSSMediaList {
        private 'MSHTML.HTMLCSSMediaList_typekey': HTMLCSSMediaList;
        private constructor();
        appendMedium(bstrMedium: string): void;
        deleteMedium(bstrMedium: string): void;
        item(index: number): string;
        readonly length: number;
        mediaText: string;
    }

    class HTMLCSSMediaRule {
        private 'MSHTML.HTMLCSSMediaRule_typekey': HTMLCSSMediaRule;
        private constructor();
        readonly cssRules: IHTMLStyleSheetRulesCollection;
        cssText: string;

        /** @param number [lIndex=-1] */
        deleteRule(lIndex?: number): void;

        /** @param number [lIndex=-1] */
        insertRule(bstrRule: string, lIndex?: number): number;
        media: any;
        readonly parentRule: IHTMLCSSRule;
        readonly parentStyleSheet: IHTMLStyleSheet;
        readonly type: number;
    }

    class HTMLCSSNamespaceRule {
        private 'MSHTML.HTMLCSSNamespaceRule_typekey': HTMLCSSNamespaceRule;
        private constructor();
        cssText: string;
        readonly namespaceURI: string;
        readonly parentRule: IHTMLCSSRule;
        readonly parentStyleSheet: IHTMLStyleSheet;
        readonly prefix: string;
        readonly type: number;
    }

    class HTMLCSSRule {
        private 'MSHTML.HTMLCSSRule_typekey': HTMLCSSRule;
        private constructor();
        cssText: string;
        readonly parentRule: IHTMLCSSRule;
        readonly parentStyleSheet: IHTMLStyleSheet;
        readonly type: number;
    }

    class HTMLCSSStyleDeclaration {
        private 'MSHTML.HTMLCSSStyleDeclaration_typekey': HTMLCSSStyleDeclaration;
        private constructor();
        accelerator: string;
        alignContent: string;
        alignItems: string;
        alignmentBaseline: string;
        alignSelf: string;
        animation: string;
        animationDelay: string;
        animationDirection: string;
        animationDuration: string;
        animationFillMode: string;
        animationIterationCount: string;
        animationName: string;
        animationPlayState: string;
        animationTimingFunction: string;
        backfaceVisibility: string;
        background: string;
        backgroundAttachment: string;
        backgroundClip: string;
        backgroundColor: any;
        backgroundImage: string;
        backgroundOrigin: string;
        backgroundPosition: string;
        backgroundPositionX: any;
        backgroundPositionY: any;
        backgroundRepeat: string;
        backgroundSize: string;
        baselineShift: any;
        behavior: string;
        border: string;
        borderBottom: string;
        borderBottomColor: any;
        borderBottomLeftRadius: string;
        borderBottomRightRadius: string;
        borderBottomStyle: string;
        borderBottomWidth: any;
        borderCollapse: string;
        borderColor: string;
        borderImage: string;
        borderImageOutset: string;
        borderImageRepeat: string;
        borderImageSlice: string;
        borderImageSource: string;
        borderImageWidth: string;
        borderLeft: string;
        borderLeftColor: any;
        borderLeftStyle: string;
        borderLeftWidth: any;
        borderRadius: string;
        borderRight: string;
        borderRightColor: any;
        borderRightStyle: string;
        borderRightWidth: any;
        borderSpacing: string;
        borderStyle: string;
        borderTop: string;
        borderTopColor: any;
        borderTopLeftRadius: string;
        borderTopRightRadius: string;
        borderTopStyle: string;
        borderTopWidth: any;
        borderWidth: string;
        bottom: any;
        boxShadow: string;
        boxSizing: string;
        breakAfter: string;
        breakBefore: string;
        breakInside: string;
        captionSide: string;
        clear: string;
        clip: string;
        readonly clipBottom: any;
        clipLeft: any;
        clipPath: string;
        clipRight: any;
        clipRule: string;
        clipTop: any;
        color: any;
        colorInterpolationFilters: string;
        columnCount: any;
        columnFill: string;
        columnGap: any;
        columnRule: string;
        columnRuleColor: any;
        columnRuleStyle: string;
        columnRuleWidth: any;
        columns: string;
        columnSpan: string;
        columnWidth: any;
        content: string;
        counterIncrement: string;
        counterReset: string;
        cssFloat: string;
        cssText: string;
        cursor: string;
        direction: string;
        display: string;
        dominantBaseline: string;
        emptyCells: string;
        enableBackground: string;
        fill: string;
        fillOpacity: any;
        fillRule: string;
        filter: string;
        flex: string;
        flexBasis: any;
        flexDirection: string;
        flexFlow: string;
        flexGrow: any;
        flexShrink: any;
        flexWrap: string;
        floodColor: any;
        floodOpacity: any;
        font: string;
        fontFamily: string;
        fontFeatureSettings: string;
        fontSize: any;
        fontSizeAdjust: any;
        fontStretch: string;
        fontStyle: string;
        fontVariant: string;
        fontWeight: string;
        getPropertyPriority(bstrPropertyName: string): string;
        getPropertyValue(bstrPropertyName: string): string;
        glyphOrientationHorizontal: any;
        glyphOrientationVertical: any;
        height: any;
        imeMode: string;
        item(index: number): string;
        justifyContent: string;
        kerning: any;
        layoutFlow: string;
        layoutGrid: string;
        layoutGridChar: any;
        layoutGridLine: any;
        layoutGridMode: string;
        layoutGridType: string;
        left: any;
        readonly length: number;
        letterSpacing: any;
        lightingColor: any;
        lineBreak: string;
        lineHeight: any;
        listStyle: string;
        listStyleImage: string;
        listStylePosition: string;
        listStyleType: string;
        margin: string;
        marginBottom: any;
        marginLeft: any;
        marginRight: any;
        marginTop: any;
        marker: string;
        markerEnd: string;
        markerMid: string;
        markerStart: string;
        mask: string;
        maxHeight: any;
        maxWidth: any;
        minHeight: any;
        minWidth: any;
        msAnimation: string;
        msAnimationDelay: string;
        msAnimationDirection: string;
        msAnimationDuration: string;
        msAnimationFillMode: string;
        msAnimationIterationCount: string;
        msAnimationName: string;
        msAnimationPlayState: string;
        msAnimationTimingFunction: string;
        msBackfaceVisibility: string;
        msBlockProgression: string;
        msContentZoomChaining: string;
        msContentZooming: string;
        msContentZoomLimit: string;
        msContentZoomLimitMax: any;
        msContentZoomLimitMin: any;
        msContentZoomSnap: string;
        msContentZoomSnapPoints: string;
        msContentZoomSnapType: string;
        msFlex: string;
        msFlexAlign: string;
        msFlexDirection: string;
        msFlexFlow: string;
        msFlexItemAlign: string;
        msFlexLinePack: string;
        msFlexNegative: any;
        msFlexOrder: any;
        msFlexPack: string;
        msFlexPositive: any;
        msFlexPreferredSize: any;
        msFlexWrap: string;
        msFlowFrom: string;
        msFlowInto: string;
        msFontFeatureSettings: string;
        msGetPropertyEnabled(name: string): boolean;
        msGridColumn: any;
        msGridColumnAlign: string;
        msGridColumns: string;
        msGridColumnSpan: any;
        msGridRow: any;
        msGridRowAlign: string;
        msGridRows: string;
        msGridRowSpan: any;
        msHighContrastAdjust: string;
        msHyphenateLimitChars: string;
        msHyphenateLimitLines: any;
        msHyphenateLimitZone: any;
        msHyphens: string;
        msImeAlign: string;
        msInterpolationMode: string;
        msOverflowStyle: string;
        msPerspective: any;
        msPerspectiveOrigin: string;
        msPutPropertyEnabled(name: string, b: boolean): void;
        msScrollChaining: string;
        msScrollLimit: string;
        msScrollLimitXMax: any;
        msScrollLimitXMin: any;
        msScrollLimitYMax: any;
        msScrollLimitYMin: any;
        msScrollRails: string;
        msScrollSnapPointsX: string;
        msScrollSnapPointsY: string;
        msScrollSnapType: string;
        msScrollSnapX: string;
        msScrollSnapY: string;
        msScrollTranslation: string;
        msTextCombineHorizontal: string;
        msTextSizeAdjust: any;
        msTouchAction: string;
        msTouchSelect: string;
        msTransform: string;
        msTransformOrigin: string;
        msTransformStyle: string;
        msTransition: string;
        msTransitionDelay: string;
        msTransitionDuration: string;
        msTransitionProperty: string;
        msTransitionTimingFunction: string;
        msUserSelect: string;
        msWrapFlow: string;
        msWrapMargin: any;
        msWrapThrough: string;
        opacity: any;
        orphans: any;
        outline: string;
        outlineColor: any;
        outlineStyle: string;
        outlineWidth: any;
        overflow: string;
        overflowX: string;
        overflowY: string;
        padding: string;
        paddingBottom: any;
        paddingLeft: any;
        paddingRight: any;
        paddingTop: any;
        pageBreakAfter: string;
        pageBreakBefore: string;
        pageBreakInside: string;
        readonly parentRule: any;
        perspective: any;
        perspectiveOrigin: string;
        pointerEvents: string;
        position: string;
        quotes: string;
        removeProperty(bstrPropertyName: string): string;
        right: any;
        rubyAlign: string;
        rubyOverhang: string;
        rubyPosition: string;
        scrollbar3dLightColor: any;
        scrollbarArrowColor: any;
        scrollbarBaseColor: any;
        scrollbarDarkShadowColor: any;
        scrollbarFaceColor: any;
        scrollbarHighlightColor: any;
        scrollbarShadowColor: any;
        scrollbarTrackColor: any;

        /** @param any [pvarPropertyPriority=''] */
        setProperty(bstrPropertyName: string, pvarPropertyValue: any, pvarPropertyPriority?: any): void;
        stopColor: any;
        stopOpacity: any;
        stroke: string;
        strokeDasharray: string;
        strokeDashoffset: any;
        strokeLinecap: string;
        strokeLinejoin: string;
        strokeMiterlimit: any;
        strokeOpacity: any;
        strokeWidth: any;
        styleFloat: string;
        tableLayout: string;
        textAlign: string;
        textAlignLast: string;
        textAnchor: string;
        textAutospace: string;
        textDecoration: string;
        textIndent: any;
        textJustify: string;
        textJustifyTrim: string;
        textKashida: any;
        textKashidaSpace: any;
        textOverflow: string;
        textShadow: string;
        textTransform: string;
        textUnderlinePosition: string;
        top: any;
        touchAction: string;
        transform: string;
        transformOrigin: string;
        transformStyle: string;
        transition: string;
        transitionDelay: string;
        transitionDuration: string;
        transitionProperty: string;
        transitionTimingFunction: string;
        unicodeBidi: string;
        verticalAlign: any;
        visibility: string;
        webkitAnimation: string;
        webkitAnimationDelay: string;
        webkitAnimationDirection: string;
        webkitAnimationDuration: string;
        webkitAnimationFillMode: string;
        webkitAnimationIterationCount: string;
        webkitAnimationName: string;
        webkitAnimationPlayState: string;
        webkitAnimationTimingFunction: string;
        webkitAppearance: string;
        webkitBackfaceVisibility: string;
        webkitBackground: string;
        webkitBackgroundAttachment: string;
        webkitBackgroundClip: string;
        webkitBackgroundColor: any;
        webkitBackgroundImage: string;
        webkitBackgroundOrigin: string;
        webkitBackgroundPosition: string;
        webkitBackgroundPositionX: any;
        webkitBackgroundPositionY: any;
        webkitBackgroundRepeat: string;
        webkitBackgroundSize: string;
        webkitBorderImage: string;
        webkitBorderImageOutset: string;
        webkitBorderImageRepeat: string;
        webkitBorderImageSlice: string;
        webkitBorderImageSource: string;
        webkitBorderImageWidth: string;
        webkitBoxAlign: string;
        webkitBoxDirection: string;
        webkitBoxFlex: any;
        webkitBoxOrdinalGroup: any;
        webkitBoxOrient: string;
        webkitBoxPack: string;
        webkitBoxSizing: string;
        webkitTextSizeAdjust: any;
        webkitTransform: string;
        webkitTransformOrigin: string;
        webkitTransition: string;
        webkitTransitionDelay: string;
        webkitTransitionDuration: string;
        webkitTransitionProperty: string;
        webkitTransitionTimingFunction: string;
        webkitUserSelect: string;
        whiteSpace: string;
        widows: any;
        width: any;
        wordBreak: string;
        wordSpacing: any;
        wordWrap: string;
        writingMode: string;
        zIndex: any;
        zoom: any;
    }

    class HTMLCurrentStyle {
        private 'MSHTML.HTMLCurrentStyle_typekey': HTMLCurrentStyle;
        private constructor();
        readonly accelerator: string;
        alignContent: string;
        alignItems: string;
        alignSelf: string;
        animation: string;
        animationDelay: string;
        animationDirection: string;
        animationDuration: string;
        animationFillMode: string;
        animationIterationCount: string;
        animationName: string;
        animationPlayState: string;
        animationTimingFunction: string;
        backfaceVisibility: string;
        readonly backgroundAttachment: string;
        readonly backgroundColor: any;
        readonly backgroundImage: string;
        readonly backgroundPositionX: any;
        readonly backgroundPositionY: any;
        readonly backgroundRepeat: string;
        readonly behavior: string;
        readonly blockDirection: string;
        readonly borderBottomColor: any;
        readonly borderBottomStyle: string;
        readonly borderBottomWidth: any;
        readonly borderCollapse: string;
        readonly borderColor: string;
        borderImage: string;
        borderImageOutset: string;
        borderImageRepeat: string;
        borderImageSlice: string;
        borderImageSource: string;
        borderImageWidth: string;
        readonly borderLeftColor: any;
        readonly borderLeftStyle: string;
        readonly borderLeftWidth: any;
        readonly borderRightColor: any;
        readonly borderRightStyle: string;
        readonly borderRightWidth: any;
        readonly borderSpacing: string;
        readonly borderStyle: string;
        readonly borderTopColor: any;
        readonly borderTopStyle: string;
        readonly borderTopWidth: any;
        readonly borderWidth: string;
        readonly bottom: any;
        readonly boxSizing: string;
        breakAfter: string;
        breakBefore: string;
        breakInside: string;
        readonly captionSide: string;
        readonly clear: string;
        readonly clipBottom: any;
        readonly clipLeft: any;
        readonly clipRight: any;
        readonly clipTop: any;
        readonly color: any;
        colorInterpolationFilters: string;
        columnCount: any;
        columnFill: string;
        columnGap: any;
        columnRule: string;
        columnRuleColor: any;
        columnRuleStyle: string;
        columnRuleWidth: any;
        columns: string;
        columnSpan: string;
        columnWidth: any;
        readonly 'constructor': any;
        readonly cursor: string;
        readonly direction: string;
        readonly display: string;
        readonly emptyCells: string;
        enableBackground: string;
        readonly filter: string;
        flex: string;
        flexBasis: any;
        flexDirection: string;
        flexFlow: string;
        flexGrow: any;
        flexShrink: any;
        flexWrap: string;
        floodColor: any;
        floodOpacity: any;
        readonly fontFamily: string;
        fontFeatureSettings: string;
        readonly fontSize: any;
        readonly fontStyle: string;
        readonly fontVariant: string;
        readonly fontWeight: any;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getPropertyPriority(bstrPropertyName: string): string;
        getPropertyValue(bstrPropertyName: string): string;
        readonly hasLayout: boolean;
        readonly height: any;
        readonly imeMode: string;
        item(index: number): string;
        justifyContent: string;
        readonly layoutFlow: string;
        readonly layoutGridChar: any;
        readonly layoutGridLine: any;
        readonly layoutGridMode: string;
        readonly layoutGridType: string;
        readonly left: any;
        readonly length: number;
        readonly letterSpacing: any;
        lightingColor: any;
        readonly lineBreak: string;
        readonly lineHeight: any;
        readonly listStyleImage: string;
        readonly listStylePosition: string;
        readonly listStyleType: string;
        readonly margin: string;
        readonly marginBottom: any;
        readonly marginLeft: any;
        readonly marginRight: any;
        readonly marginTop: any;
        readonly maxHeight: any;
        readonly maxWidth: any;
        readonly minHeight: any;
        readonly minWidth: any;
        msAnimation: string;
        msAnimationDelay: string;
        msAnimationDirection: string;
        msAnimationDuration: string;
        msAnimationFillMode: string;
        msAnimationIterationCount: string;
        msAnimationName: string;
        msAnimationPlayState: string;
        msAnimationTimingFunction: string;
        msBackfaceVisibility: string;
        readonly msBlockProgression: string;
        msContentZoomChaining: string;
        msContentZooming: string;
        msContentZoomLimit: string;
        msContentZoomLimitMax: any;
        msContentZoomLimitMin: any;
        msContentZoomSnap: string;
        msContentZoomSnapPoints: string;
        msContentZoomSnapType: string;
        msFlex: string;
        msFlexAlign: string;
        msFlexDirection: string;
        msFlexFlow: string;
        msFlexItemAlign: string;
        msFlexLinePack: string;
        msFlexNegative: any;
        msFlexOrder: any;
        msFlexPack: string;
        msFlexPositive: any;
        msFlexPreferredSize: any;
        msFlexWrap: string;
        msFlowFrom: string;
        msFlowInto: string;
        msFontFeatureSettings: string;
        msGridColumn: any;
        msGridColumnAlign: string;
        msGridColumns: string;
        msGridColumnSpan: any;
        msGridRow: any;
        msGridRowAlign: string;
        msGridRows: string;
        msGridRowSpan: any;
        msHighContrastAdjust: string;
        msHyphenateLimitChars: string;
        msHyphenateLimitLines: any;
        msHyphenateLimitZone: any;
        msHyphens: string;
        msImeAlign: string;
        readonly msInterpolationMode: string;
        msOverflowStyle: string;
        msPerspective: any;
        msPerspectiveOrigin: string;
        msScrollChaining: string;
        msScrollLimit: string;
        msScrollLimitXMax: any;
        msScrollLimitXMin: any;
        msScrollLimitYMax: any;
        msScrollLimitYMin: any;
        msScrollRails: string;
        msScrollSnapPointsX: string;
        msScrollSnapPointsY: string;
        msScrollSnapType: string;
        msScrollSnapX: string;
        msScrollSnapY: string;
        msScrollTranslation: string;
        msTextCombineHorizontal: string;
        msTextSizeAdjust: any;
        msTouchAction: string;
        msTouchSelect: string;
        msTransformStyle: string;
        msTransition: string;
        msTransitionDelay: string;
        msTransitionDuration: string;
        msTransitionProperty: string;
        msTransitionTimingFunction: string;
        msUserSelect: string;
        msWrapFlow: string;
        msWrapMargin: any;
        msWrapThrough: string;
        readonly orphans: any;
        readonly outline: string;
        readonly outlineColor: any;
        readonly outlineStyle: string;
        readonly outlineWidth: any;
        readonly overflow: string;
        readonly overflowX: string;
        readonly overflowY: string;
        readonly padding: string;
        readonly paddingBottom: any;
        readonly paddingLeft: any;
        readonly paddingRight: any;
        readonly paddingTop: any;
        readonly pageBreakAfter: string;
        readonly pageBreakBefore: string;
        readonly pageBreakInside: string;
        readonly parentRule: any;
        perspective: any;
        perspectiveOrigin: string;
        readonly position: string;
        readonly quotes: string;
        removeProperty(bstrPropertyName: string): string;
        readonly right: any;
        readonly rubyAlign: string;
        readonly rubyOverhang: string;
        readonly rubyPosition: string;
        readonly scrollbar3dLightColor: any;
        readonly scrollbarArrowColor: any;
        readonly scrollbarBaseColor: any;
        readonly scrollbarDarkShadowColor: any;
        readonly scrollbarFaceColor: any;
        readonly scrollbarHighlightColor: any;
        readonly scrollbarShadowColor: any;
        readonly scrollbarTrackColor: any;

        /** @param any [pvarPropertyPriority=''] */
        setProperty(bstrPropertyName: string, pvarPropertyValue: any, pvarPropertyPriority?: any): void;
        readonly styleFloat: string;
        readonly tableLayout: string;
        readonly textAlign: string;
        readonly textAlignLast: string;
        readonly textAutospace: string;
        readonly textDecoration: string;
        readonly textIndent: any;
        readonly textJustify: string;
        readonly textJustifyTrim: string;
        readonly textKashida: any;
        readonly textKashidaSpace: any;
        readonly textOverflow: string;
        textShadow: string;
        readonly textTransform: string;
        readonly textUnderlinePosition: string;
        readonly top: any;
        touchAction: string;
        transform: string;
        transformOrigin: string;
        transformStyle: string;
        transition: string;
        transitionDelay: string;
        transitionDuration: string;
        transitionProperty: string;
        transitionTimingFunction: string;
        readonly unicodeBidi: string;
        readonly verticalAlign: any;
        readonly visibility: string;
        webkitAnimation: string;
        webkitAnimationDelay: string;
        webkitAnimationDirection: string;
        webkitAnimationDuration: string;
        webkitAnimationFillMode: string;
        webkitAnimationIterationCount: string;
        webkitAnimationName: string;
        webkitAnimationPlayState: string;
        webkitAnimationTimingFunction: string;
        webkitAppearance: string;
        webkitBackfaceVisibility: string;
        webkitBackground: string;
        webkitBackgroundAttachment: string;
        webkitBackgroundClip: string;
        webkitBackgroundColor: any;
        webkitBackgroundImage: string;
        webkitBackgroundOrigin: string;
        webkitBackgroundPosition: string;
        webkitBackgroundPositionX: any;
        webkitBackgroundPositionY: any;
        webkitBackgroundRepeat: string;
        webkitBackgroundSize: string;
        webkitBorderImage: string;
        webkitBorderImageOutset: string;
        webkitBorderImageRepeat: string;
        webkitBorderImageSlice: string;
        webkitBorderImageSource: string;
        webkitBorderImageWidth: string;
        webkitBoxAlign: string;
        webkitBoxDirection: string;
        webkitBoxFlex: any;
        webkitBoxOrdinalGroup: any;
        webkitBoxOrient: string;
        webkitBoxPack: string;
        webkitBoxSizing: string;
        webkitTextSizeAdjust: any;
        webkitTransform: string;
        webkitTransformOrigin: string;
        webkitTransition: string;
        webkitTransitionDelay: string;
        webkitTransitionDuration: string;
        webkitTransitionProperty: string;
        webkitTransitionTimingFunction: string;
        webkitUserSelect: string;
        readonly whiteSpace: string;
        readonly widows: any;
        readonly width: any;
        readonly wordBreak: string;
        readonly wordSpacing: any;
        readonly wordWrap: string;
        readonly writingMode: string;
        readonly zIndex: any;
        readonly zoom: any;
    }

    class HTMLDDElement {
        private 'MSHTML.HTMLDDElement_typekey': HTMLDDElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        noWrap: boolean;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLDefaults {
        private 'MSHTML.HTMLDefaults_typekey': HTMLDefaults;
        private constructor();
        canHaveHTML: boolean;
        readonly 'constructor': any;
        contentEditable: string;
        frozen: boolean;
        isMultiLine: boolean;
        scrollSegmentX: number;
        scrollSegmentY: number;
        readonly style: IHTMLStyle;
        tabStop: boolean;
        viewInheritStyle: boolean;
        viewLink: IHTMLDocument;
        viewMasterTab: boolean;
    }

    class HTMLDialog {
        private 'MSHTML.HTMLDialog_typekey': HTMLDialog;
        private constructor();
        close(): void;
        readonly dialogArguments: any;
        dialogHeight: any;
        dialogLeft: any;
        dialogTop: any;
        dialogWidth: any;
        readonly menuArguments: any;
        returnValue: any;
        toString(): string;
    }

    class HTMLDivElement {
        private 'MSHTML.HTMLDivElement_typekey': HTMLDivElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        align: string;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        dataFld: string;
        dataFormatAs: string;
        dataSrc: string;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        isDefaultNamespace(pvarNamespace: any): boolean;
        readonly isDisabled: boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        readonly isMultiLine: boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly namespaceURI: any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        noWrap: boolean;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        textContent: any;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLDivPosition {
        private 'MSHTML.HTMLDivPosition_typekey': HTMLDivPosition;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        align: string;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        dataFld: string;
        dataFormatAs: string;
        dataSrc: string;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        isDefaultNamespace(pvarNamespace: any): boolean;
        readonly isDisabled: boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        readonly isMultiLine: boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly namespaceURI: any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        textContent: any;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HtmlDlgSafeHelper {
        private 'MSHTML.HtmlDlgSafeHelper_typekey': HtmlDlgSafeHelper;
        private constructor();
        readonly BlockFormats: any;
        choosecolordlg(initColor?: any): any;
        readonly fonts: any;
        getCharset(fontName: string): any;
    }

    class HTMLDListElement {
        private 'MSHTML.HTMLDListElement_typekey': HTMLDListElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compact: boolean;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLDocument {
        private 'MSHTML.HTMLDocument_typekey': HTMLDocument;
        private constructor();
        readonly activeElement: IHTMLElement;
        addEventListener(type: string, listener: any, useCapture: boolean): void;
        adoptNode(pNodeSource: IHTMLDOMNode): IHTMLDOMNode3;
        alinkColor: any;
        readonly all: IHTMLElementCollection;
        readonly anchors: IHTMLElementCollection;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        readonly applets: IHTMLElementCollection;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        bgColor: any;
        readonly body: IHTMLElement;
        readonly characterSet: string;
        charset: string;
        readonly childNodes: any;
        clear(): void;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        close(): void;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        readonly compatible: IHTMLDocumentCompatibleInfoCollection;
        readonly compatMode: string;
        readonly 'constructor': any;
        cookie: string;
        createAttribute(bstrAttrName: string): IHTMLDOMAttribute;
        createAttributeNS(pvarNS: any, bstrAttrName: string): IHTMLDOMAttribute;
        createCDATASection(text: string): IHTMLDOMNode;
        createComment(bstrData: string): IHTMLDOMNode;
        createDocumentFragment(): IHTMLDocument2;
        createDocumentFromUrl(bstrURL: string, bstrOptions: string): IHTMLDocument2;
        createElement(eTag: string): IHTMLElement;
        createElementNS(pvarNS: any, bstrTag: string): IHTMLElement;
        createEvent(eventType: string): IDOMEvent;
        CreateEventObject(pvarEventObject?: any): IHTMLEventObj;
        createNodeIterator(pRootNode: any, ulWhatToShow: number, pFilter: any, fEntityReferenceExpansion: boolean): IDOMNodeIterator;
        createProcessingInstruction(bstrTarget: string, bstrData: string): IDOMProcessingInstruction;
        createRange(): IHTMLDOMRange;
        createRenderStyle(v: string): IHTMLRenderStyle;

        /**
         * @param string [bstrHref='']
         * @param number [lIndex=-1]
         */
        createStyleSheet(bstrHref?: string, lIndex?: number): IHTMLStyleSheet;
        createTextNode(text: string): IHTMLDOMNode;
        createTreeWalker(pRootNode: any, ulWhatToShow: number, pFilter: any, fEntityReferenceExpansion: boolean): IDOMTreeWalker;
        defaultCharset: string;
        readonly defaultView: IHTMLWindow2;
        designMode: string;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        dispatchEvent(evt: IDOMEvent): boolean;
        readonly doctype: IHTMLDOMNode;
        readonly documentElement: IHTMLElement;
        readonly documentMode: any;
        domain: string;
        elementFromPoint(x: number, y: number): IHTMLElement;
        elementsFromPoint(x: number, y: number): IHTMLDOMChildrenCollection;
        elementsFromRect(left: number, top: number, width: number, height: number): IHTMLDOMChildrenCollection;
        readonly embeds: IHTMLElementCollection;

        /** @param boolean [showUI=false] */
        execCommand(cmdID: string, showUI?: boolean, value?: any): boolean;
        execCommandShowHelp(cmdID: string): boolean;
        expando: boolean;
        fgColor: any;
        readonly fileCreatedDate: string;
        readonly fileModifiedDate: string;
        readonly fileSize: string;
        readonly fileUpdatedDate: string;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        readonly forms: IHTMLElementCollection;
        readonly frames: FramesCollection;
        getElementById(v: string): IHTMLElement;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(pvarNS: any, bstrLocalName: string): IHTMLElementCollection;
        getSelection(): IHTMLSelection;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hasFocus(): boolean;
        readonly head: IHTMLElement;
        ie8_getElementById(bstrId: string): IHTMLElement2;
        readonly ie9_all: IHTMLElementCollection;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_body: IHTMLElement;
        ie9_createAttribute(bstrAttrName: string): IHTMLDOMAttribute;
        ie9_createElement(bstrTag: string): IHTMLElement;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_parentWindow: IHTMLWindow2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        readonly images: IHTMLElementCollection;
        readonly implementation: IHTMLDOMImplementation;
        importNode(pNodeSource: IHTMLDOMNode, fDeep: boolean): IHTMLDOMNode3;
        readonly inputEncoding: string;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        isDefaultNamespace(pvarNamespace: any): boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly lastChild: IHTMLDOMNode;
        readonly lastModified: string;
        linkColor: any;
        readonly links: IHTMLElementCollection;
        readonly localName: any;
        readonly location: IHTMLLocation;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        media: string;
        readonly mimeType: string;
        msCapsLockWarningOff: boolean;
        readonly nameProp: string;
        readonly namespaces: any;
        readonly namespaceURI: any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onmousedown: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmscontentzoom: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsinertiastart: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmssitemodejumplistitemremoved: any;
        onmsthumbnailclick: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectionchange: any;
        onselectstart: any;
        onstalled: any;
        onstop: any;
        onstorage: any;
        onstoragecommit: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;

        /** @param string [url='text/html'] */
        open(url?: string, name?: any, features?: any, replace?: any): any;
        readonly ownerDocument: any;
        readonly parentNode: IHTMLDOMNode;
        readonly parentWindow: IHTMLWindow2;
        readonly plugins: IHTMLElementCollection;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        readonly protocol: string;
        queryCommandEnabled(cmdID: string): boolean;
        queryCommandIndeterm(cmdID: string): boolean;
        queryCommandState(cmdID: string): boolean;
        queryCommandSupported(cmdID: string): boolean;
        queryCommandText(cmdID: string): string;
        queryCommandValue(cmdID: string): any;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readonly readyState: string;

        /** @param boolean [fForce=false] */
        recalc(fForce?: boolean): void;
        readonly referrer: string;
        releaseCapture(): void;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeEventListener(type: string, listener: any, useCapture: boolean): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        readonly rootElement: ISVGSVGElement;
        readonly Script: any;
        readonly scripts: IHTMLElementCollection;
        readonly security: string;
        readonly selection: IHTMLSelectionObject;
        readonly styleSheets: IHTMLStyleSheetsCollection;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        textContent: any;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        updateSettings(): void;
        url: string;
        readonly URLUnencoded: string;
        vlinkColor: any;
        write(...psarray: any[]): void;
        writeln(...psarray: any[]): void;
        readonly xmlEncoding: string;
        xmlStandalone: boolean;
        xmlVersion: string;
    }

    class HTMLDocumentCompatibleInfo {
        private 'MSHTML.HTMLDocumentCompatibleInfo_typekey': HTMLDocumentCompatibleInfo;
        private constructor();
        readonly 'constructor': any;
    }

    class HTMLDocumentCompatibleInfoCollection {
        private 'MSHTML.HTMLDocumentCompatibleInfoCollection_typekey': HTMLDocumentCompatibleInfoCollection;
        private constructor();
        readonly 'constructor': any;
    }

    class HTMLDOMAttribute {
        private 'MSHTML.HTMLDOMAttribute_typekey': HTMLDOMAttribute;
        private constructor();
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        readonly attributes: any;
        readonly childNodes: any;
        cloneNode(fDeep: boolean): IHTMLDOMAttribute;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        readonly 'constructor': any;
        readonly expando: boolean;
        readonly firstChild: IHTMLDOMNode;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        ie8_nodeValue: any;
        readonly ie8_specified: boolean;
        ie8_value: string;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        readonly ie9_childNodes: any;
        readonly ie9_firstChild: IHTMLDOMNode;
        ie9_hasChildNodes(): boolean;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_lastChild: IHTMLDOMNode;
        readonly ie9_name: string;
        readonly ie9_nodeName: string;
        ie9_nodeValue: any;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        readonly ie9_specified: boolean;
        ie9_value: string;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        isDefaultNamespace(pvarNamespace: any): boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly lastChild: IHTMLDOMNode;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        readonly name: string;
        readonly namespaceURI: any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly ownerDocument: any;
        readonly ownerElement: IHTMLElement2;
        readonly parentNode: IHTMLDOMNode;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        readonly specified: boolean;
        textContent: any;
        value: string;
    }

    class HTMLDOMImplementation {
        private 'MSHTML.HTMLDOMImplementation_typekey': HTMLDOMImplementation;
        private constructor();
        readonly 'constructor': any;
        createDocument(pvarNS: any, pvarTagName: any, pDocumentType: IDOMDocumentType): IHTMLDocument7;
        createDocumentType(bstrQualifiedName: string, pvarPublicId: any, pvarSystemId: any): IDOMDocumentType;
        createHTMLDocument(bstrTitle: string): IHTMLDocument7;
        hasFeature(bstrfeature: string, version?: any): boolean;
        ie9_hasFeature(bstrfeature: string, version?: any): boolean;
    }

    class HTMLDOMRange {
        private 'MSHTML.HTMLDOMRange_typekey': HTMLDOMRange;
        private constructor();
        cloneContents(): any;
        cloneRange(): IHTMLDOMRange;
        collapse(toStart: boolean): void;
        readonly collapsed: boolean;
        readonly commonAncestorContainer: IHTMLDOMNode;
        compareBoundaryPoints(how: number, sourceRange: any): number;
        deleteContents(): void;
        Detach(): void;
        readonly endContainer: IHTMLDOMNode;
        readonly endOffset: number;
        extractContents(): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        insertNode(newNode: any): void;
        selectNode(refNode: any): void;
        selectNodeContents(refNode: any): void;
        setEnd(refNode: any, offset: number): void;
        setEndAfter(refNode: any): void;
        setEndBefore(refNode: any): void;
        setStart(refNode: any, offset: number): void;
        setStartAfter(refNode: any): void;
        setStartBefore(refNode: any): void;
        readonly startContainer: IHTMLDOMNode;
        readonly startOffset: number;
        surroundContents(newParent: any): void;
        toString(): string;
    }

    class HTMLDOMTextNode {
        private 'MSHTML.HTMLDOMTextNode_typekey': HTMLDOMTextNode;
        private constructor();
        addEventListener(type: string, listener: any, useCapture: boolean): void;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        appendData(bstrstring: string): void;
        readonly attributes: any;
        readonly childNodes: any;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        readonly 'constructor': any;
        data: string;
        deleteData(offset: number, Count: number): void;
        dispatchEvent(evt: IDOMEvent): boolean;
        readonly firstChild: IHTMLDOMNode;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_deleteData(offset: number, Count: number): void;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        ie9_insertData(offset: number, bstrstring: string): void;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceData(offset: number, Count: number, bstrstring: string): void;
        ie9_splitText(offset: number): IHTMLDOMNode;
        ie9_substringData(offset: number, Count: number): string;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        insertData(offset: number, bstrstring: string): void;
        isDefaultNamespace(pvarNamespace: any): boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly lastChild: IHTMLDOMNode;
        readonly length: number;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        readonly namespaceURI: any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly ownerDocument: any;
        readonly parentNode: IHTMLDOMNode;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeEventListener(type: string, listener: any, useCapture: boolean): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceData(offset: number, Count: number, bstrstring: string): void;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        replaceWholeText(bstrText: string): IHTMLDOMNode;
        splitText(offset: number): IHTMLDOMNode;
        substringData(offset: number, Count: number): string;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        textContent: any;
        toString(): string;
        readonly wholeText: string;
    }

    class HTMLDOMXmlSerializerFactory {
        private 'MSHTML.HTMLDOMXmlSerializerFactory_typekey': HTMLDOMXmlSerializerFactory;
        private constructor();
        create(): IDOMXmlSerializer;
    }

    class HTMLDTElement {
        private 'MSHTML.HTMLDTElement_typekey': HTMLDTElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        noWrap: boolean;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLElementCollection {
        private 'MSHTML.HTMLElementCollection_typekey': HTMLElementCollection;
        private constructor();
        readonly 'constructor': any;
        ie8_item(index: number): IHTMLElement2;
        readonly ie8_length: number;
        ie8_namedItem(name: string): IHTMLElement2;
        item(name?: any, index?: any): any;
        length: number;
        namedItem(name: string): any;
        tags(tagName: any): any;
        toString(): string;
        urns(urn: any): any;
    }

    class HTMLEmbed {
        private 'MSHTML.HTMLEmbed_typekey': HTMLEmbed;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        getSVGDocument(): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        height: any;
        hidden: string;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        readonly ie8_pluginspage: string;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_src: string;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        name: string;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly palette: string;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly pluginspage: string;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        src: string;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        units: string;
        width: any;
        xmsAcceleratorKey: string;
    }

    class HTMLFieldSetElement {
        private 'MSHTML.HTMLFieldSetElement_typekey': HTMLFieldSetElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        align: string;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        readonly form: IHTMLFormElement;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLFontElement {
        private 'MSHTML.HTMLFontElement_typekey': HTMLFontElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        color: any;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        face: string;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        size: any;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLFormElement {
        private 'MSHTML.HTMLFormElement_typekey': HTMLFormElement;
        private constructor();
        acceptCharset: string;
        accessKey: string;
        action: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        appendItemSeparator(): void;

        /**
         * @param string [name='']
         * @param string [filename='']
         */
        appendNameFilePair(name?: string, filename?: string): void;

        /**
         * @param string [name='']
         * @param string [value='']
         */
        appendNameValuePair(name?: string, value?: string): void;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly elements: any;
        encoding: string;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        ie8_action: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        item(name?: any, index?: any): any;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        length: number;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        method: string;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        name: string;
        namedItem(name: string): any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        reset(): void;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        submit(): void;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tags(tagName: any): any;
        tagUrn: string;
        target: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        urns(urn: any): any;
        xmsAcceleratorKey: string;
    }

    class HTMLFrameBase {
        private 'MSHTML.HTMLFrameBase_typekey': HTMLFrameBase;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        allowTransparency: boolean;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        border: any;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        readonly contentWindow: IHTMLWindow2;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        frameBorder: string;
        frameSpacing: any;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        longDesc: string;
        marginHeight: any;
        marginWidth: any;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        name: string;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        noResize: boolean;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrolling: string;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        src: string;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLFrameElement {
        private 'MSHTML.HTMLFrameElement_typekey': HTMLFrameElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        allowTransparency: boolean;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        border: any;
        borderColor: any;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        readonly contentDocument: any;
        contentEditable: string;
        readonly contentWindow: IHTMLWindow2;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        dataFld: string;
        dataFormatAs: string;
        dataSrc: string;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        frameBorder: string;
        frameSpacing: any;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        getSVGDocument(): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        height: any;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_frameBorder: string;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_longDesc: string;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_src: string;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        isDefaultNamespace(pvarNamespace: any): boolean;
        readonly isDisabled: boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        readonly isMultiLine: boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        readonly localName: any;
        longDesc: string;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        marginHeight: any;
        marginWidth: any;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        name: string;
        readonly namespaceURI: any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        noResize: boolean;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrolling: string;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        src: string;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        textContent: any;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        width: any;
        xmsAcceleratorKey: string;
    }

    class HTMLFrameSetSite {
        private 'MSHTML.HTMLFrameSetSite_typekey': HTMLFrameSetSite;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        border: any;
        borderColor: any;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        cols: string;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        frameBorder: string;
        frameSpacing: any;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        name: string;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterprint: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeprint: any;
        onbeforeunload: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhashchange: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmessage: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onoffline: any;
        ononline: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onstorage: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onunload: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        rows: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLGenericElement {
        private 'MSHTML.HTMLGenericElement_typekey': HTMLGenericElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        namedRecordset(dataMember: string, hierarchy?: any): any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        readonly recordset: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLHeadElement {
        private 'MSHTML.HTMLHeadElement_typekey': HTMLHeadElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_profile: string;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        profile: string;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLHeaderElement {
        private 'MSHTML.HTMLHeaderElement_typekey': HTMLHeaderElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        align: string;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clear: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLHistory {
        private 'MSHTML.HTMLHistory_typekey': HTMLHistory;
        private constructor();
        back(pvargdistance?: any): void;
        readonly 'constructor': any;
        forward(pvargdistance?: any): void;
        go(pvargdistance?: any): void;
        readonly length: number;
    }

    class HTMLHRElement {
        private 'MSHTML.HTMLHRElement_typekey': HTMLHRElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        align: string;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        color: any;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        noShade: boolean;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        size: any;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        width: any;
        xmsAcceleratorKey: string;
    }

    class HTMLHtmlElement {
        private 'MSHTML.HTMLHtmlElement_typekey': HTMLHtmlElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        version: string;
        xmsAcceleratorKey: string;
    }

    class HTMLIFrame {
        private 'MSHTML.HTMLIFrame_typekey': HTMLIFrame;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        align: string;
        readonly all: any;
        allowTransparency: boolean;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        border: any;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        readonly contentDocument: any;
        contentEditable: string;
        readonly contentWindow: IHTMLWindow2;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        dataFld: string;
        dataFormatAs: string;
        dataSrc: string;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        frameBorder: string;
        frameSpacing: any;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        getSVGDocument(): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        height: any;
        hideFocus: boolean;
        hspace: number;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_frameBorder: string;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_longDesc: string;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_src: string;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        isDefaultNamespace(pvarNamespace: any): boolean;
        readonly isDisabled: boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        readonly isMultiLine: boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        readonly localName: any;
        longDesc: string;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        marginHeight: any;
        marginWidth: any;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        name: string;
        readonly namespaceURI: any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        noResize: boolean;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrolling: string;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        src: string;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        textContent: any;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        vspace: number;
        width: any;
        xmsAcceleratorKey: string;
    }

    class HTMLImageElementFactory {
        private 'MSHTML.HTMLImageElementFactory_typekey': HTMLImageElementFactory;
        private constructor();
        create(width?: any, height?: any): IHTMLImgElement;
    }

    class HTMLImg {
        private 'MSHTML.HTMLImg_typekey': HTMLImg;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        align: string;
        readonly all: any;
        alt: string;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        border: any;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        readonly complete: boolean;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        dataFld: string;
        dataFormatAs: string;
        dataSrc: string;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        dynsrc: string;
        readonly fileCreatedDate: string;
        readonly fileModifiedDate: string;
        readonly fileSize: string;
        readonly fileUpdatedDate: string;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        height: number;
        hideFocus: boolean;
        readonly href: string;
        hspace: number;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_dynsrc: string;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_longDesc: string;
        ie8_lowsrc: string;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_vrml: string;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        isDefaultNamespace(pvarNamespace: any): boolean;
        readonly isDisabled: boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        isMap: boolean;
        readonly isMultiLine: boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        readonly localName: any;
        longDesc: string;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        loop: any;
        lowsrc: string;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        readonly mimeType: string;
        msMatchesSelector(v: string): boolean;
        msPlayToDisabled: boolean;
        msPlayToPrimary: boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        name: string;
        readonly nameProp: string;
        readonly namespaceURI: any;
        readonly naturalHeight: number;
        readonly naturalWidth: number;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        readonly protocol: string;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        src: string;
        start: string;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        textContent: any;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        useMap: string;
        vrml: string;
        vspace: number;
        width: number;
        xmsAcceleratorKey: string;
    }

    class HTMLInputButtonElement {
        private 'MSHTML.HTMLInputButtonElement_typekey': HTMLInputButtonElement;
        private constructor();
        accessKey: string;
        addFilter(pUnk: any): void;
        readonly all: any;
        blur(): void;
        readonly children: any;
        className: string;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        contains(pChild: IHTMLElement): boolean;
        createTextRange(): IHTMLTxtRange;
        disabled: boolean;
        readonly document: any;
        readonly filters: IHTMLFiltersCollection;
        focus(): void;
        readonly form: IHTMLFormElement;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        id: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        name: string;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onafterupdate: any;
        onbeforeupdate: any;
        onblur: any;
        onclick: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondragstart: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onhelp: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onmousedown: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onresize: any;
        onrowenter: any;
        onrowexit: any;
        onselectstart: any;
        outerHTML: string;
        outerText: string;
        readonly parentElement: IHTMLElement;
        readonly parentTextEdit: IHTMLElement;
        readonly recordNumber: any;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeFilter(pUnk: any): void;
        scrollIntoView(varargStart?: any): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        readonly sourceIndex: number;
        status: any;
        readonly style: IHTMLStyle;
        tabIndex: number;
        readonly tagName: string;
        title: string;
        toString(): string;
        readonly type: string;
        value: string;
    }

    class HTMLInputElement {
        private 'MSHTML.HTMLInputElement_typekey': HTMLInputElement;
        private constructor();
        accept: string;
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        align: string;
        readonly all: any;
        alt: string;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        border: any;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        checked: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        readonly complete: boolean;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        createTextRange(): IHTMLTxtRange;
        readonly currentStyle: IHTMLCurrentStyle;
        dataFld: string;
        dataFormatAs: string;
        dataSrc: string;
        defaultChecked: boolean;
        defaultValue: string;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        dynsrc: string;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        readonly form: IHTMLFormElement;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        height: number;
        hideFocus: boolean;
        hspace: number;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_dynsrc: string;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_lowsrc: string;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_src: string;
        ie8_vrml: string;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        indeterminate: boolean;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        isDefaultNamespace(pvarNamespace: any): boolean;
        readonly isDisabled: boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        readonly isMultiLine: boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        loop: any;
        lowsrc: string;
        max: string;
        maxLength: number;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        min: string;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        name: string;
        readonly namespaceURI: any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readOnly: boolean;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        select(): void;
        selectionEnd: number;
        selectionStart: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        setSelectionRange(start: number, end: number): void;
        size: number;
        readonly sourceIndex: number;
        spellcheck: any;
        src: string;
        start: string;
        status: boolean;
        step: string;

        /** @param number [n=1] */
        stepDown(n?: number): void;

        /** @param number [n=1] */
        stepUp(n?: number): void;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        textContent: any;
        title: string;
        toString(): string;
        type: string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        useMap: string;
        value: string;
        valueAsNumber: number;
        vrml: string;
        vspace: number;
        width: number;
        xmsAcceleratorKey: string;
    }

    class HTMLInputFileElement {
        private 'MSHTML.HTMLInputFileElement_typekey': HTMLInputFileElement;
        private constructor();
        accessKey: string;
        addFilter(pUnk: any): void;
        readonly all: any;
        blur(): void;
        readonly children: any;
        className: string;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        contains(pChild: IHTMLElement): boolean;
        disabled: boolean;
        readonly document: any;
        readonly filters: IHTMLFiltersCollection;
        focus(): void;
        readonly form: IHTMLFormElement;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        id: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        maxLength: number;
        name: string;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onafterupdate: any;
        onbeforeupdate: any;
        onblur: any;
        onchange: any;
        onclick: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondragstart: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onhelp: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onmousedown: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onresize: any;
        onrowenter: any;
        onrowexit: any;
        onselect: any;
        onselectstart: any;
        outerHTML: string;
        outerText: string;
        readonly parentElement: IHTMLElement;
        readonly parentTextEdit: IHTMLElement;
        readonly recordNumber: any;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeFilter(pUnk: any): void;
        scrollIntoView(varargStart?: any): void;
        select(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        size: number;
        readonly sourceIndex: number;
        status: any;
        readonly style: IHTMLStyle;
        tabIndex: number;
        readonly tagName: string;
        title: string;
        toString(): string;
        readonly type: string;
        value: string;
    }

    class htmlInputImage {
        private 'MSHTML.htmlInputImage_typekey': htmlInputImage;
        private constructor();
        accessKey: string;
        addFilter(pUnk: any): void;
        align: string;
        readonly all: any;
        alt: string;
        blur(): void;
        border: any;
        readonly children: any;
        className: string;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        readonly complete: boolean;
        contains(pChild: IHTMLElement): boolean;
        disabled: boolean;
        readonly document: any;
        dynsrc: string;
        readonly filters: IHTMLFiltersCollection;
        focus(): void;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        height: number;
        hspace: number;
        id: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        loop: any;
        lowsrc: string;
        name: string;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onafterupdate: any;
        onbeforeupdate: any;
        onblur: any;
        onclick: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondragstart: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onhelp: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onload: any;
        onmousedown: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onresize: any;
        onrowenter: any;
        onrowexit: any;
        onselectstart: any;
        outerHTML: string;
        outerText: string;
        readonly parentElement: IHTMLElement;
        readonly parentTextEdit: IHTMLElement;
        readonly readyState: string;
        readonly recordNumber: any;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeFilter(pUnk: any): void;
        scrollIntoView(varargStart?: any): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        readonly sourceIndex: number;
        src: string;
        start: string;
        readonly style: IHTMLStyle;
        tabIndex: number;
        readonly tagName: string;
        title: string;
        toString(): string;
        readonly type: string;
        vrml: string;
        vspace: number;
        width: number;
    }

    class HTMLInputTextElement {
        private 'MSHTML.HTMLInputTextElement_typekey': HTMLInputTextElement;
        private constructor();
        accessKey: string;
        addFilter(pUnk: any): void;
        readonly all: any;
        blur(): void;
        readonly children: any;
        className: string;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        contains(pChild: IHTMLElement): boolean;
        createTextRange(): IHTMLTxtRange;
        dataFld: string;
        dataFormatAs: string;
        dataSrc: string;
        defaultValue: string;
        disabled: boolean;
        readonly document: any;
        readonly filters: IHTMLFiltersCollection;
        focus(): void;
        readonly form: IHTMLFormElement;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        id: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        maxLength: number;
        name: string;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onafterupdate: any;
        onbeforeupdate: any;
        onblur: any;
        onchange: any;
        onclick: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondragstart: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onhelp: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onmousedown: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onresize: any;
        onrowenter: any;
        onrowexit: any;
        onselect: any;
        onselectstart: any;
        outerHTML: string;
        outerText: string;
        readonly parentElement: IHTMLElement;
        readonly parentTextEdit: IHTMLElement;
        readOnly: boolean;
        readonly recordNumber: any;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeFilter(pUnk: any): void;
        scrollIntoView(varargStart?: any): void;
        select(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        size: number;
        readonly sourceIndex: number;
        status: any;
        readonly style: IHTMLStyle;
        tabIndex: number;
        readonly tagName: string;
        title: string;
        toString(): string;
        readonly type: string;
        value: string;
    }

    class HTMLIsIndexElement {
        private 'MSHTML.HTMLIsIndexElement_typekey': HTMLIsIndexElement;
        private constructor();
        accessKey: string;
        action: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        readonly form: IHTMLFormElement;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        prompt: string;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLLabelElement {
        private 'MSHTML.HTMLLabelElement_typekey': HTMLLabelElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        dataFld: string;
        dataFormatAs: string;
        dataSrc: string;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        readonly form: IHTMLFormElement;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        htmlFor: string;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        isDefaultNamespace(pvarNamespace: any): boolean;
        readonly isDisabled: boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        readonly isMultiLine: boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly namespaceURI: any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        textContent: any;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLLegendElement {
        private 'MSHTML.HTMLLegendElement_typekey': HTMLLegendElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        align: string;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        dataFld: string;
        dataFormatAs: string;
        dataSrc: string;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        readonly form: IHTMLFormElement;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        isDefaultNamespace(pvarNamespace: any): boolean;
        readonly isDisabled: boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        readonly isMultiLine: boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly namespaceURI: any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        textContent: any;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLLIElement {
        private 'MSHTML.HTMLLIElement_typekey': HTMLLIElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        type: string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        value: number;
        xmsAcceleratorKey: string;
    }

    class HTMLLinkElement {
        private 'MSHTML.HTMLLinkElement_typekey': HTMLLinkElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        charset: string;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        href: string;
        hreflang: string;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_href: string;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        media: string;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        rel: string;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        rev: string;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sheet: IHTMLStyleSheet;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        readonly styleSheet: IHTMLStyleSheet;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        target: string;
        title: string;
        toString(): string;
        type: string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLListElement {
        private 'MSHTML.HTMLListElement_typekey': HTMLListElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compact: boolean;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLLocation {
        private 'MSHTML.HTMLLocation_typekey': HTMLLocation;
        private constructor();
        assign(bstr: string): void;
        readonly 'constructor': any;
        hash: string;
        host: string;
        hostname: string;
        href: string;
        pathname: string;
        port: string;
        protocol: string;

        /** @param boolean [flag=false] */
        reload(flag?: boolean): void;
        replace(bstr: string): void;
        search: string;
        toString(): string;
    }

    class HTMLMapElement {
        private 'MSHTML.HTMLMapElement_typekey': HTMLMapElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        readonly areas: IHTMLAreasCollection;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        name: string;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLMarqueeElement {
        private 'MSHTML.HTMLMarqueeElement_typekey': HTMLMarqueeElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        behavior: string;
        readonly behaviorUrns: any;
        bgColor: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        dataFld: string;
        dataFormatAs: string;
        dataSrc: string;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        direction: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        height: any;
        hideFocus: boolean;
        hspace: number;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        isDefaultNamespace(pvarNamespace: any): boolean;
        readonly isDisabled: boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        readonly isMultiLine: boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        loop: number;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly namespaceURI: any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        onbounce: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfinish: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onstart: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        scrollAmount: number;
        scrollDelay: number;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        start(): void;
        stop(): void;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        textContent: any;
        title: string;
        toString(): string;
        trueSpeed: boolean;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        vspace: number;
        width: any;
        xmsAcceleratorKey: string;
    }

    class HTMLMediaElement {
        private 'MSHTML.HTMLMediaElement_typekey': HTMLMediaElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        autobuffer: boolean;
        autoplay: boolean;
        readonly behaviorUrns: any;
        blur(): void;
        readonly buffered: IHTMLTimeRanges;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        canPlayType(type: string): string;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        controls: boolean;
        createControlRange(): any;
        readonly currentSrc: string;
        readonly currentStyle: IHTMLCurrentStyle;
        currentTime: number;
        currentTimeDouble: number;
        dataFld: string;
        dataFormatAs: string;
        dataSrc: string;
        defaultPlaybackRate: number;
        defaultPlaybackRateDouble: number;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly duration: number;
        readonly durationDouble: number;
        readonly ended: boolean;
        readonly error: IHTMLMediaError;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        readonly initialTime: number;
        readonly initialTimeDouble: number;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        isDefaultNamespace(pvarNamespace: any): boolean;
        readonly isDisabled: boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        readonly isMultiLine: boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        load(): void;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        loop: boolean;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msPlayToDisabled: boolean;
        msPlayToPrimary: boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        muted: boolean;
        readonly namespaceURI: any;
        readonly networkState: number;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        pause(): void;
        readonly paused: boolean;
        play(): void;
        playbackRate: number;
        playbackRateDouble: number;
        readonly played: IHTMLTimeRanges;
        prefix: any;
        preload: string;
        readonly previousSibling: IHTMLDOMNode;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        readonly seekable: IHTMLTimeRanges;
        readonly seeking: boolean;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        src: string;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        textContent: any;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        volume: number;
        volumeDouble: number;
        xmsAcceleratorKey: string;
    }

    class HTMLMediaError {
        private 'MSHTML.HTMLMediaError_typekey': HTMLMediaError;
        private constructor();
        readonly code: number;
    }

    class HTMLMetaElement {
        private 'MSHTML.HTMLMetaElement_typekey': HTMLMetaElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        charset: string;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        content: string;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        httpEquiv: string;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_url: string;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        name: string;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        scheme: string;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        url: string;
        xmsAcceleratorKey: string;
    }

    class HTMLMSCSSKeyframeRule {
        private 'MSHTML.HTMLMSCSSKeyframeRule_typekey': HTMLMSCSSKeyframeRule;
        private constructor();
        cssText: string;
        keyText: string;
        readonly parentRule: IHTMLCSSRule;
        readonly parentStyleSheet: IHTMLStyleSheet;
        readonly style: IHTMLRuleStyle;
        readonly type: number;
    }

    class HTMLMSCSSKeyframesRule {
        private 'MSHTML.HTMLMSCSSKeyframesRule_typekey': HTMLMSCSSKeyframesRule;
        private constructor();
        appendRule(bstrRule: string): void;
        readonly cssRules: IHTMLStyleSheetRulesCollection;
        cssText: string;
        deleteRule(bstrKey: string): void;
        findRule(bstrKey: string): IHTMLMSCSSKeyframeRule;
        name: string;
        readonly parentRule: IHTMLCSSRule;
        readonly parentStyleSheet: IHTMLStyleSheet;
        readonly type: number;
    }

    class HTMLNamespace {
        private 'MSHTML.HTMLNamespace_typekey': HTMLNamespace;
        private constructor();
        attachEvent(event: string, pdisp: any): boolean;
        readonly 'constructor': any;
        detachEvent(event: string, pdisp: any): void;
        doImport(bstrImplementationUrl: string): void;
        readonly name: string;
        onreadystatechange: any;
        readonly readyState: any;
        readonly tagNames: any;
        readonly urn: string;
    }

    class HTMLNamespaceCollection {
        private 'MSHTML.HTMLNamespaceCollection_typekey': HTMLNamespaceCollection;
        private constructor();
        add(bstrNamespace: string, bstrUrn: string, implementationUrl?: any): any;
        readonly 'constructor': any;
        item(index: any): any;
        readonly length: number;
    }

    class HTMLNavigator {
        private 'MSHTML.HTMLNavigator_typekey': HTMLNavigator;
        private constructor();
        readonly appCodeName: string;
        readonly appMinorVersion: string;
        readonly appName: string;
        readonly appVersion: string;
        readonly browserLanguage: string;
        readonly connectionSpeed: number;
        readonly 'constructor': any;
        readonly cookieEnabled: boolean;
        readonly cpuClass: string;
        readonly geolocation: IWebGeolocation;
        javaEnabled(): boolean;
        readonly mimeTypes: CMimeTypes;
        readonly msDoNotTrack: string;
        readonly onLine: boolean;
        readonly opsProfile: COpsProfile;
        readonly platform: string;
        readonly plugins: IHTMLPluginsCollection;
        readonly systemLanguage: string;
        taintEnabled(): boolean;
        toString(): string;
        readonly userAgent: string;
        readonly userLanguage: string;
        readonly userProfile: COpsProfile;
    }

    class HTMLNextIdElement {
        private 'MSHTML.HTMLNextIdElement_typekey': HTMLNextIdElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        n: string;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLNoShowElement {
        private 'MSHTML.HTMLNoShowElement_typekey': HTMLNoShowElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLObjectElement {
        private 'MSHTML.HTMLObjectElement_typekey': HTMLObjectElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        align: string;
        readonly all: any;
        alt: string;
        altHtml: string;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        archive: string;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly BaseHref: string;
        readonly behaviorUrns: any;
        blur(): void;
        border: any;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        classid: string;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        code: string;
        codeBase: string;
        codeType: string;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        readonly contentDocument: any;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        data: string;
        dataFld: string;
        dataFormatAs: string;
        dataSrc: string;
        declare: boolean;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        readonly form: IHTMLFormElement;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        getSVGDocument(): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        height: any;
        hideFocus: boolean;
        hspace: number;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_codeBase: string;
        ie8_data: string;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_nodeName: string;
        ie9_object: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        isDefaultNamespace(pvarNamespace: any): boolean;
        readonly isDisabled: boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        readonly isMultiLine: boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        name: string;
        namedRecordset(dataMember: string, hierarchy?: any): any;
        readonly namespaceURI: any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly object: any;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readonly readyState: any;
        readonly recordNumber: any;
        recordset: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        standby: string;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        textContent: any;
        title: string;
        toString(): string;
        type: string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        useMap: string;
        vspace: number;
        width: any;
        xmsAcceleratorKey: string;
    }

    class HTMLOListElement {
        private 'MSHTML.HTMLOListElement_typekey': HTMLOListElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compact: boolean;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        start: number;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        type: string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLOptionButtonElement {
        private 'MSHTML.HTMLOptionButtonElement_typekey': HTMLOptionButtonElement;
        private constructor();
        accessKey: string;
        addFilter(pUnk: any): void;
        readonly all: any;
        blur(): void;
        checked: boolean;
        readonly children: any;
        className: string;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        contains(pChild: IHTMLElement): boolean;
        dataFld: string;
        dataFormatAs: string;
        dataSrc: string;
        defaultChecked: boolean;
        disabled: boolean;
        readonly document: any;
        readonly filters: IHTMLFiltersCollection;
        focus(): void;
        readonly form: IHTMLFormElement;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        id: string;
        indeterminate: boolean;
        innerHTML: string;
        innerText: string;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        name: string;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onafterupdate: any;
        onbeforeupdate: any;
        onblur: any;
        onchange: any;
        onclick: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondragstart: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onhelp: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onmousedown: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onresize: any;
        onrowenter: any;
        onrowexit: any;
        onselectstart: any;
        outerHTML: string;
        outerText: string;
        readonly parentElement: IHTMLElement;
        readonly parentTextEdit: IHTMLElement;
        readonly recordNumber: any;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeFilter(pUnk: any): void;
        scrollIntoView(varargStart?: any): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        readonly sourceIndex: number;
        status: boolean;
        readonly style: IHTMLStyle;
        tabIndex: number;
        readonly tagName: string;
        title: string;
        toString(): string;
        readonly type: string;
        value: string;
    }

    class HTMLOptionElement {
        private 'MSHTML.HTMLOptionElement_typekey': HTMLOptionElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        dataFld: string;
        dataFormatAs: string;
        dataSrc: string;
        defaultSelected: boolean;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        readonly form: IHTMLFormElement;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        ie9_value: string;
        index: number;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        isDefaultNamespace(pvarNamespace: any): boolean;
        readonly isDisabled: boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        readonly isMultiLine: boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly isTextEdit: boolean;
        label: string;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly namespaceURI: any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        selected: boolean;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        text: string;
        textContent: any;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        value: string;
        xmsAcceleratorKey: string;
    }

    class HTMLOptionElementFactory {
        private 'MSHTML.HTMLOptionElementFactory_typekey': HTMLOptionElementFactory;
        private constructor();
        create(text?: any, value?: any, defaultSelected?: any, selected?: any): IHTMLOptionElement;
    }

    class HTMLParaElement {
        private 'MSHTML.HTMLParaElement_typekey': HTMLParaElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        align: string;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clear: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLParamElement {
        private 'MSHTML.HTMLParamElement_typekey': HTMLParamElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_valueType: string;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        name: string;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        type: string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        value: string;
        valueType: string;
        xmsAcceleratorKey: string;
    }

    class HTMLPerformance {
        private 'MSHTML.HTMLPerformance_typekey': HTMLPerformance;
        private constructor();
        readonly navigation: IHTMLPerformanceNavigation;
        readonly timing: IHTMLPerformanceTiming;
        toJSON(): any;
        toString(): string;
    }

    class HTMLPerformanceNavigation {
        private 'MSHTML.HTMLPerformanceNavigation_typekey': HTMLPerformanceNavigation;
        private constructor();
        readonly redirectCount: number;
        toJSON(): any;
        toString(): string;
        readonly type: number;
    }

    class HTMLPerformanceTiming {
        private 'MSHTML.HTMLPerformanceTiming_typekey': HTMLPerformanceTiming;
        private constructor();
        readonly connectEnd: number;
        readonly connectStart: number;
        readonly domainLookupEnd: number;
        readonly domainLookupStart: number;
        readonly domComplete: number;
        readonly domContentLoadedEventEnd: number;
        readonly domContentLoadedEventStart: number;
        readonly domInteractive: number;
        readonly domLoading: number;
        readonly fetchStart: number;
        readonly loadEventEnd: number;
        readonly loadEventStart: number;
        readonly msFirstPaint: number;
        readonly navigationStart: number;
        readonly redirectEnd: number;
        readonly redirectStart: number;
        readonly requestStart: number;
        readonly responseEnd: number;
        readonly responseStart: number;
        toJSON(): any;
        toString(): string;
        readonly unloadEventEnd: number;
        readonly unloadEventStart: number;
    }

    class HTMLPhraseElement {
        private 'MSHTML.HTMLPhraseElement_typekey': HTMLPhraseElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        cite: string;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        dateTime: string;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_cite: string;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLPopup {
        private 'MSHTML.HTMLPopup_typekey': HTMLPopup;
        private constructor();
        readonly 'constructor': any;
        readonly document: IHTMLDocument;
        Hide(): void;
        readonly isOpen: boolean;
        Show(x: number, y: number, w: number, h: number, pElement: any): void;
    }

    class HTMLProgressElement {
        private 'MSHTML.HTMLProgressElement_typekey': HTMLProgressElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        dataFld: string;
        dataFormatAs: string;
        dataSrc: string;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        readonly form: IHTMLFormElement;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        isDefaultNamespace(pvarNamespace: any): boolean;
        readonly isDisabled: boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        readonly isMultiLine: boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        max: number;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly namespaceURI: any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly position: number;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        textContent: any;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        value: number;
        xmsAcceleratorKey: string;
    }

    class HTMLRenderStyle {
        private 'MSHTML.HTMLRenderStyle_typekey': HTMLRenderStyle;
        private constructor();
        defaultTextSelection: string;
        renderingPriority: number;
        textBackgroundColor: any;
        textColor: any;
        textDecoration: string;
        textDecorationColor: any;
        textEffect: string;
        textLineThroughStyle: string;
        textUnderlineStyle: string;
    }

    class HTMLRichtextElement {
        private 'MSHTML.HTMLRichtextElement_typekey': HTMLRichtextElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        cols: number;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        createTextRange(): IHTMLTxtRange;
        readonly currentStyle: IHTMLCurrentStyle;
        dataFld: string;
        dataFormatAs: string;
        dataSrc: string;
        defaultValue: string;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        readonly form: IHTMLFormElement;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        isDefaultNamespace(pvarNamespace: any): boolean;
        readonly isDisabled: boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        readonly isMultiLine: boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        name: string;
        readonly namespaceURI: any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readOnly: boolean;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        rows: number;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        select(): void;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        status: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        textContent: any;
        title: string;
        toString(): string;
        readonly type: string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        value: string;
        wrap: string;
        xmsAcceleratorKey: string;
    }

    class HTMLRuleStyle {
        private 'MSHTML.HTMLRuleStyle_typekey': HTMLRuleStyle;
        private constructor();
        accelerator: string;
        alignContent: string;
        alignItems: string;
        alignSelf: string;
        animation: string;
        animationDelay: string;
        animationDirection: string;
        animationDuration: string;
        animationFillMode: string;
        animationIterationCount: string;
        animationName: string;
        animationPlayState: string;
        animationTimingFunction: string;
        backfaceVisibility: string;
        background: string;
        backgroundAttachment: string;
        backgroundColor: any;
        backgroundImage: string;
        backgroundPosition: string;
        backgroundPositionX: any;
        backgroundPositionY: any;
        backgroundRepeat: string;
        behavior: string;
        border: string;
        borderBottom: string;
        borderBottomColor: any;
        borderBottomStyle: string;
        borderBottomWidth: any;
        borderCollapse: string;
        borderColor: string;
        borderImage: string;
        borderImageOutset: string;
        borderImageRepeat: string;
        borderImageSlice: string;
        borderImageSource: string;
        borderImageWidth: string;
        borderLeft: string;
        borderLeftColor: any;
        borderLeftStyle: string;
        borderLeftWidth: any;
        borderRight: string;
        borderRightColor: any;
        borderRightStyle: string;
        borderRightWidth: any;
        borderSpacing: string;
        borderStyle: string;
        borderTop: string;
        borderTopColor: any;
        borderTopStyle: string;
        borderTopWidth: any;
        borderWidth: string;
        bottom: any;
        boxSizing: string;
        breakAfter: string;
        breakBefore: string;
        breakInside: string;
        captionSide: string;
        clear: string;
        clip: string;
        color: any;
        colorInterpolationFilters: string;
        columnCount: any;
        columnFill: string;
        columnGap: any;
        columnRule: string;
        columnRuleColor: any;
        columnRuleStyle: string;
        columnRuleWidth: any;
        columns: string;
        columnSpan: string;
        columnWidth: any;
        readonly 'constructor': any;
        content: string;
        counterIncrement: string;
        counterReset: string;
        cssText: string;
        cursor: string;
        direction: string;
        display: string;
        emptyCells: string;
        enableBackground: string;
        filter: string;
        flex: string;
        flexBasis: any;
        flexDirection: string;
        flexFlow: string;
        flexGrow: any;
        flexShrink: any;
        flexWrap: string;
        floodColor: any;
        floodOpacity: any;
        font: string;
        fontFamily: string;
        fontFeatureSettings: string;
        fontSize: any;
        fontStyle: string;
        fontVariant: string;
        fontWeight: string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getPropertyPriority(bstrPropertyName: string): string;
        getPropertyValue(bstrPropertyName: string): string;
        height: any;
        imeMode: string;
        item(index: number): string;
        justifyContent: string;
        layoutFlow: string;
        layoutGrid: string;
        layoutGridChar: any;
        layoutGridLine: any;
        layoutGridMode: string;
        layoutGridType: string;
        left: any;
        readonly length: number;
        letterSpacing: any;
        lightingColor: any;
        lineBreak: string;
        lineHeight: any;
        listStyle: string;
        listStyleImage: string;
        listStylePosition: string;
        listStyleType: string;
        margin: string;
        marginBottom: any;
        marginLeft: any;
        marginRight: any;
        marginTop: any;
        maxHeight: any;
        maxWidth: any;
        minHeight: any;
        minWidth: any;
        msAnimation: string;
        msAnimationDelay: string;
        msAnimationDirection: string;
        msAnimationDuration: string;
        msAnimationFillMode: string;
        msAnimationIterationCount: string;
        msAnimationName: string;
        msAnimationPlayState: string;
        msAnimationTimingFunction: string;
        msBackfaceVisibility: string;
        msBlockProgression: string;
        msContentZoomChaining: string;
        msContentZooming: string;
        msContentZoomLimit: string;
        msContentZoomLimitMax: any;
        msContentZoomLimitMin: any;
        msContentZoomSnap: string;
        msContentZoomSnapPoints: string;
        msContentZoomSnapType: string;
        msFlex: string;
        msFlexAlign: string;
        msFlexDirection: string;
        msFlexFlow: string;
        msFlexItemAlign: string;
        msFlexLinePack: string;
        msFlexNegative: any;
        msFlexOrder: any;
        msFlexPack: string;
        msFlexPositive: any;
        msFlexPreferredSize: any;
        msFlexWrap: string;
        msFlowFrom: string;
        msFlowInto: string;
        msFontFeatureSettings: string;
        msGetPropertyEnabled(name: string): boolean;
        msGridColumn: any;
        msGridColumnAlign: string;
        msGridColumns: string;
        msGridColumnSpan: any;
        msGridRow: any;
        msGridRowAlign: string;
        msGridRows: string;
        msGridRowSpan: any;
        msHighContrastAdjust: string;
        msHyphenateLimitChars: string;
        msHyphenateLimitLines: any;
        msHyphenateLimitZone: any;
        msHyphens: string;
        msImeAlign: string;
        msInterpolationMode: string;
        msOverflowStyle: string;
        msPerspective: any;
        msPerspectiveOrigin: string;
        msPutPropertyEnabled(name: string, b: boolean): void;
        msScrollChaining: string;
        msScrollLimit: string;
        msScrollLimitXMax: any;
        msScrollLimitXMin: any;
        msScrollLimitYMax: any;
        msScrollLimitYMin: any;
        msScrollRails: string;
        msScrollSnapPointsX: string;
        msScrollSnapPointsY: string;
        msScrollSnapType: string;
        msScrollSnapX: string;
        msScrollSnapY: string;
        msScrollTranslation: string;
        msTextCombineHorizontal: string;
        msTextSizeAdjust: any;
        msTouchAction: string;
        msTouchSelect: string;
        msTransformStyle: string;
        msTransition: string;
        msTransitionDelay: string;
        msTransitionDuration: string;
        msTransitionProperty: string;
        msTransitionTimingFunction: string;
        msUserSelect: string;
        msWrapFlow: string;
        msWrapMargin: any;
        msWrapThrough: string;
        orphans: any;
        outline: string;
        outlineColor: any;
        outlineStyle: string;
        outlineWidth: any;
        overflow: string;
        overflowX: string;
        overflowY: string;
        padding: string;
        paddingBottom: any;
        paddingLeft: any;
        paddingRight: any;
        paddingTop: any;
        pageBreakAfter: string;
        pageBreakBefore: string;
        pageBreakInside: string;
        readonly parentRule: any;
        perspective: any;
        perspectiveOrigin: string;
        pixelBottom: number;
        pixelRight: number;
        posBottom: number;
        position: string;
        posRight: number;
        quotes: string;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeProperty(bstrPropertyName: string): string;
        right: any;
        rubyAlign: string;
        rubyOverhang: string;
        rubyPosition: string;
        scrollbar3dLightColor: any;
        scrollbarArrowColor: any;
        scrollbarBaseColor: any;
        scrollbarDarkShadowColor: any;
        scrollbarFaceColor: any;
        scrollbarHighlightColor: any;
        scrollbarShadowColor: any;
        scrollbarTrackColor: any;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;

        /** @param any [pvarPropertyPriority=''] */
        setProperty(bstrPropertyName: string, pvarPropertyValue: any, pvarPropertyPriority?: any): void;
        styleFloat: string;
        tableLayout: string;
        textAlign: string;
        textAlignLast: string;
        textAutospace: string;
        textDecoration: string;
        textDecorationBlink: boolean;
        textDecorationLineThrough: boolean;
        textDecorationNone: boolean;
        textDecorationOverline: boolean;
        textDecorationUnderline: boolean;
        textIndent: any;
        textJustify: string;
        textJustifyTrim: string;
        textKashida: any;
        textKashidaSpace: any;
        textOverflow: string;
        textShadow: string;
        textTransform: string;
        textUnderlinePosition: string;
        top: any;
        touchAction: string;
        transform: string;
        transformOrigin: string;
        transformStyle: string;
        transition: string;
        transitionDelay: string;
        transitionDuration: string;
        transitionProperty: string;
        transitionTimingFunction: string;
        unicodeBidi: string;
        verticalAlign: any;
        visibility: string;
        webkitAnimation: string;
        webkitAnimationDelay: string;
        webkitAnimationDirection: string;
        webkitAnimationDuration: string;
        webkitAnimationFillMode: string;
        webkitAnimationIterationCount: string;
        webkitAnimationName: string;
        webkitAnimationPlayState: string;
        webkitAnimationTimingFunction: string;
        webkitAppearance: string;
        webkitBackfaceVisibility: string;
        webkitBackground: string;
        webkitBackgroundAttachment: string;
        webkitBackgroundClip: string;
        webkitBackgroundColor: any;
        webkitBackgroundImage: string;
        webkitBackgroundOrigin: string;
        webkitBackgroundPosition: string;
        webkitBackgroundPositionX: any;
        webkitBackgroundPositionY: any;
        webkitBackgroundRepeat: string;
        webkitBackgroundSize: string;
        webkitBorderImage: string;
        webkitBorderImageOutset: string;
        webkitBorderImageRepeat: string;
        webkitBorderImageSlice: string;
        webkitBorderImageSource: string;
        webkitBorderImageWidth: string;
        webkitBoxAlign: string;
        webkitBoxDirection: string;
        webkitBoxFlex: any;
        webkitBoxOrdinalGroup: any;
        webkitBoxOrient: string;
        webkitBoxPack: string;
        webkitBoxSizing: string;
        webkitTextSizeAdjust: any;
        webkitTransform: string;
        webkitTransformOrigin: string;
        webkitTransition: string;
        webkitTransitionDelay: string;
        webkitTransitionDuration: string;
        webkitTransitionProperty: string;
        webkitTransitionTimingFunction: string;
        webkitUserSelect: string;
        whiteSpace: string;
        widows: any;
        width: any;
        wordBreak: string;
        wordSpacing: any;
        wordWrap: string;
        writingMode: string;
        zIndex: any;
        zoom: any;
    }

    class HTMLScreen {
        private 'MSHTML.HTMLScreen_typekey': HTMLScreen;
        private constructor();
        readonly availHeight: number;
        readonly availWidth: number;
        bufferDepth: number;
        readonly colorDepth: number;
        readonly 'constructor': any;
        readonly deviceXDPI: number;
        readonly deviceYDPI: number;
        readonly fontSmoothingEnabled: boolean;
        readonly height: number;
        readonly logicalXDPI: number;
        readonly logicalYDPI: number;
        readonly pixelDepth: number;
        readonly systemXDPI: number;
        readonly systemYDPI: number;
        updateInterval: number;
        readonly width: number;
    }

    class HTMLScriptElement {
        private 'MSHTML.HTMLScriptElement_typekey': HTMLScriptElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        charset: string;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        defer: boolean;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        event: string;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        htmlFor: string;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_src: string;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        src: string;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        text: string;
        title: string;
        toString(): string;
        type: string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        readonly usedCharset: string;
        xmsAcceleratorKey: string;
    }

    class HTMLSelectElement {
        private 'MSHTML.HTMLSelectElement_typekey': HTMLSelectElement;
        private constructor();
        accessKey: string;
        add(element: IHTMLElement, before?: any): void;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        dataFld: string;
        dataFormatAs: string;
        dataSrc: string;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        readonly form: IHTMLFormElement;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        ie8_add(pElem: IHTMLOptionElement, pvarBefore: any): void;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_add(pElem: IHTMLOptionElement, pvarBefore: any): void;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        ie9_value: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        isDefaultNamespace(pvarNamespace: any): boolean;
        readonly isDisabled: boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        readonly isMultiLine: boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly isTextEdit: boolean;
        item(name?: any, index?: any): any;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        length: number;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        multiple: boolean;
        name: string;
        namedItem(name: string): any;
        readonly namespaceURI: any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        readonly options: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [index=-1] */
        remove(index?: number): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        selectedIndex: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        size: number;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tags(tagName: any): any;
        tagUrn: string;
        textContent: any;
        title: string;
        toString(): string;
        readonly type: string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        urns(urn: any): any;
        value: string;
        xmsAcceleratorKey: string;
    }

    class HTMLSemanticElement {
        private 'MSHTML.HTMLSemanticElement_typekey': HTMLSemanticElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLSourceElement {
        private 'MSHTML.HTMLSourceElement_typekey': HTMLSourceElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        dataFld: string;
        dataFormatAs: string;
        dataSrc: string;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        isDefaultNamespace(pvarNamespace: any): boolean;
        readonly isDisabled: boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        readonly isMultiLine: boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        media: string;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly namespaceURI: any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        src: string;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        textContent: any;
        title: string;
        toString(): string;
        type: string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLSpanElement {
        private 'MSHTML.HTMLSpanElement_typekey': HTMLSpanElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        dataFld: string;
        dataFormatAs: string;
        dataSrc: string;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        isDefaultNamespace(pvarNamespace: any): boolean;
        readonly isDisabled: boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        readonly isMultiLine: boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly namespaceURI: any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        textContent: any;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLSpanFlow {
        private 'MSHTML.HTMLSpanFlow_typekey': HTMLSpanFlow;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        align: string;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        dataFld: string;
        dataFormatAs: string;
        dataSrc: string;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        isDefaultNamespace(pvarNamespace: any): boolean;
        readonly isDisabled: boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        readonly isMultiLine: boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly namespaceURI: any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        textContent: any;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLStorage {
        private 'MSHTML.HTMLStorage_typekey': HTMLStorage;
        private constructor();
        clear(): void;
        readonly 'constructor': any;
        getItem(bstrKey: string): any;
        ie9_setItem(bstrKey: string, bstrValue: string): void;
        key(lIndex: number): string;
        readonly length: number;
        readonly remainingSpace: number;
        removeItem(bstrKey: string): void;
        setItem(bstrKey: string, bstrValue: string): void;
    }

    class HTMLStyle {
        private 'MSHTML.HTMLStyle_typekey': HTMLStyle;
        private constructor();
        accelerator: string;
        alignContent: string;
        alignItems: string;
        alignSelf: string;
        animation: string;
        animationDelay: string;
        animationDirection: string;
        animationDuration: string;
        animationFillMode: string;
        animationIterationCount: string;
        animationName: string;
        animationPlayState: string;
        animationTimingFunction: string;
        backfaceVisibility: string;
        background: string;
        backgroundAttachment: string;
        backgroundColor: any;
        backgroundImage: string;
        backgroundPosition: string;
        backgroundPositionX: any;
        backgroundPositionY: any;
        backgroundRepeat: string;
        behavior: string;
        border: string;
        borderBottom: string;
        borderBottomColor: any;
        borderBottomStyle: string;
        borderBottomWidth: any;
        borderCollapse: string;
        borderColor: string;
        borderImage: string;
        borderImageOutset: string;
        borderImageRepeat: string;
        borderImageSlice: string;
        borderImageSource: string;
        borderImageWidth: string;
        borderLeft: string;
        borderLeftColor: any;
        borderLeftStyle: string;
        borderLeftWidth: any;
        borderRight: string;
        borderRightColor: any;
        borderRightStyle: string;
        borderRightWidth: any;
        borderSpacing: string;
        borderStyle: string;
        borderTop: string;
        borderTopColor: any;
        borderTopStyle: string;
        borderTopWidth: any;
        borderWidth: string;
        bottom: any;
        boxSizing: string;
        breakAfter: string;
        breakBefore: string;
        breakInside: string;
        captionSide: string;
        clear: string;
        clip: string;
        color: any;
        colorInterpolationFilters: string;
        columnCount: any;
        columnFill: string;
        columnGap: any;
        columnRule: string;
        columnRuleColor: any;
        columnRuleStyle: string;
        columnRuleWidth: any;
        columns: string;
        columnSpan: string;
        columnWidth: any;
        readonly 'constructor': any;
        content: string;
        counterIncrement: string;
        counterReset: string;
        cssText: string;
        cursor: string;
        direction: string;
        display: string;
        emptyCells: string;
        enableBackground: string;
        filter: string;
        flex: string;
        flexBasis: any;
        flexDirection: string;
        flexFlow: string;
        flexGrow: any;
        flexShrink: any;
        flexWrap: string;
        floodColor: any;
        floodOpacity: any;
        font: string;
        fontFamily: string;
        fontFeatureSettings: string;
        fontSize: any;
        fontStyle: string;
        fontVariant: string;
        fontWeight: string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getExpression(propname: string): any;
        getPropertyPriority(bstrPropertyName: string): string;
        getPropertyValue(bstrPropertyName: string): string;
        height: any;
        imeMode: string;
        item(index: number): string;
        justifyContent: string;
        layoutFlow: string;
        layoutGrid: string;
        layoutGridChar: any;
        layoutGridLine: any;
        layoutGridMode: string;
        layoutGridType: string;
        left: any;
        readonly length: number;
        letterSpacing: any;
        lightingColor: any;
        lineBreak: string;
        lineHeight: any;
        listStyle: string;
        listStyleImage: string;
        listStylePosition: string;
        listStyleType: string;
        margin: string;
        marginBottom: any;
        marginLeft: any;
        marginRight: any;
        marginTop: any;
        maxHeight: any;
        maxWidth: any;
        minHeight: any;
        minWidth: any;
        msAnimation: string;
        msAnimationDelay: string;
        msAnimationDirection: string;
        msAnimationDuration: string;
        msAnimationFillMode: string;
        msAnimationIterationCount: string;
        msAnimationName: string;
        msAnimationPlayState: string;
        msAnimationTimingFunction: string;
        msBackfaceVisibility: string;
        msBlockProgression: string;
        msContentZoomChaining: string;
        msContentZooming: string;
        msContentZoomLimit: string;
        msContentZoomLimitMax: any;
        msContentZoomLimitMin: any;
        msContentZoomSnap: string;
        msContentZoomSnapPoints: string;
        msContentZoomSnapType: string;
        msFlex: string;
        msFlexAlign: string;
        msFlexDirection: string;
        msFlexFlow: string;
        msFlexItemAlign: string;
        msFlexLinePack: string;
        msFlexNegative: any;
        msFlexOrder: any;
        msFlexPack: string;
        msFlexPositive: any;
        msFlexPreferredSize: any;
        msFlexWrap: string;
        msFlowFrom: string;
        msFlowInto: string;
        msFontFeatureSettings: string;
        msGetPropertyEnabled(name: string): boolean;
        msGridColumn: any;
        msGridColumnAlign: string;
        msGridColumns: string;
        msGridColumnSpan: any;
        msGridRow: any;
        msGridRowAlign: string;
        msGridRows: string;
        msGridRowSpan: any;
        msHighContrastAdjust: string;
        msHyphenateLimitChars: string;
        msHyphenateLimitLines: any;
        msHyphenateLimitZone: any;
        msHyphens: string;
        msImeAlign: string;
        msInterpolationMode: string;
        msOverflowStyle: string;
        msPerspective: any;
        msPerspectiveOrigin: string;
        msPutPropertyEnabled(name: string, b: boolean): void;
        msScrollChaining: string;
        msScrollLimit: string;
        msScrollLimitXMax: any;
        msScrollLimitXMin: any;
        msScrollLimitYMax: any;
        msScrollLimitYMin: any;
        msScrollRails: string;
        msScrollSnapPointsX: string;
        msScrollSnapPointsY: string;
        msScrollSnapType: string;
        msScrollSnapX: string;
        msScrollSnapY: string;
        msScrollTranslation: string;
        msTextCombineHorizontal: string;
        msTextSizeAdjust: any;
        msTouchAction: string;
        msTouchSelect: string;
        msTransformStyle: string;
        msTransition: string;
        msTransitionDelay: string;
        msTransitionDuration: string;
        msTransitionProperty: string;
        msTransitionTimingFunction: string;
        msUserSelect: string;
        msWrapFlow: string;
        msWrapMargin: any;
        msWrapThrough: string;
        orphans: any;
        outline: string;
        outlineColor: any;
        outlineStyle: string;
        outlineWidth: any;
        overflow: string;
        overflowX: string;
        overflowY: string;
        padding: string;
        paddingBottom: any;
        paddingLeft: any;
        paddingRight: any;
        paddingTop: any;
        pageBreakAfter: string;
        pageBreakBefore: string;
        pageBreakInside: string;
        readonly parentRule: any;
        perspective: any;
        perspectiveOrigin: string;
        pixelBottom: number;
        pixelHeight: number;
        pixelLeft: number;
        pixelRight: number;
        pixelTop: number;
        pixelWidth: number;
        posBottom: number;
        posHeight: number;
        position: string;
        posLeft: number;
        posRight: number;
        posTop: number;
        posWidth: number;
        quotes: string;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeExpression(propname: string): boolean;
        removeProperty(bstrPropertyName: string): string;
        right: any;
        rubyAlign: string;
        rubyOverhang: string;
        rubyPosition: string;
        scrollbar3dLightColor: any;
        scrollbarArrowColor: any;
        scrollbarBaseColor: any;
        scrollbarDarkShadowColor: any;
        scrollbarFaceColor: any;
        scrollbarHighlightColor: any;
        scrollbarShadowColor: any;
        scrollbarTrackColor: any;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;

        /** @param any [pvarPropertyPriority=''] */
        setProperty(bstrPropertyName: string, pvarPropertyValue: any, pvarPropertyPriority?: any): void;
        styleFloat: string;
        tableLayout: string;
        textAlign: string;
        textAlignLast: string;
        textAutospace: string;
        textDecoration: string;
        textDecorationBlink: boolean;
        textDecorationLineThrough: boolean;
        textDecorationNone: boolean;
        textDecorationOverline: boolean;
        textDecorationUnderline: boolean;
        textIndent: any;
        textJustify: string;
        textJustifyTrim: string;
        textKashida: any;
        textKashidaSpace: any;
        textOverflow: string;
        textShadow: string;
        textTransform: string;
        textUnderlinePosition: string;
        top: any;
        toString(): string;
        touchAction: string;
        transform: string;
        transformOrigin: string;
        transformStyle: string;
        transition: string;
        transitionDelay: string;
        transitionDuration: string;
        transitionProperty: string;
        transitionTimingFunction: string;
        unicodeBidi: string;
        verticalAlign: any;
        visibility: string;
        webkitAnimation: string;
        webkitAnimationDelay: string;
        webkitAnimationDirection: string;
        webkitAnimationDuration: string;
        webkitAnimationFillMode: string;
        webkitAnimationIterationCount: string;
        webkitAnimationName: string;
        webkitAnimationPlayState: string;
        webkitAnimationTimingFunction: string;
        webkitAppearance: string;
        webkitBackfaceVisibility: string;
        webkitBackground: string;
        webkitBackgroundAttachment: string;
        webkitBackgroundClip: string;
        webkitBackgroundColor: any;
        webkitBackgroundImage: string;
        webkitBackgroundOrigin: string;
        webkitBackgroundPosition: string;
        webkitBackgroundPositionX: any;
        webkitBackgroundPositionY: any;
        webkitBackgroundRepeat: string;
        webkitBackgroundSize: string;
        webkitBorderImage: string;
        webkitBorderImageOutset: string;
        webkitBorderImageRepeat: string;
        webkitBorderImageSlice: string;
        webkitBorderImageSource: string;
        webkitBorderImageWidth: string;
        webkitBoxAlign: string;
        webkitBoxDirection: string;
        webkitBoxFlex: any;
        webkitBoxOrdinalGroup: any;
        webkitBoxOrient: string;
        webkitBoxPack: string;
        webkitBoxSizing: string;
        webkitTextSizeAdjust: any;
        webkitTransform: string;
        webkitTransformOrigin: string;
        webkitTransition: string;
        webkitTransitionDelay: string;
        webkitTransitionDuration: string;
        webkitTransitionProperty: string;
        webkitTransitionTimingFunction: string;
        webkitUserSelect: string;
        whiteSpace: string;
        widows: any;
        width: any;
        wordBreak: string;
        wordSpacing: any;
        wordWrap: string;
        writingMode: string;
        zIndex: any;
        zoom: any;
    }

    class HTMLStyleElement {
        private 'MSHTML.HTMLStyleElement_typekey': HTMLStyleElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        media: string;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sheet: IHTMLStyleSheet;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        readonly styleSheet: IHTMLStyleSheet;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        type: string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLStyleFontFace {
        private 'MSHTML.HTMLStyleFontFace_typekey': HTMLStyleFontFace;
        private constructor();
        cssText: string;
        fontsrc: string;
        readonly parentRule: IHTMLCSSRule;
        readonly parentStyleSheet: IHTMLStyleSheet;
        readonly style: IHTMLRuleStyle;
        readonly type: number;
    }

    class HTMLStyleMedia {
        private 'MSHTML.HTMLStyleMedia_typekey': HTMLStyleMedia;
        private constructor();
        matchMedium(mediaQuery: string): boolean;
        readonly type: string;
    }

    class HTMLStyleSheet {
        private 'MSHTML.HTMLStyleSheet_typekey': HTMLStyleSheet;
        private constructor();

        /** @param number [lIndex=-1] */
        addImport(bstrURL: string, lIndex?: number): number;

        /** @param number [lIndex=-1] */
        addPageRule(bstrSelector: string, bstrStyle: string, lIndex?: number): number;

        /** @param number [lIndex=-1] */
        addRule(bstrSelector: string, bstrStyle: string, lIndex?: number): number;
        readonly 'constructor': any;
        readonly cssRules: IHTMLStyleSheetRulesCollection;
        cssText: string;

        /** @param number [lIndex=-1] */
        deleteRule(lIndex?: number): void;
        disabled: boolean;
        href: string;
        readonly id: string;
        ie8_href: string;
        readonly ie9_href: any;
        readonly ie9_media: any;
        readonly ie9_title: string;
        readonly ie9_type: string;
        readonly imports: IHTMLStyleSheetsCollection;

        /** @param number [lIndex=-1] */
        insertRule(bstrRule: string, lIndex?: number): number;
        readonly isAlternate: boolean;
        readonly isPrefAlternate: boolean;
        media: string;
        readonly ownerNode: IHTMLElement;
        readonly ownerRule: IHTMLCSSRule;
        readonly owningElement: IHTMLElement;
        readonly pages: IHTMLStyleSheetPagesCollection;
        readonly parentStyleSheet: IHTMLStyleSheet;
        readonly readOnly: boolean;
        removeImport(lIndex: number): void;
        removeRule(lIndex: number): void;
        readonly rules: IHTMLStyleSheetRulesCollection;
        title: string;
        readonly type: string;
    }

    class HTMLStyleSheetPage {
        private 'MSHTML.HTMLStyleSheetPage_typekey': HTMLStyleSheetPage;
        private constructor();
        readonly 'constructor': any;
        cssText: string;
        readonly parentRule: IHTMLCSSRule;
        readonly parentStyleSheet: IHTMLStyleSheet;
        readonly pseudoClass: string;
        readonly selector: string;
        selectorText: string;
        readonly style: IHTMLRuleStyle;
        readonly type: number;
    }

    class HTMLStyleSheetPagesCollection {
        private 'MSHTML.HTMLStyleSheetPagesCollection_typekey': HTMLStyleSheetPagesCollection;
        private constructor();
        readonly 'constructor': any;
        item(index: number): IHTMLStyleSheetPage;
        readonly length: number;
    }

    class HTMLStyleSheetRule {
        private 'MSHTML.HTMLStyleSheetRule_typekey': HTMLStyleSheetRule;
        private constructor();
        readonly 'constructor': any;
        cssText: string;
        ie9_selectorText: string;
        msGetSpecificity(index: number): number;
        readonly parentRule: IHTMLCSSRule;
        readonly parentStyleSheet: IHTMLStyleSheet;
        readonly readOnly: boolean;
        selectorText: string;
        readonly style: IHTMLRuleStyle;
        readonly type: number;
    }

    class HTMLStyleSheetRulesAppliedCollection {
        private 'MSHTML.HTMLStyleSheetRulesAppliedCollection_typekey': HTMLStyleSheetRulesAppliedCollection;
        private constructor();
        item(index: number): IHTMLStyleSheetRule;
        readonly length: number;
        propertyAppliedBy(name: string): IHTMLStyleSheetRule;
        propertyAppliedTrace(name: string, index: number): IHTMLStyleSheetRule;
        propertyAppliedTraceLength(name: string): number;
    }

    class HTMLStyleSheetRulesCollection {
        private 'MSHTML.HTMLStyleSheetRulesCollection_typekey': HTMLStyleSheetRulesCollection;
        private constructor();
        readonly 'constructor': any;
        ie9_item(index: number): IHTMLCSSRule;
        readonly ie9_length: number;
        item(index: number): IHTMLStyleSheetRule;
        readonly length: number;
    }

    class HTMLStyleSheetsCollection {
        private 'MSHTML.HTMLStyleSheetsCollection_typekey': HTMLStyleSheetsCollection;
        private constructor();
        readonly 'constructor': any;
        ie9_item(index: number): any;
        item(pvarIndex: any): any;
        readonly length: number;
    }

    class HTMLTable {
        private 'MSHTML.HTMLTable_typekey': HTMLTable;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        align: string;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        background: string;
        readonly behaviorUrns: any;
        bgColor: any;
        blur(): void;
        border: any;
        borderColor: any;
        borderColorDark: any;
        borderColorLight: any;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly caption: IHTMLTableCaption;
        cellPadding: any;
        readonly cells: IHTMLElementCollection;
        cellSpacing: any;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        cols: number;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createCaption(): IHTMLTableCaption;
        createControlRange(): any;
        createTBody(): IHTMLTableSection;
        createTFoot(): any;
        createTHead(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        dataFld: string;
        dataFormatAs: string;
        dataPageSize: number;
        dataSrc: string;
        deleteCaption(): void;

        /** @param number [index=-1] */
        deleteRow(index?: number): void;
        deleteTFoot(): void;
        deleteTHead(): void;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        firstPage(): void;
        focus(): void;
        frame: string;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        height: any;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_caption: IHTMLTableCaption;

        /** @param number [index=-1] */
        ie9_deleteRow(index?: number): void;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;

        /** @param number [index=-1] */
        ie9_insertRow(index?: number): any;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        ie9_tFoot: IHTMLTableSection;
        ie9_tHead: IHTMLTableSection;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;

        /** @param number [index=-1] */
        insertRow(index?: number): any;
        readonly isContentEditable: boolean;
        isDefaultNamespace(pvarNamespace: any): boolean;
        readonly isDisabled: boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        readonly isMultiLine: boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        lastPage(): void;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;

        /**
         * @param number [indexFrom=-1]
         * @param number [indexTo=-1]
         */
        moveRow(indexFrom?: number, indexTo?: number): any;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly namespaceURI: any;
        nextPage(): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        prefix: any;
        previousPage(): void;
        readonly previousSibling: IHTMLDOMNode;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readonly readyState: any;
        readonly recordNumber: any;
        refresh(): void;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly rows: IHTMLElementCollection;
        rules: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        summary: string;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        readonly tBodies: IHTMLElementCollection;
        textContent: any;
        readonly tFoot: IHTMLTableSection;
        readonly tHead: IHTMLTableSection;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        width: any;
        xmsAcceleratorKey: string;
    }

    class HTMLTableCaption {
        private 'MSHTML.HTMLTableCaption_typekey': HTMLTableCaption;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        align: string;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        vAlign: string;
        xmsAcceleratorKey: string;
    }

    class HTMLTableCell {
        private 'MSHTML.HTMLTableCell_typekey': HTMLTableCell;
        private constructor();
        abbr: string;
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        align: string;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        axis: string;
        background: string;
        readonly behaviorUrns: any;
        bgColor: any;
        blur(): void;
        borderColor: any;
        borderColorDark: any;
        borderColorLight: any;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly cellIndex: number;
        ch: string;
        readonly childNodes: any;
        readonly children: any;
        chOff: string;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        colSpan: number;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        headers: string;
        height: any;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_ch: string;
        ie9_chOff: string;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        noWrap: boolean;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        rowSpan: number;
        readonly runtimeStyle: IHTMLStyle;
        scope: string;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        vAlign: string;
        width: any;
        xmsAcceleratorKey: string;
    }

    class HTMLTableCol {
        private 'MSHTML.HTMLTableCol_typekey': HTMLTableCol;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        align: string;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        ch: string;
        readonly childNodes: any;
        readonly children: any;
        chOff: string;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_ch: string;
        ie9_chOff: string;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        span: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        vAlign: string;
        width: any;
        xmsAcceleratorKey: string;
    }

    class HTMLTableRow {
        private 'MSHTML.HTMLTableRow_typekey': HTMLTableRow;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        align: string;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        bgColor: any;
        blur(): void;
        borderColor: any;
        borderColorDark: any;
        borderColorLight: any;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly cells: IHTMLElementCollection;
        ch: string;
        readonly childNodes: any;
        readonly children: any;
        chOff: string;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;

        /** @param number [index=-1] */
        deleteCell(index?: number): void;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        height: any;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_ch: string;
        ie9_chOff: string;

        /** @param number [index=-1] */
        ie9_deleteCell(index?: number): void;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;

        /** @param number [index=-1] */
        ie9_insertCell(index?: number): any;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;

        /** @param number [index=-1] */
        insertCell(index?: number): any;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly rowIndex: number;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        readonly sectionRowIndex: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        vAlign: string;
        xmsAcceleratorKey: string;
    }

    class HTMLTableSection {
        private 'MSHTML.HTMLTableSection_typekey': HTMLTableSection;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        align: string;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        bgColor: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        ch: string;
        readonly childNodes: any;
        readonly children: any;
        chOff: string;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;

        /** @param number [index=-1] */
        deleteRow(index?: number): void;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_ch: string;
        ie9_chOff: string;

        /** @param number [index=-1] */
        ie9_deleteRow(index?: number): void;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;

        /** @param number [index=-1] */
        ie9_insertRow(index?: number): any;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;

        /** @param number [index=-1] */
        insertRow(index?: number): any;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;

        /**
         * @param number [indexFrom=-1]
         * @param number [indexTo=-1]
         */
        moveRow(indexFrom?: number, indexTo?: number): any;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly rows: IHTMLElementCollection;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        vAlign: string;
        xmsAcceleratorKey: string;
    }

    class HTMLTextAreaElement {
        private 'MSHTML.HTMLTextAreaElement_typekey': HTMLTextAreaElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        cols: number;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        createTextRange(): IHTMLTxtRange;
        readonly currentStyle: IHTMLCurrentStyle;
        dataFld: string;
        dataFormatAs: string;
        dataSrc: string;
        defaultValue: string;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        readonly form: IHTMLFormElement;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        isDefaultNamespace(pvarNamespace: any): boolean;
        readonly isDisabled: boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        readonly isMultiLine: boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        name: string;
        readonly namespaceURI: any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readOnly: boolean;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        rows: number;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        select(): void;
        selectionEnd: number;
        selectionStart: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        setSelectionRange(start: number, end: number): void;
        readonly sourceIndex: number;
        spellcheck: any;
        status: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        textContent: any;
        title: string;
        toString(): string;
        readonly type: string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        value: string;
        wrap: string;
        xmsAcceleratorKey: string;
    }

    class HTMLTextElement {
        private 'MSHTML.HTMLTextElement_typekey': HTMLTextElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLTimeRanges {
        private 'MSHTML.HTMLTimeRanges_typekey': HTMLTimeRanges;
        private constructor();
        end(index: number): number;
        endDouble(index: number): number;
        readonly length: number;
        start(index: number): number;
        startDouble(index: number): number;
    }

    class HTMLTitleElement {
        private 'MSHTML.HTMLTitleElement_typekey': HTMLTitleElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        text: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLUListElement {
        private 'MSHTML.HTMLUListElement_typekey': HTMLUListElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compact: boolean;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        type: string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLUnknownElement {
        private 'MSHTML.HTMLUnknownElement_typekey': HTMLUnknownElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        xmsAcceleratorKey: string;
    }

    class HTMLUrnCollection {
        private 'MSHTML.HTMLUrnCollection_typekey': HTMLUrnCollection;
        private constructor();
        readonly 'constructor': any;
        item(index: number): string;
        readonly length: number;
    }

    class HTMLVideoElement {
        private 'MSHTML.HTMLVideoElement_typekey': HTMLVideoElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        autobuffer: boolean;
        autoplay: boolean;
        readonly behaviorUrns: any;
        blur(): void;
        readonly buffered: IHTMLTimeRanges;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        canPlayType(type: string): string;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        controls: boolean;
        createControlRange(): any;
        readonly currentSrc: string;
        readonly currentStyle: IHTMLCurrentStyle;
        currentTime: number;
        currentTimeDouble: number;
        dataFld: string;
        dataFormatAs: string;
        dataSrc: string;
        defaultPlaybackRate: number;
        defaultPlaybackRateDouble: number;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly duration: number;
        readonly durationDouble: number;
        readonly ended: boolean;
        readonly error: IHTMLMediaError;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        height: number;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        readonly initialTime: number;
        readonly initialTimeDouble: number;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        isDefaultNamespace(pvarNamespace: any): boolean;
        readonly isDisabled: boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        readonly isMultiLine: boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        load(): void;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        loop: boolean;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msPlayToDisabled: boolean;
        msPlayToPrimary: boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        muted: boolean;
        readonly namespaceURI: any;
        readonly networkState: number;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        pause(): void;
        readonly paused: boolean;
        play(): void;
        playbackRate: number;
        playbackRateDouble: number;
        readonly played: IHTMLTimeRanges;
        poster: string;
        prefix: any;
        preload: string;
        readonly previousSibling: IHTMLDOMNode;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        readonly seekable: IHTMLTimeRanges;
        readonly seeking: boolean;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        src: string;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        textContent: any;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        readonly videoHeight: number;
        readonly videoWidth: number;
        volume: number;
        volumeDouble: number;
        width: number;
        xmsAcceleratorKey: string;
    }

    class HTMLW3CComputedStyle {
        private 'MSHTML.HTMLW3CComputedStyle_typekey': HTMLW3CComputedStyle;
        private constructor();
        accelerator: string;
        alignContent: string;
        alignItems: string;
        alignmentBaseline: string;
        alignSelf: string;
        animation: string;
        animationDelay: string;
        animationDirection: string;
        animationDuration: string;
        animationFillMode: string;
        animationIterationCount: string;
        animationName: string;
        animationPlayState: string;
        animationTimingFunction: string;
        backfaceVisibility: string;
        background: string;
        backgroundAttachment: string;
        backgroundClip: string;
        backgroundColor: any;
        backgroundImage: string;
        backgroundOrigin: string;
        backgroundPosition: string;
        backgroundPositionX: any;
        backgroundPositionY: any;
        backgroundRepeat: string;
        backgroundSize: string;
        baselineShift: any;
        behavior: string;
        border: string;
        borderBottom: string;
        borderBottomColor: any;
        borderBottomLeftRadius: string;
        borderBottomRightRadius: string;
        borderBottomStyle: string;
        borderBottomWidth: any;
        borderCollapse: string;
        borderColor: string;
        borderImage: string;
        borderImageOutset: string;
        borderImageRepeat: string;
        borderImageSlice: string;
        borderImageSource: string;
        borderImageWidth: string;
        borderLeft: string;
        borderLeftColor: any;
        borderLeftStyle: string;
        borderLeftWidth: any;
        borderRadius: string;
        borderRight: string;
        borderRightColor: any;
        borderRightStyle: string;
        borderRightWidth: any;
        borderSpacing: string;
        borderStyle: string;
        borderTop: string;
        borderTopColor: any;
        borderTopLeftRadius: string;
        borderTopRightRadius: string;
        borderTopStyle: string;
        borderTopWidth: any;
        borderWidth: string;
        bottom: any;
        boxShadow: string;
        boxSizing: string;
        breakAfter: string;
        breakBefore: string;
        breakInside: string;
        captionSide: string;
        clear: string;
        clip: string;
        readonly clipBottom: any;
        clipLeft: any;
        clipPath: string;
        clipRight: any;
        clipRule: string;
        clipTop: any;
        color: any;
        colorInterpolationFilters: string;
        columnCount: any;
        columnFill: string;
        columnGap: any;
        columnRule: string;
        columnRuleColor: any;
        columnRuleStyle: string;
        columnRuleWidth: any;
        columns: string;
        columnSpan: string;
        columnWidth: any;
        content: string;
        counterIncrement: string;
        counterReset: string;
        cssFloat: string;
        cssText: string;
        cursor: string;
        direction: string;
        display: string;
        dominantBaseline: string;
        emptyCells: string;
        enableBackground: string;
        fill: string;
        fillOpacity: any;
        fillRule: string;
        filter: string;
        flex: string;
        flexBasis: any;
        flexDirection: string;
        flexFlow: string;
        flexGrow: any;
        flexShrink: any;
        flexWrap: string;
        floodColor: any;
        floodOpacity: any;
        font: string;
        fontFamily: string;
        fontFeatureSettings: string;
        fontSize: any;
        fontSizeAdjust: any;
        fontStretch: string;
        fontStyle: string;
        fontVariant: string;
        fontWeight: string;
        getPropertyPriority(bstrPropertyName: string): string;
        getPropertyValue(bstrPropertyName: string): string;
        glyphOrientationHorizontal: any;
        glyphOrientationVertical: any;
        height: any;
        imeMode: string;
        item(index: number): string;
        justifyContent: string;
        kerning: any;
        layoutFlow: string;
        layoutGrid: string;
        layoutGridChar: any;
        layoutGridLine: any;
        layoutGridMode: string;
        layoutGridType: string;
        left: any;
        readonly length: number;
        letterSpacing: any;
        lightingColor: any;
        lineBreak: string;
        lineHeight: any;
        listStyle: string;
        listStyleImage: string;
        listStylePosition: string;
        listStyleType: string;
        margin: string;
        marginBottom: any;
        marginLeft: any;
        marginRight: any;
        marginTop: any;
        marker: string;
        markerEnd: string;
        markerMid: string;
        markerStart: string;
        mask: string;
        maxHeight: any;
        maxWidth: any;
        minHeight: any;
        minWidth: any;
        msAnimation: string;
        msAnimationDelay: string;
        msAnimationDirection: string;
        msAnimationDuration: string;
        msAnimationFillMode: string;
        msAnimationIterationCount: string;
        msAnimationName: string;
        msAnimationPlayState: string;
        msAnimationTimingFunction: string;
        msBackfaceVisibility: string;
        msBlockProgression: string;
        msContentZoomChaining: string;
        msContentZooming: string;
        msContentZoomLimit: string;
        msContentZoomLimitMax: any;
        msContentZoomLimitMin: any;
        msContentZoomSnap: string;
        msContentZoomSnapPoints: string;
        msContentZoomSnapType: string;
        msFlex: string;
        msFlexAlign: string;
        msFlexDirection: string;
        msFlexFlow: string;
        msFlexItemAlign: string;
        msFlexLinePack: string;
        msFlexNegative: any;
        msFlexOrder: any;
        msFlexPack: string;
        msFlexPositive: any;
        msFlexPreferredSize: any;
        msFlexWrap: string;
        msFlowFrom: string;
        msFlowInto: string;
        msFontFeatureSettings: string;
        msGridColumn: any;
        msGridColumnAlign: string;
        msGridColumns: string;
        msGridColumnSpan: any;
        msGridRow: any;
        msGridRowAlign: string;
        msGridRows: string;
        msGridRowSpan: any;
        msHighContrastAdjust: string;
        msHyphenateLimitChars: string;
        msHyphenateLimitLines: any;
        msHyphenateLimitZone: any;
        msHyphens: string;
        msImeAlign: string;
        msInterpolationMode: string;
        msOverflowStyle: string;
        msPerspective: any;
        msPerspectiveOrigin: string;
        msScrollChaining: string;
        msScrollLimit: string;
        msScrollLimitXMax: any;
        msScrollLimitXMin: any;
        msScrollLimitYMax: any;
        msScrollLimitYMin: any;
        msScrollRails: string;
        msScrollSnapPointsX: string;
        msScrollSnapPointsY: string;
        msScrollSnapType: string;
        msScrollSnapX: string;
        msScrollSnapY: string;
        msScrollTranslation: string;
        msTextCombineHorizontal: string;
        msTextSizeAdjust: any;
        msTouchAction: string;
        msTouchSelect: string;
        msTransform: string;
        msTransformOrigin: string;
        msTransformStyle: string;
        msTransition: string;
        msTransitionDelay: string;
        msTransitionDuration: string;
        msTransitionProperty: string;
        msTransitionTimingFunction: string;
        msUserSelect: string;
        msWrapFlow: string;
        msWrapMargin: any;
        msWrapThrough: string;
        opacity: any;
        orphans: any;
        outline: string;
        outlineColor: any;
        outlineStyle: string;
        outlineWidth: any;
        overflow: string;
        overflowX: string;
        overflowY: string;
        padding: string;
        paddingBottom: any;
        paddingLeft: any;
        paddingRight: any;
        paddingTop: any;
        pageBreakAfter: string;
        pageBreakBefore: string;
        pageBreakInside: string;
        readonly parentRule: any;
        perspective: any;
        perspectiveOrigin: string;
        pointerEvents: string;
        position: string;
        quotes: string;
        removeProperty(bstrPropertyName: string): string;
        right: any;
        rubyAlign: string;
        rubyOverhang: string;
        rubyPosition: string;
        scrollbar3dLightColor: any;
        scrollbarArrowColor: any;
        scrollbarBaseColor: any;
        scrollbarDarkShadowColor: any;
        scrollbarFaceColor: any;
        scrollbarHighlightColor: any;
        scrollbarShadowColor: any;
        scrollbarTrackColor: any;

        /** @param any [pvarPropertyPriority=''] */
        setProperty(bstrPropertyName: string, pvarPropertyValue: any, pvarPropertyPriority?: any): void;
        stopColor: any;
        stopOpacity: any;
        stroke: string;
        strokeDasharray: string;
        strokeDashoffset: any;
        strokeLinecap: string;
        strokeLinejoin: string;
        strokeMiterlimit: any;
        strokeOpacity: any;
        strokeWidth: any;
        styleFloat: string;
        tableLayout: string;
        textAlign: string;
        textAlignLast: string;
        textAnchor: string;
        textAutospace: string;
        textDecoration: string;
        textIndent: any;
        textJustify: string;
        textJustifyTrim: string;
        textKashida: any;
        textKashidaSpace: any;
        textOverflow: string;
        textShadow: string;
        textTransform: string;
        textUnderlinePosition: string;
        top: any;
        touchAction: string;
        transform: string;
        transformOrigin: string;
        transformStyle: string;
        transition: string;
        transitionDelay: string;
        transitionDuration: string;
        transitionProperty: string;
        transitionTimingFunction: string;
        unicodeBidi: string;
        verticalAlign: any;
        visibility: string;
        webkitAnimation: string;
        webkitAnimationDelay: string;
        webkitAnimationDirection: string;
        webkitAnimationDuration: string;
        webkitAnimationFillMode: string;
        webkitAnimationIterationCount: string;
        webkitAnimationName: string;
        webkitAnimationPlayState: string;
        webkitAnimationTimingFunction: string;
        webkitAppearance: string;
        webkitBackfaceVisibility: string;
        webkitBackground: string;
        webkitBackgroundAttachment: string;
        webkitBackgroundClip: string;
        webkitBackgroundColor: any;
        webkitBackgroundImage: string;
        webkitBackgroundOrigin: string;
        webkitBackgroundPosition: string;
        webkitBackgroundPositionX: any;
        webkitBackgroundPositionY: any;
        webkitBackgroundRepeat: string;
        webkitBackgroundSize: string;
        webkitBorderImage: string;
        webkitBorderImageOutset: string;
        webkitBorderImageRepeat: string;
        webkitBorderImageSlice: string;
        webkitBorderImageSource: string;
        webkitBorderImageWidth: string;
        webkitBoxAlign: string;
        webkitBoxDirection: string;
        webkitBoxFlex: any;
        webkitBoxOrdinalGroup: any;
        webkitBoxOrient: string;
        webkitBoxPack: string;
        webkitBoxSizing: string;
        webkitTextSizeAdjust: any;
        webkitTransform: string;
        webkitTransformOrigin: string;
        webkitTransition: string;
        webkitTransitionDelay: string;
        webkitTransitionDuration: string;
        webkitTransitionProperty: string;
        webkitTransitionTimingFunction: string;
        webkitUserSelect: string;
        whiteSpace: string;
        widows: any;
        width: any;
        wordBreak: string;
        wordSpacing: any;
        wordWrap: string;
        writingMode: string;
        zIndex: any;
        zoom: any;
    }

    class HTMLWindow2 {
        private 'MSHTML.HTMLWindow2_typekey': HTMLWindow2;
        private constructor();
        addEventListener(type: string, listener: any, useCapture: boolean): void;

        /** @param string [message=''] */
        alert(message?: string): void;
        readonly applicationCache: applicationCache;
        attachEvent(event: string, pdisp: any): boolean;
        blur(): void;
        clearInterval(timerID: number): void;
        clearTimeout(timerID: number): void;
        readonly clientInformation: IOmNavigator;
        readonly clipboardData: IHTMLDataTransfer;
        close(): void;
        readonly closed: boolean;

        /** @param string [message=''] */
        confirm(message?: string): boolean;
        readonly 'constructor': any;
        createPopup(varArgIn?: any): any;
        defaultStatus: string;
        detachEvent(event: string, pdisp: any): void;
        dispatchEvent(evt: IDOMEvent): boolean;
        readonly document: IHTMLDocument2;
        readonly event: IHTMLEventObj;

        /** @param string [language='JScript'] */
        execScript(code: string, language?: string): any;
        readonly external: any;
        focus(): void;
        readonly frameElement: IHTMLFrameBase;
        readonly frames: FramesCollection;

        /** @param string [bstrPseudoElt=''] */
        getComputedStyle(varArgIn: IHTMLDOMNode, bstrPseudoElt?: string): IHTMLCSSStyleDeclaration;
        getSelection(): IHTMLSelection;
        readonly history: IOmHistory;
        readonly innerHeight: number;
        readonly innerWidth: number;
        item(pvarIndex: any): any;
        readonly length: number;
        readonly localStorage: IHTMLStorage;
        readonly location: IHTMLLocation;
        readonly maxConnectionsPerServer: number;
        moveBy(x: number, y: number): void;
        moveTo(x: number, y: number): void;
        msWriteProfilerMark(bstrProfilerMarkName: string): void;
        name: string;
        navigate(url: string): void;
        readonly navigator: IOmNavigator;
        offscreenBuffering: any;
        onabort: any;
        onafterprint: any;
        onbeforeprint: any;
        onbeforeunload: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        ondblclick: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhashchange: any;
        onhelp: any;
        oninput: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onmessage: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsinertiastart: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onoffline: any;
        ononline: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onpopstate: any;
        onprogress: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onstalled: any;
        onstorage: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onunload: any;
        onvolumechange: any;
        onwaiting: any;

        /**
         * @param string [url='']
         * @param string [name='']
         * @param string [features='']
         * @param boolean [replace=false]
         */
        open(url?: string, name?: string, features?: string, replace?: boolean): IHTMLWindow2;
        opener: any;
        readonly outerHeight: number;
        readonly outerWidth: number;
        readonly pageXOffset: number;
        readonly pageYOffset: number;
        readonly parent: IHTMLWindow2;
        performance: any;
        postMessage(msg: string, targetOrigin?: any): void;
        print(): void;

        /**
         * @param string [message='']
         * @param string [defstr='undefined']
         */
        prompt(message?: string, defstr?: string): any;
        removeEventListener(type: string, listener: any, useCapture: boolean): void;
        resizeBy(x: number, y: number): void;
        resizeTo(x: number, y: number): void;
        readonly screen: IHTMLScreen;
        readonly screenLeft: number;
        readonly screenTop: number;
        readonly screenX: number;
        readonly screenY: number;
        scroll(x: number, y: number): void;
        scrollBy(x: number, y: number): void;
        scrollTo(x: number, y: number): void;
        readonly self: IHTMLWindow2;
        readonly sessionStorage: IHTMLStorage;
        setInterval(expression: any, msec: number, language?: any): number;
        setTimeout(expression: any, msec: number, language?: any): number;

        /** @param string [features=''] */
        showHelp(helpURL: string, helpArg: any, features?: string): void;
        showModalDialog(dialog: string, varArgIn?: any, varOptions?: any): any;

        /** @param string [url=''] */
        showModelessDialog(url?: string, varArgIn?: any, options?: any): IHTMLWindow2;
        status: string;
        readonly styleMedia: IHTMLStyleMedia;
        readonly top: IHTMLWindow2;
        toStaticHTML(bstrHTML: string): string;
        toString(): string;
        readonly window: IHTMLWindow2;
    }

    class HTMLWindowProxy {
        private 'MSHTML.HTMLWindowProxy_typekey': HTMLWindowProxy;
        private constructor();
        addEventListener(type: string, listener: any, useCapture: boolean): void;

        /** @param string [message=''] */
        alert(message?: string): void;
        readonly applicationCache: applicationCache;
        attachEvent(event: string, pdisp: any): boolean;
        blur(): void;
        clearInterval(timerID: number): void;
        clearTimeout(timerID: number): void;
        readonly clientInformation: IOmNavigator;
        readonly clipboardData: IHTMLDataTransfer;
        close(): void;
        readonly closed: boolean;

        /** @param string [message=''] */
        confirm(message?: string): boolean;
        readonly 'constructor': any;
        createPopup(varArgIn?: any): any;
        defaultStatus: string;
        detachEvent(event: string, pdisp: any): void;
        dispatchEvent(evt: IDOMEvent): boolean;
        readonly document: IHTMLDocument2;
        readonly event: IHTMLEventObj;

        /** @param string [language='JScript'] */
        execScript(code: string, language?: string): any;
        readonly external: any;
        focus(): void;
        readonly frameElement: IHTMLFrameBase;
        readonly frames: FramesCollection;

        /** @param string [bstrPseudoElt=''] */
        getComputedStyle(varArgIn: IHTMLDOMNode, bstrPseudoElt?: string): IHTMLCSSStyleDeclaration;
        getSelection(): IHTMLSelection;
        readonly history: IOmHistory;
        readonly innerHeight: number;
        readonly innerWidth: number;
        item(pvarIndex: any): any;
        readonly length: number;
        readonly localStorage: IHTMLStorage;
        readonly location: IHTMLLocation;
        readonly maxConnectionsPerServer: number;
        moveBy(x: number, y: number): void;
        moveTo(x: number, y: number): void;
        msWriteProfilerMark(bstrProfilerMarkName: string): void;
        name: string;
        navigate(url: string): void;
        readonly navigator: IOmNavigator;
        offscreenBuffering: any;
        onabort: any;
        onafterprint: any;
        onbeforeprint: any;
        onbeforeunload: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        ondblclick: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhashchange: any;
        onhelp: any;
        oninput: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onmessage: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsinertiastart: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onoffline: any;
        ononline: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onpopstate: any;
        onprogress: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onstalled: any;
        onstorage: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onunload: any;
        onvolumechange: any;
        onwaiting: any;

        /**
         * @param string [url='']
         * @param string [name='']
         * @param string [features='']
         * @param boolean [replace=false]
         */
        open(url?: string, name?: string, features?: string, replace?: boolean): IHTMLWindow2;
        opener: any;
        readonly outerHeight: number;
        readonly outerWidth: number;
        readonly pageXOffset: number;
        readonly pageYOffset: number;
        readonly parent: IHTMLWindow2;
        performance: any;
        postMessage(msg: string, targetOrigin?: any): void;
        print(): void;

        /**
         * @param string [message='']
         * @param string [defstr='undefined']
         */
        prompt(message?: string, defstr?: string): any;
        removeEventListener(type: string, listener: any, useCapture: boolean): void;
        resizeBy(x: number, y: number): void;
        resizeTo(x: number, y: number): void;
        readonly screen: IHTMLScreen;
        readonly screenLeft: number;
        readonly screenTop: number;
        readonly screenX: number;
        readonly screenY: number;
        scroll(x: number, y: number): void;
        scrollBy(x: number, y: number): void;
        scrollTo(x: number, y: number): void;
        readonly self: IHTMLWindow2;
        readonly sessionStorage: IHTMLStorage;
        setInterval(expression: any, msec: number, language?: any): number;
        setTimeout(expression: any, msec: number, language?: any): number;

        /** @param string [features=''] */
        showHelp(helpURL: string, helpArg: any, features?: string): void;
        showModalDialog(dialog: string, varArgIn?: any, varOptions?: any): any;

        /** @param string [url=''] */
        showModelessDialog(url?: string, varArgIn?: any, options?: any): IHTMLWindow2;
        status: string;
        readonly styleMedia: IHTMLStyleMedia;
        readonly top: IHTMLWindow2;
        toStaticHTML(bstrHTML: string): string;
        toString(): string;
        readonly window: IHTMLWindow2;
    }

    class HTMLWndOptionElement {
        private 'MSHTML.HTMLWndOptionElement_typekey': HTMLWndOptionElement;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        dataFld: string;
        dataFormatAs: string;
        dataSrc: string;
        defaultSelected: boolean;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        readonly form: IHTMLFormElement;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        index: number;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        isDefaultNamespace(pvarNamespace: any): boolean;
        readonly isDisabled: boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        readonly isMultiLine: boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly isTextEdit: boolean;
        label: string;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        readonly namespaceURI: any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        selected: boolean;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tagUrn: string;
        text: string;
        textContent: any;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        value: string;
        xmsAcceleratorKey: string;
    }

    class HTMLWndSelectElement {
        private 'MSHTML.HTMLWndSelectElement_typekey': HTMLWndSelectElement;
        private constructor();
        accessKey: string;
        add(element: IHTMLElement, before?: any): void;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        dataFld: string;
        dataFormatAs: string;
        dataSrc: string;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        readonly form: IHTMLFormElement;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        isDefaultNamespace(pvarNamespace: any): boolean;
        readonly isDisabled: boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        readonly isMultiLine: boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly isTextEdit: boolean;
        item(name?: any, index?: any): any;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        length: number;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        multiple: boolean;
        name: string;
        namedItem(name: string): any;
        readonly namespaceURI: any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        readonly options: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [index=-1] */
        remove(index?: number): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        selectedIndex: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        size: number;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tags(tagName: any): any;
        tagUrn: string;
        textContent: any;
        title: string;
        toString(): string;
        readonly type: string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        urns(urn: any): any;
        value: string;
        xmsAcceleratorKey: string;
    }

    class HTMLXMLHttpRequest {
        private 'MSHTML.HTMLXMLHttpRequest_typekey': HTMLXMLHttpRequest;
        private constructor();
        abort(): void;
        addEventListener(type: string, listener: any, useCapture: boolean): void;
        readonly 'constructor': any;
        dispatchEvent(evt: IDOMEvent): boolean;
        getAllResponseHeaders(): string;
        getResponseHeader(bstrHeader: string): string;
        onreadystatechange: any;
        ontimeout: any;
        open(bstrMethod: string, bstrURL: string, varAsync: any, varUser?: any, varPassword?: any): void;
        readonly readyState: number;
        removeEventListener(type: string, listener: any, useCapture: boolean): void;
        readonly responseBody: any;
        readonly responseText: string;
        readonly responseXML: any;
        send(varBody?: any): void;
        setRequestHeader(bstrHeader: string, bstrValue: string): void;
        readonly status: number;
        readonly statusText: string;
        timeout: number;
    }

    class HTMLXMLHttpRequestFactory {
        private 'MSHTML.HTMLXMLHttpRequestFactory_typekey': HTMLXMLHttpRequestFactory;
        private constructor();
        create(): IHTMLXMLHttpRequest;
    }

    class ICanvasGradient {
        private 'MSHTML.ICanvasGradient_typekey': ICanvasGradient;
        private constructor();
        addColorStop(offset: number, color: string): void;
    }

    class ICanvasImageData {
        private 'MSHTML.ICanvasImageData_typekey': ICanvasImageData;
        private constructor();
        readonly data: any;
        readonly height: number;
        readonly width: number;
    }

    class ICanvasPattern {
        private 'MSHTML.ICanvasPattern_typekey': ICanvasPattern;
        private constructor();
    }

    class ICanvasRenderingContext2D {
        private 'MSHTML.ICanvasRenderingContext2D_typekey': ICanvasRenderingContext2D;
        private constructor();
        arc(x: number, y: number, radius: number, startAngle: number, endAngle: number, anticlockwise: number): void;
        arcTo(x1: number, y1: number, x2: number, y2: number, radius: number): void;
        beginPath(): void;
        bezierCurveTo(cp1x: number, cp1y: number, cp2x: number, cp2y: number, x: number, y: number): void;
        readonly canvas: IHTMLCanvasElement;
        clearRect(x: number, y: number, w: number, h: number): void;
        clip(): void;
        closePath(): void;
        createImageData(a1: any, a2: any): ICanvasImageData;
        createLinearGradient(x0: number, y0: number, x1: number, y1: number): ICanvasGradient;
        createPattern(Image: any, repetition: any): ICanvasPattern;
        createRadialGradient(x0: number, y0: number, r0: number, x1: number, y1: number, r1: number): ICanvasGradient;
        drawImage(pSrc: any, a1: any, a2: any, a3: any, a4: any, a5: any, a6: any, a7: any, a8: any): void;
        fill(): void;
        fillRect(x: number, y: number, w: number, h: number): void;
        fillStyle: any;
        fillText(text: string, x: number, y: number, maxWidth: any): void;
        font: string;
        getImageData(sx: number, sy: number, sw: number, sh: number): ICanvasImageData;
        globalAlpha: number;
        globalCompositeOperation: string;
        isPointInPath(x: number, y: number): boolean;
        lineCap: string;
        lineJoin: string;
        lineTo(x: number, y: number): void;
        lineWidth: number;
        measureText(text: string): ICanvasTextMetrics;
        miterLimit: number;
        moveTo(x: number, y: number): void;
        putImageData(imagedata: ICanvasImageData, dx: number, dy: number, dirtyX: any, dirtyY: any, dirtyWidth: any, dirtyHeight: any): void;
        quadraticCurveTo(cpx: number, cpy: number, x: number, y: number): void;
        rect(x: number, y: number, w: number, h: number): void;
        restore(): void;
        rotate(angle: number): void;
        save(): void;
        scale(x: number, y: number): void;
        setTransform(m11: number, m12: number, m21: number, m22: number, dx: number, dy: number): void;
        shadowBlur: number;
        shadowColor: string;
        shadowOffsetX: number;
        shadowOffsetY: number;
        stroke(): void;
        strokeRect(x: number, y: number, w: number, h: number): void;
        strokeStyle: any;
        strokeText(text: string, x: number, y: number, maxWidth: any): void;
        textAlign: string;
        textBaseline: string;
        transform(m11: number, m12: number, m21: number, m22: number, dx: number, dy: number): void;
        translate(x: number, y: number): void;
    }

    class ICanvasTextMetrics {
        private 'MSHTML.ICanvasTextMetrics_typekey': ICanvasTextMetrics;
        private constructor();
        readonly width: number;
    }

    class IDOMDocumentType {
        private 'MSHTML.IDOMDocumentType_typekey': IDOMDocumentType;
        private constructor();
        readonly entities: any;
        readonly internalSubset: any;
        readonly name: string;
        readonly notations: any;
        readonly publicId: any;
        readonly systemId: any;
    }

    class IDOMEvent {
        private 'MSHTML.IDOMEvent_typekey': IDOMEvent;
        private constructor();
        readonly bubbles: boolean;
        readonly cancelable: boolean;
        cancelBubble: boolean;
        readonly currentTarget: IEventTarget;
        readonly defaultPrevented: boolean;
        readonly eventPhase: number;
        initEvent(eventType: string, canBubble: boolean, cancelable: boolean): void;
        readonly isTrusted: boolean;
        preventDefault(): void;
        readonly srcElement: IHTMLElement;
        stopImmediatePropagation(): void;
        stopPropagation(): void;
        readonly target: IEventTarget;
        readonly timeStamp: number;
        readonly type: string;
    }

    class IDOMNodeIterator {
        private 'MSHTML.IDOMNodeIterator_typekey': IDOMNodeIterator;
        private constructor();
        Detach(): void;
        readonly expandEntityReferences: boolean;
        readonly filter: any;
        nextNode(): any;
        previousNode(): any;
        readonly root: any;
        readonly whatToShow: number;
    }

    class IDOMParser {
        private 'MSHTML.IDOMParser_typekey': IDOMParser;
        private constructor();
        parseFromString(xmlSource: string, mimeType: string): IHTMLDocument2;
    }

    class IDOMProcessingInstruction {
        private 'MSHTML.IDOMProcessingInstruction_typekey': IDOMProcessingInstruction;
        private constructor();
        data: string;
        readonly target: string;
    }

    class IDOMTreeWalker {
        private 'MSHTML.IDOMTreeWalker_typekey': IDOMTreeWalker;
        private constructor();
        currentNode: any;
        readonly expandEntityReferences: boolean;
        readonly filter: any;
        firstChild(): any;
        lastChild(): any;
        nextNode(): any;
        nextSibling(): any;
        parentNode(): any;
        previousNode(): any;
        previousSibling(): any;
        readonly root: any;
        readonly whatToShow: number;
    }

    class IDOMXmlSerializer {
        private 'MSHTML.IDOMXmlSerializer_typekey': IDOMXmlSerializer;
        private constructor();
        serializeToString(pNode: IHTMLDOMNode): string;
    }

    class IEventTarget {
        private 'MSHTML.IEventTarget_typekey': IEventTarget;
        private constructor();
        addEventListener(type: string, listener: any, useCapture: boolean): void;
        dispatchEvent(evt: IDOMEvent): boolean;
        removeEventListener(type: string, listener: any, useCapture: boolean): void;
    }

    class IHTMLAreasCollection {
        private 'MSHTML.IHTMLAreasCollection_typekey': IHTMLAreasCollection;
        private constructor();
        add(element: IHTMLElement, before?: any): void;
        item(name?: any, index?: any): any;
        length: number;

        /** @param number [index=-1] */
        remove(index?: number): void;
        tags(tagName: any): any;
    }

    class IHTMLAttributeCollection3 {
        private 'MSHTML.IHTMLAttributeCollection3_typekey': IHTMLAttributeCollection3;
        private constructor();
        getNamedItem(bstrName: string): IHTMLDOMAttribute;
        item(index: number): IHTMLDOMAttribute;
        readonly length: number;
        removeNamedItem(bstrName: string): IHTMLDOMAttribute;
        setNamedItem(pNodeIn: IHTMLDOMAttribute): IHTMLDOMAttribute;
    }

    class IHTMLAudioElement {
        private 'MSHTML.IHTMLAudioElement_typekey': IHTMLAudioElement;
        private constructor();
    }

    class IHTMLBookmarkCollection {
        private 'MSHTML.IHTMLBookmarkCollection_typekey': IHTMLBookmarkCollection;
        private constructor();
        item(index: number): any;
        readonly length: number;
    }

    class IHTMLCanvasElement {
        private 'MSHTML.IHTMLCanvasElement_typekey': IHTMLCanvasElement;
        private constructor();
        getContext(contextId: string): ICanvasRenderingContext2D;
        height: number;
        toDataURL(type: string, jpegquality: any): string;
        width: number;
    }

    class IHTMLCSSRule {
        private 'MSHTML.IHTMLCSSRule_typekey': IHTMLCSSRule;
        private constructor();
        cssText: string;
        readonly parentRule: IHTMLCSSRule;
        readonly parentStyleSheet: IHTMLStyleSheet;
        readonly type: number;
    }

    class IHTMLCSSStyleDeclaration {
        private 'MSHTML.IHTMLCSSStyleDeclaration_typekey': IHTMLCSSStyleDeclaration;
        private constructor();
        accelerator: string;
        alignmentBaseline: string;
        background: string;
        backgroundAttachment: string;
        backgroundClip: string;
        backgroundColor: any;
        backgroundImage: string;
        backgroundOrigin: string;
        backgroundPosition: string;
        backgroundPositionX: any;
        backgroundPositionY: any;
        backgroundRepeat: string;
        backgroundSize: string;
        baselineShift: any;
        behavior: string;
        border: string;
        borderBottom: string;
        borderBottomColor: any;
        borderBottomLeftRadius: string;
        borderBottomRightRadius: string;
        borderBottomStyle: string;
        borderBottomWidth: any;
        borderCollapse: string;
        borderColor: string;
        borderLeft: string;
        borderLeftColor: any;
        borderLeftStyle: string;
        borderLeftWidth: any;
        borderRadius: string;
        borderRight: string;
        borderRightColor: any;
        borderRightStyle: string;
        borderRightWidth: any;
        borderSpacing: string;
        borderStyle: string;
        borderTop: string;
        borderTopColor: any;
        borderTopLeftRadius: string;
        borderTopRightRadius: string;
        borderTopStyle: string;
        borderTopWidth: any;
        borderWidth: string;
        bottom: any;
        boxShadow: string;
        boxSizing: string;
        captionSide: string;
        clear: string;
        clip: string;
        readonly clipBottom: any;
        clipLeft: any;
        clipPath: string;
        clipRight: any;
        clipRule: string;
        clipTop: any;
        color: any;
        content: string;
        counterIncrement: string;
        counterReset: string;
        cssFloat: string;
        cssText: string;
        cursor: string;
        direction: string;
        display: string;
        dominantBaseline: string;
        emptyCells: string;
        fill: string;
        fillOpacity: any;
        fillRule: string;
        filter: string;
        font: string;
        fontFamily: string;
        fontSize: any;
        fontSizeAdjust: any;
        fontStretch: string;
        fontStyle: string;
        fontVariant: string;
        fontWeight: string;
        getPropertyPriority(bstrPropertyName: string): string;
        getPropertyValue(bstrPropertyName: string): string;
        glyphOrientationHorizontal: any;
        glyphOrientationVertical: any;
        height: any;
        imeMode: string;
        item(index: number): string;
        kerning: any;
        layoutFlow: string;
        layoutGrid: string;
        layoutGridChar: any;
        layoutGridLine: any;
        layoutGridMode: string;
        layoutGridType: string;
        left: any;
        readonly length: number;
        letterSpacing: any;
        lineBreak: string;
        lineHeight: any;
        listStyle: string;
        listStyleImage: string;
        listStylePosition: string;
        listStyleType: string;
        margin: string;
        marginBottom: any;
        marginLeft: any;
        marginRight: any;
        marginTop: any;
        marker: string;
        markerEnd: string;
        markerMid: string;
        markerStart: string;
        mask: string;
        maxHeight: any;
        maxWidth: any;
        minHeight: any;
        minWidth: any;
        msBlockProgression: string;
        msInterpolationMode: string;
        msTransform: string;
        msTransformOrigin: string;
        opacity: any;
        orphans: any;
        outline: string;
        outlineColor: any;
        outlineStyle: string;
        outlineWidth: any;
        overflow: string;
        overflowX: string;
        overflowY: string;
        padding: string;
        paddingBottom: any;
        paddingLeft: any;
        paddingRight: any;
        paddingTop: any;
        pageBreakAfter: string;
        pageBreakBefore: string;
        pageBreakInside: string;
        readonly parentRule: any;
        pointerEvents: string;
        position: string;
        quotes: string;
        removeProperty(bstrPropertyName: string): string;
        right: any;
        rubyAlign: string;
        rubyOverhang: string;
        rubyPosition: string;
        scrollbar3dLightColor: any;
        scrollbarArrowColor: any;
        scrollbarBaseColor: any;
        scrollbarDarkShadowColor: any;
        scrollbarFaceColor: any;
        scrollbarHighlightColor: any;
        scrollbarShadowColor: any;
        scrollbarTrackColor: any;

        /** @param any [pvarPropertyPriority=''] */
        setProperty(bstrPropertyName: string, pvarPropertyValue: any, pvarPropertyPriority?: any): void;
        stopColor: any;
        stopOpacity: any;
        stroke: string;
        strokeDasharray: string;
        strokeDashoffset: any;
        strokeLinecap: string;
        strokeLinejoin: string;
        strokeMiterlimit: any;
        strokeOpacity: any;
        strokeWidth: any;
        styleFloat: string;
        tableLayout: string;
        textAlign: string;
        textAlignLast: string;
        textAnchor: string;
        textAutospace: string;
        textDecoration: string;
        textIndent: any;
        textJustify: string;
        textJustifyTrim: string;
        textKashida: any;
        textKashidaSpace: any;
        textOverflow: string;
        textTransform: string;
        textUnderlinePosition: string;
        top: any;
        unicodeBidi: string;
        verticalAlign: any;
        visibility: string;
        whiteSpace: string;
        widows: any;
        width: any;
        wordBreak: string;
        wordSpacing: any;
        wordWrap: string;
        writingMode: string;
        zIndex: any;
        zoom: any;
    }

    class IHTMLCurrentStyle {
        private 'MSHTML.IHTMLCurrentStyle_typekey': IHTMLCurrentStyle;
        private constructor();
        readonly accelerator: string;
        readonly backgroundAttachment: string;
        readonly backgroundColor: any;
        readonly backgroundImage: string;
        readonly backgroundPositionX: any;
        readonly backgroundPositionY: any;
        readonly backgroundRepeat: string;
        readonly behavior: string;
        readonly blockDirection: string;
        readonly borderBottomColor: any;
        readonly borderBottomStyle: string;
        readonly borderBottomWidth: any;
        readonly borderCollapse: string;
        readonly borderColor: string;
        readonly borderLeftColor: any;
        readonly borderLeftStyle: string;
        readonly borderLeftWidth: any;
        readonly borderRightColor: any;
        readonly borderRightStyle: string;
        readonly borderRightWidth: any;
        readonly borderStyle: string;
        readonly borderTopColor: any;
        readonly borderTopStyle: string;
        readonly borderTopWidth: any;
        readonly borderWidth: string;
        readonly bottom: any;
        readonly clear: string;
        readonly clipBottom: any;
        readonly clipLeft: any;
        readonly clipRight: any;
        readonly clipTop: any;
        readonly color: any;
        readonly cursor: string;
        readonly direction: string;
        readonly display: string;
        readonly fontFamily: string;
        readonly fontSize: any;
        readonly fontStyle: string;
        readonly fontVariant: string;
        readonly fontWeight: any;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        readonly height: any;
        readonly imeMode: string;
        readonly layoutGridChar: any;
        readonly layoutGridLine: any;
        readonly layoutGridMode: string;
        readonly layoutGridType: string;
        readonly left: any;
        readonly letterSpacing: any;
        readonly lineBreak: string;
        readonly lineHeight: any;
        readonly listStyleImage: string;
        readonly listStylePosition: string;
        readonly listStyleType: string;
        readonly margin: string;
        readonly marginBottom: any;
        readonly marginLeft: any;
        readonly marginRight: any;
        readonly marginTop: any;
        readonly overflow: string;
        readonly overflowX: string;
        readonly overflowY: string;
        readonly padding: string;
        readonly paddingBottom: any;
        readonly paddingLeft: any;
        readonly paddingRight: any;
        readonly paddingTop: any;
        readonly pageBreakAfter: string;
        readonly pageBreakBefore: string;
        readonly position: string;
        readonly right: any;
        readonly rubyAlign: string;
        readonly rubyOverhang: string;
        readonly rubyPosition: string;
        readonly styleFloat: string;
        readonly tableLayout: string;
        readonly textAlign: string;
        readonly textAutospace: string;
        readonly textDecoration: string;
        readonly textIndent: any;
        readonly textJustify: string;
        readonly textJustifyTrim: string;
        readonly textKashida: any;
        readonly textTransform: string;
        readonly top: any;
        readonly unicodeBidi: string;
        readonly verticalAlign: any;
        readonly visibility: string;
        readonly width: any;
        readonly wordBreak: string;
        readonly zIndex: any;
    }

    class IHTMLDataTransfer {
        private 'MSHTML.IHTMLDataTransfer_typekey': IHTMLDataTransfer;
        private constructor();
        clearData(format: string): boolean;
        dropEffect: string;
        effectAllowed: string;
        getData(format: string): any;
        setData(format: string, data: any): boolean;
    }

    class IHTMLDocument {
        private 'MSHTML.IHTMLDocument_typekey': IHTMLDocument;
        private constructor();
        readonly Script: any;
    }

    class IHTMLDocument2 {
        private 'MSHTML.IHTMLDocument2_typekey': IHTMLDocument2;
        private constructor();
        readonly activeElement: IHTMLElement;
        alinkColor: any;
        readonly all: IHTMLElementCollection;
        readonly anchors: IHTMLElementCollection;
        readonly applets: IHTMLElementCollection;
        bgColor: any;
        readonly body: IHTMLElement;
        charset: string;
        clear(): void;
        close(): void;
        cookie: string;
        createElement(eTag: string): IHTMLElement;

        /**
         * @param string [bstrHref='']
         * @param number [lIndex=-1]
         */
        createStyleSheet(bstrHref?: string, lIndex?: number): IHTMLStyleSheet;
        defaultCharset: string;
        designMode: string;
        domain: string;
        elementFromPoint(x: number, y: number): IHTMLElement;
        readonly embeds: IHTMLElementCollection;

        /** @param boolean [showUI=false] */
        execCommand(cmdID: string, showUI?: boolean, value?: any): boolean;
        execCommandShowHelp(cmdID: string): boolean;
        expando: boolean;
        fgColor: any;
        readonly fileCreatedDate: string;
        readonly fileModifiedDate: string;
        readonly fileSize: string;
        readonly fileUpdatedDate: string;
        readonly forms: IHTMLElementCollection;
        readonly frames: FramesCollection;
        readonly images: IHTMLElementCollection;
        readonly lastModified: string;
        linkColor: any;
        readonly links: IHTMLElementCollection;
        readonly location: IHTMLLocation;
        readonly mimeType: string;
        readonly nameProp: string;
        onafterupdate: any;
        onbeforeupdate: any;
        onclick: any;
        ondblclick: any;
        ondragstart: any;
        onerrorupdate: any;
        onhelp: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onmousedown: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onreadystatechange: any;
        onrowenter: any;
        onrowexit: any;
        onselectstart: any;

        /** @param string [url='text/html'] */
        open(url?: string, name?: any, features?: any, replace?: any): any;
        readonly parentWindow: IHTMLWindow2;
        readonly plugins: IHTMLElementCollection;
        readonly protocol: string;
        queryCommandEnabled(cmdID: string): boolean;
        queryCommandIndeterm(cmdID: string): boolean;
        queryCommandState(cmdID: string): boolean;
        queryCommandSupported(cmdID: string): boolean;
        queryCommandText(cmdID: string): string;
        queryCommandValue(cmdID: string): any;
        readonly readyState: string;
        readonly referrer: string;
        readonly Script: any;
        readonly scripts: IHTMLElementCollection;
        readonly security: string;
        readonly selection: IHTMLSelectionObject;
        readonly styleSheets: IHTMLStyleSheetsCollection;
        title: string;
        toString(): string;
        url: string;
        vlinkColor: any;
        write(...psarray: any[]): void;
        writeln(...psarray: any[]): void;
    }

    class IHTMLDocument7 {
        private 'MSHTML.IHTMLDocument7_typekey': IHTMLDocument7;
        private constructor();
        adoptNode(pNodeSource: IHTMLDOMNode): IHTMLDOMNode3;
        readonly all: IHTMLElementCollection;
        body: IHTMLElement;
        readonly characterSet: string;
        createAttribute(bstrAttrName: string): IHTMLDOMAttribute;
        createAttributeNS(pvarNS: any, bstrAttrName: string): IHTMLDOMAttribute;
        createCDATASection(text: string): IHTMLDOMNode;
        createElement(bstrTag: string): IHTMLElement;
        createElementNS(pvarNS: any, bstrTag: string): IHTMLElement;
        createProcessingInstruction(bstrTarget: string, bstrData: string): IDOMProcessingInstruction;
        readonly defaultView: IHTMLWindow2;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(pvarNS: any, bstrLocalName: string): IHTMLElementCollection;
        getSelection(): IHTMLSelection;
        hasAttributes(): boolean;
        readonly head: IHTMLElement;
        importNode(pNodeSource: IHTMLDOMNode, fDeep: boolean): IHTMLDOMNode3;
        readonly inputEncoding: string;
        normalize(): void;
        onabort: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        onchange: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onfocus: any;
        oninput: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onmssitemodejumplistitemremoved: any;
        onmsthumbnailclick: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onratechange: any;
        onreset: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        readonly parentWindow: IHTMLWindow2;
        readonly xmlEncoding: string;
        xmlStandalone: boolean;
        xmlVersion: string;
    }

    class IHTMLDocumentCompatibleInfo {
        private 'MSHTML.IHTMLDocumentCompatibleInfo_typekey': IHTMLDocumentCompatibleInfo;
        private constructor();
        readonly userAgent: string;
        readonly version: string;
    }

    class IHTMLDocumentCompatibleInfoCollection {
        private 'MSHTML.IHTMLDocumentCompatibleInfoCollection_typekey': IHTMLDocumentCompatibleInfoCollection;
        private constructor();
        item(index: number): IHTMLDocumentCompatibleInfo;
        readonly length: number;
    }

    class IHTMLDOMAttribute {
        private 'MSHTML.IHTMLDOMAttribute_typekey': IHTMLDOMAttribute;
        private constructor();
        readonly nodeName: string;
        nodeValue: any;
        readonly specified: boolean;
    }

    class IHTMLDOMAttribute2 {
        private 'MSHTML.IHTMLDOMAttribute2_typekey': IHTMLDOMAttribute2;
        private constructor();
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        readonly attributes: any;
        readonly childNodes: any;
        cloneNode(fDeep: boolean): IHTMLDOMAttribute;
        readonly expando: boolean;
        readonly firstChild: IHTMLDOMNode;
        hasChildNodes(): boolean;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly lastChild: IHTMLDOMNode;
        readonly name: string;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeType: number;
        readonly ownerDocument: any;
        readonly parentNode: IHTMLDOMNode;
        readonly previousSibling: IHTMLDOMNode;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        value: string;
    }

    class IHTMLDOMChildrenCollection {
        private 'MSHTML.IHTMLDOMChildrenCollection_typekey': IHTMLDOMChildrenCollection;
        private constructor();
        item(index: number): any;
        readonly length: number;
    }

    class IHTMLDOMImplementation {
        private 'MSHTML.IHTMLDOMImplementation_typekey': IHTMLDOMImplementation;
        private constructor();
        hasFeature(bstrfeature: string, version?: any): boolean;
    }

    class IHTMLDOMNode {
        private 'MSHTML.IHTMLDOMNode_typekey': IHTMLDOMNode;
        private constructor();
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        readonly attributes: any;
        readonly childNodes: any;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        readonly firstChild: IHTMLDOMNode;
        hasChildNodes(): boolean;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly lastChild: IHTMLDOMNode;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        readonly parentNode: IHTMLDOMNode;
        readonly previousSibling: IHTMLDOMNode;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
    }

    class IHTMLDOMNode3 {
        private 'MSHTML.IHTMLDOMNode3_typekey': IHTMLDOMNode3;
        private constructor();
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        isDefaultNamespace(pvarNamespace: any): boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly localName: any;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        readonly namespaceURI: any;
        prefix: any;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        textContent: any;
    }

    class IHTMLDOMRange {
        private 'MSHTML.IHTMLDOMRange_typekey': IHTMLDOMRange;
        private constructor();
        cloneContents(): any;
        cloneRange(): IHTMLDOMRange;
        collapse(toStart: boolean): void;
        readonly collapsed: boolean;
        readonly commonAncestorContainer: IHTMLDOMNode;
        compareBoundaryPoints(how: number, sourceRange: any): number;
        deleteContents(): void;
        Detach(): void;
        readonly endContainer: IHTMLDOMNode;
        readonly endOffset: number;
        extractContents(): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        insertNode(newNode: any): void;
        selectNode(refNode: any): void;
        selectNodeContents(refNode: any): void;
        setEnd(refNode: any, offset: number): void;
        setEndAfter(refNode: any): void;
        setEndBefore(refNode: any): void;
        setStart(refNode: any, offset: number): void;
        setStartAfter(refNode: any): void;
        setStartBefore(refNode: any): void;
        readonly startContainer: IHTMLDOMNode;
        readonly startOffset: number;
        surroundContents(newParent: any): void;
        toString(): string;
    }

    class IHTMLElement {
        private 'MSHTML.IHTMLElement_typekey': IHTMLElement;
        private constructor();
        readonly all: any;
        readonly children: any;
        className: string;
        click(): void;
        contains(pChild: IHTMLElement): boolean;
        readonly document: any;
        readonly filters: IHTMLFiltersCollection;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        id: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onafterupdate: any;
        onbeforeupdate: any;
        onclick: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondragstart: any;
        onerrorupdate: any;
        onfilterchange: any;
        onhelp: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onmousedown: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onrowenter: any;
        onrowexit: any;
        onselectstart: any;
        outerHTML: string;
        outerText: string;
        readonly parentElement: IHTMLElement;
        readonly parentTextEdit: IHTMLElement;
        readonly recordNumber: any;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        scrollIntoView(varargStart?: any): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        readonly sourceIndex: number;
        readonly style: IHTMLStyle;
        readonly tagName: string;
        title: string;
        toString(): string;
    }

    class IHTMLElement2 {
        private 'MSHTML.IHTMLElement2_typekey': IHTMLElement2;
        private constructor();
        accessKey: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        attachEvent(event: string, pdisp: any): boolean;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        clearAttributes(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        componentFromPoint(x: number, y: number): string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        doScroll(component?: any): void;
        focus(): void;
        getAdjacentText(where: string): string;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        mergeAttributes(mergeThis: IHTMLElement): void;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onblur: any;
        oncellchange: any;
        oncontextmenu: any;
        oncopy: any;
        oncut: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondrop: any;
        onfocus: any;
        onlosecapture: any;
        onpaste: any;
        onpropertychange: any;
        onreadystatechange: any;
        onresize: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        readonly readyState: any;
        releaseCapture(): void;
        removeBehavior(cookie: number): boolean;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;
        replaceAdjacentText(where: string, newText: string): string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        tabIndex: number;
        tagUrn: string;
    }

    class IHTMLElementCollection {
        private 'MSHTML.IHTMLElementCollection_typekey': IHTMLElementCollection;
        private constructor();
        item(name?: string | number, index?: number): any;
        length: number;
        tags(tagName: any): any;
        toString(): string;
    }

    class IHTMLEventObj {
        private 'MSHTML.IHTMLEventObj_typekey': IHTMLEventObj;
        private constructor();
        readonly altKey: boolean;
        readonly button: number;
        cancelBubble: boolean;
        readonly clientX: number;
        readonly clientY: number;
        readonly ctrlKey: boolean;
        readonly fromElement: IHTMLElement;
        keyCode: number;
        readonly offsetX: number;
        readonly offsetY: number;
        readonly qualifier: string;
        readonly reason: number;
        returnValue: any;
        readonly screenX: number;
        readonly screenY: number;
        readonly shiftKey: boolean;
        readonly srcElement: IHTMLElement;
        readonly srcFilter: any;
        readonly toElement: IHTMLElement;
        readonly type: string;
        readonly x: number;
        readonly y: number;
    }

    class IHTMLFiltersCollection {
        private 'MSHTML.IHTMLFiltersCollection_typekey': IHTMLFiltersCollection;
        private constructor();
        item(pvarIndex: any): any;
        readonly length: number;
    }

    class IHTMLFormElement {
        private 'MSHTML.IHTMLFormElement_typekey': IHTMLFormElement;
        private constructor();
        action: string;
        dir: string;
        readonly elements: any;
        encoding: string;
        item(name?: any, index?: any): any;
        length: number;
        method: string;
        name: string;
        onreset: any;
        onsubmit: any;
        reset(): void;
        submit(): void;
        tags(tagName: any): any;
        target: string;
    }

    class IHTMLFrameBase {
        private 'MSHTML.IHTMLFrameBase_typekey': IHTMLFrameBase;
        private constructor();
        border: any;
        frameBorder: string;
        frameSpacing: any;
        marginHeight: any;
        marginWidth: any;
        name: string;
        noResize: boolean;
        scrolling: string;
        src: string;
    }

    class IHTMLImgElement {
        private 'MSHTML.IHTMLImgElement_typekey': IHTMLImgElement;
        private constructor();
        align: string;
        alt: string;
        border: any;
        readonly complete: boolean;
        dynsrc: string;
        readonly fileCreatedDate: string;
        readonly fileModifiedDate: string;
        readonly fileSize: string;
        readonly fileUpdatedDate: string;
        height: number;
        readonly href: string;
        hspace: number;
        isMap: boolean;
        loop: any;
        lowsrc: string;
        readonly mimeType: string;
        name: string;
        readonly nameProp: string;
        onabort: any;
        onerror: any;
        onload: any;
        readonly protocol: string;
        readonly readyState: string;
        src: string;
        start: string;
        useMap: string;
        vrml: string;
        vspace: number;
        width: number;
    }

    class IHTMLLocation {
        private 'MSHTML.IHTMLLocation_typekey': IHTMLLocation;
        private constructor();
        assign(bstr: string): void;
        hash: string;
        host: string;
        hostname: string;
        href: string;
        pathname: string;
        port: string;
        protocol: string;

        /** @param boolean [flag=false] */
        reload(flag?: boolean): void;
        replace(bstr: string): void;
        search: string;
        toString(): string;
    }

    class IHTMLMediaError {
        private 'MSHTML.IHTMLMediaError_typekey': IHTMLMediaError;
        private constructor();
        readonly code: number;
    }

    class IHTMLMSCSSKeyframeRule {
        private 'MSHTML.IHTMLMSCSSKeyframeRule_typekey': IHTMLMSCSSKeyframeRule;
        private constructor();
        keyText: string;
        readonly style: IHTMLRuleStyle;
    }

    class IHTMLOptionElement {
        private 'MSHTML.IHTMLOptionElement_typekey': IHTMLOptionElement;
        private constructor();
        defaultSelected: boolean;
        readonly form: IHTMLFormElement;
        index: number;
        selected: boolean;
        text: string;
        value: string;
    }

    class IHTMLPerformanceNavigation {
        private 'MSHTML.IHTMLPerformanceNavigation_typekey': IHTMLPerformanceNavigation;
        private constructor();
        readonly redirectCount: number;
        toJSON(): any;
        toString(): string;
        readonly type: number;
    }

    class IHTMLPerformanceTiming {
        private 'MSHTML.IHTMLPerformanceTiming_typekey': IHTMLPerformanceTiming;
        private constructor();
        readonly connectEnd: number;
        readonly connectStart: number;
        readonly domainLookupEnd: number;
        readonly domainLookupStart: number;
        readonly domComplete: number;
        readonly domContentLoadedEventEnd: number;
        readonly domContentLoadedEventStart: number;
        readonly domInteractive: number;
        readonly domLoading: number;
        readonly fetchStart: number;
        readonly loadEventEnd: number;
        readonly loadEventStart: number;
        readonly msFirstPaint: number;
        readonly navigationStart: number;
        readonly redirectEnd: number;
        readonly redirectStart: number;
        readonly requestStart: number;
        readonly responseEnd: number;
        readonly responseStart: number;
        toJSON(): any;
        toString(): string;
        readonly unloadEventEnd: number;
        readonly unloadEventStart: number;
    }

    class IHTMLPluginsCollection {
        private 'MSHTML.IHTMLPluginsCollection_typekey': IHTMLPluginsCollection;
        private constructor();
        readonly length: number;

        /** @param boolean [reload=false] */
        refresh(reload?: boolean): void;
    }

    class IHTMLRect {
        private 'MSHTML.IHTMLRect_typekey': IHTMLRect;
        private constructor();
        bottom: number;
        left: number;
        right: number;
        top: number;
    }

    class IHTMLRectCollection {
        private 'MSHTML.IHTMLRectCollection_typekey': IHTMLRectCollection;
        private constructor();
        item(pvarIndex: any): any;
        readonly length: number;
    }

    class IHTMLRenderStyle {
        private 'MSHTML.IHTMLRenderStyle_typekey': IHTMLRenderStyle;
        private constructor();
        defaultTextSelection: string;
        renderingPriority: number;
        textBackgroundColor: any;
        textColor: any;
        textDecoration: string;
        textDecorationColor: any;
        textEffect: string;
        textLineThroughStyle: string;
        textUnderlineStyle: string;
    }

    class IHTMLRuleStyle {
        private 'MSHTML.IHTMLRuleStyle_typekey': IHTMLRuleStyle;
        private constructor();
        background: string;
        backgroundAttachment: string;
        backgroundColor: any;
        backgroundImage: string;
        backgroundPosition: string;
        backgroundPositionX: any;
        backgroundPositionY: any;
        backgroundRepeat: string;
        border: string;
        borderBottom: string;
        borderBottomColor: any;
        borderBottomStyle: string;
        borderBottomWidth: any;
        borderColor: string;
        borderLeft: string;
        borderLeftColor: any;
        borderLeftStyle: string;
        borderLeftWidth: any;
        borderRight: string;
        borderRightColor: any;
        borderRightStyle: string;
        borderRightWidth: any;
        borderStyle: string;
        borderTop: string;
        borderTopColor: any;
        borderTopStyle: string;
        borderTopWidth: any;
        borderWidth: string;
        clear: string;
        clip: string;
        color: any;
        cssText: string;
        cursor: string;
        display: string;
        filter: string;
        font: string;
        fontFamily: string;
        fontSize: any;
        fontStyle: string;
        fontVariant: string;
        fontWeight: string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        height: any;
        left: any;
        letterSpacing: any;
        lineHeight: any;
        listStyle: string;
        listStyleImage: string;
        listStylePosition: string;
        listStyleType: string;
        margin: string;
        marginBottom: any;
        marginLeft: any;
        marginRight: any;
        marginTop: any;
        overflow: string;
        padding: string;
        paddingBottom: any;
        paddingLeft: any;
        paddingRight: any;
        paddingTop: any;
        pageBreakAfter: string;
        pageBreakBefore: string;
        readonly position: string;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        styleFloat: string;
        textAlign: string;
        textDecoration: string;
        textDecorationBlink: boolean;
        textDecorationLineThrough: boolean;
        textDecorationNone: boolean;
        textDecorationOverline: boolean;
        textDecorationUnderline: boolean;
        textIndent: any;
        textTransform: string;
        top: any;
        verticalAlign: any;
        visibility: string;
        whiteSpace: string;
        width: any;
        wordSpacing: any;
        zIndex: any;
    }

    class IHTMLScreen {
        private 'MSHTML.IHTMLScreen_typekey': IHTMLScreen;
        private constructor();
        readonly availHeight: number;
        readonly availWidth: number;
        bufferDepth: number;
        readonly colorDepth: number;
        readonly fontSmoothingEnabled: boolean;
        readonly height: number;
        updateInterval: number;
        readonly width: number;
    }

    class IHTMLSelection {
        private 'MSHTML.IHTMLSelection_typekey': IHTMLSelection;
        private constructor();
        addRange(range: any): void;
        readonly anchorNode: IHTMLDOMNode;
        readonly anchorOffset: number;
        collapse(parentNode: any, offfset: number): void;
        collapseToEnd(): void;
        collapseToStart(): void;
        deleteFromDocument(): void;
        readonly focusNode: IHTMLDOMNode;
        readonly focusOffset: number;
        getRangeAt(index: number): IHTMLDOMRange;
        readonly isCollapsed: boolean;
        readonly rangeCount: number;
        removeAllRanges(): void;
        removeRange(range: any): void;
        selectAllChildren(parentNode: any): void;
        toString(): string;
    }

    class IHTMLSelectionObject {
        private 'MSHTML.IHTMLSelectionObject_typekey': IHTMLSelectionObject;
        private constructor();
        clear(): void;
        createRange(): any;
        empty(): void;
        readonly type: string;
    }

    class IHTMLStorage {
        private 'MSHTML.IHTMLStorage_typekey': IHTMLStorage;
        private constructor();
        clear(): void;
        getItem(bstrKey: string): any;
        key(lIndex: number): string;
        readonly length: number;
        readonly remainingSpace: number;
        removeItem(bstrKey: string): void;
        setItem(bstrKey: string, bstrValue: string): void;
    }

    class IHTMLStyle {
        private 'MSHTML.IHTMLStyle_typekey': IHTMLStyle;
        private constructor();
        background: string;
        backgroundAttachment: string;
        backgroundColor: any;
        backgroundImage: string;
        backgroundPosition: string;
        backgroundPositionX: any;
        backgroundPositionY: any;
        backgroundRepeat: string;
        border: string;
        borderBottom: string;
        borderBottomColor: any;
        borderBottomStyle: string;
        borderBottomWidth: any;
        borderColor: string;
        borderLeft: string;
        borderLeftColor: any;
        borderLeftStyle: string;
        borderLeftWidth: any;
        borderRight: string;
        borderRightColor: any;
        borderRightStyle: string;
        borderRightWidth: any;
        borderStyle: string;
        borderTop: string;
        borderTopColor: any;
        borderTopStyle: string;
        borderTopWidth: any;
        borderWidth: string;
        clear: string;
        clip: string;
        color: any;
        cssText: string;
        cursor: string;
        display: string;
        filter: string;
        font: string;
        fontFamily: string;
        fontSize: any;
        fontStyle: string;
        fontVariant: string;
        fontWeight: string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        height: any;
        left: any;
        letterSpacing: any;
        lineHeight: any;
        listStyle: string;
        listStyleImage: string;
        listStylePosition: string;
        listStyleType: string;
        margin: string;
        marginBottom: any;
        marginLeft: any;
        marginRight: any;
        marginTop: any;
        overflow: string;
        padding: string;
        paddingBottom: any;
        paddingLeft: any;
        paddingRight: any;
        paddingTop: any;
        pageBreakAfter: string;
        pageBreakBefore: string;
        pixelHeight: number;
        pixelLeft: number;
        pixelTop: number;
        pixelWidth: number;
        posHeight: number;
        readonly position: string;
        posLeft: number;
        posTop: number;
        posWidth: number;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        styleFloat: string;
        textAlign: string;
        textDecoration: string;
        textDecorationBlink: boolean;
        textDecorationLineThrough: boolean;
        textDecorationNone: boolean;
        textDecorationOverline: boolean;
        textDecorationUnderline: boolean;
        textIndent: any;
        textTransform: string;
        top: any;
        toString(): string;
        verticalAlign: any;
        visibility: string;
        whiteSpace: string;
        width: any;
        wordSpacing: any;
        zIndex: any;
    }

    class IHTMLStyleMedia {
        private 'MSHTML.IHTMLStyleMedia_typekey': IHTMLStyleMedia;
        private constructor();
        matchMedium(mediaQuery: string): boolean;
        readonly type: string;
    }

    class IHTMLStyleSheet {
        private 'MSHTML.IHTMLStyleSheet_typekey': IHTMLStyleSheet;
        private constructor();

        /** @param number [lIndex=-1] */
        addImport(bstrURL: string, lIndex?: number): number;

        /** @param number [lIndex=-1] */
        addRule(bstrSelector: string, bstrStyle: string, lIndex?: number): number;
        cssText: string;
        disabled: boolean;
        href: string;
        readonly id: string;
        readonly imports: IHTMLStyleSheetsCollection;
        media: string;
        readonly owningElement: IHTMLElement;
        readonly parentStyleSheet: IHTMLStyleSheet;
        readonly readOnly: boolean;
        removeImport(lIndex: number): void;
        removeRule(lIndex: number): void;
        readonly rules: IHTMLStyleSheetRulesCollection;
        title: string;
        readonly type: string;
    }

    class IHTMLStyleSheetPage {
        private 'MSHTML.IHTMLStyleSheetPage_typekey': IHTMLStyleSheetPage;
        private constructor();
        readonly pseudoClass: string;
        readonly selector: string;
    }

    class IHTMLStyleSheetPagesCollection {
        private 'MSHTML.IHTMLStyleSheetPagesCollection_typekey': IHTMLStyleSheetPagesCollection;
        private constructor();
        item(index: number): IHTMLStyleSheetPage;
        readonly length: number;
    }

    class IHTMLStyleSheetRule {
        private 'MSHTML.IHTMLStyleSheetRule_typekey': IHTMLStyleSheetRule;
        private constructor();
        readonly readOnly: boolean;
        selectorText: string;
        readonly style: IHTMLRuleStyle;
    }

    class IHTMLStyleSheetRulesAppliedCollection {
        private 'MSHTML.IHTMLStyleSheetRulesAppliedCollection_typekey': IHTMLStyleSheetRulesAppliedCollection;
        private constructor();
        item(index: number): IHTMLStyleSheetRule;
        readonly length: number;
        propertyAppliedBy(name: string): IHTMLStyleSheetRule;
        propertyAppliedTrace(name: string, index: number): IHTMLStyleSheetRule;
        propertyAppliedTraceLength(name: string): number;
    }

    class IHTMLStyleSheetRulesCollection {
        private 'MSHTML.IHTMLStyleSheetRulesCollection_typekey': IHTMLStyleSheetRulesCollection;
        private constructor();
        item(index: number): IHTMLStyleSheetRule;
        readonly length: number;
    }

    class IHTMLStyleSheetsCollection {
        private 'MSHTML.IHTMLStyleSheetsCollection_typekey': IHTMLStyleSheetsCollection;
        private constructor();
        item(pvarIndex: any): any;
        readonly length: number;
    }

    class IHTMLTableCaption {
        private 'MSHTML.IHTMLTableCaption_typekey': IHTMLTableCaption;
        private constructor();
        align: string;
        vAlign: string;
    }

    class IHTMLTableSection {
        private 'MSHTML.IHTMLTableSection_typekey': IHTMLTableSection;
        private constructor();
        align: string;
        bgColor: any;

        /** @param number [index=-1] */
        deleteRow(index?: number): void;

        /** @param number [index=-1] */
        insertRow(index?: number): any;
        readonly rows: IHTMLElementCollection;
        vAlign: string;
    }

    class IHTMLTimeRanges {
        private 'MSHTML.IHTMLTimeRanges_typekey': IHTMLTimeRanges;
        private constructor();
        end(index: number): number;
        readonly length: number;
        start(index: number): number;
    }

    class IHTMLTxtRange {
        private 'MSHTML.IHTMLTxtRange_typekey': IHTMLTxtRange;
        private constructor();

        /** @param boolean [start=true] */
        collapse(start?: boolean): void;
        compareEndPoints(how: string, sourceRange: IHTMLTxtRange): number;
        duplicate(): IHTMLTxtRange;

        /** @param boolean [showUI=false] */
        execCommand(cmdID: string, showUI?: boolean, value?: any): boolean;
        execCommandShowHelp(cmdID: string): boolean;
        expand(Unit: string): boolean;

        /**
         * @param number [Count=1073741823]
         * @param number [flags=0]
         */
        findText(String: string, Count?: number, flags?: number): boolean;
        getBookmark(): string;
        readonly htmlText: string;
        inRange(range: IHTMLTxtRange): boolean;
        isEqual(range: IHTMLTxtRange): boolean;

        /** @param number [Count=1] */
        move(Unit: string, Count?: number): number;

        /** @param number [Count=1] */
        moveEnd(Unit: string, Count?: number): number;

        /** @param number [Count=1] */
        moveStart(Unit: string, Count?: number): number;
        moveToBookmark(Bookmark: string): boolean;
        moveToElementText(element: IHTMLElement): void;
        moveToPoint(x: number, y: number): void;
        parentElement(): IHTMLElement;
        pasteHTML(html: string): void;
        queryCommandEnabled(cmdID: string): boolean;
        queryCommandIndeterm(cmdID: string): boolean;
        queryCommandState(cmdID: string): boolean;
        queryCommandSupported(cmdID: string): boolean;
        queryCommandText(cmdID: string): string;
        queryCommandValue(cmdID: string): any;

        /** @param boolean [fStart=true] */
        scrollIntoView(fStart?: boolean): void;
        select(): void;
        setEndPoint(how: string, sourceRange: IHTMLTxtRange): void;
        text: string;
    }

    class IHTMLWindow2 {
        private 'MSHTML.IHTMLWindow2_typekey': IHTMLWindow2;
        private constructor();

        /** @param string [message=''] */
        alert(message?: string): void;
        blur(): void;
        clearInterval(timerID: number): void;
        clearTimeout(timerID: number): void;
        readonly clientInformation: IOmNavigator;
        close(): void;
        readonly closed: boolean;

        /** @param string [message=''] */
        confirm(message?: string): boolean;
        defaultStatus: string;
        readonly document: IHTMLDocument2;
        readonly event: IHTMLEventObj;

        /** @param string [language='JScript'] */
        execScript(code: string, language?: string): any;
        readonly external: any;
        focus(): void;
        readonly frames: FramesCollection;
        readonly history: IOmHistory;
        readonly Image: HTMLImageElementFactory;
        item(pvarIndex: any): any;
        readonly length: number;
        readonly location: IHTMLLocation;
        moveBy(x: number, y: number): void;
        moveTo(x: number, y: number): void;
        name: string;
        navigate(url: string): void;
        readonly navigator: IOmNavigator;
        offscreenBuffering: any;
        onbeforeunload: any;
        onblur: any;
        onerror: any;
        onfocus: any;
        onhelp: any;
        onload: any;
        onresize: any;
        onscroll: any;
        onunload: any;

        /**
         * @param string [url='']
         * @param string [name='']
         * @param string [features='']
         * @param boolean [replace=false]
         */
        open(url?: string, name?: string, features?: string, replace?: boolean): IHTMLWindow2;
        opener: any;
        readonly Option: HTMLOptionElementFactory;
        readonly parent: IHTMLWindow2;

        /**
         * @param string [message='']
         * @param string [defstr='undefined']
         */
        prompt(message?: string, defstr?: string): any;
        resizeBy(x: number, y: number): void;
        resizeTo(x: number, y: number): void;
        readonly screen: IHTMLScreen;
        scroll(x: number, y: number): void;
        scrollBy(x: number, y: number): void;
        scrollTo(x: number, y: number): void;
        readonly self: IHTMLWindow2;
        setInterval(expression: string, msec: number, language?: any): number;
        setTimeout(expression: string, msec: number, language?: any): number;

        /** @param string [features=''] */
        showHelp(helpURL: string, helpArg: any, features?: string): void;
        showModalDialog(dialog: string, varArgIn?: any, varOptions?: any): any;
        status: string;
        readonly top: IHTMLWindow2;
        toString(): string;
        readonly window: IHTMLWindow2;
    }

    class IHTMLXDomainRequest {
        private 'MSHTML.IHTMLXDomainRequest_typekey': IHTMLXDomainRequest;
        private constructor();
        abort(): void;
        readonly contentType: string;
        onerror: any;
        onload: any;
        onprogress: any;
        ontimeout: any;
        open(bstrMethod: string, bstrURL: string): void;
        readonly responseText: string;
        send(varBody?: any): void;
        timeout: number;
    }

    class IHTMLXMLHttpRequest {
        private 'MSHTML.IHTMLXMLHttpRequest_typekey': IHTMLXMLHttpRequest;
        private constructor();
        abort(): void;
        getAllResponseHeaders(): string;
        getResponseHeader(bstrHeader: string): string;
        onreadystatechange: any;
        open(bstrMethod: string, bstrURL: string, varAsync: any, varUser?: any, varPassword?: any): void;
        readonly readyState: number;
        readonly responseBody: any;
        readonly responseText: string;
        readonly responseXML: any;
        send(varBody?: any): void;
        setRequestHeader(bstrHeader: string, bstrValue: string): void;
        readonly status: number;
        readonly statusText: string;
    }

    class IOmHistory {
        private 'MSHTML.IOmHistory_typekey': IOmHistory;
        private constructor();
        back(pvargdistance?: any): void;
        forward(pvargdistance?: any): void;
        go(pvargdistance?: any): void;
        readonly length: number;
    }

    class IOmNavigator {
        private 'MSHTML.IOmNavigator_typekey': IOmNavigator;
        private constructor();
        readonly appCodeName: string;
        readonly appMinorVersion: string;
        readonly appName: string;
        readonly appVersion: string;
        readonly browserLanguage: string;
        readonly connectionSpeed: number;
        readonly cookieEnabled: boolean;
        readonly cpuClass: string;
        javaEnabled(): boolean;
        readonly mimeTypes: CMimeTypes;
        readonly onLine: boolean;
        readonly opsProfile: COpsProfile;
        readonly platform: string;
        readonly plugins: IHTMLPluginsCollection;
        readonly systemLanguage: string;
        taintEnabled(): boolean;
        toString(): string;
        readonly userAgent: string;
        readonly userLanguage: string;
        readonly userProfile: COpsProfile;
    }

    class IRulesApplied {
        private 'MSHTML.IRulesApplied_typekey': IRulesApplied;
        private constructor();
        readonly appliedRules: IHTMLStyleSheetRulesAppliedCollection;
        readonly element: IHTMLElement;
        hasInheritableProperty(): boolean;
        readonly inlineStyles: IHTMLStyle;
        propertyIsInheritable(name: string): boolean;
        propertyIsInline(name: string): boolean;
    }

    class ISVGElement {
        private 'MSHTML.ISVGElement_typekey': ISVGElement;
        private constructor();
        focusable: SVGAnimatedEnumeration;
        ownerSVGElement: ISVGSVGElement;
        viewportElement: ISVGElement;
        xmlbase: string;
    }

    class ISVGElementInstance {
        private 'MSHTML.ISVGElementInstance_typekey': ISVGElementInstance;
        private constructor();
        readonly childNodes: ISVGElementInstanceList;
        readonly correspondingElement: ISVGElement;
        readonly correspondingUseElement: ISVGUseElement;
        readonly firstChild: ISVGElementInstance;
        readonly lastChild: ISVGElementInstance;
        readonly nextSibling: ISVGElementInstance;
        readonly parentNode: ISVGElementInstance;
        readonly previousSibling: ISVGElementInstance;
    }

    class ISVGElementInstanceList {
        private 'MSHTML.ISVGElementInstanceList_typekey': ISVGElementInstanceList;
        private constructor();
        item(index: number): ISVGElementInstance;
        readonly length: number;
    }

    class ISVGPathSegArcAbs {
        private 'MSHTML.ISVGPathSegArcAbs_typekey': ISVGPathSegArcAbs;
        private constructor();
        angle: number;
        largeArcFlag: boolean;
        r1: number;
        r2: number;
        sweepFlag: boolean;
        x: number;
        y: number;
    }

    class ISVGPathSegArcRel {
        private 'MSHTML.ISVGPathSegArcRel_typekey': ISVGPathSegArcRel;
        private constructor();
        angle: number;
        largeArcFlag: boolean;
        r1: number;
        r2: number;
        sweepFlag: boolean;
        x: number;
        y: number;
    }

    class ISVGPathSegClosePath {
        private 'MSHTML.ISVGPathSegClosePath_typekey': ISVGPathSegClosePath;
        private constructor();
    }

    class ISVGPathSegCurvetoCubicAbs {
        private 'MSHTML.ISVGPathSegCurvetoCubicAbs_typekey': ISVGPathSegCurvetoCubicAbs;
        private constructor();
        x: number;
        x1: number;
        x2: number;
        y: number;
        y1: number;
        y2: number;
    }

    class ISVGPathSegCurvetoCubicRel {
        private 'MSHTML.ISVGPathSegCurvetoCubicRel_typekey': ISVGPathSegCurvetoCubicRel;
        private constructor();
        x: number;
        x1: number;
        x2: number;
        y: number;
        y1: number;
        y2: number;
    }

    class ISVGPathSegCurvetoCubicSmoothAbs {
        private 'MSHTML.ISVGPathSegCurvetoCubicSmoothAbs_typekey': ISVGPathSegCurvetoCubicSmoothAbs;
        private constructor();
        x: number;
        x2: number;
        y: number;
        y2: number;
    }

    class ISVGPathSegCurvetoCubicSmoothRel {
        private 'MSHTML.ISVGPathSegCurvetoCubicSmoothRel_typekey': ISVGPathSegCurvetoCubicSmoothRel;
        private constructor();
        x: number;
        x2: number;
        y: number;
        y2: number;
    }

    class ISVGPathSegCurvetoQuadraticAbs {
        private 'MSHTML.ISVGPathSegCurvetoQuadraticAbs_typekey': ISVGPathSegCurvetoQuadraticAbs;
        private constructor();
        x: number;
        x1: number;
        y: number;
        y1: number;
    }

    class ISVGPathSegCurvetoQuadraticRel {
        private 'MSHTML.ISVGPathSegCurvetoQuadraticRel_typekey': ISVGPathSegCurvetoQuadraticRel;
        private constructor();
        x: number;
        x1: number;
        y: number;
        y1: number;
    }

    class ISVGPathSegCurvetoQuadraticSmoothAbs {
        private 'MSHTML.ISVGPathSegCurvetoQuadraticSmoothAbs_typekey': ISVGPathSegCurvetoQuadraticSmoothAbs;
        private constructor();
        x: number;
        y: number;
    }

    class ISVGPathSegCurvetoQuadraticSmoothRel {
        private 'MSHTML.ISVGPathSegCurvetoQuadraticSmoothRel_typekey': ISVGPathSegCurvetoQuadraticSmoothRel;
        private constructor();
        x: number;
        y: number;
    }

    class ISVGPathSegLinetoAbs {
        private 'MSHTML.ISVGPathSegLinetoAbs_typekey': ISVGPathSegLinetoAbs;
        private constructor();
        x: number;
        y: number;
    }

    class ISVGPathSegLinetoHorizontalAbs {
        private 'MSHTML.ISVGPathSegLinetoHorizontalAbs_typekey': ISVGPathSegLinetoHorizontalAbs;
        private constructor();
        x: number;
    }

    class ISVGPathSegLinetoHorizontalRel {
        private 'MSHTML.ISVGPathSegLinetoHorizontalRel_typekey': ISVGPathSegLinetoHorizontalRel;
        private constructor();
        x: number;
    }

    class ISVGPathSegLinetoRel {
        private 'MSHTML.ISVGPathSegLinetoRel_typekey': ISVGPathSegLinetoRel;
        private constructor();
        x: number;
        y: number;
    }

    class ISVGPathSegLinetoVerticalAbs {
        private 'MSHTML.ISVGPathSegLinetoVerticalAbs_typekey': ISVGPathSegLinetoVerticalAbs;
        private constructor();
        y: number;
    }

    class ISVGPathSegLinetoVerticalRel {
        private 'MSHTML.ISVGPathSegLinetoVerticalRel_typekey': ISVGPathSegLinetoVerticalRel;
        private constructor();
        y: number;
    }

    class ISVGPathSegMovetoAbs {
        private 'MSHTML.ISVGPathSegMovetoAbs_typekey': ISVGPathSegMovetoAbs;
        private constructor();
        x: number;
        y: number;
    }

    class ISVGPathSegMovetoRel {
        private 'MSHTML.ISVGPathSegMovetoRel_typekey': ISVGPathSegMovetoRel;
        private constructor();
        x: number;
        y: number;
    }

    class ISVGSVGElement {
        private 'MSHTML.ISVGSVGElement_typekey': ISVGSVGElement;
        private constructor();
        animationsPaused(): boolean;
        checkEnclosure(element: ISVGElement, rect: SVGRect): boolean;
        checkIntersection(element: ISVGElement, rect: SVGRect): boolean;
        contentScriptType: string;
        contentStyleType: string;
        createSVGAngle(): SVGAngle;
        createSVGLength(): SVGLength;
        createSVGMatrix(): SVGMatrix;
        createSVGNumber(): SVGNumber;
        createSVGPoint(): SVGPoint;
        createSVGRect(): SVGRect;
        createSVGTransform(): SVGTransform;
        createSVGTransformFromMatrix(matrix: SVGMatrix): SVGTransform;
        currentScale: number;
        currentTranslate: SVGPoint;
        currentView: ISVGViewSpec;
        deselectAll(): void;
        forceRedraw(): void;
        getCurrentTime(): number;
        getElementById(elementId: string): IHTMLElement;
        getEnclosureList(rect: SVGRect, referenceElement: ISVGElement): any;
        getIntersectionList(rect: SVGRect, referenceElement: ISVGElement): any;
        height: SVGAnimatedLength;
        pauseAnimations(): void;
        pixelUnitToMillimeterX: number;
        pixelUnitToMillimeterY: number;
        screenPixelToMillimeterX: number;
        screenPixelToMillimeterY: number;
        setCurrentTime(seconds: number): void;
        suspendRedraw(maxWaitMilliseconds: number): number;
        unpauseAnimations(): void;
        unsuspendRedraw(suspendHandeID: number): void;
        unsuspendRedrawAll(): void;
        useCurrentView: boolean;
        viewport: SVGRect;
        width: SVGAnimatedLength;
        x: SVGAnimatedLength;
        y: SVGAnimatedLength;
    }

    class ISVGUseElement {
        private 'MSHTML.ISVGUseElement_typekey': ISVGUseElement;
        private constructor();
        animatedInstanceRoot: ISVGElementInstance;
        height: SVGAnimatedLength;
        instanceRoot: ISVGElementInstance;
        width: SVGAnimatedLength;
        x: SVGAnimatedLength;
        y: SVGAnimatedLength;
    }

    class ISVGViewSpec {
        private 'MSHTML.ISVGViewSpec_typekey': ISVGViewSpec;
        private constructor();
    }

    class IWebGeocoordinates {
        private 'MSHTML.IWebGeocoordinates_typekey': IWebGeocoordinates;
        private constructor();
        readonly accuracy: number;
        readonly altitude: any;
        readonly altitudeAccuracy: any;
        readonly heading: any;
        readonly latitude: number;
        readonly longitude: number;
        readonly speed: any;
    }

    class IWebGeolocation {
        private 'MSHTML.IWebGeolocation_typekey': IWebGeolocation;
        private constructor();
        clearWatch(watchId: number): void;
        getCurrentPosition(successCallback: any, errorCallback?: any, options?: any): void;
        watchPosition(successCallback: any, errorCallback?: any, options?: any): number;
    }

    class NodeIterator {
        private 'MSHTML.NodeIterator_typekey': NodeIterator;
        private constructor();
        Detach(): void;
        readonly expandEntityReferences: boolean;
        readonly filter: any;
        nextNode(): any;
        previousNode(): any;
        readonly root: any;
        readonly whatToShow: number;
    }

    class OldHTMLDocument {
        private 'MSHTML.OldHTMLDocument_typekey': OldHTMLDocument;
        private constructor();
        readonly activeElement: IHTMLElement;
        addEventListener(type: string, listener: any, useCapture: boolean): void;
        adoptNode(pNodeSource: IHTMLDOMNode): IHTMLDOMNode3;
        alinkColor: any;
        readonly all: IHTMLElementCollection;
        readonly anchors: IHTMLElementCollection;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        readonly applets: IHTMLElementCollection;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        bgColor: any;
        readonly body: IHTMLElement;
        readonly characterSet: string;
        charset: string;
        readonly childNodes: any;
        clear(): void;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        close(): void;
        compareDocumentPosition(otherNode: IHTMLDOMNode): number;
        readonly compatible: IHTMLDocumentCompatibleInfoCollection;
        readonly compatMode: string;
        readonly 'constructor': any;
        cookie: string;
        createAttribute(bstrAttrName: string): IHTMLDOMAttribute;
        createAttributeNS(pvarNS: any, bstrAttrName: string): IHTMLDOMAttribute;
        createCDATASection(text: string): IHTMLDOMNode;
        createComment(bstrData: string): IHTMLDOMNode;
        createDocumentFragment(): IHTMLDocument2;
        createDocumentFromUrl(bstrURL: string, bstrOptions: string): IHTMLDocument2;
        createElement(eTag: string): IHTMLElement;
        createElementNS(pvarNS: any, bstrTag: string): IHTMLElement;
        createEvent(eventType: string): IDOMEvent;
        CreateEventObject(pvarEventObject?: any): IHTMLEventObj;
        createNodeIterator(pRootNode: any, ulWhatToShow: number, pFilter: any, fEntityReferenceExpansion: boolean): IDOMNodeIterator;
        createProcessingInstruction(bstrTarget: string, bstrData: string): IDOMProcessingInstruction;
        createRange(): IHTMLDOMRange;
        createRenderStyle(v: string): IHTMLRenderStyle;

        /**
         * @param string [bstrHref='']
         * @param number [lIndex=-1]
         */
        createStyleSheet(bstrHref?: string, lIndex?: number): IHTMLStyleSheet;
        createTextNode(text: string): IHTMLDOMNode;
        createTreeWalker(pRootNode: any, ulWhatToShow: number, pFilter: any, fEntityReferenceExpansion: boolean): IDOMTreeWalker;
        defaultCharset: string;
        readonly defaultView: IHTMLWindow2;
        designMode: string;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        dispatchEvent(evt: IDOMEvent): boolean;
        readonly doctype: IHTMLDOMNode;
        readonly documentElement: IHTMLElement;
        readonly documentMode: any;
        domain: string;
        elementFromPoint(x: number, y: number): IHTMLElement;
        elementsFromPoint(x: number, y: number): IHTMLDOMChildrenCollection;
        elementsFromRect(left: number, top: number, width: number, height: number): IHTMLDOMChildrenCollection;
        readonly embeds: IHTMLElementCollection;

        /** @param boolean [showUI=false] */
        execCommand(cmdID: string, showUI?: boolean, value?: any): boolean;
        execCommandShowHelp(cmdID: string): boolean;
        expando: boolean;
        fgColor: any;
        readonly fileCreatedDate: string;
        readonly fileModifiedDate: string;
        readonly fileSize: string;
        readonly fileUpdatedDate: string;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        readonly forms: IHTMLElementCollection;
        readonly frames: FramesCollection;
        getElementById(v: string): IHTMLElement;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(pvarNS: any, bstrLocalName: string): IHTMLElementCollection;
        getSelection(): IHTMLSelection;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hasFocus(): boolean;
        readonly head: IHTMLElement;
        ie8_getElementById(bstrId: string): IHTMLElement2;
        readonly ie9_all: IHTMLElementCollection;
        ie9_appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_body: IHTMLElement;
        ie9_createAttribute(bstrAttrName: string): IHTMLDOMAttribute;
        ie9_createElement(bstrTag: string): IHTMLElement;
        ie9_insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly ie9_parentWindow: IHTMLWindow2;
        ie9_removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        ie9_replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        readonly images: IHTMLElementCollection;
        readonly implementation: IHTMLDOMImplementation;
        importNode(pNodeSource: IHTMLDOMNode, fDeep: boolean): IHTMLDOMNode3;
        readonly inputEncoding: string;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        isDefaultNamespace(pvarNamespace: any): boolean;
        isEqualNode(otherNode: IHTMLDOMNode3): boolean;
        isSameNode(otherNode: IHTMLDOMNode3): boolean;
        isSupported(feature: string, version: any): boolean;
        readonly lastChild: IHTMLDOMNode;
        readonly lastModified: string;
        linkColor: any;
        readonly links: IHTMLElementCollection;
        readonly localName: any;
        readonly location: IHTMLLocation;
        lookupNamespaceURI(pvarPrefix: any): any;
        lookupPrefix(pvarNamespaceURI: any): any;
        media: string;
        readonly mimeType: string;
        msCapsLockWarningOff: boolean;
        readonly nameProp: string;
        readonly namespaces: any;
        readonly namespaceURI: any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onmousedown: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmscontentzoom: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsinertiastart: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmssitemodejumplistitemremoved: any;
        onmsthumbnailclick: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectionchange: any;
        onselectstart: any;
        onstalled: any;
        onstop: any;
        onstorage: any;
        onstoragecommit: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;

        /** @param string [url='text/html'] */
        open(url?: string, name?: any, features?: any, replace?: any): any;
        readonly ownerDocument: any;
        readonly parentNode: IHTMLDOMNode;
        readonly parentWindow: IHTMLWindow2;
        readonly plugins: IHTMLElementCollection;
        prefix: any;
        readonly previousSibling: IHTMLDOMNode;
        readonly protocol: string;
        queryCommandEnabled(cmdID: string): boolean;
        queryCommandIndeterm(cmdID: string): boolean;
        queryCommandState(cmdID: string): boolean;
        queryCommandSupported(cmdID: string): boolean;
        queryCommandText(cmdID: string): string;
        queryCommandValue(cmdID: string): any;
        querySelector(v: string): IHTMLElement;
        querySelectorAll(v: string): IHTMLDOMChildrenCollection;
        readonly readyState: string;

        /** @param boolean [fForce=false] */
        recalc(fForce?: boolean): void;
        readonly referrer: string;
        releaseCapture(): void;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeEventListener(type: string, listener: any, useCapture: boolean): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        readonly rootElement: ISVGSVGElement;
        readonly Script: any;
        readonly scripts: IHTMLElementCollection;
        readonly security: string;
        readonly selection: IHTMLSelectionObject;
        readonly styleSheets: IHTMLStyleSheetsCollection;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        textContent: any;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        updateSettings(): void;
        url: string;
        readonly URLUnencoded: string;
        vlinkColor: any;
        write(...psarray: any[]): void;
        writeln(...psarray: any[]): void;
        readonly xmlEncoding: string;
        xmlStandalone: boolean;
        xmlVersion: string;
    }

    class OldHTMLFormElement {
        private 'MSHTML.OldHTMLFormElement_typekey': OldHTMLFormElement;
        private constructor();
        acceptCharset: string;
        accessKey: string;
        action: string;
        addBehavior(bstrURL: string, pvarFactory?: any): number;
        addFilter(pUnk: any): void;
        readonly all: any;
        appendChild(newChild: IHTMLDOMNode): IHTMLDOMNode;
        appendItemSeparator(): void;

        /**
         * @param string [name='']
         * @param string [filename='']
         */
        appendNameFilePair(name?: string, filename?: string): void;

        /**
         * @param string [name='']
         * @param string [value='']
         */
        appendNameValuePair(name?: string, value?: string): void;
        applyElement(apply: IHTMLElement, where: string): IHTMLElement;
        ariaActivedescendant: string;
        ariaBusy: string;
        ariaChecked: string;
        ariaControls: string;
        ariaDescribedby: string;
        ariaDisabled: string;
        ariaExpanded: string;
        ariaFlowto: string;
        ariaHaspopup: string;
        ariaHidden: string;
        ariaInvalid: string;
        ariaLabelledby: string;
        ariaLevel: number;
        ariaLive: string;
        ariaMultiselectable: string;
        ariaOwns: string;
        ariaPosinset: number;
        ariaPressed: string;
        ariaReadonly: string;
        ariaRelevant: string;
        ariaRequired: string;
        ariaSecret: string;
        ariaSelected: string;
        ariaSetsize: number;
        ariaValuemax: string;
        ariaValuemin: string;
        ariaValuenow: string;
        attachEvent(event: string, pdisp: any): boolean;
        readonly attributes: any;
        readonly behaviorUrns: any;
        blur(): void;
        readonly canHaveChildren: boolean;
        readonly canHaveHTML: boolean;
        readonly childNodes: any;
        readonly children: any;
        className: string;
        clearAttributes(): void;
        click(): void;
        readonly clientHeight: number;
        readonly clientLeft: number;
        readonly clientTop: number;
        readonly clientWidth: number;
        cloneNode(fDeep: boolean): IHTMLDOMNode;
        componentFromPoint(x: number, y: number): string;
        readonly 'constructor': any;
        contains(pChild: IHTMLElement): boolean;
        contentEditable: string;
        createControlRange(): any;
        readonly currentStyle: IHTMLCurrentStyle;
        detachEvent(event: string, pdisp: any): void;
        dir: string;
        disabled: boolean;
        readonly document: any;
        doScroll(component?: any): void;
        dragDrop(): boolean;
        readonly elements: any;
        encoding: string;
        readonly filters: IHTMLFiltersCollection;
        FireEvent(bstrEventName: string, pvarEventObject?: any): boolean;
        readonly firstChild: IHTMLDOMNode;
        focus(): void;
        getAdjacentText(where: string): string;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        getAttributeNode(bstrName: string): IHTMLDOMAttribute;
        getAttributeNodeNS(pvarNS: any, bstrName: string): IHTMLDOMAttribute2;
        getAttributeNS(pvarNS: any, strAttributeName: string): any;
        getBoundingClientRect(): IHTMLRect;
        getClientRects(): IHTMLRectCollection;
        getElementsByClassName(v: string): IHTMLElementCollection;
        getElementsByTagName(v: string): IHTMLElementCollection;
        getElementsByTagNameNS(varNS: any, bstrLocalName: string): IHTMLElementCollection;
        getExpression(propname: string): any;
        hasAttribute(name: string): boolean;
        hasAttributeNS(pvarNS: any, name: string): boolean;
        hasAttributes(): boolean;
        hasChildNodes(): boolean;
        hideFocus: boolean;
        id: string;
        ie8_action: string;
        readonly ie8_attributes: IHTMLAttributeCollection3;
        ie8_getAttribute(strAttributeName: string): any;
        ie8_getAttributeNode(bstrName: string): IHTMLDOMAttribute2;
        ie8_removeAttribute(strAttributeName: string): boolean;
        ie8_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie8_setAttribute(strAttributeName: string, AttributeValue: any): void;
        ie8_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_getAttribute(strAttributeName: string): any;
        ie9_getAttributeNode(strAttributeName: string): IHTMLDOMAttribute2;
        ie9_hasAttribute(name: string): boolean;
        ie9_hasAttributes(): boolean;
        readonly ie9_nodeName: string;
        ie9_removeAttribute(strAttributeName: string): void;
        ie9_removeAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        ie9_setAttribute(strAttributeName: string, pvarAttributeValue: any): void;
        ie9_setAttributeNode(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        readonly ie9_tagName: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentElement(where: string, insertedElement: IHTMLElement): IHTMLElement;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        insertBefore(newChild: IHTMLDOMNode, refChild?: any): IHTMLDOMNode;
        readonly isContentEditable: boolean;
        readonly isDisabled: boolean;
        readonly isMultiLine: boolean;
        readonly isTextEdit: boolean;
        item(name?: any, index?: any): any;
        lang: string;
        language: string;
        readonly lastChild: IHTMLDOMNode;
        length: number;
        mergeAttributes(mergeThis: IHTMLElement, pvarFlags?: any): void;
        method: string;
        msMatchesSelector(v: string): boolean;
        msReleasePointerCapture(pointerId: number): void;
        msSetPointerCapture(pointerId: number): void;
        name: string;
        namedItem(name: string): any;
        readonly nextSibling: IHTMLDOMNode;
        readonly nodeName: string;
        readonly nodeType: number;
        nodeValue: any;
        normalize(): void;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onabort: any;
        onactivate: any;
        onafterupdate: any;
        onbeforeactivate: any;
        onbeforecopy: any;
        onbeforecut: any;
        onbeforedeactivate: any;
        onbeforeeditfocus: any;
        onbeforepaste: any;
        onbeforeupdate: any;
        onblur: any;
        oncanplay: any;
        oncanplaythrough: any;
        oncellchange: any;
        onchange: any;
        onclick: any;
        oncontextmenu: any;
        oncontrolselect: any;
        oncopy: any;
        oncuechange: any;
        oncut: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondeactivate: any;
        ondrag: any;
        ondragend: any;
        ondragenter: any;
        ondragleave: any;
        ondragover: any;
        ondragstart: any;
        ondrop: any;
        ondurationchange: any;
        onemptied: any;
        onended: any;
        onerror: any;
        onerrorupdate: any;
        onfilterchange: any;
        onfocus: any;
        onfocusin: any;
        onfocusout: any;
        onhelp: any;
        oninput: any;
        oninvalid: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onlayoutcomplete: any;
        onload: any;
        onloadeddata: any;
        onloadedmetadata: any;
        onloadstart: any;
        onlosecapture: any;
        onmousedown: any;
        onmouseenter: any;
        onmouseleave: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onmousewheel: any;
        onmove: any;
        onmoveend: any;
        onmovestart: any;
        onmsanimationend: any;
        onmsanimationiteration: any;
        onmsanimationstart: any;
        onmsgesturechange: any;
        onmsgesturedoubletap: any;
        onmsgestureend: any;
        onmsgesturehold: any;
        onmsgesturestart: any;
        onmsgesturetap: any;
        onmsgotpointercapture: any;
        onmsinertiastart: any;
        onmslostpointercapture: any;
        onmsmanipulationstatechanged: any;
        onmspointercancel: any;
        onmspointerdown: any;
        onmspointerhover: any;
        onmspointermove: any;
        onmspointerout: any;
        onmspointerover: any;
        onmspointerup: any;
        onmstransitionend: any;
        onmstransitionstart: any;
        onpage: any;
        onpaste: any;
        onpause: any;
        onplay: any;
        onplaying: any;
        onprogress: any;
        onpropertychange: any;
        onratechange: any;
        onreadystatechange: any;
        onreset: any;
        onresize: any;
        onresizeend: any;
        onresizestart: any;
        onrowenter: any;
        onrowexit: any;
        onrowsdelete: any;
        onrowsinserted: any;
        onscroll: any;
        onseeked: any;
        onseeking: any;
        onselect: any;
        onselectstart: any;
        onstalled: any;
        onsubmit: any;
        onsuspend: any;
        ontimeupdate: any;
        onvolumechange: any;
        onwaiting: any;
        outerHTML: string;
        outerText: string;
        readonly ownerDocument: any;
        readonly parentElement: IHTMLElement;
        readonly parentNode: IHTMLDOMNode;
        readonly parentTextEdit: IHTMLElement;
        readonly previousSibling: IHTMLDOMNode;
        readonly readyState: any;
        readonly recordNumber: any;
        releaseCapture(): void;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        removeAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        removeAttributeNS(pvarNS: any, strAttributeName: string): void;
        removeBehavior(cookie: number): boolean;
        removeChild(oldChild: IHTMLDOMNode): IHTMLDOMNode;
        removeExpression(propname: string): boolean;
        removeFilter(pUnk: any): void;

        /** @param boolean [fDeep=false] */
        removeNode(fDeep?: boolean): IHTMLDOMNode;
        replaceAdjacentText(where: string, newText: string): string;
        replaceChild(newChild: IHTMLDOMNode, oldChild: IHTMLDOMNode): IHTMLDOMNode;
        replaceNode(replacement: IHTMLDOMNode): IHTMLDOMNode;
        reset(): void;
        role: string;
        readonly runtimeStyle: IHTMLStyle;
        readonly scopeName: string;
        readonly scrollHeight: number;
        scrollIntoView(varargStart?: any): void;
        scrollLeft: number;
        scrollTop: number;
        readonly scrollWidth: number;
        setActive(): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        setAttributeNode(pattr: IHTMLDOMAttribute): IHTMLDOMAttribute;
        setAttributeNodeNS(pattr: IHTMLDOMAttribute2): IHTMLDOMAttribute2;
        setAttributeNS(pvarNS: any, strAttributeName: string, pvarAttributeValue: any): void;

        /** @param boolean [containerCapture=true] */
        setCapture(containerCapture?: boolean): void;

        /** @param string [language=''] */
        setExpression(propname: string, expression: string, language?: string): void;
        readonly sourceIndex: number;
        spellcheck: any;
        readonly style: IHTMLStyle;
        submit(): void;
        swapNode(otherNode: IHTMLDOMNode): IHTMLDOMNode;
        tabIndex: number;
        readonly tagName: string;
        tags(tagName: any): any;
        tagUrn: string;
        target: string;
        title: string;
        toString(): string;
        readonly uniqueID: string;
        readonly uniqueNumber: number;
        urns(urn: any): any;
        xmsAcceleratorKey: string;
    }

    class RangeException {
        private 'MSHTML.RangeException_typekey': RangeException;
        private constructor();
        code: number;
        readonly message: string;
    }

    class RulesApplied {
        private 'MSHTML.RulesApplied_typekey': RulesApplied;
        private constructor();
        readonly appliedRules: IHTMLStyleSheetRulesAppliedCollection;
        readonly element: IHTMLElement;
        hasInheritableProperty(): boolean;
        readonly inlineStyles: IHTMLStyle;
        propertyIsInheritable(name: string): boolean;
        propertyIsInline(name: string): boolean;
    }

    class RulesAppliedCollection {
        private 'MSHTML.RulesAppliedCollection_typekey': RulesAppliedCollection;
        private constructor();
        readonly element: IHTMLElement;
        item(index: number): IRulesApplied;
        readonly length: number;
        property(index: number): string;
        readonly propertyCount: number;
        propertyInheritedFrom(name: string): IRulesApplied;
        propertyInheritedTrace(name: string, index: number): IRulesApplied;
        propertyInheritedTraceLength(name: string): number;
    }

    class Scriptlet {
        private 'MSHTML.Scriptlet_typekey': Scriptlet;
        private constructor();
        AboutBox(): void;
        embed: boolean;
        readonly event: any;
        readonly readyState: number;
        Scrollbar: boolean;
        url: string;
    }

    class StaticNodeList {
        private 'MSHTML.StaticNodeList_typekey': StaticNodeList;
        private constructor();
        readonly 'constructor': any;
        item(index: number): any;
        readonly length: number;
    }

    class SVGAElement {
        private 'MSHTML.SVGAElement_typekey': SVGAElement;
        private constructor();
        readonly className: SVGAnimatedString;
        readonly externalResourcesRequired: SVGAnimatedBoolean;
        readonly farthestViewportElement: ISVGElement;
        focusable: SVGAnimatedEnumeration;
        getBBox(): SVGRect;
        getCTM(): SVGMatrix;
        getScreenCTM(): SVGMatrix;
        getTransformToElement(pElement: ISVGElement): SVGMatrix;
        hasExtension(extension: string): boolean;
        readonly href: SVGAnimatedString;
        readonly nearestViewportElement: ISVGElement;
        ownerSVGElement: ISVGSVGElement;
        readonly requiredExtensions: SVGStringList;
        readonly requiredFeatures: SVGStringList;
        readonly systemLanguage: SVGStringList;
        target: SVGAnimatedString;
        readonly transform: SVGAnimatedTransformList;
        viewportElement: ISVGElement;
        xmlbase: string;
        xmllang: string;
        xmlspace: string;
    }

    class SVGAngle {
        private 'MSHTML.SVGAngle_typekey': SVGAngle;
        private constructor();
        convertToSpecifiedUnits(unitType: number): void;
        newValueSpecifiedUnits(unitType: number, valueInSpecifiedUnits: number): void;
        unitType: number;
        value: number;
        valueAsString: string;
        valueInSpecifiedUnits: number;
    }

    class SVGAnimatedAngle {
        private 'MSHTML.SVGAnimatedAngle_typekey': SVGAnimatedAngle;
        private constructor();
        animVal: SVGAngle;
        baseVal: SVGAngle;
    }

    class SVGAnimatedBoolean {
        private 'MSHTML.SVGAnimatedBoolean_typekey': SVGAnimatedBoolean;
        private constructor();
        animVal: boolean;
        baseVal: boolean;
    }

    class SVGAnimatedEnumeration {
        private 'MSHTML.SVGAnimatedEnumeration_typekey': SVGAnimatedEnumeration;
        private constructor();
        animVal: number;
        baseVal: number;
    }

    class SVGAnimatedInteger {
        private 'MSHTML.SVGAnimatedInteger_typekey': SVGAnimatedInteger;
        private constructor();
        animVal: number;
        baseVal: number;
    }

    class SVGAnimatedLength {
        private 'MSHTML.SVGAnimatedLength_typekey': SVGAnimatedLength;
        private constructor();
        animVal: SVGLength;
        baseVal: SVGLength;
    }

    class SVGAnimatedLengthList {
        private 'MSHTML.SVGAnimatedLengthList_typekey': SVGAnimatedLengthList;
        private constructor();
        animVal: SVGLengthList;
        baseVal: SVGLengthList;
    }

    class SVGAnimatedNumber {
        private 'MSHTML.SVGAnimatedNumber_typekey': SVGAnimatedNumber;
        private constructor();
        animVal: number;
        baseVal: number;
    }

    class SVGAnimatedNumberList {
        private 'MSHTML.SVGAnimatedNumberList_typekey': SVGAnimatedNumberList;
        private constructor();
        animVal: SVGNumberList;
        baseVal: SVGNumberList;
    }

    class SVGAnimatedPreserveAspectRatio {
        private 'MSHTML.SVGAnimatedPreserveAspectRatio_typekey': SVGAnimatedPreserveAspectRatio;
        private constructor();
        animVal: SVGPreserveAspectRatio;
        baseVal: SVGPreserveAspectRatio;
    }

    class SVGAnimatedRect {
        private 'MSHTML.SVGAnimatedRect_typekey': SVGAnimatedRect;
        private constructor();
        animVal: SVGRect;
        baseVal: SVGRect;
    }

    class SVGAnimatedString {
        private 'MSHTML.SVGAnimatedString_typekey': SVGAnimatedString;
        private constructor();
        readonly animVal: string;
        baseVal: string;
    }

    class SVGAnimatedTransformList {
        private 'MSHTML.SVGAnimatedTransformList_typekey': SVGAnimatedTransformList;
        private constructor();
        animVal: SVGTransformList;
        baseVal: SVGTransformList;
    }

    class SVGCircleElement {
        private 'MSHTML.SVGCircleElement_typekey': SVGCircleElement;
        private constructor();
        cx: SVGAnimatedLength;
        cy: SVGAnimatedLength;
        readonly farthestViewportElement: ISVGElement;
        focusable: SVGAnimatedEnumeration;
        getBBox(): SVGRect;
        getCTM(): SVGMatrix;
        getScreenCTM(): SVGMatrix;
        getTransformToElement(pElement: ISVGElement): SVGMatrix;
        hasExtension(extension: string): boolean;
        readonly nearestViewportElement: ISVGElement;
        ownerSVGElement: ISVGSVGElement;
        r: SVGAnimatedLength;
        readonly requiredExtensions: SVGStringList;
        readonly requiredFeatures: SVGStringList;
        readonly systemLanguage: SVGStringList;
        readonly transform: SVGAnimatedTransformList;
        viewportElement: ISVGElement;
        xmlbase: string;
    }

    class SVGClipPathElement {
        private 'MSHTML.SVGClipPathElement_typekey': SVGClipPathElement;
        private constructor();
        readonly className: SVGAnimatedString;
        clipPathUnits: SVGAnimatedEnumeration;
        readonly externalResourcesRequired: SVGAnimatedBoolean;
        readonly farthestViewportElement: ISVGElement;
        focusable: SVGAnimatedEnumeration;
        getBBox(): SVGRect;
        getCTM(): SVGMatrix;
        getScreenCTM(): SVGMatrix;
        getTransformToElement(pElement: ISVGElement): SVGMatrix;
        hasExtension(extension: string): boolean;
        readonly nearestViewportElement: ISVGElement;
        ownerSVGElement: ISVGSVGElement;
        readonly requiredExtensions: SVGStringList;
        readonly requiredFeatures: SVGStringList;
        readonly systemLanguage: SVGStringList;
        readonly transform: SVGAnimatedTransformList;
        viewportElement: ISVGElement;
        xmlbase: string;
        xmllang: string;
        xmlspace: string;
    }

    class SVGDefsElement {
        private 'MSHTML.SVGDefsElement_typekey': SVGDefsElement;
        private constructor();
        readonly className: SVGAnimatedString;
        readonly externalResourcesRequired: SVGAnimatedBoolean;
        readonly farthestViewportElement: ISVGElement;
        focusable: SVGAnimatedEnumeration;
        getBBox(): SVGRect;
        getCTM(): SVGMatrix;
        getScreenCTM(): SVGMatrix;
        getTransformToElement(pElement: ISVGElement): SVGMatrix;
        hasExtension(extension: string): boolean;
        readonly nearestViewportElement: ISVGElement;
        ownerSVGElement: ISVGSVGElement;
        readonly requiredExtensions: SVGStringList;
        readonly requiredFeatures: SVGStringList;
        readonly systemLanguage: SVGStringList;
        readonly transform: SVGAnimatedTransformList;
        viewportElement: ISVGElement;
        xmlbase: string;
        xmllang: string;
        xmlspace: string;
    }

    class SVGDescElement {
        private 'MSHTML.SVGDescElement_typekey': SVGDescElement;
        private constructor();
        readonly className: SVGAnimatedString;
        focusable: SVGAnimatedEnumeration;
        ownerSVGElement: ISVGSVGElement;
        viewportElement: ISVGElement;
        xmlbase: string;
        xmllang: string;
        xmlspace: string;
    }

    class SVGElement {
        private 'MSHTML.SVGElement_typekey': SVGElement;
        private constructor();
        readonly all: any;
        readonly children: any;
        className: string;
        click(): void;
        contains(pChild: IHTMLElement): boolean;
        readonly document: any;
        readonly filters: IHTMLFiltersCollection;
        focusable: SVGAnimatedEnumeration;

        /** @param number [lFlags=0] */
        getAttribute(strAttributeName: string, lFlags?: number): any;
        id: string;
        innerHTML: string;
        innerText: string;
        insertAdjacentHTML(where: string, html: string): void;
        insertAdjacentText(where: string, text: string): void;
        readonly isTextEdit: boolean;
        lang: string;
        language: string;
        readonly offsetHeight: number;
        readonly offsetLeft: number;
        readonly offsetParent: IHTMLElement;
        readonly offsetTop: number;
        readonly offsetWidth: number;
        onafterupdate: any;
        onbeforeupdate: any;
        onclick: any;
        ondataavailable: any;
        ondatasetchanged: any;
        ondatasetcomplete: any;
        ondblclick: any;
        ondragstart: any;
        onerrorupdate: any;
        onfilterchange: any;
        onhelp: any;
        onkeydown: any;
        onkeypress: any;
        onkeyup: any;
        onmousedown: any;
        onmousemove: any;
        onmouseout: any;
        onmouseover: any;
        onmouseup: any;
        onrowenter: any;
        onrowexit: any;
        onselectstart: any;
        outerHTML: string;
        outerText: string;
        ownerSVGElement: ISVGSVGElement;
        readonly parentElement: IHTMLElement;
        readonly parentTextEdit: IHTMLElement;
        readonly recordNumber: any;

        /** @param number [lFlags=1] */
        removeAttribute(strAttributeName: string, lFlags?: number): boolean;
        scrollIntoView(varargStart?: any): void;

        /** @param number [lFlags=1] */
        setAttribute(strAttributeName: string, AttributeValue: any, lFlags?: number): void;
        readonly sourceIndex: number;
        readonly style: IHTMLStyle;
        readonly tagName: string;
        title: string;
        toString(): string;
        viewportElement: ISVGElement;
        xmlbase: string;
    }

    class SVGElementInstance {
        private 'MSHTML.SVGElementInstance_typekey': SVGElementInstance;
        private constructor();
        addEventListener(type: string, listener: any, useCapture: boolean): void;
        readonly childNodes: ISVGElementInstanceList;
        readonly correspondingElement: ISVGElement;
        readonly correspondingUseElement: ISVGUseElement;
        dispatchEvent(evt: IDOMEvent): boolean;
        readonly firstChild: ISVGElementInstance;
        readonly lastChild: ISVGElementInstance;
        readonly nextSibling: ISVGElementInstance;
        readonly parentNode: ISVGElementInstance;
        readonly previousSibling: ISVGElementInstance;
        removeEventListener(type: string, listener: any, useCapture: boolean): void;
    }

    class SVGElementInstanceList {
        private 'MSHTML.SVGElementInstanceList_typekey': SVGElementInstanceList;
        private constructor();
        item(index: number): ISVGElementInstance;
        readonly length: number;
    }

    class SVGEllipseElement {
        private 'MSHTML.SVGEllipseElement_typekey': SVGEllipseElement;
        private constructor();
        cx: SVGAnimatedLength;
        cy: SVGAnimatedLength;
        readonly farthestViewportElement: ISVGElement;
        focusable: SVGAnimatedEnumeration;
        getBBox(): SVGRect;
        getCTM(): SVGMatrix;
        getScreenCTM(): SVGMatrix;
        getTransformToElement(pElement: ISVGElement): SVGMatrix;
        hasExtension(extension: string): boolean;
        readonly nearestViewportElement: ISVGElement;
        ownerSVGElement: ISVGSVGElement;
        readonly requiredExtensions: SVGStringList;
        readonly requiredFeatures: SVGStringList;
        rx: SVGAnimatedLength;
        ry: SVGAnimatedLength;
        readonly systemLanguage: SVGStringList;
        readonly transform: SVGAnimatedTransformList;
        viewportElement: ISVGElement;
        xmlbase: string;
    }

    class SVGException {
        private 'MSHTML.SVGException_typekey': SVGException;
        private constructor();
        code: number;
        readonly message: string;
    }

    class SVGGElement {
        private 'MSHTML.SVGGElement_typekey': SVGGElement;
        private constructor();
        readonly className: SVGAnimatedString;
        readonly externalResourcesRequired: SVGAnimatedBoolean;
        readonly farthestViewportElement: ISVGElement;
        focusable: SVGAnimatedEnumeration;
        getBBox(): SVGRect;
        getCTM(): SVGMatrix;
        getScreenCTM(): SVGMatrix;
        getTransformToElement(pElement: ISVGElement): SVGMatrix;
        hasExtension(extension: string): boolean;
        readonly nearestViewportElement: ISVGElement;
        ownerSVGElement: ISVGSVGElement;
        readonly requiredExtensions: SVGStringList;
        readonly requiredFeatures: SVGStringList;
        readonly systemLanguage: SVGStringList;
        readonly transform: SVGAnimatedTransformList;
        viewportElement: ISVGElement;
        xmlbase: string;
        xmllang: string;
        xmlspace: string;
    }

    class SVGGradientElement {
        private 'MSHTML.SVGGradientElement_typekey': SVGGradientElement;
        private constructor();
        readonly className: SVGAnimatedString;
        readonly externalResourcesRequired: SVGAnimatedBoolean;
        focusable: SVGAnimatedEnumeration;
        gradientTransform: SVGAnimatedTransformList;
        gradientUnits: SVGAnimatedEnumeration;
        readonly href: SVGAnimatedString;
        ownerSVGElement: ISVGSVGElement;
        spreadMethod: SVGAnimatedEnumeration;
        viewportElement: ISVGElement;
        xmlbase: string;
    }

    class SVGImageElement {
        private 'MSHTML.SVGImageElement_typekey': SVGImageElement;
        private constructor();
        readonly farthestViewportElement: ISVGElement;
        focusable: SVGAnimatedEnumeration;
        getBBox(): SVGRect;
        getCTM(): SVGMatrix;
        getScreenCTM(): SVGMatrix;
        getTransformToElement(pElement: ISVGElement): SVGMatrix;
        hasExtension(extension: string): boolean;
        height: SVGAnimatedLength;
        readonly href: SVGAnimatedString;
        readonly nearestViewportElement: ISVGElement;
        ownerSVGElement: ISVGSVGElement;
        preserveAspectRatio: SVGAnimatedPreserveAspectRatio;
        readonly requiredExtensions: SVGStringList;
        readonly requiredFeatures: SVGStringList;
        readonly systemLanguage: SVGStringList;
        readonly transform: SVGAnimatedTransformList;
        readonly viewBox: SVGAnimatedRect;
        viewportElement: ISVGElement;
        width: SVGAnimatedLength;
        x: SVGAnimatedLength;
        xmlbase: string;
        y: SVGAnimatedLength;
    }

    class SVGLength {
        private 'MSHTML.SVGLength_typekey': SVGLength;
        private constructor();
        convertToSpecifiedUnits(unitType: number): void;
        newValueSpecifiedUnits(unitType: number, valueInSpecifiedUnits: number): void;
        unitType: number;
        value: number;
        valueAsString: string;
        valueInSpecifiedUnits: number;
    }

    class SVGLengthList {
        private 'MSHTML.SVGLengthList_typekey': SVGLengthList;
        private constructor();
        appendItem(newItem: SVGLength): SVGLength;
        clear(): void;
        getItem(index: number): SVGLength;
        initialize(newItem: SVGLength): SVGLength;
        insertItemBefore(newItem: SVGLength, index: number): SVGLength;
        numberOfItems: number;
        removeItem(index: number): SVGLength;
        replaceItem(newItem: SVGLength, index: number): SVGLength;
    }

    class SVGLinearGradientElement {
        private 'MSHTML.SVGLinearGradientElement_typekey': SVGLinearGradientElement;
        private constructor();
        readonly className: SVGAnimatedString;
        readonly externalResourcesRequired: SVGAnimatedBoolean;
        focusable: SVGAnimatedEnumeration;
        gradientTransform: SVGAnimatedTransformList;
        gradientUnits: SVGAnimatedEnumeration;
        readonly href: SVGAnimatedString;
        ownerSVGElement: ISVGSVGElement;
        spreadMethod: SVGAnimatedEnumeration;
        viewportElement: ISVGElement;
        x1: SVGAnimatedLength;
        x2: SVGAnimatedLength;
        xmlbase: string;
        y1: SVGAnimatedLength;
        y2: SVGAnimatedLength;
    }

    class SVGLineElement {
        private 'MSHTML.SVGLineElement_typekey': SVGLineElement;
        private constructor();
        readonly className: SVGAnimatedString;
        readonly externalResourcesRequired: SVGAnimatedBoolean;
        readonly farthestViewportElement: ISVGElement;
        focusable: SVGAnimatedEnumeration;
        getBBox(): SVGRect;
        getCTM(): SVGMatrix;
        getScreenCTM(): SVGMatrix;
        getTransformToElement(pElement: ISVGElement): SVGMatrix;
        hasExtension(extension: string): boolean;
        readonly nearestViewportElement: ISVGElement;
        ownerSVGElement: ISVGSVGElement;
        readonly requiredExtensions: SVGStringList;
        readonly requiredFeatures: SVGStringList;
        readonly systemLanguage: SVGStringList;
        readonly transform: SVGAnimatedTransformList;
        viewportElement: ISVGElement;
        x1: SVGAnimatedLength;
        x2: SVGAnimatedLength;
        xmlbase: string;
        xmllang: string;
        xmlspace: string;
        y1: SVGAnimatedLength;
        y2: SVGAnimatedLength;
    }

    class SVGMarkerElement {
        private 'MSHTML.SVGMarkerElement_typekey': SVGMarkerElement;
        private constructor();
        readonly className: SVGAnimatedString;
        readonly externalResourcesRequired: SVGAnimatedBoolean;
        focusable: SVGAnimatedEnumeration;
        markerHeight: SVGAnimatedLength;
        markerUnits: SVGAnimatedEnumeration;
        markerWidth: SVGAnimatedLength;
        orientAngle: SVGAnimatedAngle;
        orientType: SVGAnimatedEnumeration;
        ownerSVGElement: ISVGSVGElement;
        preserveAspectRatio: SVGAnimatedPreserveAspectRatio;
        refX: SVGAnimatedLength;
        refY: SVGAnimatedLength;
        setOrientToAngle(pSVGAngle: SVGAngle): void;
        setOrientToAuto(): void;
        readonly viewBox: SVGAnimatedRect;
        viewportElement: ISVGElement;
        xmlbase: string;
        xmllang: string;
        xmlspace: string;
    }

    class SVGMaskElement {
        private 'MSHTML.SVGMaskElement_typekey': SVGMaskElement;
        private constructor();
        readonly className: SVGAnimatedString;
        readonly externalResourcesRequired: SVGAnimatedBoolean;
        focusable: SVGAnimatedEnumeration;
        hasExtension(extension: string): boolean;
        height: SVGAnimatedLength;
        maskContentUnits: SVGAnimatedEnumeration;
        maskUnits: SVGAnimatedEnumeration;
        ownerSVGElement: ISVGSVGElement;
        readonly requiredExtensions: SVGStringList;
        readonly requiredFeatures: SVGStringList;
        readonly systemLanguage: SVGStringList;
        viewportElement: ISVGElement;
        width: SVGAnimatedLength;
        x: SVGAnimatedLength;
        xmlbase: string;
        xmllang: string;
        xmlspace: string;
        y: SVGAnimatedLength;
    }

    class SVGMatrix {
        private 'MSHTML.SVGMatrix_typekey': SVGMatrix;
        private constructor();
        a: number;
        b: number;
        c: number;
        d: number;
        e: number;
        f: number;
        flipX(): SVGMatrix;
        flipY(): SVGMatrix;
        inverse(): SVGMatrix;
        multiply(secondMatrix: SVGMatrix): SVGMatrix;
        rotate(angle: number): SVGMatrix;
        rotateFromVector(x: number, y: number): SVGMatrix;
        scale(scaleFactor: number): SVGMatrix;
        scaleNonUniform(scaleFactorX: number, scaleFactorY: number): SVGMatrix;
        skewX(angle: number): SVGMatrix;
        skewY(angle: number): SVGMatrix;
        translate(x: number, y: number): SVGMatrix;
    }

    class SVGMetadataElement {
        private 'MSHTML.SVGMetadataElement_typekey': SVGMetadataElement;
        private constructor();
        focusable: SVGAnimatedEnumeration;
        ownerSVGElement: ISVGSVGElement;
        viewportElement: ISVGElement;
        xmlbase: string;
    }

    class SVGNumber {
        private 'MSHTML.SVGNumber_typekey': SVGNumber;
        private constructor();
        value: number;
    }

    class SVGNumberList {
        private 'MSHTML.SVGNumberList_typekey': SVGNumberList;
        private constructor();
        appendItem(newItem: SVGNumber): SVGNumber;
        clear(): void;
        getItem(index: number): SVGNumber;
        initialize(newItem: SVGNumber): SVGNumber;
        insertItemBefore(newItem: SVGNumber, index: number): SVGNumber;
        numberOfItems: number;
        removeItem(index: number): SVGNumber;
        replaceItem(newItem: SVGNumber, index: number): SVGNumber;
    }

    class SVGPathElement {
        private 'MSHTML.SVGPathElement_typekey': SVGPathElement;
        private constructor();
        animatedNormalizedPathSegList: SVGPathSegList;
        animatedPathSegList: SVGPathSegList;
        createSVGPathSegArcAbs(x: number, y: number, r1: number, r2: number, angle: number, largeArcFlag: boolean, sweepFlag: boolean): ISVGPathSegArcAbs;
        createSVGPathSegArcRel(x: number, y: number, r1: number, r2: number, angle: number, largeArcFlag: boolean, sweepFlag: boolean): ISVGPathSegArcRel;
        createSVGPathSegClosePath(): ISVGPathSegClosePath;
        createSVGPathSegCurvetoCubicAbs(x: number, y: number, x1: number, y1: number, x2: number, y2: number): ISVGPathSegCurvetoCubicAbs;
        createSVGPathSegCurvetoCubicRel(x: number, y: number, x1: number, y1: number, x2: number, y2: number): ISVGPathSegCurvetoCubicRel;
        createSVGPathSegCurvetoCubicSmoothAbs(x: number, y: number, x2: number, y2: number): ISVGPathSegCurvetoCubicSmoothAbs;
        createSVGPathSegCurvetoCubicSmoothRel(x: number, y: number, x2: number, y2: number): ISVGPathSegCurvetoCubicSmoothRel;
        createSVGPathSegCurvetoQuadraticAbs(x: number, y: number, x1: number, y1: number): ISVGPathSegCurvetoQuadraticAbs;
        createSVGPathSegCurvetoQuadraticRel(x: number, y: number, x1: number, y1: number): ISVGPathSegCurvetoQuadraticRel;
        createSVGPathSegCurvetoQuadraticSmoothAbs(x: number, y: number): ISVGPathSegCurvetoQuadraticSmoothAbs;
        createSVGPathSegCurvetoQuadraticSmoothRel(x: number, y: number): ISVGPathSegCurvetoQuadraticSmoothRel;
        createSVGPathSegLinetoAbs(x: number, y: number): ISVGPathSegLinetoAbs;
        createSVGPathSegLinetoHorizontalAbs(x: number): ISVGPathSegLinetoHorizontalAbs;
        createSVGPathSegLinetoHorizontalRel(x: number): ISVGPathSegLinetoHorizontalRel;
        createSVGPathSegLinetoRel(x: number, y: number): ISVGPathSegLinetoRel;
        createSVGPathSegLinetoVerticalAbs(y: number): ISVGPathSegLinetoVerticalAbs;
        createSVGPathSegLinetoVerticalRel(y: number): ISVGPathSegLinetoVerticalRel;
        createSVGPathSegMovetoAbs(x: number, y: number): ISVGPathSegMovetoAbs;
        createSVGPathSegMovetoRel(x: number, y: number): ISVGPathSegMovetoRel;
        readonly farthestViewportElement: ISVGElement;
        focusable: SVGAnimatedEnumeration;
        getBBox(): SVGRect;
        getCTM(): SVGMatrix;
        getPathSegAtLength(fltdistance: number): number;
        getPointAtLength(fltdistance: number): SVGPoint;
        getScreenCTM(): SVGMatrix;
        getTotalLength(): number;
        getTransformToElement(pElement: ISVGElement): SVGMatrix;
        hasExtension(extension: string): boolean;
        readonly nearestViewportElement: ISVGElement;
        normalizedPathSegList: SVGPathSegList;
        ownerSVGElement: ISVGSVGElement;
        pathLength: SVGAnimatedNumber;
        pathSegList: SVGPathSegList;
        readonly requiredExtensions: SVGStringList;
        readonly requiredFeatures: SVGStringList;
        readonly systemLanguage: SVGStringList;
        readonly transform: SVGAnimatedTransformList;
        viewportElement: ISVGElement;
        xmlbase: string;
    }

    class SVGPathSeg {
        private 'MSHTML.SVGPathSeg_typekey': SVGPathSeg;
        private constructor();
        pathSegType: number;
        readonly pathSegTypeAsLetter: string;
    }

    class SVGPathSegArcAbs {
        private 'MSHTML.SVGPathSegArcAbs_typekey': SVGPathSegArcAbs;
        private constructor();
        angle: number;
        largeArcFlag: boolean;
        pathSegType: number;
        readonly pathSegTypeAsLetter: string;
        r1: number;
        r2: number;
        sweepFlag: boolean;
        x: number;
        y: number;
    }

    class SVGPathSegArcRel {
        private 'MSHTML.SVGPathSegArcRel_typekey': SVGPathSegArcRel;
        private constructor();
        angle: number;
        largeArcFlag: boolean;
        pathSegType: number;
        readonly pathSegTypeAsLetter: string;
        r1: number;
        r2: number;
        sweepFlag: boolean;
        x: number;
        y: number;
    }

    class SVGPathSegClosePath {
        private 'MSHTML.SVGPathSegClosePath_typekey': SVGPathSegClosePath;
        private constructor();
        pathSegType: number;
        readonly pathSegTypeAsLetter: string;
    }

    class SVGPathSegCurvetoCubicAbs {
        private 'MSHTML.SVGPathSegCurvetoCubicAbs_typekey': SVGPathSegCurvetoCubicAbs;
        private constructor();
        pathSegType: number;
        readonly pathSegTypeAsLetter: string;
        x: number;
        x1: number;
        x2: number;
        y: number;
        y1: number;
        y2: number;
    }

    class SVGPathSegCurvetoCubicRel {
        private 'MSHTML.SVGPathSegCurvetoCubicRel_typekey': SVGPathSegCurvetoCubicRel;
        private constructor();
        pathSegType: number;
        readonly pathSegTypeAsLetter: string;
        x: number;
        x1: number;
        x2: number;
        y: number;
        y1: number;
        y2: number;
    }

    class SVGPathSegCurvetoCubicSmoothAbs {
        private 'MSHTML.SVGPathSegCurvetoCubicSmoothAbs_typekey': SVGPathSegCurvetoCubicSmoothAbs;
        private constructor();
        pathSegType: number;
        readonly pathSegTypeAsLetter: string;
        x: number;
        x2: number;
        y: number;
        y2: number;
    }

    class SVGPathSegCurvetoCubicSmoothRel {
        private 'MSHTML.SVGPathSegCurvetoCubicSmoothRel_typekey': SVGPathSegCurvetoCubicSmoothRel;
        private constructor();
        pathSegType: number;
        readonly pathSegTypeAsLetter: string;
        x: number;
        x2: number;
        y: number;
        y2: number;
    }

    class SVGPathSegCurvetoQuadraticAbs {
        private 'MSHTML.SVGPathSegCurvetoQuadraticAbs_typekey': SVGPathSegCurvetoQuadraticAbs;
        private constructor();
        pathSegType: number;
        readonly pathSegTypeAsLetter: string;
        x: number;
        x1: number;
        y: number;
        y1: number;
    }

    class SVGPathSegCurvetoQuadraticRel {
        private 'MSHTML.SVGPathSegCurvetoQuadraticRel_typekey': SVGPathSegCurvetoQuadraticRel;
        private constructor();
        pathSegType: number;
        readonly pathSegTypeAsLetter: string;
        x: number;
        x1: number;
        y: number;
        y1: number;
    }

    class SVGPathSegCurvetoQuadraticSmoothAbs {
        private 'MSHTML.SVGPathSegCurvetoQuadraticSmoothAbs_typekey': SVGPathSegCurvetoQuadraticSmoothAbs;
        private constructor();
        pathSegType: number;
        readonly pathSegTypeAsLetter: string;
        x: number;
        y: number;
    }

    class SVGPathSegCurvetoQuadraticSmoothRel {
        private 'MSHTML.SVGPathSegCurvetoQuadraticSmoothRel_typekey': SVGPathSegCurvetoQuadraticSmoothRel;
        private constructor();
        pathSegType: number;
        readonly pathSegTypeAsLetter: string;
        x: number;
        y: number;
    }

    class SVGPathSegLinetoAbs {
        private 'MSHTML.SVGPathSegLinetoAbs_typekey': SVGPathSegLinetoAbs;
        private constructor();
        pathSegType: number;
        readonly pathSegTypeAsLetter: string;
        x: number;
        y: number;
    }

    class SVGPathSegLinetoHorizontalAbs {
        private 'MSHTML.SVGPathSegLinetoHorizontalAbs_typekey': SVGPathSegLinetoHorizontalAbs;
        private constructor();
        pathSegType: number;
        readonly pathSegTypeAsLetter: string;
        x: number;
    }

    class SVGPathSegLinetoHorizontalRel {
        private 'MSHTML.SVGPathSegLinetoHorizontalRel_typekey': SVGPathSegLinetoHorizontalRel;
        private constructor();
        pathSegType: number;
        readonly pathSegTypeAsLetter: string;
        x: number;
    }

    class SVGPathSegLinetoRel {
        private 'MSHTML.SVGPathSegLinetoRel_typekey': SVGPathSegLinetoRel;
        private constructor();
        pathSegType: number;
        readonly pathSegTypeAsLetter: string;
        x: number;
        y: number;
    }

    class SVGPathSegLinetoVerticalAbs {
        private 'MSHTML.SVGPathSegLinetoVerticalAbs_typekey': SVGPathSegLinetoVerticalAbs;
        private constructor();
        pathSegType: number;
        readonly pathSegTypeAsLetter: string;
        y: number;
    }

    class SVGPathSegLinetoVerticalRel {
        private 'MSHTML.SVGPathSegLinetoVerticalRel_typekey': SVGPathSegLinetoVerticalRel;
        private constructor();
        pathSegType: number;
        readonly pathSegTypeAsLetter: string;
        y: number;
    }

    class SVGPathSegList {
        private 'MSHTML.SVGPathSegList_typekey': SVGPathSegList;
        private constructor();
        appendItem(newItem: SVGPathSeg): SVGPathSeg;
        clear(): void;
        getItem(index: number): SVGPathSeg;
        initialize(newItem: SVGPathSeg): SVGPathSeg;
        insertItemBefore(newItem: SVGPathSeg, index: number): SVGPathSeg;
        numberOfItems: number;
        removeItem(index: number): SVGPathSeg;
        replaceItem(newItem: SVGPathSeg, index: number): SVGPathSeg;
    }

    class SVGPathSegMovetoAbs {
        private 'MSHTML.SVGPathSegMovetoAbs_typekey': SVGPathSegMovetoAbs;
        private constructor();
        pathSegType: number;
        readonly pathSegTypeAsLetter: string;
        x: number;
        y: number;
    }

    class SVGPathSegMovetoRel {
        private 'MSHTML.SVGPathSegMovetoRel_typekey': SVGPathSegMovetoRel;
        private constructor();
        pathSegType: number;
        readonly pathSegTypeAsLetter: string;
        x: number;
        y: number;
    }

    class SVGPatternElement {
        private 'MSHTML.SVGPatternElement_typekey': SVGPatternElement;
        private constructor();
        readonly className: SVGAnimatedString;
        readonly externalResourcesRequired: SVGAnimatedBoolean;
        focusable: SVGAnimatedEnumeration;
        hasExtension(extension: string): boolean;
        height: SVGAnimatedLength;
        readonly href: SVGAnimatedString;
        ownerSVGElement: ISVGSVGElement;
        patternContentUnits: SVGAnimatedEnumeration;
        patternTransform: SVGAnimatedTransformList;
        patternUnits: SVGAnimatedEnumeration;
        preserveAspectRatio: SVGAnimatedPreserveAspectRatio;
        readonly requiredExtensions: SVGStringList;
        readonly requiredFeatures: SVGStringList;
        readonly systemLanguage: SVGStringList;
        readonly viewBox: SVGAnimatedRect;
        viewportElement: ISVGElement;
        width: SVGAnimatedLength;
        x: SVGAnimatedLength;
        xmlbase: string;
        xmllang: string;
        xmlspace: string;
        y: SVGAnimatedLength;
    }

    class SVGPoint {
        private 'MSHTML.SVGPoint_typekey': SVGPoint;
        private constructor();
        matrixTransform(pMatrix: SVGMatrix): SVGPoint;
        x: number;
        y: number;
    }

    class SVGPointList {
        private 'MSHTML.SVGPointList_typekey': SVGPointList;
        private constructor();
        appendItem(pNewItem: SVGPoint): SVGPoint;
        clear(): void;
        getItem(index: number): SVGPoint;
        initialize(pNewItem: SVGPoint): SVGPoint;
        insertItemBefore(pNewItem: SVGPoint, index: number): SVGPoint;
        numberOfItems: number;
        removeItem(index: number): SVGPoint;
        replaceItem(pNewItem: SVGPoint, index: number): SVGPoint;
    }

    class SVGPolygonElement {
        private 'MSHTML.SVGPolygonElement_typekey': SVGPolygonElement;
        private constructor();
        animatedPoints: SVGPointList;
        readonly farthestViewportElement: ISVGElement;
        focusable: SVGAnimatedEnumeration;
        getBBox(): SVGRect;
        getCTM(): SVGMatrix;
        getScreenCTM(): SVGMatrix;
        getTransformToElement(pElement: ISVGElement): SVGMatrix;
        hasExtension(extension: string): boolean;
        readonly nearestViewportElement: ISVGElement;
        ownerSVGElement: ISVGSVGElement;
        points: SVGPointList;
        readonly requiredExtensions: SVGStringList;
        readonly requiredFeatures: SVGStringList;
        readonly systemLanguage: SVGStringList;
        readonly transform: SVGAnimatedTransformList;
        viewportElement: ISVGElement;
        xmlbase: string;
    }

    class SVGPolylineElement {
        private 'MSHTML.SVGPolylineElement_typekey': SVGPolylineElement;
        private constructor();
        animatedPoints: SVGPointList;
        readonly farthestViewportElement: ISVGElement;
        focusable: SVGAnimatedEnumeration;
        getBBox(): SVGRect;
        getCTM(): SVGMatrix;
        getScreenCTM(): SVGMatrix;
        getTransformToElement(pElement: ISVGElement): SVGMatrix;
        hasExtension(extension: string): boolean;
        readonly nearestViewportElement: ISVGElement;
        ownerSVGElement: ISVGSVGElement;
        points: SVGPointList;
        readonly requiredExtensions: SVGStringList;
        readonly requiredFeatures: SVGStringList;
        readonly systemLanguage: SVGStringList;
        readonly transform: SVGAnimatedTransformList;
        viewportElement: ISVGElement;
        xmlbase: string;
    }

    class SVGPreserveAspectRatio {
        private 'MSHTML.SVGPreserveAspectRatio_typekey': SVGPreserveAspectRatio;
        private constructor();
        align: number;
        meetOrSlice: number;
    }

    class SVGRadialGradientElement {
        private 'MSHTML.SVGRadialGradientElement_typekey': SVGRadialGradientElement;
        private constructor();
        readonly className: SVGAnimatedString;
        cx: SVGAnimatedLength;
        cy: SVGAnimatedLength;
        readonly externalResourcesRequired: SVGAnimatedBoolean;
        focusable: SVGAnimatedEnumeration;
        fx: SVGAnimatedLength;
        fy: SVGAnimatedLength;
        gradientTransform: SVGAnimatedTransformList;
        gradientUnits: SVGAnimatedEnumeration;
        readonly href: SVGAnimatedString;
        ownerSVGElement: ISVGSVGElement;
        r: SVGAnimatedLength;
        spreadMethod: SVGAnimatedEnumeration;
        viewportElement: ISVGElement;
        xmlbase: string;
    }

    class SVGRect {
        private 'MSHTML.SVGRect_typekey': SVGRect;
        private constructor();
        height: number;
        width: number;
        x: number;
        y: number;
    }

    class SVGRectElement {
        private 'MSHTML.SVGRectElement_typekey': SVGRectElement;
        private constructor();
        readonly className: SVGAnimatedString;
        readonly externalResourcesRequired: SVGAnimatedBoolean;
        readonly farthestViewportElement: ISVGElement;
        focusable: SVGAnimatedEnumeration;
        getBBox(): SVGRect;
        getCTM(): SVGMatrix;
        getScreenCTM(): SVGMatrix;
        getTransformToElement(pElement: ISVGElement): SVGMatrix;
        hasExtension(extension: string): boolean;
        height: SVGAnimatedLength;
        readonly nearestViewportElement: ISVGElement;
        ownerSVGElement: ISVGSVGElement;
        readonly requiredExtensions: SVGStringList;
        readonly requiredFeatures: SVGStringList;
        rx: SVGAnimatedLength;
        ry: SVGAnimatedLength;
        readonly systemLanguage: SVGStringList;
        readonly transform: SVGAnimatedTransformList;
        viewportElement: ISVGElement;
        width: SVGAnimatedLength;
        x: SVGAnimatedLength;
        xmlbase: string;
        xmllang: string;
        xmlspace: string;
        y: SVGAnimatedLength;
    }

    class SVGScriptElement {
        private 'MSHTML.SVGScriptElement_typekey': SVGScriptElement;
        private constructor();
        readonly externalResourcesRequired: SVGAnimatedBoolean;
        focusable: SVGAnimatedEnumeration;
        readonly href: SVGAnimatedString;
        ownerSVGElement: ISVGSVGElement;
        type: string;
        viewportElement: ISVGElement;
        xmlbase: string;
    }

    class SVGStopElement {
        private 'MSHTML.SVGStopElement_typekey': SVGStopElement;
        private constructor();
        readonly className: SVGAnimatedString;
        focusable: SVGAnimatedEnumeration;
        offset: SVGAnimatedNumber;
        ownerSVGElement: ISVGSVGElement;
        viewportElement: ISVGElement;
        xmlbase: string;
    }

    class SVGStringList {
        private 'MSHTML.SVGStringList_typekey': SVGStringList;
        private constructor();
        appendItem(newItem: string): string;
        clear(): void;
        getItem(index: number): string;
        initialize(newItem: string): string;
        insertItemBefore(newItem: string, index: number): string;
        numberOfItems: number;
        removeItem(index: number): string;
        replaceItem(newItem: string, index: number): string;
    }

    class SVGStyleElement {
        private 'MSHTML.SVGStyleElement_typekey': SVGStyleElement;
        private constructor();
        focusable: SVGAnimatedEnumeration;
        media: string;
        ownerSVGElement: ISVGSVGElement;
        type: string;
        viewportElement: ISVGElement;
        xmlbase: string;
        xmllang: string;
        xmlspace: string;
    }

    class SVGSVGElement {
        private 'MSHTML.SVGSVGElement_typekey': SVGSVGElement;
        private constructor();
        animationsPaused(): boolean;
        checkEnclosure(element: ISVGElement, rect: SVGRect): boolean;
        checkIntersection(element: ISVGElement, rect: SVGRect): boolean;
        readonly className: SVGAnimatedString;
        contentScriptType: string;
        contentStyleType: string;
        createSVGAngle(): SVGAngle;
        createSVGLength(): SVGLength;
        createSVGMatrix(): SVGMatrix;
        createSVGNumber(): SVGNumber;
        createSVGPoint(): SVGPoint;
        createSVGRect(): SVGRect;
        createSVGTransform(): SVGTransform;
        createSVGTransformFromMatrix(matrix: SVGMatrix): SVGTransform;
        currentScale: number;
        currentTranslate: SVGPoint;
        currentView: ISVGViewSpec;
        deselectAll(): void;
        readonly externalResourcesRequired: SVGAnimatedBoolean;
        readonly farthestViewportElement: ISVGElement;
        focusable: SVGAnimatedEnumeration;
        forceRedraw(): void;
        getBBox(): SVGRect;
        getCTM(): SVGMatrix;
        getCurrentTime(): number;
        getElementById(elementId: string): IHTMLElement;
        getEnclosureList(rect: SVGRect, referenceElement: ISVGElement): any;
        getIntersectionList(rect: SVGRect, referenceElement: ISVGElement): any;
        getScreenCTM(): SVGMatrix;
        getTransformToElement(pElement: ISVGElement): SVGMatrix;
        hasExtension(extension: string): boolean;
        height: SVGAnimatedLength;
        readonly nearestViewportElement: ISVGElement;
        ownerSVGElement: ISVGSVGElement;
        pauseAnimations(): void;
        pixelUnitToMillimeterX: number;
        pixelUnitToMillimeterY: number;
        preserveAspectRatio: SVGAnimatedPreserveAspectRatio;
        readonly requiredExtensions: SVGStringList;
        readonly requiredFeatures: SVGStringList;
        screenPixelToMillimeterX: number;
        screenPixelToMillimeterY: number;
        setCurrentTime(seconds: number): void;
        suspendRedraw(maxWaitMilliseconds: number): number;
        readonly systemLanguage: SVGStringList;
        unpauseAnimations(): void;
        unsuspendRedraw(suspendHandeID: number): void;
        unsuspendRedrawAll(): void;
        useCurrentView: boolean;
        readonly viewBox: SVGAnimatedRect;
        viewport: SVGRect;
        viewportElement: ISVGElement;
        width: SVGAnimatedLength;
        x: SVGAnimatedLength;
        xmlbase: string;
        xmllang: string;
        xmlspace: string;
        y: SVGAnimatedLength;
        readonly zoomAndPan: number;
    }

    class SVGSwitchElement {
        private 'MSHTML.SVGSwitchElement_typekey': SVGSwitchElement;
        private constructor();
        readonly className: SVGAnimatedString;
        readonly externalResourcesRequired: SVGAnimatedBoolean;
        readonly farthestViewportElement: ISVGElement;
        focusable: SVGAnimatedEnumeration;
        getBBox(): SVGRect;
        getCTM(): SVGMatrix;
        getScreenCTM(): SVGMatrix;
        getTransformToElement(pElement: ISVGElement): SVGMatrix;
        hasExtension(extension: string): boolean;
        readonly nearestViewportElement: ISVGElement;
        ownerSVGElement: ISVGSVGElement;
        readonly requiredExtensions: SVGStringList;
        readonly requiredFeatures: SVGStringList;
        readonly systemLanguage: SVGStringList;
        readonly transform: SVGAnimatedTransformList;
        viewportElement: ISVGElement;
        xmlbase: string;
        xmllang: string;
        xmlspace: string;
    }

    class SVGSymbolElement {
        private 'MSHTML.SVGSymbolElement_typekey': SVGSymbolElement;
        private constructor();
        readonly className: SVGAnimatedString;
        readonly externalResourcesRequired: SVGAnimatedBoolean;
        focusable: SVGAnimatedEnumeration;
        ownerSVGElement: ISVGSVGElement;
        preserveAspectRatio: SVGAnimatedPreserveAspectRatio;
        readonly viewBox: SVGAnimatedRect;
        viewportElement: ISVGElement;
        xmlbase: string;
        xmllang: string;
        xmlspace: string;
    }

    class SVGTextContentElement {
        private 'MSHTML.SVGTextContentElement_typekey': SVGTextContentElement;
        private constructor();
        readonly className: SVGAnimatedString;
        readonly externalResourcesRequired: SVGAnimatedBoolean;
        focusable: SVGAnimatedEnumeration;
        getCharNumAtPosition(point: SVGPoint): number;
        getComputedTextLength(): number;
        getEndPositionOfChar(charnum: number): SVGPoint;
        getExtentOfChar(charnum: number): SVGRect;
        getNumberOfChars(): number;
        getRotationOfChar(charnum: number): number;
        getStartPositionOfChar(charnum: number): SVGPoint;
        getSubStringLength(charnum: number, nchars: number): number;
        hasExtension(extension: string): boolean;
        lengthAdjust: SVGAnimatedEnumeration;
        ownerSVGElement: ISVGSVGElement;
        readonly requiredExtensions: SVGStringList;
        readonly requiredFeatures: SVGStringList;
        selectSubString(charnum: number, nchars: number): void;
        readonly systemLanguage: SVGStringList;
        textLength: SVGAnimatedLength;
        viewportElement: ISVGElement;
        xmlbase: string;
        xmllang: string;
        xmlspace: string;
    }

    class SVGTextElement {
        private 'MSHTML.SVGTextElement_typekey': SVGTextElement;
        private constructor();
        readonly className: SVGAnimatedString;
        dx: SVGAnimatedLengthList;
        dy: SVGAnimatedLengthList;
        readonly externalResourcesRequired: SVGAnimatedBoolean;
        readonly farthestViewportElement: ISVGElement;
        focusable: SVGAnimatedEnumeration;
        getBBox(): SVGRect;
        getCharNumAtPosition(point: SVGPoint): number;
        getComputedTextLength(): number;
        getCTM(): SVGMatrix;
        getEndPositionOfChar(charnum: number): SVGPoint;
        getExtentOfChar(charnum: number): SVGRect;
        getNumberOfChars(): number;
        getRotationOfChar(charnum: number): number;
        getScreenCTM(): SVGMatrix;
        getStartPositionOfChar(charnum: number): SVGPoint;
        getSubStringLength(charnum: number, nchars: number): number;
        getTransformToElement(pElement: ISVGElement): SVGMatrix;
        hasExtension(extension: string): boolean;
        lengthAdjust: SVGAnimatedEnumeration;
        readonly nearestViewportElement: ISVGElement;
        ownerSVGElement: ISVGSVGElement;
        readonly requiredExtensions: SVGStringList;
        readonly requiredFeatures: SVGStringList;
        rotate: SVGAnimatedNumberList;
        selectSubString(charnum: number, nchars: number): void;
        readonly systemLanguage: SVGStringList;
        textLength: SVGAnimatedLength;
        readonly transform: SVGAnimatedTransformList;
        viewportElement: ISVGElement;
        x: SVGAnimatedLengthList;
        xmlbase: string;
        xmllang: string;
        xmlspace: string;
        y: SVGAnimatedLengthList;
    }

    class SVGTextPathElement {
        private 'MSHTML.SVGTextPathElement_typekey': SVGTextPathElement;
        private constructor();
        readonly className: SVGAnimatedString;
        readonly externalResourcesRequired: SVGAnimatedBoolean;
        focusable: SVGAnimatedEnumeration;
        getCharNumAtPosition(point: SVGPoint): number;
        getComputedTextLength(): number;
        getEndPositionOfChar(charnum: number): SVGPoint;
        getExtentOfChar(charnum: number): SVGRect;
        getNumberOfChars(): number;
        getRotationOfChar(charnum: number): number;
        getStartPositionOfChar(charnum: number): SVGPoint;
        getSubStringLength(charnum: number, nchars: number): number;
        hasExtension(extension: string): boolean;
        readonly href: SVGAnimatedString;
        lengthAdjust: SVGAnimatedEnumeration;
        method: SVGAnimatedEnumeration;
        ownerSVGElement: ISVGSVGElement;
        readonly requiredExtensions: SVGStringList;
        readonly requiredFeatures: SVGStringList;
        selectSubString(charnum: number, nchars: number): void;
        spacing: SVGAnimatedEnumeration;
        startOffset: SVGAnimatedLength;
        readonly systemLanguage: SVGStringList;
        textLength: SVGAnimatedLength;
        viewportElement: ISVGElement;
        xmlbase: string;
        xmllang: string;
        xmlspace: string;
    }

    class SVGTextPositioningElement {
        private 'MSHTML.SVGTextPositioningElement_typekey': SVGTextPositioningElement;
        private constructor();
        readonly className: SVGAnimatedString;
        dx: SVGAnimatedLengthList;
        dy: SVGAnimatedLengthList;
        readonly externalResourcesRequired: SVGAnimatedBoolean;
        focusable: SVGAnimatedEnumeration;
        getCharNumAtPosition(point: SVGPoint): number;
        getComputedTextLength(): number;
        getEndPositionOfChar(charnum: number): SVGPoint;
        getExtentOfChar(charnum: number): SVGRect;
        getNumberOfChars(): number;
        getRotationOfChar(charnum: number): number;
        getStartPositionOfChar(charnum: number): SVGPoint;
        getSubStringLength(charnum: number, nchars: number): number;
        hasExtension(extension: string): boolean;
        lengthAdjust: SVGAnimatedEnumeration;
        ownerSVGElement: ISVGSVGElement;
        readonly requiredExtensions: SVGStringList;
        readonly requiredFeatures: SVGStringList;
        rotate: SVGAnimatedNumberList;
        selectSubString(charnum: number, nchars: number): void;
        readonly systemLanguage: SVGStringList;
        textLength: SVGAnimatedLength;
        viewportElement: ISVGElement;
        x: SVGAnimatedLengthList;
        xmlbase: string;
        xmllang: string;
        xmlspace: string;
        y: SVGAnimatedLengthList;
    }

    class SVGTitleElement {
        private 'MSHTML.SVGTitleElement_typekey': SVGTitleElement;
        private constructor();
        readonly className: SVGAnimatedString;
        focusable: SVGAnimatedEnumeration;
        ownerSVGElement: ISVGSVGElement;
        viewportElement: ISVGElement;
        xmlbase: string;
        xmllang: string;
        xmlspace: string;
    }

    class SVGTransform {
        private 'MSHTML.SVGTransform_typekey': SVGTransform;
        private constructor();
        angle: number;
        matrix: SVGMatrix;
        setMatrix(matrix: SVGMatrix): void;
        setRotate(angle: number, cx: number, cy: number): void;
        setScale(sx: number, sy: number): void;
        setSkewX(angle: number): void;
        setSkewY(angle: number): void;
        setTranslate(tx: number, ty: number): void;
        type: number;
    }

    class SVGTransformList {
        private 'MSHTML.SVGTransformList_typekey': SVGTransformList;
        private constructor();
        appendItem(newItem: SVGTransform): SVGTransform;
        clear(): void;
        consolidate(): SVGTransform;
        createSVGTransformFromMatrix(newItem: SVGMatrix): SVGTransform;
        getItem(index: number): SVGTransform;
        initialize(newItem: SVGTransform): SVGTransform;
        insertItemBefore(newItem: SVGTransform, index: number): SVGTransform;
        numberOfItems: number;
        removeItem(index: number): SVGTransform;
        replaceItem(newItem: SVGTransform, index: number): SVGTransform;
    }

    class SVGTSpanElement {
        private 'MSHTML.SVGTSpanElement_typekey': SVGTSpanElement;
        private constructor();
        readonly className: SVGAnimatedString;
        dx: SVGAnimatedLengthList;
        dy: SVGAnimatedLengthList;
        readonly externalResourcesRequired: SVGAnimatedBoolean;
        focusable: SVGAnimatedEnumeration;
        getCharNumAtPosition(point: SVGPoint): number;
        getComputedTextLength(): number;
        getEndPositionOfChar(charnum: number): SVGPoint;
        getExtentOfChar(charnum: number): SVGRect;
        getNumberOfChars(): number;
        getRotationOfChar(charnum: number): number;
        getStartPositionOfChar(charnum: number): SVGPoint;
        getSubStringLength(charnum: number, nchars: number): number;
        hasExtension(extension: string): boolean;
        lengthAdjust: SVGAnimatedEnumeration;
        ownerSVGElement: ISVGSVGElement;
        readonly requiredExtensions: SVGStringList;
        readonly requiredFeatures: SVGStringList;
        rotate: SVGAnimatedNumberList;
        selectSubString(charnum: number, nchars: number): void;
        readonly systemLanguage: SVGStringList;
        textLength: SVGAnimatedLength;
        viewportElement: ISVGElement;
        x: SVGAnimatedLengthList;
        xmlbase: string;
        xmllang: string;
        xmlspace: string;
        y: SVGAnimatedLengthList;
    }

    class SVGUseElement {
        private 'MSHTML.SVGUseElement_typekey': SVGUseElement;
        private constructor();
        animatedInstanceRoot: ISVGElementInstance;
        readonly farthestViewportElement: ISVGElement;
        focusable: SVGAnimatedEnumeration;
        getBBox(): SVGRect;
        getCTM(): SVGMatrix;
        getScreenCTM(): SVGMatrix;
        getTransformToElement(pElement: ISVGElement): SVGMatrix;
        hasExtension(extension: string): boolean;
        height: SVGAnimatedLength;
        readonly href: SVGAnimatedString;
        instanceRoot: ISVGElementInstance;
        readonly nearestViewportElement: ISVGElement;
        ownerSVGElement: ISVGSVGElement;
        readonly requiredExtensions: SVGStringList;
        readonly requiredFeatures: SVGStringList;
        readonly systemLanguage: SVGStringList;
        readonly transform: SVGAnimatedTransformList;
        viewportElement: ISVGElement;
        width: SVGAnimatedLength;
        x: SVGAnimatedLength;
        xmlbase: string;
        y: SVGAnimatedLength;
    }

    class SVGViewElement {
        private 'MSHTML.SVGViewElement_typekey': SVGViewElement;
        private constructor();
        readonly externalResourcesRequired: SVGAnimatedBoolean;
        focusable: SVGAnimatedEnumeration;
        ownerSVGElement: ISVGSVGElement;
        preserveAspectRatio: SVGAnimatedPreserveAspectRatio;
        readonly viewBox: SVGAnimatedRect;
        viewportElement: ISVGElement;
        viewTarget: SVGStringList;
        xmlbase: string;
        readonly zoomAndPan: number;
    }

    class SVGZoomEvent {
        private 'MSHTML.SVGZoomEvent_typekey': SVGZoomEvent;
        private constructor();
        readonly bubbles: boolean;
        readonly cancelable: boolean;
        cancelBubble: boolean;
        readonly currentTarget: IEventTarget;
        readonly defaultPrevented: boolean;
        readonly detail: number;
        readonly eventPhase: number;
        initEvent(eventType: string, canBubble: boolean, cancelable: boolean): void;
        initUIEvent(eventType: string, canBubble: boolean, cancelable: boolean, view: IHTMLWindow2, detail: number): void;
        readonly isTrusted: boolean;
        readonly newScale: number;
        readonly newTranslate: SVGPoint;
        preventDefault(): void;
        readonly previousScale: number;
        readonly previousTranslate: SVGPoint;
        readonly srcElement: IHTMLElement;
        stopImmediatePropagation(): void;
        stopPropagation(): void;
        readonly target: IEventTarget;
        readonly timeStamp: number;
        readonly type: string;
        readonly view: IHTMLWindow2;
        readonly zoomRectScreen: SVGRect;
    }

    class ThreadDialogProcParam {
        private 'MSHTML.ThreadDialogProcParam_typekey': ThreadDialogProcParam;
        private constructor();
        readonly document: any;
        readonly moniker: any;
        readonly optionString: any;
        readonly parameters: any;
    }

    class TreeWalker {
        private 'MSHTML.TreeWalker_typekey': TreeWalker;
        private constructor();
        currentNode: any;
        readonly expandEntityReferences: boolean;
        readonly filter: any;
        firstChild(): any;
        lastChild(): any;
        nextNode(): any;
        nextSibling(): any;
        parentNode(): any;
        previousNode(): any;
        previousSibling(): any;
        readonly root: any;
        readonly whatToShow: number;
    }

    class WebGeocoordinates {
        private 'MSHTML.WebGeocoordinates_typekey': WebGeocoordinates;
        private constructor();
        readonly accuracy: number;
        readonly altitude: any;
        readonly altitudeAccuracy: any;
        readonly heading: any;
        readonly latitude: number;
        readonly longitude: number;
        readonly speed: any;
    }

    class WebGeolocation {
        private 'MSHTML.WebGeolocation_typekey': WebGeolocation;
        private constructor();
        clearWatch(watchId: number): void;
        getCurrentPosition(successCallback: any, errorCallback?: any, options?: any): void;
        watchPosition(successCallback: any, errorCallback?: any, options?: any): number;
    }

    class WebGeoposition {
        private 'MSHTML.WebGeoposition_typekey': WebGeoposition;
        private constructor();
        readonly coords: IWebGeocoordinates;
        readonly timeStamp: number;
    }

    class WebGeopositionError {
        private 'MSHTML.WebGeopositionError_typekey': WebGeopositionError;
        private constructor();
        readonly code: number;
        readonly message: string;
    }

    class XDomainRequest {
        private 'MSHTML.XDomainRequest_typekey': XDomainRequest;
        private constructor();
        readonly 'constructor': any;
    }

    class XDomainRequestFactory {
        private 'MSHTML.XDomainRequestFactory_typekey': XDomainRequestFactory;
        private constructor();
        create(): IHTMLXDomainRequest;
    }

    class XMLHttpRequestEventTarget {
        private 'MSHTML.XMLHttpRequestEventTarget_typekey': XMLHttpRequestEventTarget;
        private constructor();
        addEventListener(type: string, listener: any, useCapture: boolean): void;
        dispatchEvent(evt: IDOMEvent): boolean;
        removeEventListener(type: string, listener: any, useCapture: boolean): void;
    }

    class XMLSerializer {
        private 'MSHTML.XMLSerializer_typekey': XMLSerializer;
        private constructor();
        serializeToString(pNode: IHTMLDOMNode): string;
    }
}

interface ActiveXObject {
    on(obj: MSHTML.HTMLNamespace, event: 'onreadystatechange', argNames: ['pEvtObj'], handler: (this: MSHTML.HTMLNamespace, parameter: {readonly pEvtObj: MSHTML.IHTMLEventObj}) => void): void;
    on(
        obj: MSHTML.HTMLWindow2, event: 'onerror', argNames: ['description', 'url', 'line'], handler: (
            this: MSHTML.HTMLWindow2, parameter: {readonly description: string, readonly url: string, readonly line: number}) => void): void;
    on(
        obj: MSHTML.HTMLWindowProxy, event: 'onerror', argNames: ['description', 'url', 'line'], handler: (
            this: MSHTML.HTMLWindowProxy, parameter: {readonly description: string, readonly url: string, readonly line: number}) => void): void;
    on(obj: MSHTML.Scriptlet, event: 'onscriptletevent', argNames: ['name', 'eventData'], handler: (this: MSHTML.Scriptlet, parameter: {readonly name: string, readonly eventData: any}) => void): void;
    on(
        obj: MSHTML.HTMLAnchorElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLAnchorElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLAreaElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLAreaElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLAudioElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLAudioElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLBaseElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLBaseElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLBaseFontElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLBaseFontElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLBGsound, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' | 'onbeforeeditfocus' |
        'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' | 'ondataavailable' |
        'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' | 'ondragover' | 'ondragstart' |
        'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' | 'onkeyup' | 'onlayoutcomplete' |
        'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' | 'onmousewheel' | 'onmove' |
        'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' | 'onresizestart' | 'onrowenter' |
        'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLBGsound, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLBlockElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLBlockElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLBody, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' | 'onbeforeeditfocus' |
        'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselect' | 'onselectstart',
        handler: (this: MSHTML.HTMLBody, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLBRElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLBRElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLButtonElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLButtonElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLCanvasElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLCanvasElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLCommentElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLCommentElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLDDElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLDDElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLDivElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLDivElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLDivPosition, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' |
        'oncut' | 'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselect' | 'onselectstart',
        handler: (this: MSHTML.HTMLDivPosition, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLDListElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLDListElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLDocument, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforedeactivate' | 'onbeforeeditfocus' | 'onbeforeupdate' |
        'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' |
        'ondragstart' | 'onerrorupdate' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' | 'onkeyup' | 'onmousedown' | 'onmousemove' | 'onmouseout' |
        'onmouseover' | 'onmouseup' | 'onmousewheel' | 'onpropertychange' | 'onreadystatechange' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' |
        'onselectionchange' | 'onselectstart' | 'onstop',
        handler: (this: MSHTML.HTMLDocument, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLDTElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLDTElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLEmbed, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' | 'onbeforeeditfocus' |
        'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' | 'ondataavailable' |
        'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' | 'ondragover' | 'ondragstart' |
        'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' | 'onkeyup' | 'onlayoutcomplete' |
        'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' | 'onmousewheel' | 'onmove' |
        'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' | 'onresizestart' | 'onrowenter' |
        'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLEmbed, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLFieldSetElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' |
        'oncut' | 'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselect' | 'onselectstart',
        handler: (this: MSHTML.HTMLFieldSetElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLFontElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLFontElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLFormElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onreset' | 'onresize' |
        'onresizeend' | 'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart' | 'onsubmit',
        handler: (this: MSHTML.HTMLFormElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLFrameBase, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLFrameBase, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLFrameElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLFrameElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLFrameSetSite, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLFrameSetSite, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLGenericElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLGenericElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLHeadElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLHeadElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLHeaderElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLHeaderElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLHRElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLHRElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLHtmlElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLHtmlElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLIFrame, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' | 'onbeforeeditfocus' |
        'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' | 'ondataavailable' |
        'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' | 'ondragover' | 'ondragstart' |
        'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' | 'onkeyup' | 'onlayoutcomplete' |
        'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' | 'onmousewheel' | 'onmove' |
        'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' | 'onresizestart' | 'onrowenter' |
        'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLIFrame, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLImg, event: 'onabort' | 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerror' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' |
        'onkeypress' | 'onkeyup' | 'onlayoutcomplete' | 'onload' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' |
        'onmouseover' | 'onmouseup' | 'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' |
        'onresize' | 'onresizeend' | 'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLImg, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLInputButtonElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLInputButtonElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLInputElement, event: 'onabort' | 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' |
        'oncut' | 'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerror' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' |
        'onkeypress' | 'onkeyup' | 'onlayoutcomplete' | 'onload' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' |
        'onmouseover' | 'onmouseup' | 'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' |
        'onresize' | 'onresizeend' | 'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselect' | 'onselectstart',
        handler: (this: MSHTML.HTMLInputElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLInputFileElement, event: 'onabort' | 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' |
        'oncut' | 'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerror' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' |
        'onkeypress' | 'onkeyup' | 'onlayoutcomplete' | 'onload' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' |
        'onmouseover' | 'onmouseup' | 'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' |
        'onresize' | 'onresizeend' | 'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselect' | 'onselectstart',
        handler: (this: MSHTML.HTMLInputFileElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.htmlInputImage, event: 'onabort' | 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerror' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' |
        'onkeypress' | 'onkeyup' | 'onlayoutcomplete' | 'onload' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' |
        'onmouseover' | 'onmouseup' | 'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' |
        'onresize' | 'onresizeend' | 'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.htmlInputImage, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLInputTextElement, event: 'onabort' | 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' |
        'oncut' | 'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerror' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' |
        'onkeypress' | 'onkeyup' | 'onlayoutcomplete' | 'onload' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' |
        'onmouseover' | 'onmouseup' | 'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' |
        'onresize' | 'onresizeend' | 'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselect' | 'onselectstart',
        handler: (this: MSHTML.HTMLInputTextElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLIsIndexElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLIsIndexElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLLabelElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLLabelElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLLegendElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' |
        'oncut' | 'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselect' | 'onselectstart',
        handler: (this: MSHTML.HTMLLegendElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLLIElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLLIElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLLinkElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerror' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' |
        'onkeypress' | 'onkeyup' | 'onlayoutcomplete' | 'onload' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' |
        'onmouseover' | 'onmouseup' | 'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' |
        'onresize' | 'onresizeend' | 'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLLinkElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLListElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLListElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLMapElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLMapElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLMarqueeElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'onbounce' | 'oncellchange' | 'onchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' |
        'oncopy' | 'oncut' | 'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' |
        'ondragleave' | 'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfinish' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' |
        'onkeydown' | 'onkeypress' | 'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' |
        'onmouseover' | 'onmouseup' | 'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' |
        'onresize' | 'onresizeend' | 'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselect' | 'onselectstart' |
        'onstart',
        handler: (this: MSHTML.HTMLMarqueeElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLMediaElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLMediaElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLMetaElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLMetaElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLNextIdElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLNextIdElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLNoShowElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLNoShowElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLObjectElement, event: 'onafterupdate' | 'onbeforeupdate' | 'oncellchange' | 'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' |
        'onerror' | 'onerrorupdate' | 'onreadystatechange' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted',
        handler: (this: MSHTML.HTMLObjectElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLOListElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLOListElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLOptionButtonElement, event: 'onabort' | 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' |
        'onbeforedeactivate' | 'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onchange' | 'onclick' | 'oncontextmenu' |
        'oncontrolselect' | 'oncopy' | 'oncut' | 'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' |
        'ondragenter' | 'ondragleave' | 'ondragover' | 'ondragstart' | 'ondrop' | 'onerror' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' |
        'onhelp' | 'onkeydown' | 'onkeypress' | 'onkeyup' | 'onlayoutcomplete' | 'onload' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' |
        'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' | 'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' |
        'onreadystatechange' | 'onresize' | 'onresizeend' | 'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselect' |
        'onselectstart',
        handler: (this: MSHTML.HTMLOptionButtonElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLOptionElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLOptionElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLParaElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLParaElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLParamElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLParamElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLPhraseElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLPhraseElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLProgressElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLProgressElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLRichtextElement, event: 'onabort' | 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' |
        'oncut' | 'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerror' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' |
        'onkeypress' | 'onkeyup' | 'onlayoutcomplete' | 'onload' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' |
        'onmouseover' | 'onmouseup' | 'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' |
        'onresize' | 'onresizeend' | 'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselect' | 'onselectstart',
        handler: (this: MSHTML.HTMLRichtextElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLScriptElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerror' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' |
        'onkeypress' | 'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' |
        'onmouseup' | 'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' |
        'onresizeend' | 'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLScriptElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLSelectElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' |
        'oncut' | 'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLSelectElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLSemanticElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLSemanticElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLSourceElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLSourceElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLSpanElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLSpanElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLSpanFlow, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' |
        'oncut' | 'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselect' | 'onselectstart', handler: (
            this: MSHTML.HTMLSpanFlow, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLStyleElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerror' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' |
        'onkeypress' | 'onkeyup' | 'onlayoutcomplete' | 'onload' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' |
        'onmouseover' | 'onmouseup' | 'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' |
        'onresize' | 'onresizeend' | 'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLStyleElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLTable, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' | 'onbeforeeditfocus' |
        'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' | 'ondataavailable' |
        'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' | 'ondragover' | 'ondragstart' |
        'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' | 'onkeyup' | 'onlayoutcomplete' |
        'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' | 'onmousewheel' | 'onmove' |
        'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' | 'onresizestart' | 'onrowenter' |
        'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLTable, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLTableCaption, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' |
        'oncut' | 'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselect' | 'onselectstart',
        handler: (this: MSHTML.HTMLTableCaption, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLTableCell, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' |
        'oncut' | 'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselect' | 'onselectstart', handler: (
            this: MSHTML.HTMLTableCell, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLTableCol, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLTableCol, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLTableRow, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLTableRow, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLTableSection, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLTableSection, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLTextAreaElement, event: 'onabort' | 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' |
        'oncut' | 'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerror' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' |
        'onkeypress' | 'onkeyup' | 'onlayoutcomplete' | 'onload' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' |
        'onmouseover' | 'onmouseup' | 'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' |
        'onresize' | 'onresizeend' | 'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselect' | 'onselectstart',
        handler: (this: MSHTML.HTMLTextAreaElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLTextElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLTextElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLTitleElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLTitleElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLUListElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLUListElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLUnknownElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLUnknownElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLVideoElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLVideoElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLWindow2, event: 'onafterprint' | 'onbeforeprint' | 'onbeforeunload' | 'onblur' | 'onfocus' | 'onhelp' | 'onload' | 'onresize' | 'onscroll' |
        'onunload',
        handler: (this: MSHTML.HTMLWindow2, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLWindowProxy, event: 'onafterprint' | 'onbeforeprint' | 'onbeforeunload' | 'onblur' | 'onfocus' | 'onhelp' | 'onload' | 'onresize' | 'onscroll' |
        'onunload',
        handler: (this: MSHTML.HTMLWindowProxy, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLWndOptionElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLWndOptionElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.HTMLWndSelectElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' |
        'oncut' | 'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.HTMLWndSelectElement, parameter: {}) => void): void;
    on(obj: MSHTML.HTMLXMLHttpRequest, event: 'onreadystatechange' | 'ontimeout', handler: (this: MSHTML.HTMLXMLHttpRequest, parameter: {}) => void): void;
    on(
        obj: MSHTML.OldHTMLDocument, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforedeactivate' | 'onbeforeeditfocus' | 'onbeforeupdate' |
        'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' |
        'ondragstart' | 'onerrorupdate' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' | 'onkeyup' | 'onmousedown' | 'onmousemove' | 'onmouseout' |
        'onmouseover' | 'onmouseup' | 'onmousewheel' | 'onpropertychange' | 'onreadystatechange' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' |
        'onselectionchange' | 'onselectstart' | 'onstop',
        handler: (this: MSHTML.OldHTMLDocument, parameter: {}) => void): void;
    on(
        obj: MSHTML.OldHTMLFormElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onreset' | 'onresize' |
        'onresizeend' | 'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart' | 'onsubmit',
        handler: (this: MSHTML.OldHTMLFormElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.Scriptlet, event: 'onclick' | 'ondblclick' | 'onkeydown' | 'onkeypress' | 'onkeyup' | 'onmousedown' | 'onmousemove' | 'onmouseup' |
        'onreadystatechange',
        handler: (this: MSHTML.Scriptlet, parameter: {}) => void): void;
    on(
        obj: MSHTML.SVGAElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' | 'onbeforeeditfocus' |
        'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' | 'ondataavailable' |
        'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' | 'ondragover' | 'ondragstart' |
        'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' | 'onkeyup' | 'onlayoutcomplete' |
        'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' | 'onmousewheel' | 'onmove' |
        'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' | 'onresizestart' | 'onrowenter' |
        'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.SVGAElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.SVGCircleElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.SVGCircleElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.SVGClipPathElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.SVGClipPathElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.SVGDefsElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.SVGDefsElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.SVGElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' | 'onbeforeeditfocus' |
        'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' | 'ondataavailable' |
        'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' | 'ondragover' | 'ondragstart' |
        'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' | 'onkeyup' | 'onlayoutcomplete' |
        'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' | 'onmousewheel' | 'onmove' |
        'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' | 'onresizestart' | 'onrowenter' |
        'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.SVGElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.SVGEllipseElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.SVGEllipseElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.SVGGElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' | 'onbeforeeditfocus' |
        'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' | 'ondataavailable' |
        'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' | 'ondragover' | 'ondragstart' |
        'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' | 'onkeyup' | 'onlayoutcomplete' |
        'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' | 'onmousewheel' | 'onmove' |
        'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' | 'onresizestart' | 'onrowenter' |
        'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.SVGGElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.SVGGradientElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.SVGGradientElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.SVGImageElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.SVGImageElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.SVGLineElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.SVGLineElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.SVGMarkerElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.SVGMarkerElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.SVGMaskElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.SVGMaskElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.SVGPathElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.SVGPathElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.SVGPatternElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.SVGPatternElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.SVGPolygonElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.SVGPolygonElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.SVGPolylineElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.SVGPolylineElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.SVGRectElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.SVGRectElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.SVGScriptElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.SVGScriptElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.SVGStopElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.SVGStopElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.SVGSVGElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.SVGSVGElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.SVGSymbolElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.SVGSymbolElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.SVGTextElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.SVGTextElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.SVGTextPathElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.SVGTextPathElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.SVGTSpanElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.SVGTSpanElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.SVGUseElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.SVGUseElement, parameter: {}) => void): void;
    on(
        obj: MSHTML.SVGViewElement, event: 'onactivate' | 'onafterupdate' | 'onbeforeactivate' | 'onbeforecopy' | 'onbeforecut' | 'onbeforedeactivate' |
        'onbeforeeditfocus' | 'onbeforepaste' | 'onbeforeupdate' | 'onblur' | 'oncellchange' | 'onclick' | 'oncontextmenu' | 'oncontrolselect' | 'oncopy' | 'oncut' |
        'ondataavailable' | 'ondatasetchanged' | 'ondatasetcomplete' | 'ondblclick' | 'ondeactivate' | 'ondrag' | 'ondragend' | 'ondragenter' | 'ondragleave' |
        'ondragover' | 'ondragstart' | 'ondrop' | 'onerrorupdate' | 'onfilterchange' | 'onfocus' | 'onfocusin' | 'onfocusout' | 'onhelp' | 'onkeydown' | 'onkeypress' |
        'onkeyup' | 'onlayoutcomplete' | 'onlosecapture' | 'onmousedown' | 'onmouseenter' | 'onmouseleave' | 'onmousemove' | 'onmouseout' | 'onmouseover' | 'onmouseup' |
        'onmousewheel' | 'onmove' | 'onmoveend' | 'onmovestart' | 'onpage' | 'onpaste' | 'onpropertychange' | 'onreadystatechange' | 'onresize' | 'onresizeend' |
        'onresizestart' | 'onrowenter' | 'onrowexit' | 'onrowsdelete' | 'onrowsinserted' | 'onscroll' | 'onselectstart',
        handler: (this: MSHTML.SVGViewElement, parameter: {}) => void): void;
    new<K extends keyof ActiveXObjectNameMap = any>(progid: K): ActiveXObjectNameMap[K];
}

interface ActiveXObjectNameMap {
    htmlfile: MSHTML.HTMLDocument;
    'ScriptBridge.ScriptBridge': MSHTML.Scriptlet;
    'TemplatePrinter.TemplatePrinter': MSHTML.CTemplatePrinter;
}

interface SafeArray<T = any> {
    _brand: SafeArray<T>;
}
